c   **** NOTES:
c	  uses CFITSIO libs for *reading* FITS files 
c     will read:
c     .fits
c     .fits.gz
c     .fz  [RICE compressed files]
c
c     .pl [IRAF pixel list format -- untested as yet]
c
c     MEFs -- specify MEF extension as: 739902p.fits^12
c     will be stored in pppdir as 739902p^12 
c     modify writing routines to output .fits, .pl, and other compressed files
c
c note on extension storage: 
c   nextend(254)=pppdir storage (total num of ext) in common/dir/
c   nextendh(15)=image header storage(total num of ext) (in imagepar.inc)
c   idext(15)=extension number of core image  (in picdir.inc)
c
c   ihead=-1 : read header only
c
	SUBROUTINE rdkfits(*,NFR,FILENCT,IREP,IX,NU,NV,KF,IR,ihead)
	INTEGER IX(NU,NV,KF),NFLAG,NID,NJD
       integer lun,status,rmode,wmode,i,j,k,ii,jj,kk,nkeys,naxes(2)
       integer nfound,nbuffer,group,firstpix,nfr!,ext
	integer maxkeys,irice,iz
	CHARACTER*24 NFILEN,FILEN*24,FILENF*24,dumstr*8,filenct*60
	CHARACTER FILENC*60,filent*60,filenh*18,fitsname*24
	character headblk*2880,hdr(720)*80,headbst*2880
	CHARACTER*36 NCOM,NCOMC,objnam,imdir*55
      character tmphdr*80,errmsg*30,cext*2
	logical ex,anynull,simple,extend
	INCLUDE 'picdir.inc'
	INCLUDE 'mosaic.inc'
	include 'imagepar.inc'
	COMMON/PICC/ NCOMC(15),fitsname(15)
	common/imagedir/imdir
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254),
     *              NID(254),NJD(254),nextend(254)
	common/headerst/bzest(15),bscst(15),headbst(20,15),nhbst(15)
	common/header/bzero,bscale,headblk(20),nhb
c*
	equivalence (headblk(1)(1:1),hdr(1)(1:1))
	include 'ppparm.inc'
	include 'objcat.inc'
	call stthead(nfr)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
C decode filename
20001	IR=0
c  save the incoming name and leave it unchanged
	filenc=filenct
	IF (FILENC.EQ.' ') then
	  WRITE(6,10)
 10	FORMAT('  Enter NAME of file, ^n for extension (max 60 char): ',$)
	  call readstr(60,filenc,*999,*6001)
	end if
c get fits file name without extension
 6001	namelen=index(filenc,'^')-1
c	write(6,*) ' namelen ',namelen
	if (namelen.le.0) namelen=lnblnk(filenc)
c filent is used for the name without the extension
	filent=filenc
c  names are checked if it is longer than 24 characters
	if (namelen.gt.24) then
	  write(6,11) namelen
 11	format(' Name longer than 24 (',i2,'), not listed in directory')
	  ip=0
	else
C  get name for checking with directory
c check for existence of file, and uncompress if .Z
	  filen=filent(1:namelen)
 	  CALL DIREC(FILEN,FILENF,NFR,IP,1,IDF)
C  File name does not exit in pppdir; 
	  IF (IP.EQ.0) then
	    WRITE(6,301) FILEN
 301	FORMAT(' ++ ',A24,' ++ does not exist in ppp DIRECTORY'
     *          /'    attempting to locate unlisted .fits file....')
	  else
	    WRITE(6,22) FILEN,ncom(idf),nid(idf),njd(idf)
 22     FORMAT(1X,A18,' : ''',A35,''' size: ',I4,' X ',I4)
	  end if
	end if
c get the extension character cext
	call imagext(filent,iext,cext)
	if (iext.eq.-999) return1    ! extension error, exit
c	write(6,*) filent(1:lnblnk(filent)),' extension: ',cext,iext
c check for existence of file (rootname), and uncompress if .Z
	idext(nfr)=iext
c check if image exist 
	call imageex(filent,filenc,iimex)
c	write(6,*) 'iimex ',iimex
	if (iimex.lt.0) return1   ! image does not exist, exit
c   attach extension if requested
	if (iext.gt.0) then
	  filent=filenc(1:lnblnk(filenc))//'['//cext(1:lnblnk(cext))
     *                 //']'
	else
	  filent=filenc
	end if
c
c  attempt to open file
	rmode=0
c	wmode=1
	status=0
c get nextend, if the image is not in ppp directory
c   this is done using the 0th HUD
 	if (ip.eq.0) then
	  call ftgiou(lun,status)
	  call ftnopn(lun,imdir(1:lnblnk(imdir))//
     *      filenc(1:lnblnk(filenc))//'[0]',rmode, status)
	  call ftgkyj(lun,'NEXTEND',nextendt,dumstr,status)
c  if not found, set nextend to 1
	  if (status.ne.0) then
	    nextendt=1
	    status=0
	  end if
 	  write(6,*) ' # of extension: ',nextendt,status
	  call ftgerr(status,errmsg)
	  call ftclos(lun, status)
	  call ftfiou(lun, status)
	end if
c now read image
 	call ftgiou(lun,status)
 	PRINT *,' ..Opening '//imdir(1:lnblnk(imdir))//
     *       filent(1:lnblnk(filent))
	fitsname(nfr)=filenc(1:lnblnk(filenc))
	call ftnopn(lun,imdir(1:lnblnk(imdir))//
     *      filent(1:lnblnk(filent)),rmode, status)
	call ftgerr(status,errmsg)
c        print *,errmsg
c        print *,'status1 ',status
c     ---
c     -- read header 
	pcount=0     ! this stuff req'd for MEFs?
	gcount=1
	extend=.true.
C     The FTGHSP subroutine returns the number of existing keywords in the
C     current header data unit (CHDU), not counting the required END keyword,
	call ftghsp(lun,nkeys,nspace,status)
c  add 1 to include END card
	nkeys=nkeys+1
C     Read each 80-character keyword record,  the array hdr is
c          equivalenced to headblk (20 cards of 80 characters)
	maxkeys=720
	if(nkeys.gt.maxkeys) then 
	  print *,'header truncated:'
	  print *,'only taken first ',maxkeys,' lines of ',nkeys
	  nkeys=maxkeys
	end if
	do i=1, nkeys
	  call ftgrec(lun,i,hdr(i),status)
	end do
c number of header blocks
	nhb=(nkeys+35)/36
c	hdr(nkeys)='END'
	write(6,*) '  # of header blks: ',nhb,' hd cards ',nkeys
c     -- determine the size of the image
	if(iimex.eq.3) then
c**** might want to translate some of the rice compression keywords to 
c     standard keywords for future ref.  e.g. znaxes-->naxes
	  call ftgknj(lun,'ZNAXIS',1,2,naxes,nfound,status)
	else
c     **** need to go to correct extension
c     unit,keyroot,startno,maxkeys,>keyvals,nfound,status
	  call ftgknj(lun,'NAXIS',1,2,naxes,nfound,status)
	end if
c     print *,'status ',status
c     -- check that it found both NAXIS1 and NAXIS2 keywords
 	write(6,*) ' Image size: ', naxes
	if (nfound .ne. 2)then
	  print *,'READIMAGE failed to read the NAXISn keywords.'
	  return1
	end if
c  for reading header only
	if (ihead.eq.-1) return1
C check if the ppp buffer is large enough
	if (naxes(1).gt.nu.or.naxes(2).gt.nv) then
	  write (6,5) nu,nv
 5	format(' *** buffer size (',2i6,') TOO SMALL, image not read'/
     *     '     need to set nu and nv to the proper size')
	  return1
	end if
	NI=naxes(1)
	NJ=naxes(2)
c     ---- Read FITS file (may be compressed) using CFITSIO routines
	nbuffer=min(nu*nv,NI*NJ)
	group=1
	firstpix=1
c     -- need implied do loop as ix buffer is 3D and ftgpve expects 2D
c          this is probably quite a slow-down!
c     **** check exact details of this loop on non-square image
	nbuffer=ni
	do j=1,nj
	  call ftgpvj(lun,group,firstpix,nbuffer,nullval,
     *                ix(1,j,nfr),anynull,status,ni,j)
	  firstpix=firstpix+ni
	enddo
c     -- close file and free lun
	call ftclos(lun, status)
	call ftfiou(lun, status)
c     if file was originally .Z compressed, recompress in bgd, now
c	  if(iz.gt.0) idum=system('compress '//filenf//' &')
c..................................................
c  PART 2: for .pic files  *** deleted Nov 19 2004
c..........................................
c  reading finished, now tidy up the ppp and core directory
c
 305	NII(NFR)=NI
	NJJ(NFR)=NJ
c store header block to headbst(ndr) 
c	write(6,777) (hdr(kk),kk=1,nkeys)
 777	format(a80)
	call headtst(nfr)
c get values of key words from header
	call getkeyval(*309,nfr,kf)
 309	continue
c assign initial position file boundry
	ilpos(nfr)=1
	iupos(nfr)=nii(nfr)
	jlpos(nfr)=1
	jupos(nfr)=njj(nfr)
	if (ip.eq.0) then
	  nextendh(nfr)=nextendt
	else
c get it from pppdirectory
	  nextendh(nfr)=nextend(idf)
	end if
c                          
c  update core directory 
	if (ip.eq.1) then
C       change core directory
	  NF(NFR)=IDF
	  NCOMC(NFR)=NCOM(IDF)
	  DO 233 K=1,5
 233	    NFL(K,NFR)=NFLAG(K,IDF)
c         WRITE(6,270) FILENF,cext,NFR
          WRITE(6,270) FILENT,cext,NFR
  270 FORMAT ('  Image ',A24,'[',a2,'] read from DISK into FRAME',I3)
 	  RETURN1
	else if (ip.eq.0) then
C 2) file does not exist in directory -- update ppp directory
C
	  DO 230 M=1,5
 230	    NFL(M,NFR)=0
	    if (namelen.le.24) then
 	  write(6,*) ' ... adding entry to ppp directory '
	      call direc(filen,filenf,nfr,ip,4,idf)
c add header to ncom
	      ncom(nof)=ncomc(nfr)
	      nextend(nof)=nextendt
 	      NF(NFR)=NOF
	    end if
	else if (ip.eq.2) then
	  write(6,*) '  +++PPP directory full ',nof
	end if
c  updating ppp directory: need to add new entry if required,
c	if (ip.eq.0.and.namelen.le.24) then
c	  write(6,*) ' ... adding entry to ppp directory '
c	  call direc(filen,filenf,nfr,ip,4,idf)
c	  WRITE(6,*) ' ...NEW entry to ppp directry has been made'
c	else IF (IP.EQ.2.or.namelen.gt.24) THEN
	IF (IP.EQ.2.or.namelen.gt.24) THEN
	  NF(NFR)=0 
   	  WRITE(6,*) ' ++ NO new directory entry made ++'
	end if
	return1
 997	WRITE(6,19) NFILENF
 19	FORMAT(' **** OPEN ERROR ****',A18,' NO such file, or incrorre'
     *    ,'ct SIZE')
	IR=-1
	RETURN1 
c
c  ***error messages***
 991	WRITE(6,*) '  ****ILLEGAL FILE NAME***'
	IR=-1
	RETURN1
 996	WRITE(6,18) NI,NJ
 18	FORMAT(1X,' ***** PICTURE SIZE: ',I4,' X',I4,' TOO LARGE FOR',
     *         ' CURRENT CONFIGURATION***')
	return1
 995	write(6,*) '  **** error in .fhd file ****'
	return1
 979	write(6,*) '  ** error in creating .fdh file, already exist **'
	return1
 998	write(6,*) '   +++ image not read +++'
 999	RETURN1
	END
c///////////////////////////////////////////////

C *************************************************************************
      subroutine printerror(status)

C  This subroutine prints out the descriptive text corresponding to the
C  error status value and prints out the contents of the internal
C  error message stack generated by FITSIO whenever an error occurs.

      integer status
      character errtext*30,errmessage*80

C  Check if status is OK (no error); if so, simply return
      if (status .le. 0)return

C  The FTGERR subroutine returns a descriptive 30-character text string that
C  corresponds to the integer error status number.  A complete list of all
c  the error numbers can be found in the back of the FITSIO User''s Guide.
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

C  FITSIO usually generates an internal stack of error messages whenever
C  an error occurs.  These messages provide much more information on the
C  cause of the problem than can be provided by the single integer error
C  status value.  The FTGMSG subroutine retrieves the oldest message from
C  the stack and shifts any remaining messages on the stack down one
C  position.  FTGMSG is called repeatedly until a blank message is
C  returned, which indicates that the stack is empty.  Each error message
C  may be up to 80 characters in length.  Another subroutine, called
C  FTCMSG, is available to simply clear the whole error message stack in
C  cases where one is not interested in the contents.
      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      end do
      end
C *************************************************************************

C/////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO return name and extension (separately) for cfitsio
c
c  the name is strip of the extension and ".fits" if included
c   MEF extensions, written as: file^ext
c
C    RETURN FILE NAME to be read, AND PARAMETER IP
C    NC=NUMBE OF CHARACTERS BEFORE BLANK, OR '.'
	SUBROUTINE imagext(FILEN,iext,cext)
	CHARACTER FILEN*60,cext*2
	cext='0'
	iext=0
c note: index returns FIRST occurence of substring
c
c  parse name string
c  1: check if .fits is included, if so, strip it
 200    nc=index(filen,'.') 
	len=lnblnk(filen)
	if (nc.ne.0) then
	  if (filen(nc:nc+3).eq.'fits') then
	    filen=filen(1:nc-1)//filen(nc+4:len)
c check for next '.'
	  else 
	    nc2=index(filen(nc+1:len),'.')
	    if (nc2.ne.0) then
	      if (filen(nc2:nc2+3).eq.'fits') then
	        filen=filen(1:nc2-1)//filen(nc2+4:len)
	      end if
	    end if
	  end if
	end if
c     check for mef extension
	ipext=index(filen,'^')
	if(ipext.gt.0) then
	  cext=filen(ipext+1:lnblnk(filen))
	  filen=filen(1:ipext-1)
	  read(cext,*,err=899) iext
	  return
 899	  write(6,*) ' ** Error in extension, read aborted **'
	  iext=-999
	  return
	else
	  cext='0'
	endif
	RETURN
	END
c//////////////////////////////////////////////////////////////////////
c
c subroutine to check for existence of the image in various forms
c   iimex=-1 if does not exist
c          0  not compressed
c          1 .Z, and uncompressed
c          2 .gz
c          3 .fz
c
c  filen is the input name, filenc is the output name with
c      chip number stripped, and extension added
c
	subroutine imageex(filen,filenl,iimex)
	character filen*60,filenl*60,imdir*55
	logical ex
	common/imagedir/imdir
	iimex=0
	ndir=lnblnk(imdir)
c  straight fits file
	filenl=filen(1:lnblnk(filen))//'.fits'
	inquire(file=imdir(1:ndir)//filenl,exist=ex)
	if (ex.eqv..true.) return
c check  .gz
	filenl=filen(1:lnblnk(filen))//'.fits.gz'
	inquire(file=imdir(1:ndir)//filenl,exist=ex)
	if (ex.eqv..true.) then
	  iimex=2
	  write(6,*) '   +++ gunzipping .gz version ... '
	  idum=system('gunzip '//imdir(1:lnblnk(imdir))//
     *         filenl(1:lnblnk(filenl)))
	  filenl=filen(1:lnblnk(filen))//'.fits'
	  return
	end if
c check rice compression .fz
	filenl=filen(1:lnblnk(filen))//'.fz'
	inquire(file=imdir(1:ndir)//filenl,exist=ex)
	if (ex.eqv..true.) then
	  iimex=3
	  return
	end if
c  check .Z compression and uncompress
	filenl=filen(1:lnblnk(filen))//'.fits.Z'
	inquire(file=imdir(1:ndir)//filenl,exist=ex)
	if (ex.eqv..true.) then
	  iimex=1
	  write(6,*) '   +++ uncompressing .Z version ... '
	  idum=system('uncompress '//imdir(1:lnblnk(imdir))//
     *         filenl(1:lnblnk(filenl)))
	  filenl=filen(1:lnblnk(filen))//'.fits'
	  return
	end if
c file does not exists
	iimex=-1
	write(6,*) ' +++ image ',filen(1:lnblnk(filen)),
     *       ' does not exist'
	return
	end 
c////////////////////////////////////////////////////////////////
c   subroutine to read file using directory number
c
c    the pppdirectory number is passed on by a string, 
c              3^4= 4th chip of file 3
c
	SUBROUTINE RDIRFIL(*,NFR,dirnstr,IX,NU,NV,KF)
	INTEGER IX(NU,NV,KF),NFLAG,NID,NJD
	CHARACTER*24 NFILEN,NFILDUM,dirnstr*60,cext*4
	CHARACTER*36 NCOM,NCOMC,fitsname*24
	INCLUDE 'picdir.inc'
	COMMON/PICC/ NCOMC(15),fitsname(15)
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254), 
     *              NID(254),NJD(254),nextend(254)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001   IF (dirnstr.eq.' ') THEN
 600      WRITE(6,10)
 10     FORMAT('  Enter PPPDIR file number to be read: ',$)
	  read(6,'(a60)',end=999) dirnstr
	END IF
	n1=index(dirnstr,'^')
	if (n1.ne.0) then
c  extension
	  read(dirnstr(1:n1-1),*,err=999) nfil
	  read(dirnstr(n1:lnblnk(dirnstr)),'(a4)',err=999) cext
	else
	  read(dirnstr,*,err=999) nfil
	  cext=' '
	end if
c parse diretory number string
	IF (NFIL.LT.1.OR.NFIL.GT.NOF) THEN
	  WRITE(6,*) ' **** File number too large or <0 ****'
	  RETURN1
	ELSE
	  dirnstr=NFILEN(NFIL)(1:lnblnk(nfilen(nfil)))//cext
	  CALL rdkfits(*80,NFR,dirnstr,irep,IX,NU,NV,KF,IR,0)
 80       CONTINUE
	END IF
 999    RETURN1
	END
