C///////////////////////////////////////////////////////////////////////
c        subroutines to write fits to disk
c
c   using cfitsio
c  adopted from old wrfits.f
c/////////////////////////////////////////////
c
C  subroutine to write frame nfr to either (1) a new fits file, or
c                                          (2) the nth extension of an
c                                              existing file
c    if it is a new file, update the ppp directory
c      if it is an existing file, update the extension number
c   allows option of writing as interger 4 (regular) or integer 2 (mask files)
c
	SUBROUTINE wdkfits(*,nfr,FILENC,irep,IX,NU,NV,kf,IR)
	INTEGER IX(NU,NV,kf)
	CHARACTER*24 NFILEN,FILEN
	CHARACTER*24 FILENC*60,FILENF,filenh,objnam*36,fitsname*24
	character headblk*2880,hdr(360)*80,size*20,fdate*24
     *         ,itest1*3,blank*20,axistr*20,imdir*55,nyes*1,
     *        ncomc*36,ncom*36
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	common/header/bzero,bscale,headblk(20),nhb
	common/headerst/bzest(15),bscst(15),headbst(20,15),nhbst(15)
	equivalence (headblk(1)(1:1),hdr(1)(1:1))
	common/imagedir/imdir
	COMMON/PICC/ NCOMC(15),fitsname(15)
	COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254),
     *              NID(254),NJD(254)
C decode filename
	CALL QUERYNFR(NFR,KF,0,*999,*2001)
2001	IR=0
	blank='                   '
	if (filenc.eq.' ') then
	  write(6,1)
 1	FORMAT('  Enter output name, ^n for extsn (max 60char): ',$)
	  read(5,'(a60)',end=999) filenc
	end if
c parse the extension 
c get fits file name without extension
	namelen=index(filenc,'^')-1
c       write(6,*) ' namelen ',namelen
        if (namelen.le.0) namelen=lnblnk(filenc)
c filent is the name without the extension
        filent=filenc
c  names are checked if it is longer than 24 characters
        if (namelen.gt.24) then
          write(6,11) namelen
 11     format(' Name longer than 24 (',i2,'), not listed in directory')
	  filenc=' '
	  goto 2001
	else if (namelen.le.0) then
c  no extension, and name is shorter than 24
	  iext=0
	else
c there is an extension, parse the name for extension number (iext) and string
	  call imagext(filenc,iext,cext)
        end if
c filenf is the root name of the image
	filenf=filenc(1:lnblnk(filenc)
c check ppp directory for pre-existing files
	if (irep.eq.0) then
	  CALL DIREC(FILEN,FILENF,NFR,IP,2,IDF)
	else
	  CALL DIREC(FILEN,FILENF,NFR,IP,3,IDF)
	end if
c  need to figure out how to deal with duplicate names...
C a duplicate name is found in DIR
        IF (IP.EQ.1) THEN
 600      WRITE(6,2) FILEN
 2      FORMAT(' --- ',A12,' --- Already EXIST, Do you want to'
     *         ,' DELETE? (y/[n]): ',$)
          call readstr(1,nyes,*999,*600)
          IF (NYES.EQ.'y') THEN
C             delete original
            CALL DIREC(FILEN,FILENF,NFR,IP,0,IDF)
            GO TO 79
          ELSE
            WRITE(6,*) ' ...NO FILE WRITTEN.'
            RETURN1
          END IF
C   directory full
        ELSE  IF (IP.EQ.2) THEN
          WRITE(6,*) ' *** NO FILE WRITTEN *** '
          IR=-1
          RETURN1
        ELSE IF (IP.EQ.-1) THEN
          RETURN1
        END IF
C
C  start write:
C
 71	NI=NII(nfr)
	NJ=NJJ(nfr)
	call stthead(nfr)
	write(6,*) 'bzero ', bzero,' bscale ',bscale
c  writing fits
	open(unit=20,file=imdir(1:lnblnk(imdir))//filenf
     *        ,status='new',access='direct',recl=2880,err=9001)
 777	format(1x,a18)
c  write header
c  copy header block headblk, (this version copies nhb header blocks)
	if (nhb.gt.0) then
	  ihb=1
	  ihistory=0
	  if (headblk(ihb).ne.' ') then
c  replace size information on hb#1
            DO 1181 I=1,36
              IF (hdr(i)(1:6).eq.'NAXIS1') then
	        istatus=encode(axistr,float(ni),1,0,idum)
	        hdr(i)(11:30)=axistr
	      end if
              IF (hdr(i)(1:6).eq.'NAXIS2') then
	        istatus=encode(axistr,float(nj),1,0,idum)
	        hdr(i)(11:30)=axistr
	      end if
c replace "object" field
              IF (hdr(i)(1:3).eq.'OBJ') then
c  why is objname=ncom(nof)?  corrected Apr 17/08
c	      objnam=ncom(nof)(1:18)
	        objnam=ncomc(nfr)(1:18)
	        hdr(i)(1:30)='OBJECT  = '''//objnam//''''
	      end if
c  add a card before end card to indicate the file was created by ppp
              if (hdr(i)(1:3).eq.'    ') then
	        if (ihistory.eq.0) then
                  hdr(i)='HISTORY = Saved from PPP '//fdate()
	          ihistory=1
	        end if
	      end if
	      if (hdr(i)(1:3).eq.'END') goto 1182
 1181  	    continue
   	    write(20,rec=1) headblk(1)
c  the more than one card
	  do 1081 n=2,nhb
            do 1183 i=36*(n-1)+1,36*n
              if (hdr(i)(1:3).eq.'    ') then
	        if (ihistory.eq.0) then
                  hdr(i)='HISTORY = Saved from PPP '//fdate()
	          ihistory=1
	        end if
	      end if
              if (hdr(i)(1:3).eq.'END') then
	        ihb=n
                goto 1182
              end if
 1183       continue
   	    write(20,rec=n) headblk(n)
 1081     continue
c  in this case, no end card was found!
	  ihb=nhb
	  hdr(i-1)='END'
c  write last header card
 1182 	  write(20,rec=ihb) headblk(ihb)
	end if
	else
c   if there is no data in header block, create simple header
c     and use default bscale and bzero (1 and 0)
	  write(6,10)
c10	format('  No default fits header.  Enter Object name : ',$)
 10	format('  No default fits header.  simple header used: ',$)
c	  read(5,'(a20)',end=998) objname
	  objnam=ncomc(nfr)(1:20)
c  changed Jan 15 2008, to allow exp time, gain etc to be encoded
c  what happens if there are no values such as exp time... etc
c	  call makefhd(nfr,ni,nj,1,objnam)
	  call makefhd(nfr,ni,nj,0,objnam)
	  ihb=1
 	  write(20,rec=ihb) headblk(ihb)
	end if
	write(6,*) ' bscale ',bscale,' bzero ',bzero, 'nfr ',nfr
	call fitsdataout(20,ihb,ix(1,1,nfr),
     *         nu,nv,ni,nj,ibyte,bscale,bzero)
 998	close(unit=20)
 999	return1
 9001	write(6,*) ' *** no such file *** '
	return1
	end
c////////////////////////////////////////////////////////////
c  
c//////////////////////////////////////////////////
c
c  subroutine to write out fits data (data only)
c  ihb is the number of header blks already written
c
c  Apr 17 2008: note fitsdataout is for I*2, cannot deal with
c    over float, it would crash....
	subroutine fitsdataout(idev,ihb,ix,nu,nv,ni,nj,ibyte,
     *          bscale,bzero)
	integer ix(nu,nv)
	integer*2 ixt(1440)
	i=1
	j=1
	nblk=ihb
 201	nblk=nblk+1
	do 202 k=1,1440
	  if (i.gt.ni) then
c  go to next line
	    j=j+1
	    if (j.gt.nj) then
c  pad with zeros
	      do 203, l=k,1440
	        ixt(l)=0
 203	      continue
	      if (ibyte.eq.1) call byte_swap(ixt,2880)
	      write(idev,rec=nblk) ixt
	      return
	    end if
	    i=1
	  end if
	  ixt(k)=nint((float(ix(i,j))-bzero)/bscale)
c do byte switching if needed
	  i=i+1
 202	continue
	if (ibyte.eq.1) call byte_swap(ixt,2880)
	write(idev,rec=nblk) ixt
	go to 201
	end
c
c//////////////////////////////////////////////////////////////
c
c  subroutine to make a simple .fits header, returning 1 2880 byte
c     block as the first blk in the common headblk
c
c  ipar=0 make the most simple header
c  ipar=1 include some additional information from imagepar.inc
	subroutine makefhd(nfr,ni,nj,ipar,objnam)
	character objnam*36,fdate*24,headblk*2880,hdr(360)*80
     *          ,size*5,blank*20,bzstr*20,tempstr*20
	common/header/bzero,bscale,headblk(20),nhb
	equivalence (headblk(1)(1:1),hdr(1)(1:1))
	include 'imagepar.inc'
	blank='                    '
	hdr(1)='SIMPLE  =                    T  /  FITS STANDARD'
	hdr(2)='BITPIX  =                   16  /  FITS BITS/PIXEL'
	hdr(3)='NAXIS   =                    2  /  NUMBER OF AXES'
	istatus=encode(size,float(ni),1,0,idum)
	hdr(4)='NAXIS1  ='//BLANK(1:21-lnblnk(size))//size(1:
     *         lnblnk(size))//'  /'
	istatus=encode(size,float(nj),1,0,idum)
	hdr(5)='NAXIS2  ='//BLANK(1:21-lnblnk(size))//size(1:
     *         lnblnk(size))//'  /'
	istatus=encode(bzstr,bscale,1,6,idum)
	hdr(6)='BSCALE  =    '//bzstr//' / PIX= FITS*BS + BZ'
c	hdr(6)='BSCALE  =       1.0000000000E0  /  PIX= FITS*BS + BZ'
c *** fix bzero
	istatus=encode(bzstr,bzero,1,6,idum)
	hdr(7)='BZERO   =    '//bzstr//' / PIX= FITS*BS + BZ'
	write(6,*) bzero,bzstr
	hdr(8)='OBJECT  = '''//objnam(1:20)//''''
	iah=8
c add other info 
	if (ipar.ne.0) then
	  if (exptime(nfr).gt.0..and.exptime(nfr).lt.1000000.) then
	    istatus=encode(tempstr,exptime(nfr),1,2,idum)
	    iah=iah+1
	    hdr(iah)='EXPTIME = '//tempstr//'  / exposure time'
	  end if
	  if (ccdgn(nfr).gt.0..and.ccdgn(nfr).lt.100.) then
	    istatus=encode(tempstr,ccdgn(nfr),1,2,idum)
	    iah=iah+1
	    hdr(iah)='GAIN    = '//tempstr//'  / Gain e/ADU'
	  if (pixscale(nfr).gt.0..and.pixscale(nfr).lt.10.) then
	    istatus=encode(tempstr,pixscale(nfr),1,2,idum)
	    iah=iah+1
	    hdr(iah)='PIXSCA  = '//tempstr//'  / arcsec per pix'
	  end if
	  end if
	  if (readnoise(nfr).gt.0..and.readnoise(nfr).lt.10000.) then
	    istatus=encode(tempstr,readnoise(nfr),1,2,idum)
	    iah=iah+1
	    hdr(iah)='RDNOISE = '//tempstr//'  / readnoise ADU '
	  end if
	  if (obsdate(nfr).ne.'') then
	    iah=iah+1
	    hdr(iah)='DATE-OBS= '//obsdate(nfr)//
     *                   '  / Date created/observed'
	  end if
	end if
	hdr(iah+1)='HISTORY = Saved from PPP '//fdate()
	hdr(iah+2)='END'
c fill the rest with blank
	do 100 i=iah+3,36
	  hdr(i)=' '
 100	continue
	return
	end
