C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CLEAN COSMIC RAYS USING TWO PICTURES AND A MAP OF COSMIC
C       RAY POSITIONS CREATED BY CRMAP AND CONA.
C       IT REPLACES WITH A SCALED PIXEL FROM REFERENCE WHENEVER THERE IS A 
C       NON-ZERO POINT IN THE COSMIC RAY MAP
C          IPAR = SWITCH FOR USING EXCLUSITON RADIUS FROM OBJECTS IN POS FILE.
C
	SUBROUTINE REPIX(*,NFR,NFR2,NMAP,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION SCALE(4,4),ISCALE(5),JSCALE(5),IT(200)
	CHARACTER NCOMC*36,ian*1,igrid*1,fitsname*24
	INCLUDE 'picdir.inc'
	include 'objcat.inc'
	COMMON/PICC/NCOMC(15),fitsname(15)
	CALL QUERYNFR(NFR,KF,5,*999,*20001)
20001	IF (IPAR.EQ.1) THEN
	  IF (NFR.GT.nposfil) THEN
	    WRITE(6,*) '   ***** NO POSITION FILE ALLOWED FOR FRAME ',
     *                 NFR
	    RETURN1
	  ELSE IF (NOB(NFR).EQ.0) THEN
	    WRITE(6,*) '  ??? Warning !!! ZERO object in position file'
	  END IF
	END IF
	IF (NFR2.EQ.0) THEN
 600	  WRITE(6,10)
 10	FORMAT('  Enter donating frame number: ',$)
	  call read1i(nfr2,*999,*600)
	END IF
	CALL QUERYNFR(NFR2,KF,5,*999,*20002)
20002	IF (NMAP.EQ.0) THEN
 601	  WRITE(6,11) nmap
 11	FORMAT('  Enter cosmic ray/BPFIX  map frame number [',i2,
     *        ']: ',$)
	  call read1i(nmap,*999,*601)
	END IF
	CALL QUERYNFR(NMAP,KF,5,*999,*20003)
20003	WRITE(6,12) 
 12	FORMAT('  Scaling: auto single(s)/grid(g)/entered scaling '
     *   ,'const(c)' /,' entered y linear scaling (y)/auto add const(a)'
     *    ,' /add entered const(e)/: ',$)
	call readstr(1,igrid,*999,*20003)
 1	FORMAT(A1)
6011	WRITE(6,35) NFR,NFR2,NFR,NFR2,NFR,id,jd
 35	FORMAT('  Pixel replacement: Frame',I2,' will be altered.'/
     *  '  Enter INTEGER shift (in I,J) of reference frame',I2,
     *         ' from frame',I2,/
     *	'   i.e., SHIFT = co-ord of',I2,' - co-ord of',I2,' [',2i4,
     *     ']: ',$)
	call read2i(id,jd,*999,*6011)
	IF (IPAR.EQ.1) THEN
 602	  WRITE(6,19) idia
 19	FORMAT('   Enter DIAMETER (INT) of exclusion from objects [',
     *         i4,']: ',$)
	  call read1i(idia,*999,*602)
	  IF (IDIA.LT.1.OR.IDIA.GT.200) THEN
	    WRITE(6,*) '  **** ILLEGAL DIAMETER: too large or <=0 ****'
	    GO TO 602
	  END IF
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	IF (ID.GE.NI.OR.JD.GE.NJ) RETURN1
C   Calcultes a 4 by 4 grid of mode values for local scaling
	ISCALE(1)=1
	JSCALE(1)=1
	IF (IGRID.EQ.'g') THEN
C   grid number: at least 2, max 4, divided to nearest 100 pixel
	   NGR2=MAX0(2,MIN0(4,MAX0(NJJ(NFR),NII(NFR))/100+1))
	   IGSIZE2=MAX0(NII(NFR),NJJ(NFR))/NGR2
	   NGR1=MIN0(NII(NFR),NJJ(NFR))/IGSIZE2+1
	   IGSIZE1=MIN0(NII(NFR),NJJ(NFR))/NGR1
	   IF (NII(NFR).GT.NJJ(NFR)) THEN
	     ITE=NGR1
	     NGR1=NGR2
	     NGR2=ITE
	     ITE=IGSIZE1
	     IGSIZE1=IGSIZE2
	     IGSIZE2=ITE
	   END IF
	   ISCALE(NGR1+1)=NII(NFR)
	   DO 100 I=2,NGR1
 100	     ISCALE(I)=ISCALE(I-1)+IGSIZE1 
	   JSCALE(NGR2+1)=NJJ(NFR)
	   DO 101 I=2,NGR2
 101	     JSCALE(I)=JSCALE(I-1)+IGSIZE2	
	WRITE(6,*) ISCALE
	WRITE(6,*) JSCALE
C
C   calculate grid vales: 9 ROWS WITHIN GRID ARE USED, THE MEDIAN IS TAKEN
C                        AS THE ANSWER
	   DO 102 J=1,NGR2
	     DO 1021 I=1,NGR1
	       CALL STRIPSKY(NFR,ISCALE(I),JSCALE(J),ISCALE(I+1),
     *                      JSCALE(J+1),9,SCALE(I,J),SIG,1,IX,NU,NV,KF)
 	       CALL STRIPSKY(NFR2,ISCALE(I),JSCALE(J),ISCALE(I+1),
     *                      JSCALE(J+1),9,TSCALE,SIG,1,IX,NU,NV,KF)
	       IF (TSCALE.NE.0.0) THEN
	         SCALE(I,J)=SCALE(I,J)/TSCALE
	       ELSE
	         SCALE(I,J)=1.
	       END IF
1021	    CONTINUE
	    WRITE(6,*) (SCALE(K,J),K=1,NGR1)
102	  CONTINUE
	ELSE IF (IGRID.eq.'s'.or.igrid.eq.'a') THEN
C  A single ratio between the two pictues are used
	  CALL STRIPSKY(NFR,1,1,NII(NFR),NJJ(NFR),7,SCALE(1,1),SIG,1,
     *               IX,NU,NV,KF)
	  CALL STRIPSKY(NFR2,1,1,NII(NFR),NJJ(NFR),7,TSCALE,SIG,1,
     *               IX,NU,NV,KF)
	  if (igrid.eq.'s') then
	    NGR1=1
	    NGR2=1
	    ISCALE(2)=NII(NFR)
	    JSCALE(2)=NJJ(NFR)
	    IF (TSCALE.NE.0.0) THEN
	      SCALE(1,1)=SCALE(1,1)/TSCALE
	    ELSE
	      SCALE(1,1)=1.
	    END IF
	    WRITE(6,*) '  Scaling constant = ',SCALE(1,1)
	  else
	    iconst=nint(scale(1,1)-tscale)
	    write(6,*) ' constant correction to 2: ',iconst
	  end if
	ELSE IF (IGRID.EQ.'c') THEN
	  NGR1=1
	  NGR2=1
	  ISCALE(2)=NII(NFR)
	  JSCALE(2)=NJJ(NFR)
 690	  WRITE(6,5) DRSCALE
 5	FORMAT('   Enter scaling constant (receiving/donating) [',
     *      F6.3,']: ',$)
	  CALL READ1R(DRSCALE,*999,*690)
	  SCALE(1,1)=DRSCALE
	else if (igrid.eq.'e') then
 691	  write(6,21) iconst
 21	format('  Enter additive constant to donating frame [',i5,']: '
     *         ,$)
	  call read1i(iconst,*999,*691)
	else if (igrid.eq.'y') then
 692	  write(6,22) y1,y2
 22	format('  Enter scaling at y=1 and y=njj [',2f7.2,']: ',$)
	  call read2r(y1,y2,*999,*692)
	END IF
	nfl(6,nfr)=1
	NF1=0
C  create map of object exclusion by turning the map bits to negative
C  these numbers are returned to positive at the end of the routine
	IF (IPAR.EQ.1) THEN
	  CALL APARAY(IDIA,IT,IROW,DUM1,DUM2,DUM3,NCP,0)
	  DO 251 K=1,NOB(NMAP)
	    KK=0
	    DO 252 L=MAX0(1,IJOJ(K,NMAP)-IROW),
     *                    MIN0(NJJ(NMAP),IJOJ(K,NMAP)+IROW)
	      KK=KK+1
	      KAP=IT(KK)/2
	      DO 252 M=MAX0(1,IJOI(K,NMAP)-KAP),
     *                      MIN0(NII(NMAP),IJOI(K,NMAP)+KAP) 
	        IF (IX(M,L,NMAP).GT.0) IX(M,L,NMAP)=-IX(M,L,NMAP)
 252	    CONTINUE
 251	  CONTINUE
	END IF	
C  begin cosmic ray locating
c  case 1 for scaling the data
	if (igrid.ne.'a'.and.igrid.ne.'e') then
	  if (igrid.eq.'y') then
	    dy=y2-y1
	    size=float(njj(nfr2)-1)
	    DO 211 J=1,NJ
	      J2=J+JD
	      IF (J2.LT.1.OR.J2.GT.NJ) GO TO 211
	      DO 212 I=1,NI
	        I2=I+ID
	        IF (I2.LT.1.OR.I2.GT.NI) GO TO 212
C  check cosmic ray map
	        IF (IX(I,J,NMAP).GT.0) THEN
C swap
	          IXX=(y1+dy*(float(j2-1)/size))*IX(I2,J2,NFR2)
	          IX(I,J,NFR)=INTLIMI(IXX)
	          NF1=NF1+1
	        END IF
 212	      continue
 211	    CONTINUE
	  else 
	    DO 201 J=1,NJ
	      J2=J+JD
	      IF (J2.LT.1.OR.J2.GT.NJ) GO TO 201
	      DO 209 I=1,NI
	        I2=I+ID
	        IF (I2.LT.1.OR.I2.GT.NI) GO TO 209
C  check cosmic ray map
	        IF (IX(I,J,NMAP).GT.0) THEN
	          DO 202 L=2,NGR2+1
	            IF (I.LE.ISCALE(L)) GO TO 203
 202	          CONTINUE
	          L=L-1
 203	          L=L-1
C	    this IS correct !!!
	          DO 204 M=2,NGR1+1
	            IF (J.LE.JSCALE(M)) GO TO 205
 204	          CONTINUE
	          M=M-1
 205	          M=M-1
C swap
                  IXX=SCALE(L,M)*IX(I2,J2,NFR2)
                  IX(I,J,NFR)=INTLIMI(IXX)
	          NF1=NF1+1
	        END IF
 209	      continue
 201	    CONTINUE
	  end if
	else
c case 2 add constant before swapping
	  do 300 j=1,nj
	    J2=J+JD
	    IF (J2.LT.1.OR.J2.GT.NJ) GO TO 300
	    do 301 i=1,ni
	      I2=I+ID
	      IF (I2.LT.1.OR.I2.GT.NI) GO TO 301
	      if (ix(i,j,nmap).gt.0) then
	        ix(i,j,nfr)=intlimi(ix(i2,j2,nfr2)+iconst)
	        nf1=nf1+1
	      end if
 301	    continue
 300	  continue
	end if
	WRITE(6,13) NF1,NFR,NFR2
 13	FORMAT(3X,'--- ',I8,' pixels in frame ',I1,' replaced from ',I1)
	IF (IPAR.EQ.1) THEN
 603	  WRITE(6,14) 
 14	FORMAT('  Do you want to restore the cosmic ray map? (y/n): ',$)
	  call readstr(1,ian,*999,*603)
	  IF (IAN.EQ.'y') THEN
	    DO 261 K=1,NOB(NMAP)
	      KK=0
	      DO 262 L=MAX0(1,IJOJ(K,NMAP)-IROW),
     *                    MIN0(NJJ(NMAP),IJOJ(K,NMAP)+IROW)
	        KK=KK+1
	        KAP=IT(KK)/2
	        DO 262 M=MAX0(1,IJOI(K,NMAP)-KAP),
     *                      MIN0(NII(NMAP),IJOI(K,NMAP)+KAP) 
	          IF (IX(M,L,NMAP).LT.0) IX(M,L,NMAP)=-IX(M,L,NMAP)
 262	      CONTINUE
 261	    CONTINUE
	  END IF
	END IF	
 999	RETURN1
	END
C///////////////////////////////////////////////////////////////////////
C
c   pixel replacement subroutine: this changes the bad pixel map into
c     pixels to be replaced by using a donating frame and a ratio frame.
c     The replacement frame is then applied to the image using another
c     subroutine. (This is done this way so that only 3 frames at any
c     one time is needed.
c        The ratioing map is such that 100=ratio of 1, the pixels from
c        the donating frame is multiplied by ratio/100 of the ratioing frame
c        The ratio is formed by using the median of pixels in a box 
c         (computed with rejection algorithm), excluding pixels that are
c         marked as bad pixels.
C
	subroutine ratrepix(*,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION array(500),index(500),it(200)
	CHARACTER NCOMC*36,fitsname*24 
	INCLUDE 'picdir.inc'
	include 'objcat.inc'
	COMMON/PICC/NCOMC(15),fitsname(15)
	IF (IPAR.EQ.1) THEN
	  IF (NFR.GT.nposfil) THEN
	    WRITE(6,*) '   ***** NO POSITION FILE ALLOWED FOR FRAME ',
     *                 NFR
	    RETURN1
	  ELSE IF (NOB(NFR).EQ.0) THEN
	    WRITE(6,*) '  ??? Warning !!! ZERO object in position file'
	  END IF
	END IF
 600	WRITE(6,10) nfrd,nfrr
 10	FORMAT('  Enter donating and ratioing frame number [',2i3,']: ',$)
	call read2i(nfrd,nfrr,*999,*600)
	CALL QUERYNFR(nfrd,KF,5,*999,*20001)
20001	CALL QUERYNFR(nfrr,KF,5,*999,*601)
 601	WRITE(6,11) nmap
 11	FORMAT('  Enter mask frame number [',i2,']: ',$)
	call read1i(nmap,*999,*601)
	CALL QUERYNFR(NMAP,KF,5,*999,*20003)
20003	write(6,*) ' +++ mask map will be written over with replacement',
     *      ' pixel values +++'
 603	write(6,8) isiz,jsiz
 8	format('  Enter box size in I and J (must be odd) [',2i4,']: ',$)
	call read2i(isiz,jsiz,*999,*603)
	if (isiz*jsiz.gt.500) then
	  write(6,*) '  Box size too large, must be <500 pixels'
	  goto 603
	end if
	isizh=0.5*isiz
	jsizh=0.5*jsiz
	NI=NII(nfrd)
	NJ=NJJ(nfrd)
	IF (IPAR.EQ.1) THEN
 602	  WRITE(6,19) idia
 19	FORMAT('   Enter DIAMETER (INT) of exclusion from objects [',
     *         i4,']: ',$)
	  call read1i(idia,*999,*602)
	  IF (IDIA.LT.1.OR.IDIA.GT.200) THEN
	    WRITE(6,*) '  **** ILLEGAL DIAMETER: too large or <=0 ****'
	    GO TO 602
	  END IF
C  create map of object exclusion by turning the map bits to negative
C  these numbers are returned to positive at the end of the routine
	  CALL APARAY(IDIA,IT,IROW,DUM1,DUM2,DUM3,NCP,0)
	  DO 251 K=1,NOB(NMAP)
	    KK=0
	    DO 252 L=MAX0(1,IJOJ(K,NMAP)-IROW),
     *                    MIN0(NJJ(NMAP),IJOJ(K,NMAP)+IROW)
	      KK=KK+1
	      KAP=IT(KK)/2
	      DO 252 M=MAX0(1,IJOI(K,NMAP)-KAP),
     *                      MIN0(NII(NMAP),IJOI(K,NMAP)+KAP) 
	        IF (IX(M,L,NMAP).GT.0) IX(M,L,NMAP)=-1000
 252	    CONTINUE
 251	  CONTINUE
	END IF	
C  begin cosmic ray locating
	do 100 j=1,nj
	  do 101 i=1,ni
	    if (ix(i,j,nmap).gt.0) then
c  it is a bad pixel
c     compute scaling ratio, first form array of ratio
	      npt=0
	      do 110 n=-jsizh,jsizh
	        jj=j+n
	        if (jj.lt.1.or.jj.gt.nj) go to 110
	        do 111 m=-isizh,isizh
	          ii=i+m
	          if (ii.lt.1.or.ii.gt.ni) go to 111
	          if (ix(ii,jj,nmap).gt.0) go to 111
c point is to be used
	          npt=npt+1
	          array(npt)=ix(ii,jj,nfrr)
 111	        continue
 110	      continue
c  compute ratio by median
	      if (npt.gt.3) then
	        call mememo(array,npt,nret,index,rmean,rmed,rmod,sig)
	        rmed=rmed*.01
	      else
	        rmed=1.
	      end if
c  save replacement pixel in map
	      ix(i,j,nmap)=intlimr(rmed*ix(i,j,nfrd))
	    end if
 101	  continue
 100	continue
	nfl(6,nmap)=1
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CLEAN COSMIC RAYS USING TWO PICTURES
C       THRES = THRESHOLD IN SIGMA OF SKY FOR WHICH PIXELS
C       WILL BE "CLEANED"
C
	SUBROUTINE CLCOSA(*,NFR1,NFR2,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER NOPER*1,STRING*60,NCOMC*36,strbox*60,isky*1,
     *        fitsname*24
	INCLUDE 'picdir.inc'
	COMMON/PICC/NCOMC(15),fitsname(15)
	DATA NOPER/'+'/
	CALL QUERYNFR(NFR1,KF,1,*999,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*999,*20002)
20002	NI=NII(NFR1)
	NJ=NJJ(NFR1)
	write(6,2) nfr1,nfr2
 2	format('  Creating cosmic ray map for frame ',i2,' based on'
     *      ,' comparison with frame ',i2,'.')
 690	WRITE(6,30) nres1
 30	FORMAT('  Enter frame # for storing map [df:',i3,
     *          ']: ',$)
	call read1i(nres1,*999,*690)
 6901	WRITE(6,35) NFR2,NFR1,NFR2,NFR1,id,jd
 35	FORMAT('  Enter INTEGER shift (in I,J) of frame',I2,
     *         ' from frame',I2,/
     *	'   i.e., SHIFT = fr ',I2,' - fr ',I2,' [',2i4,']: ',$)
	call read2i(id,jd,*999,*6901)
	IF (ID.GE.NI.OR.JD.GE.NJ) go to 6901
 6902	write(6,36)
 36	format('  Method for sky and sig (b/box,s=dflt/strip,n=none): '
     *         ,$)
	read(5,'(a1)',end=999) isky
c  old way to do sky
	if (isky.eq.'b') then
	K1=NI/3-100
	K2=K1+200
	K3=NJ/3-100
	K4=K3+200
	CALL PSTAT(*110,NFR1,K1,K3,K2,K4,RMODE1,SIG1,NDUM,1,IX,NU,NV,KF)
 110	CALL PSTAT(*109,NFR2,K1,K3,K2,K4,RMODE2,SIG2,NDUM,1,IX,NU,NV,KF)
	else if (isky.ne.'n') then
C
C    sky for each frame
	CALL STRIPSKY(NFR1,1,1,NII(NFR1),NJJ(NFR1),7,RMODE1,SIG1,1,
     *                IX,NU,NV,KF)
	CALL STRIPSKY(NFR2,1,1,NII(NFR2),NJJ(NFR2),7,RMODE2,SIG2,1,
     *                IX,NU,NV,KF)
	end if
 109	if (thres.le.0.00001) thres=1.
 691	write(6,1) thres
 1	format('  Enter threshold in units of sigma [',f5.2,']: ',$)
	call read1r(thres,*999,*691)
	if (isky.ne.'n') then
 	  CONST=RMODE2-RMODE1
	else
	  const=0.
	end if
	iconst=nint(const)
    	WRITE(6,190) NFR1,NFR2,const
 190	FORMAT('   Frame ',I2,' is matched to frame ',I2,' by adding ',
     *     f6.1)
	strbox=' '
	string=' '
	rmode1=rmode1+iconst
	write(6,*) ' new mode for frame ',nfr1,rmode1,
     *     ' (image not changed)'
 1111	RAT=RMODE1/RMODE2
	SIGF1=SIG1/RMODE1
	SIGF2=SIG2/RMODE2
c	THRES=1.
	SIGT=SQRT(SIGF1*SIGF1+SIGF2*SIGF2)
	RATU=RAT+SIGT*THRES
	RATL=RAT-SIGT*THRES
	RATU2=RAT+SIGT*THRES*3.
	RATL1=RAT-SIGT*THRES*3.
	WRITE(6,*) ' upper and lower acceptable ratios ',RATU,RATL
	IB1U=RMODE1+THRES*SIG1
	IB1L=RMODE1-THRES*SIG1
	IB2U=RMODE2+THRES*SIG2
	IB2L=RMODE2-THRES*SIG2
	WRITE(6,*) ' upper and lower background for 1 ', IB1U,IB1L
	WRITE(6,*) ' upper and lower background for 2 ', IB2U,IB2L
C  initialize new frame
	NII(NRES1)=NII(NFR1)
	NJJ(NRES1)=NJJ(NFR1)
	nfl(6,nres1)=1
c	NII(NRES2)=NII(NFR2)
c	NJJ(NRES2)=NJJ(NFR2)
	NCOMC(NRES1)='Cosmic rays from '//NCOMC(NFR1)(1:18)
c	NCOMC(NRES2)='Cosmic rays from '//NCOMC(NFR2)(1:18)
	DO 111 J=1,NJ
	  DO 111 I=1,NI
 111	    IX(I,J,NRES1)=0
c	DO 112 J=1,NJ
c	  DO 112 I=1,NI
c 112	    IX(I,J,NRES2)=0
	NF1=0
	NF2=0
C  begin cosmic ray locating
	DO 101 J=1,NJ
	  J2=J+JD
	  IF (J2.LT.1.OR.J2.GT.NJ) GO TO 101
	  DO 105 I=1,NI
c  first check the ratio of the pixel to each another
c  ratio= ratio of actual pixels 1/2
c  rat= expected ratio, based on background  of mode 1/mode2
c  ratu/ratl=upper and lower bound of acceptable ratio of 2 pixels
c  sigt= quadractic mean of sig/mode of the 2 frame
	    I2=I+ID
	    IF (I2.LT.1.OR.I2.GT.NI) GO TO 105
	    IX1=IX(I,J,NFR1)+iconst
	    IX2=IX(I2,J2,NFR2)
	    IF (IX2.LE.0) IX2=1
	    RATIO=FLOAT(IX1)/FLOAT(IX2)
	    SIGRAT=ABS(RATIO-RAT)/SIGT
	    IF (RATIO.LT.RATU.AND.RATIO.GT.RATL) GO TO 105
c  one of the pixel is outside of expected range
C
C	DETERMINE WHICH PICTURE HAS THE LIKELY BOGUS PIXEL
C
C	CASE 1: ONE OF THE PIXEL IS WITHIN THE EXPECTED BACKGROUND
C               RANGE, then the other is the bad pixel	
	  IBP1=1
	  IBP2=1
C  IBP =1 if the pixel is outside the expected range, 0 if within
	  IF (IX1.LT.IB1U.AND.IX1.GT.IB1L) IBP1=0	
	  IF (IX2.LT.IB2U.AND.IX2.GT.IB2L) IBP2=0	
	  IF (IBP1.EQ.IBP2) GO TO 130
	  IF (IBP1.NE.0) THEN
	    IX(I,J,NRES1)=max0(1,nint(SIGRAT))
	    NF1=NF1+1
	  ELSE
c	    IX(I2,J2,NRES2)=SIGRAT
c	    IX(I2,J2,NRES2)=max0(1,nint(SIGRAT))
	    NF2=NF2+1
	  END IF
	  GO TO 105
C	
C	CASE 2: BOTH PIXELS ARE ABOVE THE EXPECTED RANGE
C	        ASSUME THE HIGH ONE IS THE BOGUS PIXEL
C               AFTER TESTING WITH A LOOSER TEST
C	! both are within range, no action taken
 130	  IF (IBP1.EQ.0) then
	    n3rej=n3rej+1
	    GO TO 105
	  end if
	  IF (IX1.LT.IB1L.AND.IX2.LT.IB2L) GO TO 132
CCCCC	          ///IF (RATIO.LT.RATU2.AND.RATIO.GT.RATL2) GO TO 105
	  IF (IX1.LE.IX2) THEN
c	    IX(I2,J2,NRES2)=max0(1,nint(SIGRAT))
	    NF2=NF2+1
	  ELSE
	    IX(I,J,NRES1)=max0(1,nint(SIGRAT))
	    NF1=NF1+1
	  END IF
	  GO TO 105
C
C	CASE 3: BOTH PIXELS ARE BELOW RANGE, ASSUME THE LOW ONE IS BOGUS
C
 132	  IF (IX1.GE.IB1L) THEN
c	    IX(I2,J2,NRES2)=max0(1,nint(SIGRAT))
	    NF2=NF2+1
	  ELSE
	    IX(I,J,NRES1)=max0(1,nint(SIGRAT))
	    NF1=NF1+1
	  END IF
 105	  continue
 101	CONTINUE
	WRITE(6,15) NF1,NFR1,thres
c	WRITE(6,15) NF2,NFR2
 15	FORMAT(' ',I8,' pixels from frame',I2,' >',f4.2,
     *            ' sigma above')
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CLEAN COSMIC RAYS USING TWO PICTURES
C       THRES = THRESHOLD IN SIGMA OF SKY FOR WHICH PIXELS
C       WILL BE "CLEANED"
C
c  modified  Oct 24 1996, to use local sky
c  modified Jan 04, 2007, allow the use of a predefined box (1)
c                  to compute sky stats
c    The program first check for deviant pixels using global
c         sky, the deviant pixels are then checked more
c         carefully using local sky with box size isb X jsb
	SUBROUTINE CLCOSB(*,NFR1,NFR2,isb,jsb,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER NOPER*1,STRING*60,NCOMC*36,strbox*60,isky*2,
     *        fitsname*24
	dimension array1(1600), array2(1600)
	INCLUDE 'picdir.inc'
	COMMON/PICC/NCOMC(15),fitsname(15)
	COMMON/BOX/IBOX(4,10),NBOX
	DATA NOPER/'+'/
	CALL QUERYNFR(NFR1,KF,1,*999,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*999,*20002)
20002	NI=NII(NFR1)
	NJ=NJJ(NFR1)
	write(6,2) nfr1,nfr2
 2	format('  Creating cosmic ray map for frame ',i2,' based on'
     *      ,' comparison with frame ',i2,'.')
 690	WRITE(6,30) nres1
 30	FORMAT('  Enter frame # for storing map [df:',i3,
     *          ']: ',$)
	call read1i(nres1,*999,*690)
 6901	WRITE(6,35) NFR2,NFR1,NFR2,NFR1,id,jd
 35	FORMAT('  Enter INTEGER shift (in I,J) of frame',I2,
     *         ' from frame',I2,/
     *	'   i.e., SHIFT = fr ',I2,' - fr ',I2,' [',2i4,']: ',$)
	call read2i(id,jd,*999,*6901)
	IF (ID.GE.NI.OR.JD.GE.NJ) go to 6901
 6902	write(6,36)
 36	format('  Method for sky and sig: (cn,sn,bn=no auto bk cor)'/
     *   ' (c=central box,s=dflt/row strip,b=box 1): ',$)
	read(5,'(a2)',end=999) isky
c  old way to do sky
	if (isky(1:1).eq.'c') then
	  K1=NI/3-100
	  K2=K1+200
	  K3=NJ/3-100
	  K4=K3+200
	CALL PSTAT(*110,NFR1,K1,K3,K2,K4,RMODE1,SIG1,NDUM,1,IX,NU,NV,KF)
 110	CALL PSTAT(*109,NFR2,K1,K3,K2,K4,RMODE2,SIG2,NDUM,1,IX,NU,NV,KF)
	else if (isky(1:1).eq.'b') then
c  use predefined box 1, if box 1 has not been defined, use center
	  if (nbox.eq.1) then
	    K1=ibox(1,1)
	    K2=ibox(2,1)
	    K3=ibox(3,1)
	    K4=ibox(4,1)
	  else
	    write(6,*) ' *** warning, box 1 not defined, using center'
	    K1=NI/3-100
	    K2=K1+200
	    K3=NJ/3-100
	    K4=K3+200
	  end if
	CALL PSTAT(*211,NFR1,K1,K3,K2,K4,RMODE1,SIG1,NDUM,1,IX,NU,NV,KF)
 211	CALL PSTAT(*109,NFR2,K1,K3,K2,K4,RMODE2,SIG2,NDUM,1,IX,NU,NV,KF)
	else
C using stipes of rows (columns?)
	CALL STRIPSKY(NFR1,1,1,NII(NFR1),NJJ(NFR1),7,RMODE1,SIG1,1,
     *                IX,NU,NV,KF)
	CALL STRIPSKY(NFR2,1,1,NII(NFR2),NJJ(NFR2),7,RMODE2,SIG2,1,
     *                IX,NU,NV,KF)
	end if
 109	if (thres.le.0.00001) thres=1.5
 691	write(6,1) thres
 1	format('  Enter threshold in units of sigma [',f5.2,']: ',$)
	call read1r(thres,*999,*691)
	if (isky(2:2).ne.'n') then
 	  CONST=RMODE2-RMODE1
	else
	  const=0.
	end if
	iconst=nint(const)
    	WRITE(6,190) NFR1,NFR2,const
 190	FORMAT('   Frame ',I2,' is matched to frame ',I2,' by adding ',
     *     f6.1)
	strbox=' '
	string=' '
	rmode1=rmode1+iconst
	write(6,*) ' new mode for frame ',nfr1,rmode1,
     *     ' (image not changed)'
 1111	RAT=RMODE1/RMODE2
	SIGF1=SIG1/RMODE1
	SIGF2=SIG2/RMODE2
c 	THRESG=amin1(0.5*thres,1.)
  	THRESG=0.5*thres
	SIGT=SQRT(SIGF1*SIGF1+SIGF2*SIGF2)
	RATU=RAT+SIGT*THRESG
	RATL=RAT-SIGT*THRESG
	WRITE(6,*) ' upper and lower acceptable ratios ',RATU,RATL
c the values below are not actually used
 	IB1UG=RMODE1+THRESG*SIG1
 	IB1LG=RMODE1-THRESG*SIG1
 	IB2UG=RMODE2+THRESG*SIG2
 	IB2LG=RMODE2-THRESG*SIG2
	WRITE(6,*) ' upper and lower background for 1 ', IB1UG,IB1LG
	WRITE(6,*) ' upper and lower background for 2 ', IB2UG,IB2LG
C  initialize new frame
	NII(NRES1)=NII(NFR1)
	NJJ(NRES1)=NJJ(NFR1)
	nfl(6,nres1)=1
	NCOMC(NRES1)='Cosmic rays from '//NCOMC(NFR1)(1:18)
	DO 111 J=1,NJ
	  DO 111 I=1,NI
 111	    IX(I,J,NRES1)=0
	NF1=0
	NF2=0
        ISBH=ISB/2
        JSBH=JSB/2
C  begin cosmic ray locating
	n1rej=0
	n2rej=0
	n3rej=0
	n4rej=0
	DO 101 J=1,NJ
	  J2=J+JD
	  IF (J2.LT.1.OR.J2.GT.NJ) GO TO 101
	  DO 105 I=1,NI
c  first check the ratio of the pixel to each another
c  ratio= ratio of actual pixels fr 1/ fr 2
c  rat= expected ratio, based on background  of mode 1/mode2
c  ratu/ratl=upper and lower bound of acceptable ratio of 2 pixels
c  sigt= quadractic mean of sig/mode of the 2 frames
	    I2=I+ID
	    IF (I2.LT.1.OR.I2.GT.NI) GO TO 105
	    IX1=IX(I,J,NFR1)+iconst
	    IX2=IX(I2,J2,NFR2)
	    IF (IX2.LE.0) IX2=1
c  add April 15 1997: if both pixels are below lower bg limit, don''t
c     bother
c  this is commented out, no longer used
c	    if (ix1.lt.ib1lg.and.ix2.lt.ib2lg) goto 105
	    RATIO=FLOAT(IX1)/FLOAT(IX2)
c	    SIGRAT=ABS(RATIO-RAT)/SIGT
c  first cut to limit the number of pixels checked
	    IF (RATIO.LT.RATU.AND.RATIO.GT.RATL) then
	      n1rej=n1rej+1
	      GO TO 105
	    end if
c compute local sky and sig
C   make array of pixels to determine local background and sigma
            K=0
            DO 181 M=MAX0(1,J-JSBH),MIN0(J+JSBH,NJJ(NFR1))
              DO 181 L=MAX0(1,I-ISBH),MIN0(I+ISBH,NII(NFR1))
                IF (M.NE.J.OR.L.NE.I) THEN
                  K=K+1
                  ARRAY1(K)=IX(L,M,NFR1)
                END IF
 181        CONTINUE
	    CALL MMM(ARRAY1,K,NZ3,ZMEAN1,ZMED1,ZMODE1,ZSIG1,
     *              ZSK,ZREJ,NIT,1.,ZM1)
	    k=0
            DO 182 M=MAX0(1,J2-JSBH),MIN0(J2+JSBH,NJJ(NFR2))
              DO 182 L=MAX0(1,I2-ISBH),MIN0(I2+ISBH,NII(NFR2))
                IF (M.NE.J2.OR.L.NE.I2) THEN
                  K=K+1
                  ARRAY2(K)=IX(L,M,NFR2)
                END IF
 182        CONTINUE
	    CALL MMM(ARRAY2,K,NZ3,ZMEAN2,ZMED2,ZMODE2,ZSIG2,
     *              ZSK,ZREJ,NIT,1.,ZM1)
c  check ratio of the pixels again; compare to local ratio
	    ratu2=(zmode1+thres*zsig1)/zmode2
	    ratl2=(zmode1-thres*zsig1)/zmode2
	    if (ratio.lt.ratu2.and.ratio.gt.ratl2) then
	      n2rej=n2rej+1
	      go to 105
	    end if
	    SIGRAT=ABS(RATIO-zmode1/zmode2)/(zsig1/zmode1)
c compute local background upper and lower acceptable boundry
 	    IB1U=zmode1+THRES*zsig1
 	    IB1L=zmode1-THRES*zsig1
 	    IB2U=zmode2+THRES*zsig2
 	    IB2L=zmode2-THRES*zsig2
c  one of the pixel is outside of expected range
C
C	DETERMINE WHICH PICTURE HAS THE LIKELY BOGUS PIXEL
C
C	CASE 1: ONE OF THE PIXEL IS WITHIN THE EXPECTED BACKGROUND
C               RANGE, then the other is the bad pixel	
	    IBP1=1
	    IBP2=1
C  IBP =1 if the pixel is outside the expected range, 0 if within
	    IF (IX1.LT.IB1U.AND.IX1.GT.IB1L) IBP1=0	
	    IF (IX2.LT.IB2U.AND.IX2.GT.IB2L) IBP2=0	
	    IF (IBP1.EQ.IBP2) GO TO 130
	    IF (IBP1.NE.0) THEN
	      IX(I,J,NRES1)=max0(1,nint(SIGRAT))
	      NF1=NF1+1
	    ELSE
c	      IX(I2,J2,NRES2)=SIGRAT
c	      IX(I2,J2,NRES2)=max0(1,nint(SIGRAT))
	      NF2=NF2+1
	    END IF
	    GO TO 105
C	
C	CASE 2: BOTH PIXELS ARE ABOVE THE EXPECTED RANGE
C	        ASSUME THE HIGH ONE IS THE BOGUS PIXEL
C               AFTER TESTING WITH A LOOSER TEST
C	! both are within range, no action taken
c130	    IF (IBP1.EQ.0) GO TO 101
 130	    IF (IBP1.EQ.0) then
	      n3rej=n3rej+1
	      GO TO 105
	    end if
c  what is this criterion?
	    IF (IX1.LT.IB1L.AND.IX2.LT.IB2L) then
	      n4rej=n4rej+1
	      GO TO 132
	    end if
C	          ///IF (RATIO.LT.RATU2.AND.RATIO.GT.RATL2) GO TO 105
	    IF (IX1.LE.IX2) THEN
c	    IX(I2,J2,NRES2)=max0(1,nint(SIGRAT))
	      NF2=NF2+1
	    ELSE
	      IX(I,J,NRES1)=max0(1,nint(SIGRAT))
	      NF1=NF1+1
	    END IF
	    GO TO 105
C
C	CASE 3: BOTH PIXELS ARE BELOW RANGE, ASSUME THE LOW ONE IS BOGUS
c             Apr 8 1997: modified to ignoring both pixels
C
c132	  IF (IX1.GE.IB1L) THEN
cc	    IX(I2,J2,NRES2)=max0(1,nint(SIGRAT))
c	    NF2=NF2+1
c	  ELSE
c	    IX(I,J,NRES1)=max0(1,nint(SIGRAT))
c	    NF1=NF1+1
c	  END IF
 132	  continue
 105      continue
 101	CONTINUE
	WRITE(6,15) NF1,NFR1,thres,n1rej,n2rej,n3rej,n4rej,nf2
 15	FORMAT(' ',I8,' pixels from frame',I2,' >',f5.2,
     *            ' sigma above'/
     *      i8,' pixels within global ratio; ',i8,' local;'/,
     *      i8,' within bk range;',i8,' n4rej:',i8,' f2 cr;')
	ntot=nf1++nf2+n1rej+n2rej+n3rej+n4rej
	write(6,*) '   total pixels examined: ',ntot
 999	RETURN1
	END

C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CLEAN COSMIC RAYS USING TWO PICTURES
C       THRES = THRESHOLD IN SIGMA OF SKY FOR WHICH PIXELS
C       WILL BE "CLEANED"
C  new version March 4, using local sky rms
C
	SUBROUTINE CLCOSC(*,NFR1,NFR2,isb,jsb,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER NOPER*1,STRING*60,NCOMC*36,strbox*60,isky*1,
     *     fitsname*24
	dimension array1(1600),array2(1600)
	INCLUDE 'picdir.inc'
	COMMON/PICC/NCOMC(15),fitsname(15)
	DATA NOPER/'+'/
	CALL QUERYNFR(NFR1,KF,1,*999,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*999,*20002)
20002	NI=NII(NFR1)
	NJ=NJJ(NFR1)
	write(6,2) nfr1,nfr2
 2	format('  Creating cosmic ray map for frame ',i2,' based on'
     *      ,' comparison with frame ',i2,'.')
 690	WRITE(6,30) nres1
 30	FORMAT('  Enter frame # for storing map [df:',i3,
     *          ']: ',$)
	call read1i(nres1,*999,*690)
 6901	WRITE(6,35) NFR2,NFR1,NFR2,NFR1,id,jd
 35	FORMAT('  Enter INTEGER shift (in I,J) of frame',I2,
     *         ' from frame',I2,/
     *	'   i.e., SHIFT = fr ',I2,' - fr ',I2,' [',2i4,']: ',$)
	call read2i(id,jd,*999,*6901)
	write(6,*) '  *Current version does not allow shifting...'
	if (id.ne.0.and.jd.ne.0) return1
	IF (ID.GE.NI.OR.JD.GE.NJ) go to 6901
 6902	write(6,36)
 36	format('  Method for sky and sig (b/box,s=dflt/strip): ',$)
	read(5,'(a1)',end=999) isky
c  old way to do sky
	if (isky.eq.'b') then
	  K1=NI/3-100
	  K2=K1+200
	  K3=NJ/3-100
	  K4=K3+200
	CALL PSTAT(*110,NFR1,K1,K3,K2,K4,RMODE1,SIG1,NDUM,1,IX,NU,NV,KF)
 110	CALL PSTAT(*109,NFR2,K1,K3,K2,K4,RMODE2,SIG2,NDUM,1,IX,NU,NV,KF)
	else
C
C    sky for each frame
	  CALL STRIPSKY(NFR1,1,1,NII(NFR1),NJJ(NFR1),7,RMODE1,SIG1,1,
     *                IX,NU,NV,KF)
	  CALL STRIPSKY(NFR2,1,1,NII(NFR2),NJJ(NFR2),7,RMODE2,SIG2,1,
     *                IX,NU,NV,KF)
	end if
 109	if (thres.le.0.00001) thres=1.
 691	write(6,1) thres
 1	format('  Enter threshold in units of sigma [',f5.2,']: ',$)
	call read1r(thres,*999,*691)
 	CONST=RMODE2-RMODE1
	iconst=nint(const)
    	WRITE(6,190) NFR1,NFR2,const
 190	FORMAT('   Frame ',I2,' is matched to frame ',I2,' by adding ',
     *     f6.1)
	strbox=' '
	string=' '
	rmode1=rmode1+iconst
	write(6,*) ' new mode for frame ',nfr1,rmode1,
     *     ' (image not changed)'
        IF (FLOAT(ISB*JSB).GT.1600) THEN
          WRITE(6,*) '  *** filter too large (max 1600 pixels) ***'
          return1
        END IF
        ISBH=ISB/2
        JSBH=JSB/2
C  initialize new frame
	NII(NRES1)=NII(NFR1)
	NJJ(NRES1)=NJJ(NFR1)
	nfl(6,nres1)=1
	NCOMC(NRES1)='Cosmic rays from '//NCOMC(NFR1)(1:18)
	DO 111 J=1,NJ
	  DO 111 I=1,NI
 111	    IX(I,J,NRES1)=0
	NF1=0
C  begin cosmic ray locating
	DO 101 J=1,NJ
	  J2=J+JD
	  IF (J2.LT.1.OR.J2.GT.NJ) GO TO 101
	  DO 105 I=1,NI
	    I2=I+ID
	    IF (I2.LT.1.OR.I2.GT.NI) GO TO 105
c   now determine local sky
C  
C   make array of pixels to determine local background and sigma
            K=0
            DO 181 M=MAX0(1,J-JSBH),MIN0(J+JSBH,NJJ(NFR1))
              DO 181 L=MAX0(1,I-ISBH),MIN0(I+ISBH,NII(NFR1))
                IF (M.NE.J.OR.L.NE.I) THEN
                  K=K+1
                  ARRAY1(K)=IX(L,M,NFR1)
                  ARRAY2(K)=IX(L,M,NFR2)
                END IF
 181        CONTINUE
            CALL MEDSIGR(ARRAY1,RMODE1,SIG1,K)
            CALL MEDSIGR(ARRAY2,RMODE2,SIG2,K)
 	    RAT=RMODE1/RMODE2
	    SIGF1=SIG1/RMODE1
c	    SIGF2=SIG2/RMODE2
c	    SIGT=thres*SQRT(SIGF1*SIGF1+SIGF2*SIGF2)
	    SIGT=thres*SIGF1
	    RATU=RAT+SIGT
	    RATL=RAT-SIGT
c	    RATU2=RAT+SIGT*THRES*3.
c	    RATL2=RAT-SIGT*THRES*3.
	    IB1U=RMODE1+THRES*SIG1
	    IB1L=RMODE1-THRES*SIG1
	    IB2U=RMODE2+THRES*SIG2
	    IB2L=RMODE2-THRES*SIG2
c  first check the ratio of the pixel to each another
c  ratio= ratio of actual pixels 1/2
c  rat= expected ratio, based on background  of mode 1/mode2
c  ratu/ratl=upper and lower bound of acceptable ratio of 2 pixels
c  sigt= quadractic mean of sig/mode of the 2 frame
	    IX1=IX(I,J,NFR1)+iconst
	    IX2=IX(I2,J2,NFR2)
	    IF (IX2.LE.0) IX2=1
	    RATIO=FLOAT(IX1)/FLOAT(IX2)
	    SIGRAT=ABS(RATIO-RAT)/SIGT
	    IF (RATIO.LT.RATU.AND.RATIO.GT.RATL) GO TO 105
c  one of the pixel is outside of expected range
C
C	DETERMINE WHICH PICTURE HAS THE LIKELY BOGUS PIXEL
C
C	CASE 1: ONE OF THE PIXEL IS WITHIN THE EXPECTED BACKGROUND
C               RANGE, then the other is the bad pixel	
	  IBP1=1
	  IBP2=1
C  IBP =1 if the pixel is outside the expected range, 0 if within
	  IF (IX1.LT.IB1U.AND.IX1.GT.IB1L) IBP1=0	
	  IF (IX2.LT.IB2U.AND.IX2.GT.IB2L) IBP2=0	
	  IF (IBP1.EQ.IBP2) GO TO 130
	  IF (IBP1.NE.0) THEN
	    IX(I,J,NRES1)=max0(1,nint(SIGRAT))
	    NF1=NF1+1
	  END IF
	  GO TO 105
C	
C	CASE 2: BOTH PIXELS ARE ABOVE THE EXPECTED RANGE
C	        ASSUME THE HIGH ONE IS THE BOGUS PIXEL
C               AFTER TESTING WITH A LOOSER TEST
C	! both are within range, no action taken
 130	  IF (IBP1.EQ.0) GO TO 105
	  IF (IX1.LT.IB1L.AND.IX2.LT.IB2L) GO TO 132
CCCCC	          ///IF (RATIO.LT.RATU2.AND.RATIO.GT.RATL2) GO TO 105
	  IF (IX1.GT.IX2) THEN
	    IX(I,J,NRES1)=max0(1,nint(SIGRAT))
	    NF1=NF1+1
	  END IF
	  GO TO 105
C
C	CASE 3: BOTH PIXELS ARE BELOW RANGE, ASSUME THE LOW ONE IS BOGUS
C
 132	  IF (IX1.LE.IB1L) THEN
	    IX(I,J,NRES1)=max0(1,nint(SIGRAT))
	    NF1=NF1+1
	  END IF
 105	  continue
 101	CONTINUE
	WRITE(6,15) NF1,NFR1,thres
 15	FORMAT(' ',I8,' pixels from frame',I2,' >',f4.2,
     *            ' sigma above')
 999	RETURN1
	END

C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO MAKE MAP OF CONNECTED PIXEL AREA WITH VALUE>=IXLIM
C    STARTING FROM SEEDS WITH VALUE>ISEED, WITH MIMUM SIZE OF NCON PIXELS
C      
	SUBROUTINE CONAREA(*,NFRA,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
c    *             ICONC(0:199999)
	INTEGER IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
     *             ICONC(0:199999)
	INTEGER NFRA(5)
	character ian*1
	INCLUDE 'pppcore.inc'
	COMMON/CONN/IPT,IPIX1,ITURN,MAXPIX,IMAX,JMAX,iptmax
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	EQUIVALENCE (ITC(0),iscr(1)),(JTC(0),iscr(200001))
     #              ,(ICONC(0),iscr(400001))
	NFR=NFRA(1)
	NRES=NFRA(2)
	iptmax=199999
	IF (IPAR.NE.0) THEN
	  IF (NFR.GT.6) THEN
	    WRITE(6,*) '  **** Position file must be <=6 ***'
	    RETURN1
	  END IF
	END IF
	ISEED=NFRA(3)
	IXLIM=NFRA(4)
	NCON=NFRA(5)
	CALL QUERYNFR(NFR,KF,5,*999,*20001)
20001	CALL QUERYNFR(NRES,KF,4,*999,*20002)
20002	CALL STRIPSKY(NFR,1,1,NII(NFR),NJJ(NFR),7,AVER,SIG,1,IX,NU,NV,KF)
	IF (ISEED.EQ.0) THEN
 600	  WRITE(6,10) iseed
 10	FORMAT('   Enter SEED value for finding connected area (df:',i3,
     *           ': ',$)
	  call read1i(iseed,*999,*600)
	END IF
	IF (IXLIM.EQ.0) THEN
 601	  WRITE(6,11) ixlim
 11	FORMAT('   Enter LIMITING value for connecting (df:',i5,'): ',$)
	  call read1i(ixlim,*999,*601)
	END IF
	IF (IXLIM.LE.INT(AVER).OR.ISEED.LE.INT(AVER)) THEN
	  WRITE(6,*) ' **** ILLEGAL LIMITS (<= average of background)**'
	  RETURN1
	ELSE IF (IXLIM.LT.INT(AVER+0.5*SIG).OR.ISEED.LE.INT(AVER+SIG)) 
     *          THEN
	  CALL RBELL(2)
 6021	  WRITE(6,19)
 19	FORMAT('  ### Warning: limiting values too close to background,'
     *        /,'    Do you want to continue? (y/n): ',$)
	  call readstr(1,ian,*999,*6021)
	  IF (IAN.NE.'y') RETURN1
	END IF
	IF (NCON.EQ.0) THEN
 602	  WRITE(6,12) ncon
 12	FORMAT('  Enter the minimum number of pixels needed for an area'
     *         ,/'    to be considered connected (df:',i3,'): ',$)
	  call read1i(ncon,*999,*602)
	END IF
	IF (IPAR.EQ.1) THEN
	  NFRA(3)=ISEED
	  NFRA(4)=IXLIM
	  NFRA(5)=NCON
	END IF
1	FORMAT(A1)
	NII(NRES)=NII(NFR)
	NJJ(NRES)=NJJ(NFR)
	nfl(6,nres)=1
	DO 100 J=1,NJJ(NRES)
	  DO 100 I=1,NII(NRES)
 100	    IX(I,J,NRES)=0
	K=0
	DO 101	J=1,NJJ(NRES)
	  DO 101 I=1,NII(NRES)
	    IF (IX(I,J,NRES).NE.1) THEN
	      IF (IX(I,J,NFR).GE.ISEED) THEN
C!  a seed is found
C	WRITE(6,*) 'SEED',I,J,IX(I,J,NFR)
	        IMAX=I
	        JMAX=J
	        MAXPIX=IX(I,J,NFR)
	        IX(I,J,NRES)=1
	        IPIX1=0
	        IPT=0
	        ITURN=0
	        ITC(0)=I
	        JTC(0)=J
	        CALL CONNECT(NFR,NRES,IXLIM,I,J,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
	        IF (IPT+1.LT.NCON) THEN
C  reset everything to 0
	          IX(ITC(0),JTC(0),NRES)=0
	          DO 112 NN=1,IPT
	            IF (IX(ITC(NN),JTC(NN),NRES).EQ.1) THEN
	              DO 113 JQ=MAX0(JTC(NN)-1,1),
     *                          MIN0(JTC(NN)+1,NJJ(NRES))
	                DO 113 IQ=MAX0(ITC(NN)-1,1),
     *                          MIN0(ITC(NN)+1,NII(NRES))
 113	                  IX(IQ,JQ,NRES)=0
	            END IF
 112	          CONTINUE
	        ELSE
	          IF (IPAR.EQ.0) THEN
	            K=K+1
	            WRITE(6,15) K,IMAX,JMAX,MAXPIX,IPT+1
 15	FORMAT('  area #',I4,' at',2I5,' peak:',I6,' No. of pixels:',I5)
	          ELSE
C  store in position file
	            NOB(NFR)=NOB(NFR)+1
	            IF (NOB(NFR).GT.3000) THEN
	              WRITE(6,*) '  ** >3000 OBJECTS, FILE OVERFLOW **'
	              RETURN1
	            END IF
	            IDOB(NOB(NFR),NFR)=MIN0(32676,IPT+1)
	            IJOI(NOB(NFR),NFR)=IMAX
	            IJOJ(NOB(NFR),NFR)=JMAX
	            WRITE(6,16) NOB(NFR),IJOI(NOB(NFR),NFR),IJOJ(NOB(NFR
     *              ),NFR),IX(IJOI(NOB(NFR),NFR),IJOJ(NOB(NFR),NFR),NFR)
     *              ,IPT+1
 16	FORMAT('  Obj#',I4,':   at ',2I5,' peak ',I6,'  size ',I5)
	          END IF
	        END IF
	      END IF
	    END IF
101	CONTINUE
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO MAKE MAP OF CONNECTED PIXEL AREA 
C    STARTING FROM SEEDS WITH a bad pix map as seeds
c       mask point >0 is not connected
C      
	subroutine conseed(*,NFRA,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
c    *          ICONC(0:199999)
	INTEGER IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
     *          ICONC(0:199999)
	dimension NFRA(5),zray(2000)
	INCLUDE 'pppcore.inc'
	COMMON/CONN/IPT,IPIX1,ITURN,MAXPIX,IMAX,JMAX,iptmax
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	include 'apert.inc'
	EQUIVALENCE (ITC(0),iscr(1)),(JTC(0),iscr(200001))
     #              ,(ICONC(0),iscr(400001)),(zray(1),iscr(900001))
	if (kf.le.3) then
	  write(6,*) ' *** Error -- must have 3 or more core frames ***'
	  return1
	end if
	NFR=NFRA(1)
	NRES=NFRA(2)
	if (nfseed.eq.0) NFSEED=NFRA(3)
	CALL QUERYNFR(NFR,KF,5,*999,*20001)
20001	CALL QUERYNFR(NRES,KF,4,*999,*20002)
20002	IF (nfra(3).EQ.0) THEN
 600	  WRITE(6,10) nfseed
 10	FORMAT('   Enter frame # with seeded pixel map: [',i2,']: ',$)
	  call read1i(nfseed,*999,*600)
	END IF
	CALL QUERYNFR(nfseed,KF,-1,*999,*20003)
20003	CALL STRIPSKY(NFR,1,1,NII(NFR),NJJ(NFR),7,AVER,SIG,1,IX,NU,NV,KF)
	if (sigmul.lt.0.001) sigmul=3.0
 601	WRITE(6,11) sigmul
 11	FORMAT('  Enter limiting sigma value for connecting [',f6.2,
     *    ']: ',$)
	call read1r(sigmul,*999,*601)
	if (ncon.eq.0) ncont=-150
 602	write(6,12) ncont
 12	format('  Enter maximum # (ncon) of pix in a single connected area'/
     *   '   (+:include only area >ncon, -:include only areas < -ncon ['
     *        ,i4,']: ',$)
	call read1i(ncont,*999,*602)
	iptmax=iabs(ncont)
	NII(NRES)=NII(NFR)
	NJJ(NRES)=NJJ(NFR)
	nfl(6,nres)=1
c  set frame nres to 0 and copy frame nfseed to scratch
	DO 100 J=1,NJJ(NRES)
	  DO 100 I=1,NII(NRES)
 	    IX(I,J,NRES)=0
 100	continue
C  make inner and outer circle for ring
	CALL APARAY(IOR,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
	CALL APARAY(IIR,IT1(1,1),IROW1(1),QDUM,RDUM,PDUM,NDUM,1)
	DO 101	J=1,NJJ(NRES)
	  DO 101 I=1,NII(NRES)
	    IF (IX(I,J,nfseed).ge.1.and.ix(i,j,nres).eq.0) THEN
C!  a seed is found, do not do if the final map array is already not 0
c   set all the other pts connected to this seed to 0
c	      call zeroseed(i,j,nii(nfr),njj(nfr),ix(1,1,kf),nu,nv)
c
c  initializing connection subroutine common block
	      IMAX=I
	      JMAX=J
 	      MAXPIX=IX(I,J,NFR)
	      IX(I,J,NRES)=1
	      IPIX1=0
	      IPT=0
	      ITURN=0
	      ITC(0)=I
	      JTC(0)=J
c  determine local sky and sigma
 	      CALL RCSKY(1,sky,SIG,1,I,J,nii(nfr),njj(nfr)
     *              ,IX(1,1,nfr),NU,NV,ZRAY,2000,nsky,0,IPR)
	      if (ipr.eq.999) return1
c compute threshold for connection
 	      ixlim=nint(sky+sigmul*sig)
 	      CALL CONNECT(NFR,NRES,IXLIM,I,J,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
c	      CALL CONNECTB(NFR,NRES,sigmul,I,J,IX,NU,NV,KF
c    *                       ,ITC,JTC,ICONC)
c	      IF (IPT+1.GT.NCON) THEN
c connected area is greater than ncon
	      if (ncont.eq.0) go to 101
	      if (ncont.ge.0.and.ipt+1.ge.iptmax) go to 101
	      if (ncont.lt.0.and.ipt.lt.iptmax) go to 101
C  reset everything to 0
	        IX(ITC(0),JTC(0),NRES)=0
	        DO 112 NN=1,IPT
	          IF (IX(ITC(NN),JTC(NN),NRES).EQ.1) THEN
	            DO 113 JQ=MAX0(JTC(NN)-1,1),
     *                        MIN0(JTC(NN)+1,NJJ(NRES))
	              DO 113 IQ=MAX0(ITC(NN)-1,1),
     *                        MIN0(ITC(NN)+1,NII(NRES))
 113	                IX(IQ,JQ,NRES)=0
	          END IF
 112	        CONTINUE
	    END IF
101	CONTINUE
c  copy the original seed map onto the connected map if ncont<0
	if (ncont.lt.0) then
	  do 200 j=1,njj(nres)
	    do 200 i=1,nii(nres)
	      if (ix(i,j,nfseed).ge.1) ix(i,j,nres)=1
 200	  continue
	end if
c  reset all points with seed<0 back to 0
	  do 201 j=1,njj(nres)
	    do 201 i=1,nii(nres)
	      if (ix(i,j,nfseed).lt.0) ix(i,j,nres)=0
 201	  continue
 999	RETURN1
	END
c//////////////////////////////////////////////////
c
	subroutine zeroseed(ii,jj,ni,nj,ix,nu,nv)
c	integer*2 ix(nu,nv)
	integer ix(nu,nv)
	integer nsi(100),nsj(100),nsi2(100),nsj2(100)
c  check each direction in i,j
	call find1s(ii,jj,nsi,nsj,n1s,ni,nj,ix,nu,nv)
	do 101 k=1,n1s
	  call find1s(nsi(k),nsj(k),nsi2,nsj2,n1s2,ni,nj,ix,nu,nv)
 101	continue
	return
	end
c/////////////////////////////////////////
c
	subroutine find1s(ii,jj,nsi,nsj,n1s,ni,nj,ix,nu,nv)
c	integer*2 ix(nu,nv)
	integer ix(nu,nv)
	integer nsi(100),nsj(100)
	n1s=0
	do 100 i=ii+1,ni
	  if (ix(i,jj).ge.1) then
	    n1s=n1s+1
	    if (n1s.gt.100) return
	    nsi(n1s)=i
	    nsj(n1s)=jj
	    ix(i,jj)=0
	  else
	    go to 101
	  end if
 100	continue
 101	do 102 i=ii-1,1,-1
	  if (ix(i,jj).ge.1) then
	    n1s=n1s+1
	    if (n1s.gt.100) return
	    nsi(n1s)=i
	    nsj(n1s)=jj
	    ix(i,jj)=0
	  else
	    go to 103
	  end if
 102	continue
 103	do 104 j=jj+1,nj
	  if (ix(ii,j).ge.1) then
	    n1s=n1s+1
	    if (n1s.gt.100) return
	    nsi(n1s)=ii
	    nsj(n1s)=j
	    ix(ii,j)=0
	  else
	    go to 105
	  end if
 104	continue
 105	do 106 j=jj-1,1,-1
	  if (ix(ii,j).ge.1) then
	    n1s=n1s+1
	    if (n1s.gt.100) return
	    nsi(n1s)=ii
	    nsj(n1s)=j
	    ix(ii,j)=0
	  else
	    return
	  end if
 106	continue
	return
	end
c////////////////////////////////////////////////////
c
c  subroutine to pad existing bad pixel map
c
	subroutine padmap(*,nfr,ix,nu,nv,kf,ipart)
c	integer*2 ix(nu,nv,kf)
	integer ix(nu,nv,kf)
	INCLUDE 'picdir.inc'
	call querynfr(nfr,KF,5,*999,*2000)
 2000	if (ipart.lt.0) then
 600	  write(6,1) ipar
 1	format('  Enter padding choice: 0=no corners, 1=corners [',
     *    i2,']: ',$)
	  call read1i(ipar,*999,*600)
	else
	  ipar=ipart
	end if
c see if the frame is likely a mask
c
	if (ipar.gt.0) then
	  do 100 j=2,njj(nfr)-1
	    do 100 i=2,nii(nfr)-1
	      if (ix(i,j,nfr).gt.0) then
c  a mask point has been found, no go around it and look for zeros
	        do 110 m=j-1,j+1
	          do 110 l=i-1,i+1
	            if (ix(l,m,nfr).eq.0) ix(l,m,nfr)=-1
  110	        continue
	      end if
 100	  continue
	else
	  do 101 j=2,njj(nfr)-1
	    do 101 i=2,nii(nfr)-1
	      if (ix(i,j,nfr).gt.0) then
	        do 111 m=j-1,j+1
	          if (ix(i,m,nfr).eq.0) ix(i,m,nfr)=-1
 111	        continue
	        do 112 l=i-1,i+1
	          if (ix(l,j,nfr).eq.0) ix(l,j,nfr)=-1
 112	        continue
	      end if
 101	  continue
	end if
c now turn all -1''s to 1
	npt=0
	do 102 j=1,njj(nfr)
	  do 102 i=1,nii(nfr)
	    if (ix(i,j,nfr).eq.-1) then
	      ix(i,j,nfr)=1
	      npt=npt+1
	    end if
 102	continue
	nfl(6,nfr)=1
	write(6,*) npt,' additional pixels marked' 
 999	return1
	end 
C
C////////////////////////////////////////////////////////////
C
C
	SUBROUTINE CONNECT(NFR,NRES,IXLIM,IC,JC,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
c	INTEGER*2 IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
c    *         ICONC(0:199999)
	INTEGER IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
     *         ICONC(0:199999)
	COMMON/CONN/IPT,IPIX1,ITURN,MAXPIX,IMAX,JMAX,iptmax
	INCLUDE 'picdir.inc'
	ITURN=ITURN+1
	IF (ITURN.GT.iptmax) RETURN
	ICONC(ITURN)=0
C	WRITE(6,*) ' INPUT CHECK',ITURN,IC,JC
	J1=MAX0(JC-1,1)
	I1=MAX0(IC-1,1)
	J2=MIN0(JC+1,NJJ(NFR))
	I2=MIN0(IC+1,NII(NFR))
C   explicit do loop to get around Fortran
	M=J1-1
 500	M=M+1
	IF (M.GT.J2) GO TO 502
	  L=I1-1
 501	  L=L+1
	  IF (L.GT.I2) GO TO 500
	    IF (IX(L,M,NRES).EQ.0) THEN
	      IF (IX(L,M,NFR).GE.IXLIM) THEN 
C	 total count
	        IPT=IPT+1
C index of storage of L,M
	        IPIX1=IPIX1+1
	        IF (IX(L,M,NFR).GT.MAXPIX) THEN
C	!  new peak
	          MAXPIX=IX(L,M,NFR)
	          IMAX=L
	          JMAX=M
	        END IF
C	! counts of ith turn
	        ICONC(ITURN)=ICONC(ITURN)+1
	        ITC(IPIX1)=L
	        JTC(IPIX1)=M
 	        IX(L,M,NRES)=1
	        CALL CONNECT1(NFR,NRES,IXLIM,L,M,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
C	! ITURN has been incremented by CALL
	        IPIX1=IPIX1-ICONC(ITURN)
C	! set ITURN back to current loop
	        ITURN=ITURN-1
C   recover the original running pxiel varialbles L, M and limits I2,J2
	        L=ITC(IPIX1)
	        M=JTC(IPIX1)
C	! ICONC(ITURN) of current loop
	        I2=ITC(IPIX1-ICONC(ITURN))
	        J2=JTC(IPIX1-ICONC(ITURN))
C	WRITE(6,*) ITURN,IPIX1,L,M,I2,J2,ICONC(ITURN+1)
	      END IF
	    END IF
	GO TO 501
 502	CONTINUE
	RETURN
	END	          
C
C////////////////////////////////////////////////////////////
C
c  subroutine connect, but with a variable limit based on
c    the latested connected pixel.
C
	SUBROUTINE CONNECTB(NFR,NRES,sigmul,IC,JC,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
c	INTEGER*2 IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
c    *         ICONC(0:199999)
	INTEGER IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
     *         ICONC(0:199999)
	COMMON/CONN/IPT,IPIX1,ITURN,MAXPIX,IMAX,JMAX,iptmax
	dimension zray(2000)
	INCLUDE 'picdir.inc'
	ITURN=ITURN+1
	IF (ITURN.GT.iptmax) RETURN
	ICONC(ITURN)=0
C	WRITE(6,*) ' INPUT CHECK',ITURN,IC,JC
	J1=MAX0(JC-1,1)
	I1=MAX0(IC-1,1)
	J2=MIN0(JC+1,NJJ(NFR))
	I2=MIN0(IC+1,NII(NFR))
C   explicit do loop to get around Fortran
	M=J1-1
 500	M=M+1
	IF (M.GT.J2) GO TO 502
	  L=I1-1
 501	  L=L+1
	  IF (L.GT.I2) GO TO 500
	    IF (IX(L,M,NRES).EQ.0) THEN
c  compute variable limit
	      CALL RCSKY(1,sky,SIG,1,I,J,nii(nfr),njj(nfr)
     *              ,IX(1,1,nfr),NU,NV,ZRAY,2000,nsky,0,IPR)
	      if (ipr.eq.999) return 
	      ixlim=nint(sky+sigmul*sig)
	      IF (IX(L,M,NFR).GE.IXLIM) THEN 
C	 total count
	        IPT=IPT+1
C index of storage of L,M
	        IPIX1=IPIX1+1
	        IF (IX(L,M,NFR).GT.MAXPIX) THEN
C	!  new peak
	          MAXPIX=IX(L,M,NFR)
	          IMAX=L
	          JMAX=M
	        END IF
C	! counts of ith turn
	        ICONC(ITURN)=ICONC(ITURN)+1
	        ITC(IPIX1)=L
	        JTC(IPIX1)=M
 	        IX(L,M,NRES)=1
	        CALL CONNECT1B(NFR,NRES,float(IXLIM),L,M,
     *                      IX,NU,NV,KF,ITC,JTC,ICONC)
C	! ITURN has been incremented by CALL
	        IPIX1=IPIX1-ICONC(ITURN)
C	! set ITURN back to current loop
	        ITURN=ITURN-1
C   recover the original running pxiel varialbles L, M and limits I2,J2
	        L=ITC(IPIX1)
	        M=JTC(IPIX1)
C	! ICONC(ITURN) of current loop
	        I2=ITC(IPIX1-ICONC(ITURN))
	        J2=JTC(IPIX1-ICONC(ITURN))
C	WRITE(6,*) ITURN,IPIX1,L,M,I2,J2,ICONC(ITURN+1)
	      END IF
	    END IF
	GO TO 501
 502	CONTINUE
	RETURN
	END	          

C
C////////////////////////////////////////////////////////////
C
C
	SUBROUTINE CONNECT1(NFR,NRES,IXLIM,IC,JC,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
c	INTEGER*2 IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
c    *            ICONC(0:199999)
	INTEGER IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
     *            ICONC(0:199999)
	COMMON/CONN/IPT,IPIX1,ITURN,MAXPIX,IMAX,JMAX,iptmax
	INCLUDE 'picdir.inc'
	ITURN=ITURN+1
	IF (ITURN.GT.iptmax) RETURN
	ICONC(ITURN)=0
C	WRITE(6,*) ' INPUT CHECK',ITURN,IC,JC
	J1=MAX0(JC-1,1)
	I1=MAX0(IC-1,1)
	J2=MIN0(JC+1,NJJ(NFR))
	I2=MIN0(IC+1,NII(NFR))
C   explicit do loop to get around Fortran
	M=J1-1
 500	M=M+1
	IF (M.GT.J2) GO TO 502
	  L=I1-1
 501	  L=L+1
	  IF (L.GT.I2) GO TO 500
	    IF (IX(L,M,NRES).EQ.0) THEN
	      IF (IX(L,M,NFR).GE.IXLIM) THEN 
C		! total count
	        IPT=IPT+1
C		! index of storage of L,M
	        IPIX1=IPIX1+1
	        IF (IX(L,M,NFR).GT.MAXPIX) THEN
C		!  new peak
	          MAXPIX=IX(L,M,NFR)
	          IMAX=L
	          JMAX=M
	        END IF
C		! counts of ith turn
	        ICONC(ITURN)=ICONC(ITURN)+1
	        ITC(IPIX1)=L
	        JTC(IPIX1)=M
 	        IX(L,M,NRES)=1
	        CALL CONNECT(NFR,NRES,IXLIM,L,M,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
C		! ITURN has been increment by CALL
	        IPIX1=IPIX1-ICONC(ITURN)
C		! set ITURN back to current loop
	        ITURN=ITURN-1
C   recover the original running pxiel varialbles L, M and limits I2,J2
	        L=ITC(IPIX1)
	        M=JTC(IPIX1)
C		! ICONC(ITURN) of current loop
	        I2=ITC(IPIX1-ICONC(ITURN))
	        J2=JTC(IPIX1-ICONC(ITURN))
C	WRITE(6,*) ITURN,IPIX1,L,M,I2,J2,ICONC(ITURN+1)
	      END IF
	    END IF
	GO TO 501
 502	CONTINUE
	RETURN
	END	          
C
C////////////////////////////////////////////////////////////
C
C
	SUBROUTINE CONNECT1B(NFR,NRES,siglim,IC,JC,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
c	INTEGER*2 IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
c    *            ICONC(0:199999)
	INTEGER IX(NU,NV,KF),ITC(0:199999),JTC(0:199999),
     *            ICONC(0:199999)
	COMMON/CONN/IPT,IPIX1,ITURN,MAXPIX,IMAX,JMAX,iptmax
	INCLUDE 'picdir.inc'
	dimension zray(2000)
	ITURN=ITURN+1
	IF (ITURN.GT.iptmax) RETURN
	ICONC(ITURN)=0
C	WRITE(6,*) ' INPUT CHECK',ITURN,IC,JC
	J1=MAX0(JC-1,1)
	I1=MAX0(IC-1,1)
	J2=MIN0(JC+1,NJJ(NFR))
	I2=MIN0(IC+1,NII(NFR))
C   explicit do loop to get around Fortran
	M=J1-1
 500	M=M+1
	IF (M.GT.J2) GO TO 502
	  L=I1-1
 501	  L=L+1
	  IF (L.GT.I2) GO TO 500
	    IF (IX(L,M,NRES).EQ.0) THEN
c  compute variable limit
	      CALL RCSKY(1,sky,SIG,1,I,J,nii(nfr),njj(nfr)
     *              ,IX(1,1,nfr),NU,NV,ZRAY,2000,nsky,0,IPR)
	      if (ipr.eq.999) return 
	      ixlim=nint(sky+sigmul*sig)
	      IF (IX(L,M,NFR).GE.IXLIM) THEN 
C		! total count
	        IPT=IPT+1
C		! index of storage of L,M
	        IPIX1=IPIX1+1
	        IF (IX(L,M,NFR).GT.MAXPIX) THEN
C		!  new peak
	          MAXPIX=IX(L,M,NFR)
	          IMAX=L
	          JMAX=M
	        END IF
C		! counts of ith turn
	        ICONC(ITURN)=ICONC(ITURN)+1
	        ITC(IPIX1)=L
	        JTC(IPIX1)=M
 	        IX(L,M,NRES)=1
	        CALL CONNECTB(NFR,NRES,siglim,L,M,IX,NU,NV,KF
     *                       ,ITC,JTC,ICONC)
C		! ITURN has been increment by CALL
	        IPIX1=IPIX1-ICONC(ITURN)
C		! set ITURN back to current loop
	        ITURN=ITURN-1
C   recover the original running pxiel varialbles L, M and limits I2,J2
	        L=ITC(IPIX1)
	        M=JTC(IPIX1)
C		! ICONC(ITURN) of current loop
	        I2=ITC(IPIX1-ICONC(ITURN))
	        J2=JTC(IPIX1-ICONC(ITURN))
C	WRITE(6,*) ITURN,IPIX1,L,M,I2,J2,ICONC(ITURN+1)
	      END IF
	    END IF
	GO TO 501
 502	CONTINUE
	RETURN
	END	          

C
C////////////////////////////////////////////////////////////
C
C
	SUBROUTINE DISCON(NRES,IC,JC,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	J1=MAX0(JC-1,1)
	I1=MAX0(IC-1,1)
	J2=MIN0(JC+1,NJJ(NRES))
	I2=MIN0(IC+1,NII(NRES))
	DO 200 M=J1,J2
	  DO 200 L=I1,I2
	    IF (IX(L,M,NRES).EQ.1) THEN
	      IX(L,M,NRES)=0
	      CALL DISCON1(NRES,L,M,IX,NU,NV,KF)
	    END IF
 200	CONTINUE
	RETURN
	END	          
C
C////////////////////////////////////////////////////////////
C
C
	SUBROUTINE DISCON1(NRES,IC,JC,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	J1=MAX0(JC-1,1)
	I1=MAX0(IC-1,1)
	J2=MIN0(JC+1,NJJ(NRES))
	I2=MIN0(IC+1,NII(NRES))
	DO 200 M=J1,J2
	  DO 200 L=I1,I2
	    IF (IX(L,M,NRES).EQ.1) THEN
	      IX(L,M,NRES)=0
	      CALL DISCON(NRES,L,M,IX,NU,NV,KF)
	    END IF
 200	CONTINUE
	RETURN
	END	          
c////////////////////////////////////////////////////////////
c  subroutine to create border of mask from a filled mask
c
	subroutine bpborder(*,nfr,ipar,ix,nu,nv,kf)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	character ncomc*36,fitsname*24
	COMMON/PICC/NCOMC(15),fitsname(15)
	CALL QUERYNFR(NFR,KF,5,*999,*20001)
20001	continue
c  ipar=0:
c  check each pixel, if 1 or more pixels are zeros then it is
c   border pixel, set it to 10000. This sets the inside border
c  ipar=1:
c  the alternative is to set the outside border. Here is one or
c  more pixle is not zero, set it to 10000
	if (ipar.eq.0) then
	do 100 j=1,njj(nfr)
	  do 101 i=1,nii(nfr)
	    if (ix(i,j,nfr).gt.0) then
c surrounding 8 pixels
	      nzero=0
	      do 110 n=j-1,j+1
	        do 111 m=i-1,i+1
	          if (ix(m,n,nfr).eq.0) nzero=nzero+1
 111	        continue
 110	      continue
	      if (nzero.gt.1) then
c  it is a border pixel
	        ix(i,j,nfr)=10000
	      else
	        ix(i,j,nfr)=999
	      end if
	    end if
 101	  continue
 100	continue
c set all 999's to 0
	do 120 j=1,njj(nfr)
	  do 120 i=1,nii(nfr)
	    if (ix(i,j,nfr).eq.999) ix(i,j,nfr)=0
 120	continue
	else
	do 200 j=1,njj(nfr)
	  do 201 i=1,nii(nfr)
	    if (ix(i,j,nfr).eq.0) then
c surrounding 8 pixels
	      nzero=0
	      do 210 n=j-1,j+1
	        do 211 m=i-1,i+1
	          if (ix(m,n,nfr).gt.0.and.ix(m,n,nfr).lt.10000
     *              ) nzero=nzero+1
 211	        continue
 210	      continue
	      if (nzero.gt.1) ix(i,j,nfr)=10000
	    end if
 201	  continue
 200	continue
c set all non 10000''s to 0
	do 220 j=1,njj(nfr)
	  do 220 i=1,nii(nfr)
	    if (ix(i,j,nfr).ne.10000) ix(i,j,nfr)=0
 220	continue
	end if
 999	return1
	end
c////////////////////////////////////////////////////////////////
c    subroutine to create mask for bleeding columns using position files
c
c       ipar=0 create an image
c       ipar=1 create a crbp file
c       inew=0 write on existing image
c       inew=1 write on new image
c       imkcen=0 do not mask the center of saturated stars (for obj finding)
c       imkcen=1 mask the center of saturated stars
c
	subroutine bleedmap(*,nfr,nfm,ix,nu,nv,kf,ipar,inew,imkcen)
c	integer*2 ix(nu,nv,kf),itc(200000),jtc(200000)
	integer ix(nu,nv,kf),itc(200000),jtc(200000)
	character filen*20,dumstr*60
	dimension idat(5)
	include 'ppparm.inc'
	include 'objcat.inc'
	INCLUDE 'picdir.inc'
	include 'pppcore.inc'
	include 'pipeparm.inc'
	COMMON/CONN/IPT,IPIX1,ITURN,MAXPIX,IMAX,JMAX,iptmax
	common/photdata/reali,realj,counts,terr
 	EQUIVALENCE (ITC(1),iscr(1)),(JTC(1),iscr(300001))
	call querynfr(nfr,KF,0,*999,*2000)
 2000	if (nob(nfr).eq.0) then
 	  write(6,*) '  *** no object in position file, aborted  ***'
	  return1
	end if
 	if (ipar.eq.1) then
 600	  write(6,1)
 1	format('  Enter crbp mask file name: ',$)
	  read(5,'(a20)') filen
	else
	  if (nfm.eq.0) then
 601	    write(6,2)
 2	format(' Enter mask frame number: ',$)
	    call read1i(nfm,*999,*601)
	    call querynfr(nfm,kf,4,*999,*2001)
 2001	    continue
	  end if
	  if (inew.eq.0) then
	    if ((nii(nfr).ne.nii(nfm)).or.(njj(nfr).ne.njj(nfm))) 
     *           then
	      write(6,15) nii(nfm),njj(nfm),nii(nfr),njj(nfr)
 15	format('  *** warning ** existing mask frame (',2i6,
     *    ') does not match parent frame (',2i6,')'/
     *        '      --- mask frame size changed to match')
	    end if
	  end if
	  nii(nfm)=nii(nfr)
	  njj(nfm)=njj(nfr)
	  nfl(6,nfm)=1
	end if
	if (npad.eq.0) npad=1
	if (ircspipe.eq.0) then
 602	  write(6,4) npad
 4	format('  Enter number of layers of padding [',i2,']: ',$)
	  call read1i(npad,*999,*602)
	else
	  npad=npadpipe
	  write(6,*) '  ... layer of padding: ',npad
	end if
c create image
	if (ipar.eq.0.and.inew.eq.1) then
	  write(6,*) '  -- making a new mask :'
	  do 110 j=1,njj(nfm)
	    do 110 i=1,nii(nfm)
	      ix(i,j,nfm)=0
 110	  continue
	end if
c  go through the position file to pick up saturated at .9adusat
c    
c    all pixels above 0.5 (adusat-sky) are connected
	iadu=adusat
	iadu=0.9*iadu
	call stripsky(nfr,1,1,nii(nfr),njj(nfr),5,sky,sig,1,ix,nu,nv,kf)
	isky=nint(sky)
	iadu2=0.5*(iadu-isky)+isky
c radius of exclusion ~ior
c	iorsq=ior*ior*0.5
	iorsq=ior*iir
	write(6,*) ' iadu limit for diffraction mask ',iadu
	do 100 i=1,nob(nfr)
	  if (ix(ijoi(i,nfr),ijoj(i,nfr),nfr).gt.iadu) then
	    icen=ijoi(i,nfr)
	    jcen=ijoj(i,nfr)
            CALL SEGCON(ICEN,JCEN,iadu2,ITC,JTC,IPT,NII(NFR),NJJ(NFR),
     *                 IX(1,1,NFR),NU,NV)
c  leave the central IOR (radius) pixels unmaskeda
c          (by setting the connected pixel indicator to -1)
c   do this only for object finding
c 
	    if (imkcen.eq.0) then
	      do 101 j=1,ipt
	        if (itc(j).eq.-1) goto 101
	    if (((itc(j)-icen)**2+(jtc(j)-jcen)**2).le.iorsq) then
	          itc(j)=-1
	          jtc(j)=-1
	        end if
 101	      continue
	    end if
c adjust connected pixel array
c	    j=0
c 102	    j=j+1
c 103        if (j.gt.ipt) go to 105
c 	    if (itc(j).eq.-1) then
c	      do 104 k=j,ipt-1
c	        itc(k)=itc(k+1)
c	        jtc(k)=jtc(k+1)
c 104	      continue
c	      ipt=ipt-1
c	      goto 103
c	    else
c	      goto 102
c	    end if
c 105	    continue
c  save bad pixel map
	    if (ipar.eq.0) then
c create image
	      do 106 j=1,ipt
	        if (itc(j).gt.0.and.jtc(j).gt.0) 
     *	          ix(itc(j),jtc(j),nfm)=1
 106	      continue
	    else if (ipar.eq.1) then
c make crbp macro file
	    end if
	  end if
 100	continue
c padding (only for bleeding columns)
	if (ipar.eq.0) then
	  do 107 i=1,npad
	    if (i.ne.1.and.i.eq.npad) then
	      call padmap(*107,nfm,ix,nu,nv,kf,0)
	    else
	      call padmap(*107,nfm,ix,nu,nv,kf,1)
	    end if
 107	  continue
	end if
c  add defraction spike map 
c  this should be done only for object finding, but not photometry
	if (dsc(1).lt.-900.) return1
	do 120 k=1, nob(nfr)
	  if (ix(ijoi(k,nfr),ijoj(k,nfr),nfr).gt.iadu) then
	    idat(1)=nfr 
	    idat(2)=ijoi(k,nfr)
	    idat(3)=ijoj(k,nfr)
	    idat(4)=4*iir
	    idat(5)=idat(4)+2*iapis
c  determine total counts
	write(6,*)  ' -- phodri for sat star',k,' @ ',idat(2),idat(3)
	    call phodri(*200,idat,dumstr,dumstr,1,ix,nu,nv,kf)
c  determine length
 200	    countt=counts*.0000001
	    mlen=nint(dsc(1)+dsc(2)*countt+dsc(3)*countt*countt)
	    if (mlen.gt.0) then
	      write(6,*) ' star ',k,'counts/10^7',counts,
     *                ' spike length',mlen
	    end if
 	    if (mlen.le.nint(dsc(1)+2)) goto 120
c  added Apr 18, 2008: the gap in the center is put in for obj finding
c            but not for making area mask map
	      if (imkcen.eq.1) then
c do no mask center
	        iben=0
	      else
	        iben=13
	      end if
c  
c  make mask (all with same thickness of 5 pix)
	    if (abs(difang).lt.0.01) then
c   horizontal (in I)
	      do 121 j=ijoj(k,nfr)-5, ijoj(k,nfr)+5
	        do 122 i=iben,mlen
	          ii1=max0(1,ijoi(k,nfr)-i)
	          ii2=min0(nii(nfr),ijoi(k,nfr)+i)
	          ix(ii1,j,nfm)=1
	          ix(ii2,j,nfm)=1
 122	        continue
 121	      continue
c   vertical (in J)
	      do 131 j=iben,mlen
	        do 132 i=ijoi(k,nfr)-5, ijoi(k,nfr)+5
	          jj1=max0(1,ijoj(k,nfr)-j)
	          jj2=min0(njj(nfr),ijoj(k,nfr)+j)
	          ix(i,jj1,nfm)=1
	          ix(i,jj2,nfm)=1
 132	        continue
 131	      continue
	    else
c at a specified angle difang:  difang is the position angle
c    defined as 12o''clock=0, and anticlockwise=positive (ie N to E)
c   compute the delta I and delta J range, then use the meteor
c   algorithm of crbp. 
	      i1=nint(mlen*sin(difang/57.2958))
	      j1=nint(mlen*cos(difang/57.2958))
	      ic=ijoi(k,nfr)
	      jc=ijoj(k,nfr)
c not sure why this is there
	      iben=iben/2
c  upper left
	      call meteorline(ic-i1,ic-iben,jc+j1,jc+iben,-5,
     *              ix(1,1,nfm),nu,nv,nii(nfr),njj(nfr))
c  lower right
	      call meteorline(ic+iben,ic+i1,jc-iben,jc-j1,-5,
     *              ix(1,1,nfm),nu,nv,nii(nfr),njj(nfr))
c  for the next two, the angle is complementry, thus switch i1 and j1
c  lower left
	      call meteorline(ic-j1,ic-iben,jc-i1,jc-iben,-5,
     *              ix(1,1,nfm),nu,nv,nii(nfr),njj(nfr))
c  upper right
	      call meteorline(ic+iben,ic+j1,jc+iben,jc+i1,-5,
     *              ix(1,1,nfm),nu,nv,nii(nfr),njj(nfr))
	    end if
c if star is brigther than certain counts, also make ghost 1 (rcs2 only)
c  the threshold is obtained looking at RCS2 megacam r image 0133A0,
c    where star @ 1678 209 in chip2 with cts=14800000 is barely acceptable)
	  if (counts.gt.16000000.0) then
	      write(6,*) ' -- adding bstarmask for star ',k,' @ ',
     *          ijoi(k,nfr),ijoj(k,nfr)
	      call addbstarmask(nfm,ijoi(k,nfr),ijoj(k,nfr),
     *                ix(1,1,nfm),nu,nv)
	    end if
	  end if
 120	continue
 999	return1
	end
c/////////////////////////////////////////////////////////
c  subroutine to determine the center point for the box to be
c    used for computing sigma and background for decosmic raying
c    using a map of the MOS spectra.  
c    the map has 1=pixels with spectra, and 0=blank
c  - algorithm: pick the center of the chip, and then determine
c    the x and y extend of the closest spectrum box
c  - compute rms of a series of boxes (size width of the spectrum, 
c   and 60 pix long), running the length of the spectrum box,
c   pick a position with stable rms, and inport the x y position
c   to box 1
c
c    nfr1 = data frame
c    nfr2 = mask frame
	subroutine pickspecbox(*,nfr1,nfr2,ix,nu,nv,kf)
	integer ix(nu,nv,kf)
	dimension isppix(5000),ave(400),sig(400),ijcen(400),
     *   avsig1(400),sigsig1(400),indxavsig(400),indxsigsig(400)
     *   ,irankav(400),iranksig(400)
	character ian*1
	COMMON/BOX/IBOX(4,10),NBOX
	INCLUDE 'picdir.inc'
	call querynfr(nfr1,kf,5,*999,*2001)
 2001	call querynfr(nfr2,kf,6,*999,*2002)
c determine spectrum box, first pick the center chip pixel
 2002	ic=nii(nfr2)*.5
	jc=njj(nfr2)*.5
 110	continue
	if (ix(ic,jc,nfr2).eq.0) then
	  ic=ic+5
	  jc=jc+5
	  if (ic.gt.nii(nfr2).or.jc.gt.njj(nfr2)) then
	    write(6,*) ' ++ no spectrum found, aborted ++ '
	    return1
	  end if
	  goto 110
	end if
	write(6,*) ' ... initial center i j: ',ic,jc
c  search in x and y direction for the edges
	do 100 i=ic,1,-1
	  if (ix(i,jc,nfr2).eq.0) goto 111
 100	continue
 111	ibeg=i+2
	do 101 i=ic,nii(nfr2)
	  if (ix(i,jc,nfr2).eq.0) goto 112
 101	continue
 112	iend=i-2
	do 102 j=jc,1,-1
	  if (ix(ic,j,nfr2).eq.0) goto 113
 102	continue
 113	jbeg=j+2
	do 103 j=jc,njj(nfr2)
	  if (ix(ic,j,nfr2).eq.0) goto 114
 103	continue
 114	jend=j-2
c decide the direction of the spectra
	isize=iend-ibeg+1
	jsize=jend-jbeg+1
	write(6,*) ' ... spectrum box identified: ',ibeg,iend,jbeg,
     *           jend, ' size: ',isize,jsize
	if (jsize.gt.isize) then
	  idirn=0
	else
	  idirn=1
	end if
c  new center
	ic=(iend+ibeg)/2
	jc=(jend+jbeg)/2
	idelp=10
c  determine box co-ordinate
	if (idirn.eq.0) then
c spectra are up and down, ic is the center x co-ord of spectrum
c   jboxsize is size of the box in y direction
	  jboxsize=61
	  jbegt=jbeg+jboxsize
	  do 200 k=1,500
c fill the array for statistics
	    jbegt=jbegt+idelp
	    if (jbegt.gt.(jend-1.5*jboxsize)) goto 230
	    npt=0
	    do 210 j=jbegt,min0(njj(nfr1),jbegt+jboxsize)
	      do 211 i=ibeg,iend
	        npt=npt+1
	        isppix(npt)=ix(i,j,nfr1)
 211	      continue
 210	    continue
	    call avsig(isppix,ave(k),sig(k),rmax,rmin,npt)
	    ijcen(k)=jbegt+jboxsize/2
	    write(6,10) k,ijcen(k),ave(k),sig(k)
 10	    format(i3,' box central pix: ',i4,'  ave:',f8.2,
     *              ' sigma: ',f7.3)
 200	  continue
	else
c spectra are left and right, jc is the center y co-ord of spectrum
c   iboxsize is size of the box in x direction
	  iboxsize=61
	  ibegt=ibeg+iboxsize
	  do 201 k=1,500
c fill the array for statistics
	    ibegt=ibegt+idelp
	    if (ibegt.gt.iend-iboxsize) goto 230
	    npt=0
	    do 220 j=jbeg,jend
	      do 221 i=ibegt,min0(nii(nfr1),ibegt+iboxsize)
	        npt=npt+1
	        isppix(npt)=ix(i,j,nfr1)
 221	      continue
 220	    continue
	    call avsig(isppix,ave(k),sig(k),rmax,rmin,npt)
	    ijcen(k)=ibegt+iboxsize/2
	    write(6,10) k,ijcen(k),ave(k),sig(k)
 201	  continue
	end if
 230	nrms=k-1
c  analyze the rms to pick the stable one: find a series of 10 rms
c   which has a small rms, starting from the middle
c
c  compute the average rms
	write(6,*) '  total number of points checked: ',nrms
	call avsigr(sig,aversig,sigsig,rmaxsig,rminsig,nrms)
	write(6,*) '  average sigma and sigma sigma: ',aversig,sigsig 
	call avsigr(ave,averave,sigave,rmaxave,rminave,nrms)
	write(6,*) '  average average and sigma ave: ',averave,sigave 
	avsigt=aversig
c find the smallest sigma of sigma on the running 9 point average
	do 250 k=1,nrms-9
	  call avsigr(sig(k),avsig1(k),sigsig1(k),rmaxsig,rminsig,9)
 250	continue
c  rank the avsig1 and sigsig1
	call indexx(nrms-9,avsig1,indxavsig)
	call indexx(nrms-9,sigsig1,indxsigsig)
c  assign the rank
	do 270 k=1,nrms-9
	  irankav(indxavsig(k))=k
	  iranksig(indxsigsig(k))=k
 270	continue
	do 260 k=1,nrms-9
	write(6,*) k,ijcen(k+5),avsig1(k),irankav(k),sigsig1(k)
     *                   ,iranksig(k)
 260	continue
c  compute the quadrature summed rank
	isumrank=1000000
	do 251 k=1,nrms-9
	   irank=iranksig(k)*iranksig(k)+
     *           irankav(k)*irankav(k) 
	   if (irank.lt.isumrank) then
	     isumrank=irank
	     kcen=k+5
	   end if
 251	continue
	write(6,*) ' rank ',sqrt(float(isumrank)), ' /',nrms-9
c  center co-ordinate
	if (idirn.eq.0) then
	  jc=ijcen(kcen)
c box co-ordinate, 1=lower i, 2=upper i, 3=lower j, 4=upper j
	  ibox(1,1)=ibeg
	  ibox(2,1)=iend
	  ibox(3,1)=jc-jboxsize/2
	  ibox(4,1)=ibox(3,1)+jboxsize
	else
	  ic=ijcen(kcen)
	  ibox(1,1)=ic-iboxsize/2
	  ibox(2,1)=ibox(1,1)+ioboxsize
	  ibox(3,1)=jbeg
	  ibox(4,1)=jend
	end if
	write(6,11) ic,jc,ave(kcen),sig(kcen), (ibox(m,1),m=1,4)
 11	format('  --- Central ij ',2i5,' ave/sig: ',2f9.3/
     *        ' box limits (i1,i2,j1,j2): ',4i5)
c assign the box
	nbox=1
 999	return1
	end
