C///////////////////////////////////////////////////////////////////////
C
C    SUBROUTINE  PACKAGE TO DO CROWDED FIELD GALAXY PHOTOMETRY
C
C***********************************************************************

C/////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR CORRECTION OF APERTURE SIZE OF CROWDED OBJECTS
C
C
	SUBROUTINE IDSCOR(NOJ,NAP,IDS,REALI,REALJ,SP)
c	INTEGER*2 IDS(1)
	INTEGER IDS(1)
	DIMENSION REALI(1),REALJ(1), SP(0:30,3000)
	ANEIG=1.5*NAP
	ANEIGSQ=ANEIG*ANEIG
	WRITE(6,*) ' Crowded photometry correction:'
	WRITE(6,13)
 13	FORMAT(1X,' Obj Neigh  Pk(obj) Pk(neig)  Iold Inew Kobj Kneig'
     *         ,'       SBobj   SBneig')
	DO L=1,2
	  IF (L.EQ.1) THEN
	    J1=2
	    J2=NOJ
	    J3=1
	    WRITE(6,*) '   First run, correcting objects to right...'
	  ELSE
	    J1=NOJ-1
	    J2=1
	    J3=-1
	    WRITE(6,*) '   Second run, correcting objects to left...'
	  END IF
	  DO 100 J=J1,J2,J3
	    IF (IDS(J).LE.2) GO TO 100
	    IF (L.EQ.1) THEN
	      I1=1
	      I2=J-1
	    ELSE
	      I1=J+1
	      I2=NOJ
	    END IF
	    DO 101 I=I1,I2
C   check for nearest object (within 1.5 NAP of object)
	      AX=ABS(REALI(I)-REALI(J))
	      AY=ABS(REALJ(I)-REALJ(J))
	      IF (AX.LT.ANEIG.AND.AY.LT.ANEIG) THEN
	        RR=AX*AX+AY*AY
	        IF (RR.LE.ANEIGSQ) THEN
	          IRR=NINT(SQRT(RR)-.25)
	          IDIST=IDS(J)
C  re-arrange neighbour's profile in reverse, the points of profile of neig
C    now is equated to RR-R(POINT), and now test when the two profile cross,
C    that point is than chosen as the reasonable separating point of the objs
	          DO 102 K=MIN0(30,IDS(I)+1),0,-1
C  kk is the equivalent index of profile of object J
	            KK=IRR-K
	            IF (KK.GE.2) THEN
	              IF (KK.GE.IDIST) GO TO 1021
	              IF (SP(K,I).EQ.100.) THEN
	                IF (K+1.LE.NAP) THEN
	                  SPK=.5*(SP(K-1,I)+SP(K+1,I))
	                ELSE
	                  GO TO 102
	                END IF
	              ELSE
	                SPK=SP(K,I)
	              END IF
	              IF (SPK.GT.30.) GO TO 102
	              IF (SP(KK,J).EQ.100.) THEN
	                IF (KK+1.LE.NAP) THEN
	                  SPKK=.5*(SP(KK-1,J)+SP(KK+1,J))
	                ELSE
	                  GO TO 102
	                END IF
	              ELSE
	                SPKK=SP(KK,J)
	              END IF
	              IF (SPKK.GT.30.) GO TO 102
C	TYPE*,KK,SPKK,K,SPK
	              IF (SPK.LT.SPKK) THEN
	                IDS(J)=MIN0(IDS(J),KK)
C     minimum aperture = 3rd
	                IF (IDS(J).EQ.2) THEN
	                  IDS(J)=3
	                  IF (IDIST.EQ.3) GO TO 1021
	                END IF
	                GO TO 103
	              END IF
	            END IF
 102	          CONTINUE
 1021             WRITE(6,14) J,I,SP(0,J),SP(0,I),IDS(J),IDS(I)
 14	FORMAT(1X,'#',I3,I5,2F8.2,3X,I4,14X,I4,'       No change')
	          GO TO 104
 103	          WRITE(6,10) J,I,SP(0,J),SP(0,I),IDIST,IDS(J),
     *                      KK,K,SPKK,SPK
 19	FORMAT(5X,I5,' corrected also',5X,2(I4,2X))
 10	FORMAT(1X,'#',I3,I5,2F8.2,3X,4(I4,2X),2X,2F8.2)
 104              CONTINUE
	        END IF
	      END IF
 101	    CONTINUE
 100	  CONTINUE
	END DO
	RETURN
	END
	      
C////////////////////////////////////////////////////////////////////////
C
C    SUBROUTINE TO OBTAIN A CUT BETWEEN TWO POINTS  (IX1,IY1) AND (IX2,IY2)
C           USING BILINEAR INTERPOLATION
c  Added May 25 1997: mpt: max number of points allowed
c
C
	SUBROUTINE MKLINE(IX1,IY1,IX2,IY2,NPT,mpt,XLINE,NI,NJ,IX,NU,NV)
c	INTEGER*2 IX(NU,NV)
	INTEGER IX(NU,NV)
	REAL XLINE(*)
C  determine delta I and delta J for change of 1 pixel in length
	TOLEN=SQRT(FLOAT((IX2-IX1)*(IX2-IX1)+(IY2-IY1)*(IY2-IY1)))
	IF (TOLEN.EQ.0.) THEN
	  WRITE(6,*) '  **** ERROR: END POINTS FOR CUT ARE IDENTICAL **'
	  WRITE(6,*) IX1,IX2,IY1,IY2
	  RETURN
	END IF
	DELI=(IX2-IX1)/TOLEN
	DELJ=(IY2-IY1)/TOLEN
	NPT=nint(TOLEN)
	if (npt.gt.mpt) then
c	  write(6,1) npt,mpt
 1	format('  +++ warning: dist between pts,',i5,
     *        ', exceeds max distance allowed (',i4,' ++')
	  npt=mpt
	end if
C  loop for each pixel of the line
	XT=IX1
	YT=IY1
	DO 100 I=1,NPT
C  co-ordinate of ith point
	  XT=XT+DELI
	  YT=YT+DELJ
	  IXT=NINT(XT)
	  IYT=NINT(YT)
	  DX=XT-IXT
	  DY=YT-IYT
	  ISX=SIGN(1.,DX)
	  ISY=SIGN(1.,DY)
	  DX=ABS(DX)
	  DY=ABS(DY)
C determine value by bilinear interpolation
	  XLINE(I)=(1-DX)*(1-DY)*IX(IXT,IYT)+DX*DY*IX(IXT+ISX,IYT+ISY)
     *	          +(1-DX)*DY*IX(IXT,IYT+ISY)+DX*(1-DY)*IX(IXT+ISX,IYT)
 100	CONTINUE
	RETURN
	END
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO OBTAIN EQUATION JOINING TWO POINTS (Y=A1X+B1) AND
C       A ORTHOGONAL LINE GOING TROUH A POINT DL FROM POINT 1 ON THE.
C       LINE. (Y=A2X+B2)
	SUBROUTINE DLINES(X1,Y1,X2,Y2,DL,A1,B1,A2,B2)
	IF (ABS(X1-X2).GT.0.0000001) THEN
	  A1=(Y1-Y2)/(X1-X2)
	  B1=Y1-A1*X1
	ELSE
	  A1=10E10
	  B1=0
	END IF
	IF (A1.NE.0.) THEN
	  A2=-1/A1
	  DSQ=(SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2)))
	  IF (DSQ.EQ.0.) THEN
	  WRITE(6,*) '  **** ERROR: END POINTS FOR CUT ARE IDENTICAL **'
	    WRITE(6,*) X1,X2,Y1,Y2
	    RETURN
	END IF
	  RR=DL/DSQ
	  XP1=X1+RR*(X2-X1)
	  YP1=Y1+RR*(Y2-Y1)
	  B2=YP1-A2*XP1
	ELSE
	  A2=100000.
	  B2=X1+SIGN(DL,X2-X1)
	END IF
	RETURN
	END
C////////////////////////////////////////////////////////////////////
C
C   DRIVING ROUTINE FOR AUTOPHOT, WITH OBJECT MASKING FOR CROWDED FIELDS
C
C               IPRT=0 DO NOT PRINT INTERMEDIATE RESULTS
C 		IPR1=1 PRINT ALL INTERMEDIATE STEPS
C               IPO=0 SAVE RESULTS
C               IPO>0 NO WRITE
	SUBROUTINE ACPDRI(*,NFRA,STRF,TCOMMENT,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),IDS(3000),NNEI(3000),
	INTEGER IX(NU,NV,KF),IDS(3000),NNEI(3000),
     *    ICLP(3000),ICLS(3000),APERMASK(200,200),NMASK(100,100)
	integer nng(30)
	DIMENSION  NFRA(5),RI(30),RMAG(30,3000),PK(3000)
     *   ,REALI(3000),REALJ(3000),SKY(3000),ZSIG(3000),ELL(3000)
     *    ,ANG(3000),RAD(3000),DELMAG(3000),EXMAG(3000),SP(0:30,3000)
     *     ,SKYERR(3000),REFST(30),IREF(10),
     *     SUMDEL(3000),SKARAY(50000),CLSCT(3),PIXN(30),PKF(3000)
	CHARACTER*18 FILOUT,FILT,DEV,HPLOT,SPLOT
	CHARACTER*1 IANS,IANS2
	CHARACTER*60 COMMENT,STRF,TCOMMENT
	character*64 fstr24,fstr27,string1,string2
	character*24 fdate
	REAL*8 FIL
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	COMMON/PLOTDEV/ HPLOT,SPLOT,ipinit
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	include 'apert.inc'
	equivalence (iscr(1),rmag(1,1)),
     *     (iscr(200001),PK(1)),(iscr(210001),REALI(1)),
     *     (iscr(220001),REALJ(1)),(iscr(230001),SKY(1)),
     *     (iscr(230001),ZSIG(1)),(iscr(240001),ELL(1)),
     *     (iscr(250001),ANG(1)),(iscr(260001),RAD(1)),
     *     (iscr(270001),DELMAG(1)),(iscr(280001),EXMAG(1)),
     *     (iscr(290001),SKYERR(1)),
     *     (iscr(310001),pkf(1)),(iscr(320001),nnei(1)),
     *     (iscr(330001),IDS(1)),(iscr(340001),ICLP(1)),
     *     (iscr(350001),ICLS(1)),(iscr(380001),sumdel(1)),
     *     (iscr(390001),refst(1)),(iscr(391501),ri(1)),
     *     (iscr(392001),pixn(1)),(iscr(392501),nng(1)),
     *     (iscr(400001),APERMASK(1,1)),(iscr(500001),NMASK(1,1)),
     *     (iscr(600001),sp(0,1)),(iscr(900001),skaray(1))
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.6) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <=6 FOR POSITION FILE'
	  RETURN1
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	NOBB=NOB(NFR)
 600	CALL READFN(FILT,STRF(1:18),FILOUT,'phm','o',11,*999,*600,*20002)
20002	IF (FILOUT.NE.'n') THEN 
	  IF (TCOMMENT.EQ.' ') THEN
 6600	    WRITE(6,9) COMMENT
 9	FORMAT('   ENTER comment, <=60 characters: Default: '/,' (',
     *        A60,')'/' :',$)
	    CALL READSTRD(60,COMMENT,*999,*6600)
	  ELSE
	    COMMENT=TCOMMENT
	  END IF
	END IF
 203	K=4
	IF (FILOUT.EQ.'n') K=3
	IF (NFRA(K).LE.IAPMIN+4) THEN
	  WRITE(6,11) IAPMIN,IAPIS,IAPMAX
 11	FORMAT(' Initial obj diameter:',I2,', Max sky diam=(max obj dia'
     *        ,'m)+',I2,' dflt max obj diam=',I3,
     *	      /'   Enter MAX obj DIAMETER in integer pixels: ',$)
	  call read1i(iapmax,*999,*203)
	ELSE
	  IAPMAX=NFRA(K)
	  NFRA(K)=0
	END IF
	IF (IAPMAX.LE.IAPMIN) GO TO 203
	IAP2=IAPMAX+IAPIS
	IF (IAP2.GT.maxap) THEN
	  WRITE(6,*) '  **** Diameter too large ******'
	  GO TO 203
	END IF
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,IPRT)
C number of apertures
	NAP=MIN0(30,(IAPMAX-IAPMIN+2)/2)
	IEXAP1=MIN0(IEXAP,NAP)
C
C   MAKE APERTURES
C
	DO 80 I=1,NAP
	  IAP1(I)=IAPMIN+(I-1)*2
	  CALL APARAY(IAP1(I),IT1(1,I),IROW1(I),QQ(I),RR(I),PP(I),
     *                 NA(I),IPRT)
	  X1(I)=(PP(I)-RR(I))*QQ(I)
	  X2(I)=QQ(I)*QQ(I)-NA(I)*PP(I)
	  X3(I)=QQ(I)*QQ(I)-NA(I)*RR(I)
 80	  X4(I)=X1(I)*(X2(I)+X3(I))/QQ(I)
C create aperture map:
	DO 180 J=1,IAP1(NAP)
	  DO 180 I=1,IAP1(NAP)
 180	    APERMASK(I,J)=0
	IAC=(IAP1(NAP)+1)/2
	DO 285 M=1, NAP
	  K=0
	  PIXN(M)=NA(M)
	  DO 285 J=IAC-IROW1(M),IAC+IROW1(M)
	    K=K+1
	    DO 285 I=IAC-IT1(K,M)/2,IAC+IT1(K,M)/2
 285	      APERMASK(I,J)=APERMASK(I,J)+1
C	DO 1811 I=1,IAC
C 1811	  WRITE(6,1182) ((APERMASK(I,J)),J=1,IAC)
c 1182	FORMAT(1X,<IAC>I3)
C  set inner sky aperture radius
	IF (IAP2-IAP1(NAP).GT.8) THEN
	  NNAP=NAP
	ELSE
	  NNAP=NAP-1
	END IF
C
C  do photometry for each objects
C
	IRMAX=IAP1(NAP)
	iexapf=min0(iexap,nap)
	IRMAXSQ=IRMAX*IRMAX
	MASKSIZE=2*IAP1(NAP)+1
	DO 100 I=1,NOB(NFR)
c! Maximum allowable final aperture
	  MAXIDS=nap
	  II=IJOI(I,NFR)
	  JJ=IJOJ(I,NFR)
C  check for neighbours
	  CALL NNEIGH(NNEI(I),NNG,II,JJ,NOB,IJOI(1,NFR),IJOJ(1,NFR),
     *          I,IRMAX,IRMAXSQ)
 1711	  WRITE(6,42) I,NNEI(I)
 42	FORMAT(/' Object #',I4,'  Number of neighbours:',I3)
C  determine sky
	  IF (ISKYSEC.EQ.0) THEN
	    CALL RCSKY(1,SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,NFR)
     *                    ,NU,NV,SKARAY,50000,nsky,IPRT,IPR)
	  ELSE
	    CALL RING8SKY(SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,NFR)
     *                    ,NU,NV,SKARAY,50000,nsky,IPRT,IPR)
	  END IF
	  IF (IPR.NE.0) THEN
	    WRITE(6,*) ' ****  photometry not done *****'
	    DO  JK=1,30
	      RI(JK)=0.
	    END DO
	    ZSIG(I)=0
	    DELI=0.
	    DELJ=0.
	    DELIN=0.
	    DELJN=0.
	    GO TO 1741
	  END IF
C  set up mask
	  CALL MAKEMASK(MASKSIZE,NMASK,NNEI(I),NNG,
     *        IJOI(1,NFR),IJOJ(1,NFR),II,JJ,
     *        SKY(I),IRMAX,IX(1,1,NFR),NU,NV,NI,NJ,maxids,iapmin)
C  Do photometry
 	  CALL CFPHOT(NFR,II,JJ,RI,ANG(I),ELL(I),PKF(I),NPC,RAD(I)
     *	   ,DELI,DELJ,DELIN,DELJN,NAPCEN,NI,NJ,SKY(I),IRMAX,APERMASK,
     *      NMASK,IX,NU,NV,KF,IPRT)
c! Temp. for checking
 1741	  REALI(I)=II+DELIN   
	  REALJ(I)=JJ+DELJN
	  PK(I)=IX(NINT(REALI(I)),NINT(REALJ(I)),NFR)-SKY(I)
	  SKYERR(I)=(ZSIG(I)*SQRT(FLOAT(NA(ISE)))) 
	  IF (SKYERR(I).NE.0) SKYERR(I)=RI(ISE)/SKYERR(I)
C  calculate integrated and surface profile
C  calculate growth curve in mag and linear surface profile
	  SP(0,I)=PK(I)
	  SP(1,I)=(RI(1)-PK(I))/(PIXN(1)-1.)
 	  IF (RI(1).GT.0.) THEN
	    RMAG(1,I)=-2.5*ALOG10(RI(1))
	  ELSE
	    RMAG(1,I)=99.0
	  END IF
	  DO 82 L=2,NAP
 	    IF (RI(L).GT.0.) THEN
	      RMAG(L,I)=-2.5*ALOG10(RI(L))
	    ELSE
	      RMAG(L,I)=99.0
	    END IF
	    SP(L,I)=(RI(L)-RI(L-1))/(PIXN(L)-PIXN(L-1))
 82	  CONTINUE
	  CALL IDSDET(NAP,RMAG(1,I),RI,PIXN,ZSIG(I),DER1X,DER2X,NSTOP)
	  IDS(I)=MAX0(1,MIN0(MAXIDS,NSTOP))
C
C  OUTPUT RESULTS
C
 94	  WRITE(6,15) REALI(I),REALJ(I),RI(IDS(I)),RMAG(IDS(I),I),
     *      SKYERR(I),PK(I)
 15	FORMAT(3X,'centroid:',2F7.2,'  cts:',F8.0,'  mag:',F8.3,
     *        '  S/N:',F7.1,'  npk:',F8.2)
	  WRITE(6,8) (RMAG(L,I), L=1,MIN0(10,NAP))
	  IF (NAP.GT.10) WRITE(3,16) (RMAG(L,I),L=11,NAP)
 8	FORMAT(3X,'m(rad):',10F7.2)
 16	FORMAT(10X,10F7.2)
 100	CONTINUE
C
C determine reference star
C
 606	CALL REFSTAR(REFST,REFPK,IDSREF,SKYERR,NAP,RMAG,PK,IDS,SKY
     *    ,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),IREF,NREF,IPAR,
     *    ADUSAT-5000.,IREFMIN,iexapf,*999)
	IDSREF=MIN0(IDSREF,IEXAP1)
C    estimate seeing
	CALL SEEING1(SP(0,IREF(NREF)),IAPMIN,IDS(IREF(NREF)),IDELD,SEE)
	WRITE(6,316) IREF(NREF),SEE
 316	FORMAT(/'  Estimated FWHM from object',I5,':',F7.3,' pix'
     *          /'  Classification:')
	AA=REFST(IDSREF)+2.5*ALOG10(AMAX1(.0001,REFPK))
C
C
C    BIG LOOP FOR EACH OBJECT TO DETERMINE EXTRAPOLATED MAG,
C      SURFACE PROFILE AND PARAMETERS, AND TWO CLASSIFICATIONS
C
	DO KK=1,3
	  CLSCT(KK)=CLSC(KK)
	END DO
	ISDAPT=MIN0(2,MAX0(1,ISDAP))
	DO 309 I=1,NOB(NFR)
C 
C Determine first order extrapolated magnitude : up to aperture IEXAP
C
	  CALL MAGEXT(IDS(I),IDSREF,EXMAG(I),RMAG(IDS(I),I),REFST)
C  calculate exponential fit to profile, starting from apt 3 to NSTOP
C	  CALL EXPFITP(SP(0,I),IDS(I),IAP1,SZ(I),RZ(I),RSQ(I))
C
C Calculate distribution of delta mag from reference line
C
C  classification
	  CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),REFST,IDSREF,
     *                 AA,SKY(I),ADUSAT,ISDAPT,
     *                CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
	  WRITE(6,41) I,EXMAG(I),IDS(I),SUMDEL(I),ICLS(I)
 41	FORMAT(2X,'#',I4,'  mag:',F6.2,'  apert.:',I2,'  C2:',F7.3,
     *        '   Cl:',I2)
 309	CONTINUE
C
C  plotting options
C
 160	CONTINUE
 603 	  WRITE(6,17) 
 17	FORMAT('  Do you want PLOT of classifier vs mag?'
     *            ,' y=dflt/n/p: ',$)
	  READ(5,18,ERR=603,END=999)  IANS2
 18	FORMAT(A1)
 	  IF (IANS2.NE.'n') THEN
	    IF (IANS2.EQ.'p') THEN
	      DEV=HPLOT
	      CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOB(NFR),IREF,NREF,
     *                CLSCT,icls,FILOUT,DEV,nsct(nfr))
	    ELSE
	      DEV=SPLOT
	      CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOB(NFR),IREF,NREF,
     *                CLSCT,icls,FILOUT,DEV,nsct(nfr))
 604	      WRITE(6,19) 
 19	FORMAT('  Do you want to change ref. star (s) or '
     *        ,'class criteria (c)? (n(o)/s/c): ',$)
	      READ(5,18,ERR=604,END=999) IANS2
	      IF (IANS2.EQ.'c') THEN
 605	        WRITE(6,20) CLSCT(3),CLSCT(2),CLSCT(1)
 20	FORMAT('   C2 default values:',3F7.3,' for division of class'
     *        ,' 0,3,2,1'/'   Enter 3 (temporary) values: ',$)
	        CALL READR4(3,CLSCT(3),CLSCT(2),CLSCT(1),*999,*605,
     &               *20004,*20004)
C  re-classification
20004	        DO 159 I=1,NOB(NFR)
	          CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *                 REFST,IDSREF,AA,SKY(I),ADUSAT,ISDAPT,
     *                CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
	          WRITE(6,41) I,EXMAG(I),IDS(I),SUMDEL(I),ICLS(I)
 159	        CONTINUE
	        GO TO 160
	      ELSE IF (IANS2.EQ.'s') THEN
 	        GO TO 606
	      ELSE IF (IANS2.NE.'n'.AND.IANS2.NE.' ') THEN
	        GO TO 604
	      END IF
	    END IF
	  END IF
 607	  WRITE(6,21) 
 21	FORMAT('  Do you want PLOT of MAG versus APERTURE? '/
     *         '   (PRINTRONIX PLOT FILE ONLY) y/n (dflt:n): ',$)
	  READ(5,18,ERR=607,END=999)  IANS
	  IF (IANS.EQ.'y') THEN
 608	    WRITE(6,22)
 22	format('  Enter title (<=8 characters): ',$)
	    READ(5,23,ERR=608,END=999) FIL
 23	FORMAT(A8)
C  put differential profile in mag
	  DO 81 I=1,NOB(NFR)
	    DO 81 L=0,NAP
	      IF (SP(L,I).GT.0.0001) THEN
	        SP(L,I)=-2.5*ALOG10(SP(L,I))
	      ELSE
	        SP(L,I)=99.
	      END IF
 81	    CONTINUE
c	    CALL PLTPHO(IAP1,RMAG,SP,IDS,ICLS,EXMAG,NOB(NFR),
c     *               NAP,FIL,FILOUT,SEE)
	  END IF
 	IF (FILOUT.EQ.'n') RETURN1
C save results in disk
	KAP=MIN0(10,NAP)
	OPEN(UNIT=28,FILE=FILOUT,status='NEW',ERR=999)
	IF (COMMENT.EQ.'c') COMMENT=PCOMMENT(NFR)
c	CALL DATE(ADATE)
c	CALL TIME(ATIME)
C attach date and time to comment
	DO 300 JN=60,1,-1
 300	  IF (COMMENT(JN:JN).NE.' ') GO TO 301
 301	COMMENT=COMMENT(1:MIN0(39,JN+1))//fdate()//' '//'AUCP'
C Write 2 line header
c
	istatus=encode(string1,float(max0(1,min0(7,nref))),1,0,idum)
	istatus=encode(string2,float(max0(1,4*(7-nref)+1)),1,0,idum)
	fstr24='(1x,a80,1x,''REF *:'','//
     &  string1(1:lnblnk(string1))//'i4,'//
     &  string2(1:lnblnk(string2))//'x,'' C2'',3f6.3)'
	WRITE(28,fstr24) COMMENT,(IREF(K),K=NREF,MAX0(NREF-6,1),-1)
     *               ,CLSCT(3),CLSCT(2),CLSCT(1)
c
c 24	FORMAT(1X,A60,1X,'REF *:',<MAX0(1,MIN0(7,NREF))>I4,
c     *                  <MAX0(1,4*(7-NREF)+1)>X,' C2',3F6.3)
c
	WRITE(28,25) IAP2,IAP1(1),IAP1(NAP),NI,NJ,ISE,IEXAP1,SEE
 25	FORMAT(1X,'SKY APERT:',I3,'  1ST APERT:',I3,'  LAST APERT:',I3
     *     ,3X,'SIZE:',2I5,3X,'ERR APER ',I2,3X,'EXTRP APER ',I2,
     *      3X,'FWHM:',F5.2,' PIX')
	DO 302 I=1,NOB(NFR)
C  calculate sky err for adopted best aperture
	  TERR=10.**(-RMAG(IDS(I),I)/2.5)
     *              /(ZSIG(I)*SQRT(AMAX1(1.,PIXN(IDS(I)))))
	  WRITE(28,26)I,REALI(I),REALJ(I),RMAG(IDS(I),I),EXMAG(I),
     *    TERR,SKYERR(I),PK(I),NNEI(I),IDOB(I,NFR),RAD(I),SKY(I),
     *     ZSIG(I),DELMAG(I),ICLP(I),SUMDEL(I),ICLS(I)
c
	  istatus=encode(string1,float(kap),1,0,idum)
	  istatus=encode(string2,float(8*(10-kap)+3),1,0,idum)
	  fstr27='(4x,2(i4,3x),i2,3x,'//
     &    string1(1:lnblnk(string1))//'f8.3,'//
     &    string2(1:lnblnk(string2))//'x,i2)'
c
	  WRITE(28,fstr27) IJOI(I,NFR),IJOJ(I,NFR),IDOB(I,NFR)
     *	                   ,(RMAG(L,I), L=1,KAP),IDS(I)
	  WRITE(28,28) (RMAG(L,I),L=11,NAP)
 302	CONTINUE
 	CLOSE(UNIT=28)
c
c 27	FORMAT(4X,2(I4,3X),I2,3X,<KAP>F8.3,<8*(10-KAP)+3>X,I2)
c
 28	FORMAT(23X,10F8.3)
c 3	FORMAT(1X,I3,1X,2(F6.2,1X),E10.4,F7.2,F7.1,F9.1,3F7.3,F9.3,
c    *      F8.3,1X,F6.2,I2,F6.2,I2)
 26	FORMAT(1X,I3,1X,2(F6.2,1X),2F7.2,F7.1,F7.1,F8.1,2I7,F7.3,F10.3,
     *      F8.3,1X,F6.2,I2,F6.2,I2)
 999	RETURN1
	END
	
C
C/////////////////////////////////////////////////////////////
C
C  Subroutine to extrapolate mag to largest aperture
C
	SUBROUTINE MAGEXT(IDS,IDSREF,EXMAG,RMAG,REFST)
C
	DIMENSION REFST(30)
c	INTEGER*2 IDS
	INTEGER IDS
	  IF (IDS.LT.IDSREF) THEN
	    IF (RMAG.NE.99.) THEN
              EXMAG=RMAG+REFST(IDSREF)-REFST(IDS)
	    ELSE
	      EXMAG=99.
	    END IF
	  ELSE
	    EXMAG=RMAG
	  END IF
	RETURN
	END
C//////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR APERTURE PHOTOMETRY WITH CROWDED-FIELD CORRECTION
C    BY MASKING NEIGHBOURING OBJECTS
C
C
C
C
	SUBROUTINE CFPHOT(NFR,IO,JO,RI,ANG,ELL,PEAK,NPE,RAD,DELI,DELJ,
     *   DELIN,DELJN,NCED,NI,NJ,SKY,MSH,APERMASK,NMASK,IX,NU,NV,KF,IW)
	DIMENSION RI(30)
c	INTEGER*2 APERMASK(200,200),NMASK(100,100),IX(NU,NV,KF),
	INTEGER APERMASK(200,200),NMASK(100,100),IX(NU,NV,KF),
     *               NPIXIN(30),NPIXOUT(30)
	INCLUDE 'picdir.inc'
	include 'apert.inc'
	NAPP=NAP
C  CALCULATE MOMENTS for two apertures: NPE= aperture index for fitting
C     peak, NCED = index for obtaining centroid
	IF (NCED.EQ.NPE) THEN
c! same index, do only once
	  NMOM=1    
	ELSE
	  NMOM=2
	END IF
	DO 257 KK=1,NMOM
	  IF (KK.EQ.1) NCE=NPE
	  IF (KK.EQ.2) NCE=NCED
	  JR1=JO-IROW1(NCE)
	  JR2=JO+IROW1(NCE)
	  RMI=0.
	  RMJ=0.
 	  RMII=0.
	  RMJJ=0.
	  RMIJ=0.
	  RI(NCE)=0.
	  K=0
	  DO 200 J=MAX0(1,JR1), MIN0(NJ,JR2)
	    K=K+1
	    DO 201 I=MAX0(1,IO-IT1(K,NCE)/2), MIN0(NI,IO+IT1(K,NCE)/2)
	      SS=FLOAT(IX(I,J,NFR))-SKY
	      II=I-IO
	      JJ=J-JO
	      S1=SS*II
	      S2=SS*JJ
	      RI(NCE)=RI(NCE)+SS
	      RMI=RMI+S1
	      RMJ=RMJ+S2
	      RMII=RMII+S1*II
	      RMJJ=RMJJ+S2*JJ
	      RMIJ=RMIJ+S2*II
 201	    CONTINUE
 200	  CONTINUE
C  intensity centroid within aperture
	  IF (RI(NCE).NE.0.) THEN
	    DELIN=RMI/RI(NCE)
	    DELJN=RMJ/RI(NCE)
	  ELSE
	    DELIN=0.
	    DELJN=0.
	  END IF
C PARAMETERS FOR PARABOLOID FIT:
C ---- IX(IJ)  =  AI**2+BIJ+CJ**2+DI+EJ+F  -----
	  B=RMIJ/RR(NCE)
	  D=RMI/QQ(NCE)
	  E=RMJ/QQ(NCE)
	  A=(X1(NCE)*RI(NCE)+X2(NCE)*RMII-X3(NCE)*RMJJ)/X4(NCE)
	  C=(X1(NCE)*RI(NCE)+X2(NCE)*RMJJ-X3(NCE)*RMII)/X4(NCE)
	  F=(RI(NCE)-QQ(NCE)*(A+C))/FLOAT(NA(NCE))
C   CALCULATE OBJECT PARAMETERS
C     the first pass all parameters are calculated, the second
C      pass (if peak aperture NPE and centroid aperture NCED
C      are not equal) all parameters are recalculated except
C      the peak
	  DEL=4.*A*C-B*B
	  RAD=0.
	  ANG=0.
	  IF (DEL.EQ.0.) THEN
	    IF (KK.EQ.1) PEAK=0.
	    ELL=0.
	    DELI=0.
	    DELJ=0.
	    WRITE(6,*) ' ***** WARNING NO PARABOLIC FIT TO OBJECT ****'
	    GO TO 257
	  END IF
	  IF ((A-C).NE.0.) ANG=0.5*ATAN(B/(A-C))
	  ELL=SQRT((A+C)*(A+C)-DEL)
	  ELL=0.5*ELL*(A+C-ELL)/DEL
	  PEAKT=F+(B*D*E-C*D*D-A*E*E)/DEL
	  IF (KK.EQ.1) PEAK=PEAKT
	  IF (DEL.GT.0..AND.PEAKT.GE.0.) RAD=SQRT(PEAKT/SQRT(DEL))
	  DELI=(E*B-2.*D*C)/DEL
	  DELJ=(D*B-2.*E*A)/DEL
 257	CONTINUE
C   calculate flux for all apertures
	IM=1-IO+MSH
	JM=1-JO+MSH
	DO 270 I=1,NAP
	  NPIXIN(I)=0
	  NPIXOUT(I)=0
 270	  RI(I)=0.
	IAC=IO-(IAP1(NAP)+1)/2
	JAC=JO-(IAP1(NAP)+1)/2
	DO 271 J=1,IAP1(NAP)
	  JZ=JAC+J
	  DO 271 I=1,IAP1(NAP)
	    IF (APERMASK(I,J).GT.0) THEN
c! index of APERTURE
	      INDX=NAP-APERMASK(I,J)+1  
C  determine I,J in  frame
	      IZ=IAC+I
C  determine if pixel is in frame
	      IF (JZ.LT.1.OR.JZ.GT.NJ.OR.IZ.LT.1.OR.IZ.GT.NI) THEN
	        NPIXOUT(INDX)=NPIXOUT(INDX)+1
	      ELSE
C determine if affected by neighbours
	        IF (NMASK(IM+IZ,JM+JZ).EQ.0) THEN
	          NPIXIN(INDX)=NPIXIN(INDX)+1
	          RI(INDX)=RI(INDX)+FLOAT(IX(IZ,JZ,NFR))-SKY
	        ELSE
	          NPIXOUT(INDX)=NPIXOUT(INDX)+1
	        END IF
	      END IF
	    END IF
 271	CONTINUE
C calculate normalized  flux in each ring
	DO 272 I=1,NAP
	  IF (NPIXIN(I).GT.0) 
     *	    RI(I)=RI(I)*(NPIXIN(I)+NPIXOUT(I))/FLOAT(NPIXIN(I))
	  IF (IW.EQ.1) WRITE(6,777) I,RI(I),NPIXIN(I),NPIXOUT(I)
 777	FORMAT(' ring#',I3,F15.2,'    pix in:',I5,'    pix out:',I5)
 272	CONTINUE
C  Calculate growth curve
	DO 273 I=NAP,2,-1
	  DO 273 J=1,I-1
 273	    RI(I)=RI(I)+RI(J)
C	DO 251 I=1,NNAP
C	  JR1=JO-IROW1(I)
C	  JR2=JO+IROW1(I)
C	  K=0
C  	  RI(I)=0.
C	  NPIXIN=0
C	  NPIXOUT=0
C	  DO 250 J=JR1,JR2
C	    K=K+1
C	    DO 250 L=IO-IT1(K,I)/2,IO+IT1(K,I)/2
C pixel is out side of frame
C	      IF (J.LE.0.OR.J.GT.NJ.OR.L.LE.0.OR.L.GT.NI) THEN
C	        NPIXOUT=NPIXOUT+1
C	      ELSE
C pixel is in frame, calculate equivalent pixel on mask frame
C check if pixel is masked
C	        IF (IX(IM+L,JM+J,6).EQ.0) THEN
C	          NPIXIN=NPIXIN+1
C	          RI(I)=RI(I)+FLOAT(IX(L,J,NFR))-SKY
C	        ELSE
C	          NPIXOUT=NPIXOUT+1
C	        END IF
C	      END IF
C250	  CONTINUE
C	  RI(I)=RI(I)*(NPIXOUT+NPIXIN)/FLOAT(NPIXIN)
C 251	CONTINUE
	RETURN
	END
