C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO flatten picture line by line by fitting a cubic to 
c           each median filter smoothed row
C     NSFIL   =  SIZE OF FILTER 
c          ipar = 0 : fit line with polynomial before flattening
c                 1 : use just the median filtered line for flattening
c                 2 : produce a line medianed image
C
	SUBROUTINE cubflat(*,NFR,JLT,JRT,nsfilt,ipar,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),linein(3000)
	INTEGER IX(NU,NV,KF),linein(3000)
	real u(300,6),v(6,6),w(6),rlineout(3000),x(300),sig(300)
     *       ,scale(3000),y(300),coef(6)
	EQUIVALENCE (linein(1),iscr(1)),(rlineout,iscr(10001)),
     *    (u(1,1),iscr(100501)),(x(1),iscr(20001)),(sig(1),
     *       iscr(30001)),(scale(1),iscr(40001)),(y(1),iscr(31001))
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	external fpoly
	CALL QUERYNFR(NFR,KF,0,*999,*6001)
C
C check inputs, request info if missing
 6001	if (jlt.eq.0.or.jrt.eq.0) then
 600	  WRITE(6,10) JL,JR
 10	FORMAT('  Enter J range to be smoothed,'/
     *         ,'   (0 0 = whole image) (dflt:',2I5,'): ',$)
	  CALL READ2I(JL,JR,*999,*600)
	  if (jl.eq.0.and.jr.eq.0) then
	    jl=1
	    jr=njj(nfr)
	  end if
	else
	  jl=jlt
	  jr=jrt
	END IF
	jl=max0(1,jl)
	ir=min0(jr,njj(nfr))
	if (nsfilt.eq.0) then
 603	  WRITE(6,12) nsfil
 12	FORMAT('  Enter smoothing length in pixels (ODD, dflt:',I4,
     *       ' ): ',$)
	  call read1i(nsfil,*999,*603)
	else
	  nsfil=nsfilt
	end if
	if (nsfil.gt.499) then
	  write(6,*) '  ** filter too large, must be less than 500 ** '
	  go to 603
	else if (nsfil.lt.3) then
	  write(6,*) ' *** filter  too small..'
	  go to 603
	else if (mod(nsfil,2).eq.0) then
	  nsfil=nsfil+1
	  write(6,*) ' .. Filter size increased by 1 to ',nsfil
	end if
	nsh=NSFIL/2
	if (ipar.eq.0) then
 604	  write(6,13) ndeg
 13	format('  Enter fitting polynominal degree: (1-3) [',i2,']:',$)
	  call read1i(ndeg,*999,*604)
	  if (ndeg.gt.5.or.ndeg.lt.1) go to 604
c get an estimate of sky error
	  call pstat(*6041,nfr,jr/3,0,0,0,dum1,err,npix,8,ix,nu,nv,kf)
c fill x and sig array for fitting routine
 6041	  npp=0
	  do 80 i=5,nii(nfr),10
	    npp=npp+1
	    x(npp)=1.*i
	    sig(npp)=err
 80	  continue
	else if (ipar.eq.2) then
 605	  write(6,14) nres
 14	format('  Enter frame # for result [dflt:',i3,']: ',$)
	  call read1i(nres,*999,*605)
	  call querynfr(nres,kf,4,*999,*6051)
 6051	  nii(nres)=nii(nfr)
	  njj(nres)=njj(nfr)
	  nfl(6,nres)=1
	end if
c do for each row (I)
c pad the array with -500 and 30000  
	do 102 i=1,nsh,2
 102	  linein(i)=-500
	do 103 i=2,nsh,2
 103	  linein(i)=30000
	do 104 i=nii(nfr)+1,nii(nfr)+nsh,2
 104	  linein(i)=-500
	do 105 i=nii(nfr)+2,nii(nfr)+nsh,2
 105	  linein(i)=30000
	do 100 j=jl,jr
c	write(6,*) 'line ',j
c fill array to pass on to smoothing routine
	  do 101 i=1,nii(nfr)
	    linein(i+nsh)=ix(i,j,nfr)
 101	  continue
	  call mdfline(linein,rlineout,nsfil,nsh,nii(nfr))
	  if (ipar.eq.1) then
	    call smoothj1(rlineout,nii(nfr),ix(1,j,nfr))
	  else if (ipar.eq.0) then
c fit the line, using every 10th points
	    npp=0
	    do 260 k=5,nii(nfr),10
	      npp=npp+1
	      y(npp)=rlineout(k)
 260	    continue 
  	    call svdfit(x,y,sig,npp,coef,ndeg+1,
     *              u,v,w,300,6,chisq,fpoly)
c	write(6,*) j,coef(1),coef(2),coef(3),coef(4),chisq 
c smooth the J row in the picture	
	    call smoothj(coef,ndeg,nii(nfr),scale,ix(1,j,nfr))
	  else if (ipar.eq.2) then
c fill result frame	
	    do 106 i=1,nii(nfr)
c no need for nint since rlineout are really in integer values
	      ix(i,j,nres)=rlineout(i)
 106	    continue
	  end if
 100	continue
 999	return1
	end
c/////////////////////////////////////////////////////
c   subroutine to median filter a line
C   A HISTOGRAM OF SIZE 33000 IS SET UP FOR INT*2, IF MEDIAN
C     OF THE DATA IS <-232, IT WILL GIVE -232 AS THE ANSWER
	subroutine mdfline(linein,rlineout,nsfil,nsfh,nend)
c	integer*2 linein(1),ibox(500),IRO(100),IRN(100)
	integer linein(*),ibox(500),IRO(100),IRN(100)
	dimension rlineout(1)
	include 'pppcore.inc'
	INTEGER IHIST(-232:32767)
	EQUIVALENCE (IBOX(1),iscr(250001)),(iro(1),iscr(251001)),
     *    (irn(1),iscr(251501)),(IHIST(-232),iscr(260001))
c fill ibox to be pass on to histogram routine
	DO 101 J=1,nsfil
 101	  IBOX(j)=linein(j)
	CALL INITHISTO(IBOX,nsfil,IHIST,MED,IMO)
	rlineout(1)=MED
C
C move window and adjust IBOX
C
	iii=0
	if (iii.eq.0) then
	DO 109 I=2,nend 
c  IRO= pixel values to be deleted
c  IRN= pixel values to be  added  
	  IRO(1)=linein(i-1)
 	  IRN(1)=linein(i+nsfil)
	  CALL REPROW(IHIST,nsfil,IRO,IRN,NSFIL,MED,IMO)
	  rlineout(i)=MED
 109	continue
	else
	DO 100 I=2,nsfh+1
c  IRO= pixel values to be deleted
c  IRN= pixel values to be  added  
	  IRO(1)=linein(i-1)
 	  IRN(1)=linein(i+nsfil)
	  CALL REPROW(IHIST,nsfil,IRO,IRN,NSFIL,MED,IMO)
	  rlineout(i)=MED
 100	continue
c for this part, find modal value
	aver=0.
	do 110 i=nsfh+1,nsfil+nsfh
	  aver=aver+linein(i)
 110	continue
	aver=aver/float(nsfil)
c	write(6,*) '  pix 1 aver ',aver,rlineout(nsfh+1)
c	rlineout(nsfh+1)=3*rlineout(nsfh+1)-2*aver
	DO 111 I=nsfh+2,nend-nsfh
	  IRO(1)=linein(i-1)
 	  IRN(1)=linein(i+nsfil)
	  CALL REPROW(IHIST,nsfil,IRO,IRN,NSFIL,MED,IMO)
c  compute average
	  aver=(nsfil*aver-iro(1)+irn(1))/float(nsfil)
	  rlineout(i)=MED
c	  rlineout(i)=3.*MED-2.*aver
 111	continue
	DO 102 I=nend-nsfh+1,nend
c  IRO= pixel values to be deleted
c  IRN= pixel values to be  added  
	  IRO(1)=linein(i-1)
 	  IRN(1)=linein(i+nsfil)
	  CALL REPROW(IHIST,nsfil,IRO,IRN,NSFIL,MED,IMO)
	  rlineout(i)=MED
 102	continue
	end if
 999	RETURN
	end
c////////////////////////////////////////////////////////////
c
c subroutine to  smooth the row using the fitting function	
	subroutine  smoothj(coef,ndeg,nii,scale,ix)
	dimension coef(6),scale(*)
c	integer*2 ix(1)
	integer ix(*)
	sum=0.
	do 100 i=1,nii
	  scale(i)=coef(1)
	  xx=1.*i
	  do 101 j=2,ndeg+1
	    scale(i)=scale(i)+coef(j)*xx
	    xx=xx*i
 101	  continue
 100 	continue
c  normalize image according to the central 1/4
	iu=3*nii/8
	id=5*nii/8
	do 102 i=iu,id
	  sum=sum+scale(i)
 102	continue
	sum=sum/(float(id-iu+1))
	do 103 i=1,nii
	  ix(i)=nint(ix(i)*(sum/scale(i)))
 103	continue
	return
	end
c////////////////////////////////////////////////////////////
c
c subroutine to  smooth the row using the medianed line
	subroutine  smoothj1(scale,nii,ix)
	dimension scale(*)
c	integer*2 ix(1)
	integer ix(*)
	sum=0.
c  normalize image according to the central 1/3
	iu=3*nii/8
	id=5*nii/8
	do 102 i=iu,id
	  sum=sum+scale(i)
 102	continue
	sum=sum/(float(id-iu+1))
	do 103 i=1,nii
	  ix(i)=nint(ix(i)*(sum/scale(i)))
 103	continue
	return
	end
