c  Command interpreter for interactive programs
C  This subroutine takes a string as input and parse it into a command
C  input strings, integers and real numbers and return the current
C  command and an updated stack of command history.
c 
c  usage: lcom: maximum number of commands in stack
c         kop:  running pointer of command to be executed, set to lcom-1
c               initially, and pass through to the routine as a variable.
c         cstr: array of command string
c         numc: running sequential command numbers
c         mnd:  returned command, A4
c         ninput:  number of input in command string allowed
c         scom: array of input strings, max ninput
c         nfr:  array of input integers, max ninput
c         rn:   array of input reals, max ninput
c         progname: name for command prompts
c         return1: exit main program
c         imacrun: parameter for running macro, set to 0 initially
c         return2: invalid command format
c         return:  normal return to next statement
c
c         # = comment command line
c         ! = previous comment
c         % = shell escape
c
	subroutine command(cstr,numc,lcom,mnd,scom,nfr,rn,ninput
     *         ,kop,progname,iecho,imacrun,idin,idout,idhis,*,*)
	INTEGER*4 nfr(ninput),IB(40),IE(40),numc(lcom)
c	integer lnblnk
	REAL RN(ninput)
	CHARACTER*80 CSTR(lcom)
	CHARACTER*60 SCOM(ninput+1)
	CHARACTER mnd*4,atime*24,blank1*1,progname*3
	character*32 fstr10,fstr11,fstr12,fstr191,string*3
 
c  always operates on the LCOMth CSTR
 99	KOP=KOP+1
	IF (KOP.EQ.LCOM) THEN   
c	  atime=fdate()
	  CALL fdate(ATIME)
	  READ(ATIME(15:19),1631) ITM1,ITS1
 1631	FORMAT(I2,1X,I2)
	  IF (((ITM1-ITM2)*60+ITS1-ITS2).GE.IBELLTIME) CALL RBELL(IBELL)
 991	  write(idout,2) progname,numc(lcom)+1
 2	FORMAT(/a3,i3,'>> ',$)
	  read(idin,3,ERR=991,END=993) CSTR(LCOM)
 3	format(a80)
c  normal data entry
	  GO TO 994  
C  Next block 993-994 for end of data entry
C  takes care of end of data: 3 "END OF DATA" in row will cause exit from 
c  program
 993	  IENDATA=IENDATA+1
	  IF (IENDATA.GE.3) THEN
	    IF (IMACRUN.LE.0) THEN
	        return1
	    ELSE
	        write(idout,*) '  ++++ Abnormal termination of Marco +++'
	        IENDATA=0
	        CALL ENDMACRO(*991,4,idevtty,IMACRUN,iecho)
	    END IF
	  END IF
c re-open input device
	  close(unit=5)
c	  open(unit=5)
	  open(unit=5,file='/dev/tty')
	  cstr(lcom)=' '
	  GO TO 991
C  normal input string
c!reset "end of data" count
 994	  IENDATA=0           
c	  atime=fdate()
	  CALL fdate(ATIME)
	  READ(ATIME(15:19),1631) ITM2,ITS2
	  CALL FSTR(CSTR(LCOM),80,IB,IE,NS)
	  istatus=encode(string,float(ie(ns)),1,0,idum)
	  fstr12='(a'//string(1:lnblnk(string))//')'
	  if (cstr(lcom).ne.' '.and.idhis.gt.0) 
     *                     write(idhis,fstr12) cstr(lcom)(1:ie(ns))
	  KOP=KOP-1
	  IF (NS.EQ.0) GO TO 99
	  READ(CSTR(LCOM)(IB(1):IB(1)),1) BLANK1
 1	format(a1)
C  perform the -n command
	  IF (BLANK1.EQ.'-') THEN
	    ICL=IE(1)-IB(1)
	    istatus=encode(string,float(icl),1,0,idum)
	    fstr12='(I'//string(1:lnblnk(string))//')'
	    READ(CSTR(LCOM)(IB(1)+1:IE(1)),fstr12,ERR=99) NBACK
	    NBACK=MIN0(LCOM-1,NBACK)
 600	    write(idout,10) CSTR(LCOM-NBACK)
 10	format(5x,'-- ',a40,':: execute? (y=dflt/n): ',$)
	    read(idin,1,END=99,ERR=600) BLANK1
	    IF (BLANK1.NE.'n') THEN
	      CSTR(LCOM)=CSTR(LCOM-NBACK)
	      KOP=KOP+1
	      GO TO 994
	    ELSE
	      GO TO 99
	    END IF
c  do command #nrep in stack
	  else if (blank1.eq.'!') then
	    if (ie(1).gt.ib(1)) then
	      read(cstr(lcom)(ib(1)+1:ie(1)),*,err=999,end=999) nrep
	    else if (ns.gt.1) then
	      read(cstr(lcom)(ib(2):ie(2)),*,err=999,end=999) nrep
	    else
	      nrep=numc(lcom-1) 
	    end if
 	    do 150 j=1,41
	      if (nrep.eq.numc(j)) go to 601
 150	    continue
	    write(idout,*) '  +++ command number not found +++ '
	    go to 99
 601	    write(idout,10) CSTR(j)
	    read(idin,1,END=99,ERR=601) BLANK1
	    IF (BLANK1.NE.'n') THEN
	      CSTR(LCOM)=CSTR(j)
	      KOP=KOP+1
	      GO TO 994
	    ELSE
	      GO TO 99
	    end if
	  end if
C shift command in stack by 1
	  numc(lcom)=numc(lcom)+1
	  DO 359 M=1,LCOM-1
	    numc(m)=numc(m+1)
 359	    CSTR(M)=CSTR(M+1)
C   read the next command if the current one ends with ';'
	  IF (CSTR(LCOM)(IE(NS):IE(NS)).EQ.';') THEN 
	    CSTR(LCOM-1)(IE(NS):IE(NS))=' '
	    IE(NS)=IE(NS)-1
	    GO TO 991
	  END IF
 	END IF
c! do the last command that does not end with ;
	CSTR(LCOM)=CSTR(KOP)  
 357	DO 358 M=1,ninput
	  SCOM(M)=' '
	  RN(M)=0.
 358	  NFR(M)=0
	scom(ninput+1)=' '
	 MND=' '
C
C check if it is a unix command
c
	IF (CSTR(LCOM)(1:1).EQ.'%') THEN
c	  CALL LIB$SPAWN(CSTR(LCOM)(2:80),,,,,'PPP')
	  call system(cstr(lcom)(2:80))
	  GO TO 99
	ELSE IF (CSTR(LCOM)(1:1).EQ.'#') THEN
C  check if it is just a comment
	  GO TO 99
	END IF
C
C Search for blanks, and read command structure
C  
	CALL FSTR(CSTR(LCOM),80,IB,IE,NS)
	IF (NS.EQ.0) GO TO 99
	ICL=MIN0(60,IE(1)-IB(1)+1)
	IF (ICL.LE.0) GO TO 999
c
	istatus=encode(string,float(icl),1,0,idum)
	fstr10='(A'//string(1:lnblnk(string))//')'	
	READ(CSTR(LCOM)(IB(1):IB(1)+ICL-1),fstr10) SCOM(1)
c
311	ICL=MIN0(4,ICL)
	istatus=encode(string,float(icl),1,0,idum)
	fstr10='(A'//string(1:lnblnk(string))//')'
 	READ(CSTR(LCOM)(IB(1):IB(1)+ICL-1),fstr10,ERR=999) MND
	IF (NS.EQ.1) GO TO 202
	K=0
	DO 330 L=2,NS
	  K=K+1
	  if (k.gt.ninput) go to 341
	  ICL=MIN0(60,IE(L)-IB(L))+1
	  IF (ICL.LE.0) GO TO 999
c
	  istatus=encode(string,float(icl),1,0,idum)
	  fstr10='(A'//string(1:lnblnk(string))//')'
	  fstr11='(F'//string(1:lnblnk(string))//'.0)'
	  fstr12='(I'//string(1:lnblnk(string))//')'
	  READ(CSTR(LCOM)(IB(L):IB(L)+ICL-1),fstr10,ERR=331) SCOM(K+1)
 331	  READ(CSTR(LCOM)(IB(L):IB(L)+ICL-1),fstr11,ERR=332) RN(K)
 332	  READ(CSTR(LCOM)(IB(L):IB(L)+ICL-1),fstr12,ERR=330) NFR(K)
 330	CONTINUE
c	nn1=ninput+1
c	IF (NS.EQ.nn1+1) THEN
c	  ICL=IE(nn1+1)-IB(nn1+1)+1
c	  istatus=encode(string,float(icl),1,0,idum)
c	  fstr12='(I'//string(1:lnblnk(string))//')'
c	  READ(CSTR(LCOM)(IB(nn1):IB(nn1)+ICL-1),fstr12,ERR=202) NFR(ninput)
c	END IF
c
c	  istatus=encode(string,float(icl),1,0,idum)
c	  fstr10='(A'//string(1:lnblnk(string))//')'
c	  fstr11='(F'//string(1:lnblnk(string))//'.0)'
c	  fstr12='(I'//string(1:lnblnk(string))//')'
c
c 10	FORMAT(A<ICL>)
c 11	FORMAT(F<ICL>.0)
c 12	FORMAT(I<ICL>)
C
 341	istatus=encode(string,float(max0(1,ie(ns)-ib(1)+1)),1,0,idum)
	fstr191='(5X,''-- '',A'//string(1:lnblnk(string))//','' --'')'
 202	IF (IECHO.EQ.1) write(idout,fstr191) CSTR(LCOM)(IB(1):IE(NS))
c 191	FORMAT(5X,'-- ',A<MAX0(1,IE(NS)-IB(1)+1)>,' --')
	return
 999	return2
	end

c///////////////////////////////////////////////////////////////////
C   Subroutine for starting macros
C
	SUBROUTINE GOMACRO(*,MNAME,IMAC,IDEV,idevtty,progname,IMACRUN
     *                       ,iecho)
	CHARACTER MNAME*20,MAC*30,progname*10
C  for user input macro name
	IF (IMAC.EQ.0) THEN
	  IF (MNAME.EQ.' ') THEN
 600	    WRITE(6,10)
 10	FORMAT('  Enter Macro file name (dflt extension .macro): ',$)
c	    read(6,'(a30)',end=999) mac
 	    call readstr(30,mac,*999,*600)
 11	FORMAT(A25)
	  ELSE
	    MAC=MNAME(1:lnblnk(mname))
	  END IF
C check name
	  DO 100 I=1,19
	    IF (MAC(I:I).EQ.' ') GO TO 102
	    IF (MAC(I:I).EQ.'.') GO TO 101
 100	  CONTINUE
 102	  MAC=MAC(1:I-1)//'.macro'
 101	  CONTINUE
	ELSE IF (IMAC.EQ.1) THEN
	  MAC=progname(1:lnblnk(progname))//'.macro1'
	ELSE IF (IMAC.EQ.2) THEN
	  MAC=progname(1:lnblnk(progname))//'.macro2'
	else if (imac.eq.3) then
	  MAC=progname(1:lnblnk(progname))//'.macro3'
	END IF
C  check if the last line is "END"
c	OPEN(UNIT=IDEV,FILE=MAC,STATUS='OLD',ERR=998)
c	DO 103 I=1,1000
c	  READ(IDEV,12,ERR=997,END=106) DUMSTRING
c	  IF (DUMSTRING.EQ.'END') GO TO 107
c103	CONTINUE
c12	FORMAT(A3)
c106 	WRITE(6,*) '  *** Macro file does not end with END, aborted ***'
c	GO TO 995
	close(unit=idev)
	if (imacrun.eq.0) idevtty=idev
	imacrun=imacrun+1
	OPEN(UNIT=IDEV,FILE=MAC,STATUS='OLD',ERR=998)
	WRITE(6,17) IMACRUN 
 17	FORMAT('  macro level',I3,' begins... ')
	iecho=1
 999	RETURN1
 998	WRITE(6,14) MAC
	idev=idevtty
	imacrun=imacrun-1
	if (imacrun.eq.0) iecho=0
	open(unit=idev,file='/dev/tty')
 14	FORMAT('  **** ERROR OPENING macro file: ',A20,' ***')
	RETURN1
	END
C/////////////////////////////////////////////////////////////////////
C  
C   subroutine to end macro
	SUBROUTINE ENDMACRO(*,IDEV,idevtty,IMACRUN,iecho)
	IF (IMACRUN.GT.0) THEN
	  CLOSE(UNIT=IDEV,ERR=999)
	  WRITE(6,10)  IMACRUN
 10	FORMAT(' ...end of Macro level',I3)
	  if (imacrun.eq.1) iecho=0 
 99 	  IMACRUN=IMACRUN-1
c   reset unit to the previous level
c	  idev=idev-imacrun
	  if (imacrun.eq.0) then
	    idev=idevtty
	    open(unit=idev,file='/dev/tty')
	  end if 	
	ELSE
	  WRITE(6,*)'   ++++ You are not running a Macro +++'
	END IF
 999	RETURN1
	END
C/////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO TYPE THE PREVIOUS LCOM COMMANDS
C
	SUBROUTINE TYCOMM(*,CSTR,LCOM,numc)
	CHARACTER*80 CSTR(lcom),dumstr*1
	integer numc(lcom)
	WRITE(6,9) LCOM
 9	FORMAT('  ///// List of previous (<=',I3,') commands ////')
	IWC=0
	DO 100 I=1,LCOM-1
 	  IF (CSTR(I).NE.' ') THEN
	    IWC=IWC+1
	    IF (IWC.EQ.20) THEN
 600	      WRITE(6,11)
	      call readstr(1,dumstr,*999,*600)
	    END IF
	    WRITE(6,10) numc(I),CSTR(I)
	  END IF
 100	CONTINUE
 10	FORMAT('  <',I3,':: ',A60)
 11	FORMAT('   ...<cr> to continue...')
 999	RETURN1
	END
