c/////////////////////////////////////////
c  routine to do simple x-y position matching, using a set of reference objects
C/////////////////////////////////////////////////////////////////
c  driving subroutine to compute shifts between filters for all chips
c          to allow running as a stand alone command for testing
c
	subroutine mulshdri(*,nch1,nch2,ix,nu,nv,kf)
	character filestr*60,filen*60,filenc*60,
     *            cext*2,imdir*55,dumstr*8,errmsg*30
	integer ib(6),ie(6),ibm(6),iem(6),status,rmode
	integer ix(nu,nv,kf)
	include 'pppcore.inc'
	include 'ppparm.inc'
	include 'pipeparm.inc'
	common/imagedir/imdir
c	common/bstarxy/nbstar,bstx(10),bsty(10),bsrad(10),bsmag(10)
c for now, the primary filter is always the first one on the input string
	nfilref=1
c filestr is a string containing the root names of images for each filter
	write(6,1)
 1	format('  Enter fits file names (.fits.*/fz implicit), max 6:'
     *          /': ',$)
	read(5,'(a60)',end=999) filestr
c save the string in the common block for later use
	pfiltstr=filestr
c  parse the file string for getting names of the files
	call fstr(filestr,60,ib,ie,nfilt)
	if (nfilt.le.0) then
	  write(6,*) ' **error in image name string ***'
	  ircspipe=0
	  return1
	end if
c determine the number of chips	using the first image (all others
c    must have the same number of chips!)
	filen=filestr(ib(1):ie(1))
c   .hdr file name root: the patch name with ^cext added
	do 161 k=1,lnblnk(filen)
	  if (filen(k:k).eq.'_') goto 162
 161	continue
 162	continue
c162	hdrname=filestr(ib(1):k-1)
	call imageex(filen,filenc,iimex)
	if (iimex.lt.0) then
	  ircspipe=0
	  return1
	end if
c  attempt to open file  (cfitsio rwmode: 0=read, 1=write)
	rmode=0
c	wmode=1
	status=0
	call ftgiou(lun,status)    
	call ftnopn(lun,imdir(1:lnblnk(imdir))//
     *      filenc(1:lnblnk(filenc))//'[0]',rmode, status)
	call ftgkyj(lun,'NEXTEND',nextendt,dumstr,status)
c  if not found, set nextend to 1
	if (status.ne.0) nextendt=1
	write(6,*) ' # of extension: ',nextendt,status
	call ftgerr(status,errmsg)
	call ftclos(lun, status)
	call ftfiou(lun, status)
	if (nch1.eq.0) then
	  jc1=1
	  jc2=nextendt
	else if (nch2.eq.0) then
	  jc1=nch1
	  jc2=nch1
	else
	  jc1=nch1
	  jc2=nch2
	end if
	write(6,*) ' +++ matching for chips ',jc1,' to ',jc2
c automatic mask creation is always assumed
	nfilm=-1
	call mulshift(jc1,jc2,nextendt,
     *     filestr,1,nfilm,ie,ib,iem,ibm,ix,nu,nv,kf)
 999	return1
	end
c////////////////////////////////////////////////////////////
c   subroutine to pre-compute shifts between different filters
c        for all the chips before doing object finding/photometry
c
c     jc1, jc2: chip range
c     filestr: the string of filter names
c     ie,ib: positions of filter names in the string  (the total
c                number of filters are passed on by nfilt (
c     nextendt: number of extension in fits file (number of chips)
c     nfilm: number of mask images (=number of filter, or -1 for auto)
c
c   Dec 15 2005
C 
c   Jan 11, 2008; added comments, but made no change for the
c                    ppprcsad subroutine.
c
	subroutine mulshift(jc1,jc2,nextendt,filestr,ifilbeg,
     *              nfilm,ie,ib,iem,ibm,ix,nu,nv,kf)
	integer ix(nu,nv,kf),ib(6),ie(6),ibm(6),iem(6)
	dimension avxshif1(10),avyshif1(10),naver1(10),
     *            avxshif2(10),avyshif2(10),naver2(10)
	character filestr*60,dumstr*60,shiftname*40,
     *        filen*24,filent*60,cext*2,primname*60
	include 'pppcore.inc'
	include 'pipeparm.inc'
	include 'imagepar.inc'
	include 'objcat.inc'
	include 'picdir.inc'
	include 'ppparm.inc'
	dumstr='dummy'
	idum=0
	imaskpipe=2
	ircspipe=1
c  nfilref is assumed to be on: need to update
	nfilref=1
c for each chip, quickfind is applied to the "reference" filter image
c  to find the positions of reference objects, and saved
	write(6,*)  ' ..pos matching; total # of filters: ',nfilt
	write(6,*)  '                  starting filter: ',ifilbeg
	do 200, jj=jc1,jc2
	  istatus=encode(cext,float(jj),1,0,idum)
	  jchip=jj
	  do 100, i=1,nfilt
c  the do loop needs to do i=1 (to get the reference), but skip
c      all filter until the beginning of the new filter
	    if (i.ne.1) then
	      if (i.lt.ifilbeg) goto 100
	    end if
	    write(6,*) ' @@@@ matching for chip ',cext,' filter ',i
c create name strings
	    filen=filestr(ib(i):ie(i))
	    primname=filen(1:index(filen,'_')-1)
	    filent=filen(1:lnblnk(filen))//'^'//cext(1:lnblnk(cext))
c read image
	    write(6,*) '  ^^^^ reading image: ',filent
c check for .head files, which, if found, replaces the wcs solution
c   read from the .fits file (chkwcshead)
c    this is implement for Gilbank''s fix of very badly off wcs solutions
c      where are fixed by creating a fits header that contain a more
c       correct wcs solution
	    call rdkfits(*800,1,filent,irep,ix,nu,nv,kf,ir,0)
 800	    call chkwcshead(1,filent,cext)
	    call chzeros(*8001,*999,1,ix,nu,nv,kf,ichzero)
c read mask
c create mask from image (the only choice)
 8001	    call createmask(ix(1,1,1),ix(1,1,2),nu,nv,
     *                    nii(1),njj(1),nii(2),njj(2),0)
 	    write(6,*) ' ^^^^ created mask from image'
c  fill zeros
 801	    irplim=-10
	    irprep=nint(saturate(1))
	    icomp=0
	    call searchpix(*802,1,icomp,' ',' ',1,ix,nu,nv,kf)
c  finished reading image, note that reference filter is the first
c    image to be read, and the quick objects finding is done before any
c    shift computation can take place.
c   compute shift: if ref filter, find references; if other filters
c                     compute shifts
 802	    if (i.eq.nfilref) then
c create the ref position file (assume the ref image is always filter 1
c   this uses the reference image and save reference objs positions
c    in common/refobj/. (No shift is done here)
	      call smspars(1,filent)
c fix adusat
	      call getadusat(adusat,saturate(1),adusatpipe)
 	      write(6,*) ' ^^^ qfnd for primary filter'
	      call FINOBD(*803,1,dumstr,dumstr,0.00,7,IX,NU,NV,KF)
 803	      write(6,*) ' ^^^ arf for position reference '
	      adulowpipe=adulowfil(i)
c autoref eliminates non-stars, and store the computed centroids of
c   the remaining objects in common block arrays: refx and refy (fracpos)
	      call autoref(1,ix,nu,nv,kf,0,*804)
 804	      continue
c store header info for reference filter
	    else
c for other filters, find shifts
 	      write(6,*) ' ^^^ pos matching for filter',i
c apply wcs solution as an initial correction 
 	      if (iwcssh.eq.1.and.iwcs.eq.1) then
c the operating frame is always frame 1
	        call wcsshift(1,nfilref,iwcshift,jwcshift,2)
	        iinitpipe=iwcshift
	        jinitpipe=jwcshift
	        write(6,14) iinitpipe,jinitpipe
 14	format('  ^^^ estimated shifts from wcs: ',2i5)
	      else
	        iinitpipe=0
	        jinitpipe=0
	      end if
c  store the wcs shifts
	      xchshift(i,jj)=float(iinitpipe)
	      ychshift(i,jj)=float(jinitpipe)
c  do position matching between filter i and primary, using
c        wcs shifts as first approximation
c  simposmat uses refx and refy as the reference position, with
c    an estimated wcs shift, to try to locate objects in the filter
c    image (which is always image 1)
	      call simposmat(1,iir,iret,1,1,ix,nu,nv,kf,*8041) 
c  the matching result parameter is stored
 8041	      imatch(i,jj)=iret
c  store the posmat shifts (the shifts from simposmat is stored
c     in dxmean and dymean (in objcat.inc)
	      pmxshift(i,jj)=dxmean
	      pmyshift(i,jj)=dymean
	    end if
 100	  continue
 200	continue
c  compute average from good chips
	call avshifts2(avxshif1,avyshif1,avxshif2,avyshif2
     *         ,jc1,jc2,naver1,naver2,nextendt)
c out put shift results for diagnostic
	shiftname=primname(1:lnblnk(primname))//'.shf'
        call opennew(26,1,40,shiftname,*998)
	write(26,19) primname(1:lnblnk(primname))
 19	format('   --- Position Matching Results for ',a20/
     * '     (Imatch  1: good; 0: ok/check; -1: failed'/
     *    ' Chip#  Imatch  wcs_shift   posmat_shift ')
	do 110 k=1,nfilt
	  if (k.ne.nfilref) then
	    write(26,24) k
 24	format('       ___ Filter',i2,'_____')
	    do 111 jj=jc1,jc2
	      write(26,20) jj,imatch(k,jj),xchshift(k,jj),
     *	          ychshift(k,jj),pmxshift(k,jj),pmyshift(k,jj)
 20	format(3x,i2,5x,i3,2f7.2,2x,2f7.2)
 111	    continue
	  end if
 110	continue
	write(26,23)
 23	format(/'   ... average shifts (used for bad chips) ..')
	nsplit=nint(nextendt*0.5)
	write(26,*) ' N_chip split ', nsplit,nextendt
	do 130 i=1,nfilt
	  if (i.ne.nfilref) then
	    write(26,22) i,nsplit,avxshif1(i),avyshif1(i),naver1(i),
     *             nsplit+1,nextendt,
     *              avxshif2(i),avyshif2(i),naver2(i)
	  end if
 22	format(' Filter',i2,' Chip 1 to',i3,' :  ',2f7.2,
     *           ' # of chips used: ',i2/
     *         '           Chip',i3,' to',i3,' :  ',2f7.2,
     *           ' # of chips used: ',i2)
 130	continue
c for bad chips, replace first guess shifts using average, and
c    redo position matching, and substitute the corrected shifts
	idev=26
	call fixshift(idev,jc1,jc2,nextendt,avxshif1,avyshif1,
     *  avxshif2,avyshif2,filestr,nfilm,ie,ib,iem,ibm,ix,nu,nv,kf)
 998	close(unit=26)
 999	return
	end
c//////////////////////////////////////////////////////////
c
	subroutine fixshift(idev,jc1,jc2,nextendt,avxshif1,
     *   avyshif1,avxshif2,avyshif2,filestr,nfilm,ie,ib,iem,ibm,
     *     ix,nu,nv,kf)
	integer ix(nu,nv,kf),ib(6),ie(6),ibm(6),iem(6)
	dimension avxshif1(10),avyshif1(10),
     *           avxshif2(10),avyshif2(10)
	character filestr*60,dumstr*60,
     *        filen*24,filent*60,cext*2,primname*60
	include 'pppcore.inc'
	include 'pipeparm.inc'
	include 'imagepar.inc'
	include 'objcat.inc'
	include 'picdir.inc'
	include 'ppparm.inc'
	dumstr='dummy'
c do for each filter
	write(6,*)  ' Fixing position matching ',nfilt,' filters'
	do 200, jj=jc1,jc2
	  istatus=encode(cext,float(jj),1,0,idum)
	  ifind=0
	  jchip=jj
	  do 100, i=1,nfilt
c don''t do the reference filter
	    if (i.eq.nfilref) goto 100
c check if the filter is bad
	    if (imatch(i,jj).le.-1) then
	      write(6,*) ' @@@@ redoing matching for chip ',
     *                   cext,' filter ',i
	      if (ifind.eq.0) then
c  first read the reference image and do object finding for ref pos 
	        filen=filestr(ib(nfilref):ie(nfilref))
	        primname=filen(1:index(filen,'_')-1)
	        filent=filen(1:lnblnk(filen))//'^'//cext(1:lnblnk(cext))
c read image
	        write(6,*) '  ^^^^ reading reference image: ',filent
	        call rdkfits(*800,1,filent,irep,ix,nu,nv,kf,ir,0)
 800	        call chzeros(*8001,*999,1,ix,nu,nv,kf,ichzero)
c read mask
c create mask from image (the only choice)
 8001	        call createmask(ix(1,1,1),ix(1,1,2),nu,nv,
     *                    nii(1),njj(1),nii(2),njj(2),0)
 	        write(6,*) ' ^^^^ created mask from image'
c  fill zeros
 801	        irplim=-10
	        irprep=nint(saturate(1))
	        icomp=0
	        call searchpix(*802,1,icomp,' ',' ',1,ix,nu,nv,kf)
c create the ref position file (assume the ref image is always filter 1
c   this uses the reference image and save reference objs positions
c    in common/refobj/. (No shift is done here)
 802            write(6,*) ' ^^^ qfnd for primary filter'
	        ifind=1
	        call FINOBD(*803,1,dumstr,dumstr,0.00,7,IX,NU,NV,KF)
 803	        write(6,*) ' ^^^ arf for position reference '
	        call autoref(1,ix,nu,nv,kf,0,*804)
 804	        ifind=1
	      end if
c now find shift 
 	      write(6,*) ' ^^^ pos matching for filter',i
	      filen=filestr(ib(i):ie(i))
	      primname=filen(1:index(filen,'_')-1)
	      filent=filen(1:lnblnk(filen))//'^'//cext(1:lnblnk(cext))
c read image
	      write(6,*) '  ^^^^ reading image: ',filent
	      call rdkfits(*830,1,filent,irep,ix,nu,nv,kf,ir,0)
c  use initial shifts for simposmat from average
 830	      continue
	      nsplit=nint(nextendt*.5)
	      if (jchip.le.nsplit) then
	        iinitpipe=nint(avxshif1(i))
	        jinitpipe=nint(avyshif1(i))
	      else
	        iinitpipe=nint(avxshif2(i))
	        jinitpipe=nint(avyshif2(i))
	      end if
	      write(6,14) iinitpipe,jinitpipe
 14     format('  ### shifts estimated from average: ',2i5)
c  determine shift between filter i and primary
              call simposmat(1,iir,iret,1,1,ix,nu,nv,kf,*8041)
c  the matching result parameter is stored
 8041	      imatch(i,jj)=iret
	      if (imatch(i,jj).lt.0) then
c  can''t fix the shift, issue warning, and do not do photometry
	        write(6,16) i,jj
 16	format(' Chip ',i3,' Filter ',i2,
     *        ' **** matching fails again ****')
	      end if
c  store the posmat shifts (the shifts from simposmat is stored
c     in dxmean and dymean (in objcat.inc)
	      pmxshift(i,jj)=dxmean
	      pmyshift(i,jj)=dymean
c output new final shifts for checking
	      write(26,17) jj,i,pmxshift(i,jj),pmyshift(i,jj),
     *             imatch(i,jj)
 17	format(' Chip ',i3,' Filter ',i2,' New matched shift: ',
     *               2f7.2,'  Imatch:',i3)
	    end if
 100	  continue
 200	continue
 999	return
	end
c/////////////////////////////////////////////////////////////
C  SUBROUTINE TO read in reference position file
c
	subroutine rdrefpos(*,filen)
	character filen*60,comment*60,test*1
	include 'objcat.inc'
	if (filen.eq.' ') then
 600	  write(6,1)
 1	format('  Enter reference position file name (.pos appended): ',$)
	  read(5,'(a60)',end=999) filen
	end if
	filen=filen(1:lnblnk(filen))//'.pos'
	open(unit=29,name=filen,status='old',err=998)
c  read header line
	read(29,'(a60)',end=997) comment
	write(6,'(a60)') comment
c read additional comments
	do 120 k=1,5
	  read(29,'(a1)',end=997) test
  	  if (test.ne.'#') then
	    backspace 29
	    goto 121
	  end if
 120	continue
 121	continue
	do 100 i=1,200
	  read(29,*,err=997,end=101) refx(i),refy(i)
 100	continue
 101	close(unit=29)
	nobref=i-1
 999	return1
 998	write(6,*) ' *** no such file ***'
	return1
 997	write(6,*) ' *** read error, at object #',i
	return1
	end 
c////////////////////////////////////////////////////////////////////
c  
c   subroutine to determine offsets from reference position file
c    This assumes the reference star is fairly isolated, and the
c    new peak can be found by search for high points within a box
c    of size isbox X isbox (subroutine findpk)
c
c   The algorithm solves for rotation (around a point x_0,y_0) and xy
c    shifts.  It avoids solving for (x_0,y_0) by using a small
c    angle approximation, and absorbing it into the xy shifts.
c       (See note book, Jun 23 2001, for detailed derivation).
c    Solve first for delta-theta by computing delta''s for all pairs,
c       (nobref X (nobref-1) pairs).
c    then, using this delta theta, compute the average delta-x
c    and delta-y, using each point.
c    The meani values are obtained using rejection averaging.
c    A goodness of fit criterion is applied to see if the solution
c    is good enough.  This is done by computing the reference object
c    positions and compare them to the actual found positions.  A score
c    of 1 is assigned to each object with residual>2 pixels, and N
c     to residual of N>3.  A score of > 3*nobref/10 will cause an
c    issuing of a warning, and a scpre > 4*nobref/10 will cause an
c    abort for the image.
c
c  input ref obj positions
c    in common statement /refpos/, which can be filled using
c      aref (if a .pos file already exists), or
c        by reading in a file (using rdrefpos)
c
c  return status:
c  iret=-1  transformation is not working
c  iret=0   transformation produces some large residuals
c  iret=1   transformation is okay 
c
c  ipar=0: shift, rotate, and stretch
c  ipar=1: no stretching fits
c  ipar=2: no rotation
c
c  ipipe=0: interactive, no .mat file saved
c        1: .mat file produced
c
c   isbox is set to IIR of set.
c
	subroutine simposmat(nfr,isbox,iret,ipar,ipipe,
     *              ix,nu,nv,kf,*)
	character outname*40,comment*60,outname2*40,
     *       ncomc*36,fitsname*24,ncom*36,nfilen*24,cext*2
	integer ix(nu,nv,kf),ipeak(200)
	parameter (nrfmax=200)
	integer icomp(nrfmax),jcomp(nrfmax),nmrej(5000)
	real rnewi(nrfmax),rnewj(nrfmax),deltath
	real*8 theta1,theta2,cosvalue
	dimension delx(nrfmax),dely(nrfmax),delth(20000),skaray(50000),
     *         dumsig(nrfmax),xf(nrfmax),yf(nrfmax)
	include 'objcat.inc' 
	include 'apert.inc'
	include 'picdir.inc'
	include 'ppparm.inc'
	include 'pipeparm.inc'
        COMMON/DIR/ nof,NCOM(254),NFILEN(254),NFLAG(5,254)
     *              ,NID(254),NJD(254)
        COMMON/PICC/ NCOMC(15),fitsname(15)
c	common/phottemp/napp,irobj,niikf,njjkf,is2,ipsff,jpsff,
c    *       irmax,irmaxsq
c	common/skymask/nsm,ibpm(60000),jbpm(60000),kbprad(60000),
c    *                ibps(60000),jbps(60000),irowm(60),itm(201,60)
c	call prephot(*790)
	iinit=0
	jinit=0
	iadusat=nint(adusat)
	call querynfr(nfr,kf,0,*999,*510)
 510	continue
	if (ircspipe.eq.0) then
c request initial position shift if required
 612 	  write(6,11) 
 11	  format('  Enter initial rough x/y shifts ',
     *     '(to add to fiducial co-ords) [0,0]'/,
     *     ' enter auto for wcs determinted initital shifts: ',$)
	  call read2i(iinit,jinit,*999,*610)
	  goto 611
 610	  if (iwcs.eq.1) then
	    write(6,*) '  using wcs solution for initial shifts'
	    call wcsshift(nfr,nref,iinit,jjint,1)
	  else
	    write(6,*) ' ** no wcs solution for auto initial shifts'
	    goto 612
	  end if
	else
	  iinit=iinitpipe
	  jinit=jinitpipe
	end if
 611	if (ipipe.eq.0) then
c interactive
	  idev=6
	else
c   if pipeline, set up file for matching info out put .mat file
	  istatus=encode(cext,float(jchip),1,0,idum)
	  outname=nfilen(nf(nfr))(1:lnblnk(nfilen(nf(nfr))))//
     *       cext(1:lnblnk(cext))//'.mat'
          call opennew(41,1,40,outname,*790)
	  idev=41
        end if
	robj=5.
	iia2=55
 790	continue
	nnn=min0(nrfmax,nobref)
	do 100 i=1,nnn
c find new peak
	  newi(i)=nint(refx(i))+iinit
	  newj(i)=nint(refy(i))+jinit
c check if object is in frame
	  if (newi(i).lt.0.or.newi(i).gt.nii(nfr)) then
	    ipeak(i)=0
	    goto 771
	  end if
	  if (newj(i).lt.0.or.newj(i).gt.njj(nfr)) then
	    ipeak(i)=0
	    goto 771
	  end if
 	  call findpk(i,newi(i),newj(i),ix(1,1,nfr),nii(nfr),
     *	      njj(nfr),nu,nv,isbox,ipeak(i),iadusat,idev)
c if ipeak=0 (not found), remove object from list
	  if (ipeak(i).eq.1) then
     	    call pcentr(nfr,0,ix,nu,nv,kf,rnewi(i),rnewj(i),
     *       dumag,dumsky,newi(i),newj(i),1,robj,iia2,1,15)
c	    write(6,1) refx(i),refy(i),rnewi(i),rnewj(i)
	    write(idev,1) refx(i),refy(i),rnewi(i),rnewj(i)
 1	format(' ........ref:',2f9.3, '  new: ',2f9.3)
c  compare peak with sky value, if <1.5xsky, reject (set ipeak=0)
	    if (ix(newi(i),newj(i),nfr).lt.nint(1.5*dumsky)) then
	      write(idev,51) ix(newi(i),newj(i),nfr),dumsky
 51	format(' +++ peak value',i7,' too low compared to sky',
     *         f7.1,' **rejected**')
	      ipeak(i)=0
	    end if
	  end if
	  goto 100
 771	  write(idev,12) newi(i),newj(i)
 12	format('  *** obj at ',2i6,' out of bound, not used')
 100	continue
c compute mean rotation and shift
c
c  form all combinations of delta theta
	n=0
	do 110 j=1,nnn-1
	  if (ipeak(j).eq.0) goto 110
	  do 111 i=j+1,nnn
	    if (ipeak(i).eq.0) goto 111
	    n=n+1
	    if (n.gt.20000) then
	      write(6,*) ' ++ warning: max delta theta (20000) exceeded'
	      goto 119
	    end if
	    dx=refx(i)-refx(j)
	    dy=refy(i)-refy(j)
	    rad=sqrt(dx*dx+dy*dy)
	    cosvalue=dx/rad
	    if (cosvalue.ge.1.0000000) then
	      cosvalue=1.00000
	    else if (cosvalue.le.-1.00000) then
	      cosvalue=-1.00000
	    end if
	    theta1=dacos(cosvalue)
 	    dxnew=rnewi(i)-rnewi(j)
	    cosvalue=amin1(1.000000,dxnew/rad)
	    if (cosvalue.ge.1.0000000) then
	      cosvalue=1.00000
	    else if (cosvalue.le.-1.00000) then
	      cosvalue=-1.00000
	    end if
	    theta2=dacos(cosvalue)
c 	write(6,*) cosvalue1,cosvalue,theta1,theta2
	    delth(n)=theta2-theta1
c	    write(idev,6) n,j,i,delth(n)*57.2958
 6	format(' pair#',i4,' objs ',2i3,'  deg:',f8.5)
 111	  continue
 110	continue
c  determine average delta theta, with rejection
 119	call avsigrej(delth,thmean,thsig,n,nrej,nmrej)
	ndelth=n
	write(idev,21) ndelth,nrej,thmean*57.296,thsig*57.296
 21	format(' averging: # of theta:',i6,', rejected:',i3,' mean:',
     *     f7.3,'  sig:',f7.4)
c
	if (ipar.eq.0) then
	  deltath=0.0
	else
c  only apply rotation if the rotation is larger than 2 sigma
c
	  if (abs(thmean).gt.2*thsig) then
	    deltath=thmean
  	  else
	    write(idev,*) '  ... rotation too small rel to sigma,',
     *               ' Set to 0.0'
	    deltath=0.0
      	  end if
	end if
c  compute average shifts
	nshif=0
	do 112 i=1,nnn
	  if (ipeak(i).eq.1) then
	    nshif=nshif+1
	    delx(nshif)=rnewi(i)-refx(i)+refy(i)*deltath
	    dely(nshif)=rnewj(i)-refy(i)-refx(i)*deltath
 	    write(idev,22) i,delx(nshif),dely(nshif),nshif
	  end if
 22	format(' ref obj#',i3,' del-x',f8.4,'  del-y',f8.4,i5)
 112	continue
	if (nshif.gt.1) then
	  call avsigrej(delx,dxmean,dxsig,nshif,nrej,nmrej)
	else
	  dxmean=999.
	  dxsig=999.
	  write(6,*) '  **** no good object to compute x shift'
	end if
 	write(idev,23) nshif,nrej,dxmean,dxsig
 23	format(' # of delta x:',i4,', rejected:',i3,' mean:',
     *     f8.3,'  sig:',f8.4)
	if (nshif.gt.1) then
	  call avsigrej(dely,dymean,dysig,nshif,nrej,nmrej)
	else
	  dymean=999.
	  dysig=999.
	  write(6,*) '  **** no good object to compute y shift'
	end if
 	write(idev,24) nshif,nrej,dymean,dysig
 24	format(' # of delta y:',i4,', rejected:',i3,' mean:',
     *     f8.3,'  sig',f8.4)
c 
c compute fit to delta-y or x for stretch corrections
c   this should be in the E-W direction:  using parameter istretch
c               0=y,  1=x
c    remove rejected objects
	nfit=0
c temporary
	istretch=0
	if (istretch.eq.0) then
	  do 140 i=1,nnn
	    do 141 k=1,nrej
	      if (i.eq.nmrej(k)) goto 140
 141	    continue
	    nfit=nfit+1
	    xf(nfit)=rnewj(i)
	    yf(nfit)=dely(i)
	    dumsig(nfit)=0.0
 140	  continue
	else 
	  do 142 i=1,nnn
	    do 143 k=1,nrej
	      if (i.eq.nmrej(k)) goto 142
 143	    continue
	    nfit=nfit+1
	    xf(nfit)=rnewi(i)
	    yf(nfit)=delx(i)
	    dumsig(nfit)=0.0
 142	  continue
	end if
c
c temporarily disable stretching
c	call lnfit(xf,yf,nfit,dumsig,0,aadelxy,bbdelxy,
c     *               siga,sigb,chi2,q2)
	bbdelxy=0.0000
	aadelxy=dymean
	if (istretch.eq.0) then
	  write(idev,41) aadelxy,siga,bbdelxy,sigb,chi2,q2
	else 
	  write(idev,42) aadelxy,siga,bbdelxy,sigb,chi2,q2
	end if
 41	format(' Fit to dy: Dy=',f7.3,'+/-',f6.3,' dy/y:',f8.6,'+/-',
     *         f8.6,'  chi^2,q',f10.4,f6.3)
 42	format(' Fit to dx: Dx=',f7.3,'+/-',f6.3,' dx/x:',f8.6,'+/-',
     *         f8.6,'  chi^2,q',f10.4,f6.3)
c
c    applying  the transformation to the reference objects
c	  icomp(i)=nint(refx(i)-refy(i)*deltath+dxmean)
c	  if (ipar.eq.0) then
c	    dycom=aadely+refy(i)*bbdely
c	  else
c	    dycom=0.000
c	  end if
c	  jcomp(i)=nint(refy(i)+refx(i)*deltath+dycom)
c	  jcomp(i)=nint(refy(i)+refx(i)*deltath+dymean)
	write(idev,*) '  ... Verification: '
	if (ipar.eq.0) then
	  write(idev,35) deltath*57.296
	  if (ipipe.eq.1) write(6,35) deltath*57.296
 35	format(' ... Shift, rotate (',f7.4,'), and stretch used..')
	else if (ipar.eq.1) then
	  write(idev,36) dxmean,dymean,deltath*57.296
	  if (ipipe.eq.1) write(6,36) dxmean,dymean,deltath*57.296
 36	format(' ... shift (',2f8.3,') and rotate (',f7.4,') only.. ')
	else if (ipar.eq.2) then
	  write(idev,37) dxmean, dymean
	  if (ipipe.eq.1) write(6,37) dxmean, dymean
 37	format(' ... shift only [dx,dy] = ',2f8.4)
	end if
 	do 115 i=1,nnn
	  call simptrans(refx(i),refy(i),txx,tyy,ipar)
	  icomp(i)=nint(txx)
	  jcomp(i)=nint(tyy)
	  if (ipeak(i).eq.1) then
	    write(idev,25) i,nint(refx(i)),nint(refy(i)),icomp(i)
     *               ,jcomp(i),newi(i),newj(i)
	  else
	    write(idev,26) i,nint(refx(i)),nint(refy(i)),icomp(i)
     *               ,jcomp(i),newi(i),newj(i)
	  end if
 25	format('#',i3,' ref:',2I5,'  computed:',2I5,'  actual:',2I5)
 26	format('#',i3,' ref:',2I5,'  computed:',2I5,'  actual:',2I5,
     *           ' **bad obj, not used ')
 115	continue
c compute score for goodness of result
	iscore=0
	nbigshift=0
	n_used=0
	do 120 i=1,nnn
c how badly the computed vs actual
	  if (ipeak(i).eq.1) then
	    n_used=n_used+1
	    idi=iabs(icomp(i)-nint(rnewi(i)))
	    idj=iabs(jcomp(i)-nint(rnewj(i)))
c how big is the shift
	    ideli=iabs(nint(rnewi(i)-refx(i)))
	    idelj=iabs(nint(rnewj(i)-refy(i)))
	    if (idi.ge.3) then
c note that the score is only added once, for the worst of the 2 co-ord
	      iscore=iscore+idi
	    else if (idj.ge.3) then
	      iscore=iscore+idj
	    else if (idi.eq.2.or.idj.eq.2) then
	      iscore=iscore+1
	    end if
	    if (ideli.ge.3.or.idelj.ge.3) then
c  this signifies always do the transformation
	      nbigshift=nbigshift+1000
	    else if (ideli.eq.1.or.idelj.eq.1) then
	      nbigshift=nbigshift+1
	    end if
	  end if
 120	continue
c  
c	nscrit=min0(3,nint((3.*nnn)/10.))
c  a less stringent criterion: score of 6
c	nscrit=max0(6,nint((3.*nnn)/10.))
 	nscrit=max0(5,nint((3.*n_used)/10.))
	iret=1
	write(idev,38) iscore,n_used,nscrit
 38	format('  Transformation validation score:',i4,/
     *       ,'   For ',i3,' ref objs, a score of <',i3,
     *         ' is acceptable.')
	if (nshif.le.1) then
	  write(idev,*) '  **** no matching objects, failed ***',nnn
	  iret=-1
	end if
	if (iscore.ge.nscrit) then
c  issue warning
	  if (iscore.lt.nint(nscrit*1.333)) then
	    write(idev,*) '  +++ warning, match scores indicate'
     *             ,'possible poor transform +++'
	  else if (iscore.lt.nscrit*3) then
c score a bit large, photometry done, but should be checked
	    write(idev,*) ' +++ shift may be incorrect, photometry'
     *            ,' should be checked'
	    iret=0
	  else if (iscore.ge.nscrit*3) then
c really bad score: do not do photometry
	    write(idev,*) '  **** shift correction faulty, photometry'
     *            ,' not done, skipping to next image'
	    iret=-1
	  end if
	end if
c issue warning if too many objects are rejected
	frac_use=float(n_used)/float(nnn)
	if (frac_use.le.0.85) then
	  if (frac_use.le.0.6) then
c more than 1/2 are rejected, assume no match
	    iret=-1
	    write(idev,61) nnn-n_used,nnn
 61	format(2x,i3,' out of ',i3,' rejected'/
     *    '  **** more than 40% rejected, match failed ****')
	  else
c more than 1/2 are rejected, assume no match
	    iret=0
	    write(idev,62) nnn-n_used,nnn
 62	format(2x,i3,' out of ',i3,' rejected'/
     *    '  ++++ between 15% to 40%  rejected, check match ++++')
	  end if
	end if
	if (ipipe.eq.2) then
c  correct position file if needed
c  this is done only if more than 20% of the objects have a shift 
c  of >=2 pixels, or at any single object with a shift of >=3 pix
	if (nbigshift.ge.nint(0.2*nnn)) then
	  do 125 i=1,nob(nfr)
	    ijoi(i,nfr)=ijoi(i,nfr)-nint(ijoj(i,nfr)*deltath-dxmean)
 	    dycom=aadely+ijoj(i,nfr)*bbdely
 	    ijoj(i,nfr)=ijoj(i,nfr)+nint(ijoi(i,nfr)*deltath+dycom)
c 	    ijoj(i)=ijoj(i)+nint(ijoi(i)*deltath+dymean)
 125	  continue
	  if (nbigshift.gt.999) then
	    ntemp=nbigshift/1000
	    write(idev,30) nnn,ntemp
 30	format(' ... of',i4,' pos refs,',i3,' have shifts>3 pix,',
     *        ' position file transformed')
	  else 
	    write(idev,31) nnn,nbigshift
 31	format(' ... of',i4,' pos refs,',i3,' have shifts=1 pix,',
     *        ' position file transformed')
	  end if
	end if
	end if
c	if (ipipe.eq.0) then
	if (ipipe.eq.2) then
	  write(idev,71)
	  outname=' '
 71	format('  Enter output pos file name (blank=none): ',$)
	  read (5,'(a20)',end=999) outname
	  if (outname.eq.' ') return1
	  outname=outname(1:lnblnk(outname))//'.pos'
	  call opennew(29,1,20,outname,*999)
 601	  write(idev,2)
 2	format(' Enter comment: ',$)
	  read(5,'(a60)',end=999) comment
	  comment=comment(1:lnblnk(comment))//' : '//fdate()
	  write(29,'(i5,2x,a60)') nob, comment
	  write(29,3)
 3	format('#')
	  do 131 i=1,nob(nfr)
	    write(29,4) ijoi(i,nfr),ijoj(i,nfr),i
 4	  format(2i8,2x,'  0     0    ',i6)
 131	  continue
	  close(unit=29)
	else if (ipipe.eq.1) then
	  close(unit=idev)
	  if (iret.eq.-1) then
c  matching failed, mv .mat file to .mat.FAILED file
	    outname2=outname(1:lnblnk(outname))//'.FAILED'
c  query if the file already exists
	    call system('mv '//outname//' '//outname2)
	  else if (iret.eq.0) then
c  matching need checking, mv .mat file to .mat.CHECK file
	    outname2=outname(1:lnblnk(outname))//'.CHECK'
	    call system('mv '//outname//' '//outname2)
	  end if
	end if
 999	return1
	end
c///////////////////////////////////////////
c  subroutine to locate local maximum around a give pixel,
c   and return the new position,  This assumes a well behaved
c   and isolated object of sufficient S/N.
c   It simply searchs for a 2nschX2nsch area for the highest pixel.
c   if this pixel is not at the edge of the box, it is returned
c   as a found peak.  If it is at the edge of the box, it
c   is returned as a new position, but it is not considered
c   as a peak (ipeak=0)
c
	subroutine findpk(num,ii,jj,ix,ni,nj,nu,nv,nsch,ipeak,
     *                    iadusat,idev)
	integer ix(nu,nv)
	ixtem=ix(ii,jj)
	ip=ii
	jp=jj
c locate the highest pixel within the box
	do 100 j=jj-nsch,jj+nsch
	  do 101 i=ii-nsch,ii+nsch
	    if (ix(i,j).gt.ixtem) then
	      ixtem=ix(i,j)
	      ip=i
	      jp=j
	    end if
 101	  continue
 100	continue
c  now check the new peak 
	if (ip.lt.ii+nsch.and.ip.gt.ii-nsch) then
	  if (jp.lt.jj+nsch.and.jp.gt.jj-nsch) then
c the peak is not at the edges, therefore it is a good peak
c	write(6,10) num,ii,jj,ip,jp,ix(ip,jp)
	write(idev,10) num,ii,jj,ip,jp,ix(ip,jp)
 10	format(i3,'.... old peak',2i5,'  NEW peak found: ',2i5,i7)
	    if (ix(ip,jp).gt.1.and.ix(ip,jp).lt.iadusat) then
	      ipeak=1
	      ii=ip
	      jj=jp
	    else
	      ipeak=0
	      write(idev,*) ' **peak saturated or below sky, not used'
	    end if
	    return
	  end if
	end if
c  peak is at edge, not successful in finding a new peak
	write(6,11) ii,jj,ip,jp,ix(ip,jp)
	write(idev,11) ii,jj,ip,jp,ix(ip,jp)
 11	format('.... old peak',2i5,'  NEW peak found at border: '
     *          ,2i5,i7)
	ii=ip
	jj=jp
	ipeak=0
	return
	end
c////////////////////////////////////////////////////
c  subroutine to apply transformation from simptran (one at a time)
c
c   ipar=0 apply all correction
c   ipar=1 do not apply stretch
c
	subroutine simptrans(xorig,yorig,xnew,ynew,ipar)
	common/transf/dxmean,dymean,deltath,aadelxy,bbdelxy,istretch
	if (istretch.eq.0) then
c  stretch correction is in y
	  xnew=xorig-yorig*deltath+dxmean
	  if (ipar.eq.0) then
	    dycom=aadelxy+yorig*bbdelxy
	  else
	    dycom=dymean
	  end if
	  ynew=yorig+xorig*deltath+dycom
	else
c  stretch correction is in y
	  ynew=yorig-xorig*deltath+dymean
	  if (ipar.eq.0) then
	    dxcom=aadelxy+xorig*bbdelxy
	  else
	    dxcom=dxmean
	  end if
	  xnew=xorig+yorig*deltath+dxcom
	end if
	return
	end
c/////////////////////////////////////////////////////////////
c   subroutine to find the general transformation between 2 position
c     file using Bauching''s routine for finding shift and rotation
c         (subroutine ftrans).
c
c    this is used for testing the routine.  Use subroutine transfpos to
c          use the result to transform a position file
c
c   the master is nfr1, and the transformation is to put the xy of 1 onto 2
c
	subroutine transfdri(nfr1,nfr2,ix,nu,nv,kf,*)
	integer ix(nu,nv,kf)
	character dumstr*60
	include 'objcat.inc'
	call querynfr(nfr1,kf,1,*999,*2001)
 2001	call querynfr(nfr2,kf,2,*999,*2002)
 2002	if (nfr1.gt.2.or.nfr2.gt.2) then
	  write(6,*) '  **** position files for fr 1 and 2 only * abort'
	  return1
	end if
c  quick fine positions for frames 1 and 2
	dumstr='dummy'
	call FINOBD(*809,nfr1,dumstr,dumstr,0.00,7,IX,NU,NV,KF)
 809	call FINOBD(*810,nfr2,dumstr,dumstr,0.00,7,IX,NU,NV,KF)
c  use autoref to get rid of junks and galaxies
c810	call autoref(1,ix,nu,nv,kf,0,*811)
c811	call autoref(2,ix,nu,nv,kf,0,*812)
 810	call ftrans(nfr2,nfr1,nob(nfr2),ijoi(1,nfr2),ijoj(1,nfr2),
     *        nob(nfr1),ijoi(1,nfr1),ijoj(1,nfr1))
 999	return1
	end
c//////////////////////////////////////////////////////////
c   driving routine for transfpos
c
	subroutine tposdri(nfr,kf,*)
	include 'objcat.inc'
	call querynfr(nfr,kf,0,*999,*2001)
 2001	if (ixncompute.ne.1) then
	  write(6,1) 
 1	format(' *** transform not done: coefficents have not',
     *             ' been computed ***')
	  return 1
	end if
	call transfpos(nob(nfr),ijoi(1,nfr),ijoj(1,nfr),xn)
 999	return1
	end
c//////////////////////////////////////////////////
c  subroutine to apply transformation of shift and rotate (from
c                fshr) to position file;
c     Note: this changes the posfil array of frame nfr
c       must run fshr first to fill xn array
	subroutine transfpos(nob,iii,jjj,xn)
	integer iii(*),jjj(*)
	real*8 xn(3),sinxn,cosxn
c  compute new positions
 2001 	sinxn=dsin(xn(4))
	cosxn=dcos(xn(3))
	write(6,1) xn(1),xn(2),xn(3),xn(4)
 1	format(' transformation coeff. xn1 xn2 xn3 xn4: ',2f6.2,2f8.4)
	do 100,i=1,nob
c  need to save one of the co-ordinate 
	 iitem=iii(i)
         iii(i)=nint(xn(1)+cosxn*iii(i)+sinxn*jjj(i))
         jjj(i)=nint(xn(2)-sinxn*iitem+cosxn*jjj(i))
 100	continue
    	return 
	end
c/////////////////////////////////////////////////////
c  subroutine to find the general (shift and rotate) transformation
c    using 2 position files; adopted from BauChing Hsieh.
c
c  input nobj1/2, objx1/2 objy1/2: input object number and xy for 2 files
c     this version uses integer object position (probably okay, since
c     it''s a fit from many objects) 
c  output:  xn(3), this is stored in a common statement
c   the transformation formulae are:
c        x_new=xn(1)+cos(nx(3))*x+sin(nx(3))*y
c        y_new=xn(2)-sin(nx(3))*x+cos(nx(3))*y
c
c  note the order here is nfr2 is the master, nfr1 is the
c   one to be matched
c
	subroutine ftrans(nfr1,nfr2,nobj1,objx1,objy1,nobj2,objx2,objy2)
	integer objx1(*),objy1(*),objx2(*),objy2(*)
	INTEGER arraya(10000),arrayb(10000),arrayat(10000),arraybt(10000)
	INTEGER nobj1,nobj2,objx21,objy21,xnew,ynew,ref(2),
     *          findcount,goodfindcount
	real goodxn(4),newx1(10000),newy1(10000),newx2(10000),newy2(10000)
	real*8 newxn(4),cosxn,sinxn
	include 'objcat.inc'
c matching objects
c rough solution
c h is for rotation
                                                                                
        goodfindcount=0
        do j=1,nobj2
          do L=1,nobj1
c this assume small stretch, so g is not searched here
            do h=-0.1,0.1,0.002
              findcount=0
                                                                                
              XN(1)=objx1(L)-objx2(j)
              XN(2)=objy1(L)-objy2(j)
              XN(3)=h
              cosXN=dcos(XN(3))
              sinXN=dsin(XN(3))
                                                                                
              if(abs(XN(1)).ge.200..or.abs(XN(2)).ge.200.) then
                goto 55
              endif
                                                                                
              do n=1,nobj2
                objx21=XN(1)+objx2(j)
     1            +cosXN*(objx2(n)-objx2(j))
     1            +sinXN*(objy2(n)-objy2(j))
                objy21=XN(2)+objy2(j)
     1            -sinXN*(objx2(n)-objx2(j))
     1            +cosXN*(objy2(n)-objy2(j))
                do m=1,nobj1
                  if(abs(objx21-objx1(m)).le.5..and.
     1               abs(objy21-objy1(m)).le.5.) then
                    findcount=findcount+1
c store matched objects for polynomial fittings
                    arrayat(findcount)=m
                    arraybt(findcount)=n
                  endif
                enddo
              enddo
                                                                                
              if(findcount.gt.goodfindcount) then
                goodfindcount=findcount
                goodXN(1)=XN(1)
                goodXN(2)=XN(2)
                goodXN(3)=XN(3)
                ref(1)=objx2(j)
                ref(2)=objy2(j)
                do n=1,goodfindcount
                  arraya(n)=arrayat(n)
                  arrayb(n)=arraybt(n)
                enddo
              endif
                                                                                
 55         enddo
          enddo
        enddo
                                                                                
                                                                                
        write(*,'(A,I5)')'No. of Objects matched:',goodfindcount
        write(*,'(A,F5.1,A)')
     1    'Find ratio1:',real(goodfindcount)/real(nobj1)*100.,'%'
        write(*,'(A,F5.1,A)')
     1    'Find ratio2:',real(goodfindcount)/real(nobj2)*100.,'%'
                                                                                
        XN(3)=goodXN(3)
        cosXN=dcos(XN(3))
        sinXN=dsin(XN(3))
                                                                                
        XN(1)=goodXN(1)+ref(1)-cosXN*ref(1)-sinXN*ref(2)
        XN(2)=goodXN(2)+ref(2)+sinXN*ref(1)-cosXN*ref(2)
                                                                                

c put matched objects into new arrays for polynomial fittings
        do i=1,goodfindcount
          newx1(i)=objx1(arraya(i))
          newy1(i)=objy1(arraya(i))
          newx2(i)=objx2(arrayb(i))
          newy2(i)=objy2(arrayb(i))
c for checking: put the matched objects into posf
c	  ijoi(i,nfr1)=nint(newx1(i))
c	  ijoj(i,nfr1)=nint(newy1(i))
c	  ijoi(i,nfr2)=nint(newx2(i))
c	  ijoj(i,nfr2)=nint(newy2(i))
        enddo
c	nob(nfr1)=goodfindcount
c	nob(nfr2)=goodfindcount
                                                                                
        chi=0
        cosXN=dcos(XN(3))
        sinXN=dsin(XN(3))
                                                                                
        do n=1,goodfindcount
          chi=chi
     1       +((XN(1)+cosXN*newx2(n)+sinXN*newy2(n))
     1       -newx1(n))**2.
     1       +((XN(2)-sinXN*newx2(n)+cosXN*newy2(n))
     1       -newy1(n))**2.
        enddo
        write(*,'(A,2F6.1,F8.4,F9.2)')'Before fitting, XN(1,2,3), chi:',
     1    XN(1),XN(2),XN(3),chi/real(goodfindcount)
                                                                                
        goodchi=99999999.
	xn(4)=xn(3)
c Perform polynomial fitting
c xx is for X-offset
c yy is for Y-offset
c tt ss is for rotation
                                                                                
        do xx=-8,8,0.1
          do yy=-8,8,0.1
            do tt=-0.006,0.006,0.0001
              do ss=-0.006,0.006,0.0001
              chi=0
              newXN(1)=XN(1)+xx
              newXN(2)=XN(2)+yy
              newXN(3)=XN(3)+tt
              newXN(4)=XN(4)+ss
              cosXN=dcos(newXN(3))
              sinXN=dsin(newXN(4))
                                                                                
                                                                                
              do n=1,goodfindcount
                chi=chi
     1             +((newXN(1)+cosXN*newx2(n)+sinXN*newy2(n))
     1             -newx1(n))**2.
     1             +((newXN(2)-sinXN*newx2(n)+cosXN*newy2(n))
     1             -newy1(n))**2.
              enddo
                                                                                
              if(chi.lt.goodchi) then
                goodXN(1)=newXN(1)
                goodXN(2)=newXN(2)
                goodXN(3)=newXN(3)
                goodXN(4)=newXN(4)
                goodchi=chi
              endif
                                                                                
              enddo
            enddo
          enddo
        enddo
c shift+rotate  fitting finished
c       added by HY: allows a scale change between filters
c          note: this would only work if the scale change is small, a
c                few pix over the whole chip!!
c
c  this assumes the center is fitted properly
c	do ss=-1.02,1.02,0.0005
c	end do
c fitting finished
        XN(1)=goodXN(1)
        XN(2)=goodXN(2)
        XN(3)=goodXN(3)
        XN(4)=goodXN(4)
        cosXN=dcos(XN(3))
        sinXN=dsin(XN(4))
        ixncompute=1                                                            
        write(*,'(A,2F6.1,2F8.4,F9.2)')'After fitting, XN(1,2,3), chi: ',
     1          XN(1),XN(2),XN(3),xn(4),goodchi/real(goodfindcount)
                                                                                
	return
	end
c/////////////////////////////////////////////////////
c  subroutine to take in a posref file and produce a posref
c   file with fractional pixel centroid.
c    it uses the positions already stored in refx and refy
c       ipar=1: output the result in a file
c            0: no output
	subroutine fracpos(nfr,ix,nu,nv,kf,ipar,*)
	integer ix(nu,nv,kf)
c	real reali(200),realj(200)
	dimension skaray(50000)
	character filout*20,comment*60
	include 'objcat.inc' 
	include 'apert.inc'
	include 'picdir.inc'
	common/phottemp/napp,irobj,niikf,njjkf,is2,ipsff,jpsff,
     *       irmax,irmaxsq
c	call prephot(*790)
c790	continue
	robj=5.
	iia2=55
	do 100 i=1,nobref
	  newi(i)=nint(refx(i))
	  newj(i)=nint(refy(i))
	  call pcentr(nfr,0,ix,nu,nv,kf,reali,realj,dumag,
     *        sky,newi(i),newj(i),1,robj,iia2,1,15)
c          CALL RCSKY(1,SKY,ZSIG,NAPP,newi,newj,NII,NJJ,IX
c     *                    ,NU,NV,SKARAY,50000,nsk,0,iret,6)
c	  call ccenter(i,newi,newj,2,5.,reali(i),realj(i),sky,
c     *                 ix,nu,nv,1,iconv,6)
c  store the fractional pixel back inot refx and refy
	  refx(i)=reali
	  refy(i)=realj
c	write(6,*) ' object',i,refx(i),refy(i)
 100	continue
c  output
	if (ipar.eq.1) then
 600	  write(6,1)
 1	format(' Enter output ref pos file name: ',$)
	  read(5,'(a20)',end=999) filout
	  filout=filout(1:lnblnk(filout))//'.pos'
 601	  write(6,2)
 2	format(' Enter comment: ',$)
	  read(5,'(a60)',end=999) comment
	  call opennew(29,1,20,filout,*999)
	  comment=comment(1:lnblnk(comment))//' : '//fdate()
	  write(29,'(i5,2x,a60)') nobref, comment
	  write(29,3)
 3	format('#')
	  do 101 i=1,nobref
	    write(29,4) refx(i),refy(i),i
 4	format(2f11.4,2x,i4)
 101	  continue
	  close(unit=29)
	end if
 999	return1
	end
c//////////////////////////////////////////////////////////////
c  take (I,J) file of positions from 1, with the corresponding 
c  WCS solutions for 1 and 2, transform position file 1 into 2''s co-ord
c   by transforming ij from 1 into RA/Dec, then to ij in 2
c
	subroutine wcstranpf(nob,iipos1,jjpos1,iipos2,jjpos2,nfr1,nfr2)
	integer iipos1(*),jjpos1(*),iipos2(*),jjpos2(*)
	real*8 ra,dec
	include 'imagepar.inc'
	do 100 i=1,nob
c get RA and dec from wcs1
	  xx=iipos1(i)
	  yy=jjpos1(i)
	  call astrom(nfr1,xx,yy,ra,dec)
c get pix position on 2 from ra and dec, using wcs2, convert RA to deg first
	  ra=ra*15.0
	  call xypixpos(nfr2,xx,yy,ra,dec)
	  iipos2(i)=nint(xx)
	  jjpos2(i)=nint(yy)
 100	continue
	return
	end
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CALCULTE AVERAGE AND SIGMA, with rejection
c   the first rejection uses 2.25 sigma,
c    after that, 3.1 sigma
c
c   nmrej contains the object numbers of rejected objects
C
	SUBROUTINE avsigrej(XX,AVE,SIG,NPTT,nrej,nmrej)
	REAL XX(*),x(nptt)
	integer nmrej(*),indx(nptt)
	npt=nptt
	nrej=0
	do 111 k=1,npt
	  indx(k)=k
	  x(k)=xx(k)
 111	continue
	do 110 k=1,10
	  SUM=0.
	  DO 100 I=1,NPT
 100	    SUM=SUM+X(I)
	  AVE=SUM/FLOAT(NPT)
	  sig=0.
	  IF (NPT.LE.1) RETURN
	  do 101 i=1,npt
	    s=x(i)-ave
	    sig=sig+s*s
 101	  continue
	  SIG=SQRT(AMAX1(.000000001,sig/FLOAT(NPT-1)))
c  rejection
	  if (k.eq.1) then
c	    thres=2.9
c	    thres=2.25
	    thres=2.00
	  else if (k.eq.2) then
c	    thres=3.0
	    thres=2.5
	  else if (k.ge.3) then
	    thres=3.0
	  end if
	  chek=thres*sig
c  nj is the number of rejection for each iteration
c  nrej is the total number
	  nj=0
	  nrejmax=nptt/4
	  do 102 i=1,npt
	    if (i.gt.npt-nj) goto 102
	    if (abs(x(i)-ave).gt.chek) then
	      nrej=nrej+1
	      if (nrej.gt.nrejmax) then
	        write(6,*) '  ** more than 1/4 rejected ** '
     *                , ' rejection algorithm stopped '
	        write(6,*) '  ** aver/sig prob not correct ** '
	        goto 103
	      end if
	      nmrej(nrej)=indx(i)
	      do 105 n=i,npt-nj-1
	        x(n)=x(n+1)
	        indx(n)=indx(n+1)
 105	      continue
	      nj=nj+1
	    end if
 102	  continue
 103	  npt=npt-nj
c   	write(6,*) ' ave sig npt nrej',ave,sig,npt,nj
	  if (nj.eq.0) goto 115
 110	continue
c115	nrej=nptt-npt
 115	if (nrej.ne.nptt-npt) write(6,*) 
     *      ' **** rejection cts inconsistent'
	RETURN
	END
c//////////////////////////////////////////////////
c  linear regression fit
c   from Numerical Recipie
c    fits Y=BX+A,  MWT=0: no error on data, =1 with error
c
      SUBROUTINE LNFIT(X,Y,NDATA,SIG,MWT,A,B,SIGA,SIGB,CHI2,Q)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA)
      SX=0.
      SY=0.
      ST2=0.
      B=0.
      IF(MWT.NE.0) THEN
        SS=0.
        DO 11 I=1,NDATA
          WT=1./(SIG(I)**2)
          SS=SS+WT
          SX=SX+X(I)*WT
          SY=SY+Y(I)*WT
11      CONTINUE
      ELSE
        DO 12 I=1,NDATA
          SX=SX+X(I)
          SY=SY+Y(I)
12      CONTINUE
        SS=FLOAT(NDATA)
      ENDIF
      SXOSS=SX/SS
      IF(MWT.NE.0) THEN
        DO 13 I=1,NDATA
          T=(X(I)-SXOSS)/SIG(I)
          ST2=ST2+T*T
          B=B+T*Y(I)/SIG(I)
13      CONTINUE
      ELSE
        DO 14 I=1,NDATA
          T=X(I)-SXOSS
          ST2=ST2+T*T
          B=B+T*Y(I)
14      CONTINUE
      ENDIF
      B=B/ST2
      A=(SY-SX*B)/SS
      SIGA=SQRT((1.+SX*SX/(SS*ST2))/SS)
      SIGB=SQRT(1./ST2)
      CHI2=0.
      IF(MWT.EQ.0) THEN
        DO 15 I=1,NDATA
          CHI2=CHI2+(Y(I)-A-B*X(I))**2
15      CONTINUE
        Q=1.
        SIGDAT=SQRT(CHI2/(NDATA-2))
        SIGA=SIGA*SIGDAT
        SIGB=SIGB*SIGDAT
      ELSE
        DO 16 I=1,NDATA
          CHI2=CHI2+((Y(I)-A-B*X(I))/SIG(I))**2
16      CONTINUE
        Q=GAMMQ(0.5*(NDATA-2),0.5*CHI2)
      ENDIF
      RETURN
      END
