	SUBROUTINE MMM(ZRAY,NZ1,NZ3,ZMEAN,ZMEDIAN,ZMODE,ZSIGMA,ZSKEW,
     &       ZREJECT,NITER,RKLUGE,ONEMEAN)
C-----'FLOATING' REJECTION INSTALLED, SEPT 78, DCW.
c  Notes on the parameter RKLUGE: the rejection criterion
c    July 29, 2008
c     RKLUGE has a significant effect on the rms value returned.
c        it seems to be connected with the sigma multiple as the criterion.
c      When it is <1.0, it is computed using some formula, which
c      essentially produces a rejction very close to rkluge >3 
c      when it is between 1 and 2, it is set to 2; the values raises
c        quickly to a stable value for rkluge>3 (few rejections) 
c         
	REAL ZRAY(NZ1)
	REAL*8 S,SS
	REAL PLTX(2),PLTY(2)
	COMMON IFREQ
	DATA ICT/0/
	DATA XINDEF/-99999/
C
	IF(NZ1.LE.0)GO TO 33
C
C-----EXTRACT NONBLANK PIXELS,SET CUT1=ZMIN,CUT2=ZMAX:
	N=0
	S=0.000000000000000
	SS=0.000000000000000
	DO 30 I=1,NZ1
	Z=ZRAY(I)
	IF(N.NE.0)GO TO 20
	CUT1=Z
	CUT2=Z
   20	CUT1=AMIN1(Z,CUT1)
	CUT2=AMAX1(Z,CUT2)
	N=N+1
	ZRAY(N)=Z
	S=S+Z
	SS=SS+Z*Z
   30	CONTINUE
C
C-----CHECK FOR AT LEAST ONE VALUE:
	IF(N.NE.0)GO TO 35
   33	NZ3=0
	NITER=0
	ZMEAN=XINDEF
	ZMEDIAN=XINDEF
	ZMODE=XINDEF
	ZSIGMA=XINDEF
	ZSKEW=XINDEF
	ZREJECT=XINDEF
	RETURN
C
C-----SORT THE DATA:
   35	I=0
	Z0=ZRAY(I)
	ZNP1=ZRAY(N+1)
	ZRAY(I)=CUT1
	ZRAY(N+1)=CUT2
c  adder Jan 25 2005 to prevent N=0
	N=max(1,N)
	CALL QUIK1(N,ZRAY,ZRAY,N,1)
	ZRAY(I)=Z0
	ZRAY(N+1)=ZNP1
C
C-----INITIALIZE FOR ITERATION LOOP:
	NIT=0
	J1=0
	NZ2=N
	J2=N
C
C-----THE BIG LOOP:
   40	NIT=NIT+1
	J1L=J1
	NZL=NZ2
C
C-----GET MEAN AND SIGMA:
	FNZL=NZL
	ZBAR=S/FNZL
	IF(NIT.EQ.1)ONEMEAN=ZBAR 
	ZSIG=SS/FNZL-ZBAR*ZBAR
	IF (ZSIG.LT.0.) RETURN
	ZSIG=SQRT(ZSIG)
C
C-----GET MEDIAN:
C     (NOTE THAT DATA ARRAY STAYS SORTED EVEN WHEN VALUES ARE REJECTED)
	J=J1L+(NZL +1)/2
C############################## ADDED MAR 26 84
C	JJM=J   !+1
	JJM=J
C	PRINT*, 'J1L',JIL,'NZL',NZL,'JJM',JJM
C  if NZL is even, test if the median pixel is at the low end of a boundry
	IF (MOD(NZL,2).EQ.0) THEN
	  IF (ZRAY(JJM).NE.ZRAY(JJM+1)) THEN
C count if the numbers on either side of the boundry is the same, if so
C  med = aver of the two values	
	    KH=1
	    DO 440 KK=JJM+2,NZ1
	      IF (ZRAY(JJM+1).NE.ZRAY(KK)) GO TO 441
	      KH=KH+1
 440	    CONTINUE
 441	    KL=1
	    DO 442 KK=JJM-1,J1L+1,-1
	      IF (ZRAY(KK).NE.ZRAY(JJM)) GO TO 443
	      KL=KL+1
 442	    CONTINUE
 443	    CONTINUE
C	PRINT*,' testing even array, KH,KL',KH,KL
	    IF (KH.EQ.KL) THEN
	      ZMED=0.5*(ZRAY(JJM)+ZRAY(JJM+1))
	      GO TO 455
	    END IF
	  END IF
	END IF
	DO 400 KK=JJM+1,NZ1
 400	IF (ZRAY(KK).GT.ZRAY(JJM)) GO TO 401
 401	KH=KK-1
	DO 402 KK=JJM-1,J1L+1,-1
 402	IF (ZRAY(KK).LT.ZRAY(JJM)) GO TO 403
 403	KL=KK+1
C ##### modification Apr 12 1987: RKTOT is the total number of pixels
C    with the value of ZMED (=integer), (an addtional 1 is added to it
C    for an APR 2 87 version, that was incorrect)
C    RJMM is the counts in that bin
C    to arrive at the real median pixel corrected for .5 unit--- 
C     RJJM was JMM-KL-1 on the old old version.  the 0.5*(MOD etc
C    is added because in case of even number of pixels because the
C    the initial guess of the median pixel is NZL/2     
	RKTOT=KH-KL+1.
	RJJM=JJM-KL+0.5  +0.5*(MOD(NZL+1,2))
	ZMED=ZRAY(JJM)
c	PRINT*,'ZMED',ZMED,'RJJM,RKTOT',RJJM,RKTOT
C##########################################
	IF (RKTOT.GT.1.) ZMED=ZMED-(.5-RJJM/RKTOT)
C      IF((NZL.AND.1).EQ.0)ZMED=0.5*(ZRAY(J)+ZMED)
C
C-----GET MODE ESTIMATE:
 455	ZMOD=3.*ZMED-2.*ZBAR
C      PRINT *,CUT1,CUT2,ZBAR,ZMED,ZMOD,ZSIG,N
C
	IF(NIT.GT.10)GO TO 190
C
C-----GET CHAUVENET REJECTION CRITERION:
	R=RKLUGE
	IF(R.GT.1.0)GO TO 60
	R=ALOG10(FNZL*R)
	R=(-.1042*R+1.1695)*R+.8895
   60	R=AMAX1(R,2.0)
C
C-----GET REJECTION CUTS BASED ON MODE:
	CUT=R*ZSIG+0.5*ABS(ZBAR-ZMOD)
	CUT1=ZMOD-CUT
	CUT2=ZMOD+CUT
C
C-----NOW USE CUT1+CUT2 TO REJECT VALUES FROM LIST:
C     J1 POINTS TO LAST REJECTED VALUE AT BEGINNING OF LIST.
C     J2 POINTS TO LAST ACCEPTED VALUE IN LIST.
C     SO, J2-J1 IS THE NUMBER OF ACCEPTED VALUES IN THE LIST.
C     LIST IS SORTED, SO WE WILL SIMPLY STEP J1 AND J2 FORWARD OR
C     BACKWARD TO FIND WHERE CUT1 AND CUT2 FIT INTO THE LIST
C     OF SORTED VALUES. WE ADD OR SUBTRACT VALUES FROM THE S AND SS SUMS
C     AS WE MOVE THE J1 AND J2 POINTERS.
C     WE DEPEND ON THE 48-BIT MANTISSA OF THE 6400 TO MAINTAIN ENOUGH
C     PRECISION IN THE S AND SS SUMS SO THAT WE CAN CALCULATE -ZSIG-.
C
C     SHOULD CUT1 BE MOVED TOWARD MIDDLE OF LIST:
	IF(J1.EQ.N)GO TO 80
	Z=ZRAY(J1+1)
	IF(CUT1.LE.Z)GO TO 80
   70	S=S-Z
	SS=SS-Z*Z
	J1=J1+1
	IF(J1.EQ.N)GO TO 90
	Z=ZRAY(J1+1)
	IF(CUT1.GT.Z)GO TO 70
	GO TO 90
C     ELSE, SHOULD CUT1 BE MOVED TOWARD BEGINNING OF LIST:
   80	IF(J1.EQ.0)GO TO 90
	Z=ZRAY(J1)
	IF(CUT1.GT.Z)GO TO 90
	S=S+Z
	SS=SS+Z*Z
	J1=J1-1
	GO TO 80
C     SHOULD CUT2 BE MOVED TOWARD MIDDLE OF LIST:
   90	IF(J2.EQ.0)GO TO 110
	Z=ZRAY(J2)
	IF(CUT2.GE.Z)GO TO 110
  100	S=S-Z
	SS=SS-Z*Z
	J2=J2-1
	IF(J2.EQ.0)GO TO 120
	Z=ZRAY(J2)
	IF(CUT2.LT.Z)GO TO 100
	GO TO 120
C     ELSE, SHOULD CUT2 BE MOVED TOWARD END OF LIST:
  110	IF(J2.EQ.N)GO TO 120
	Z=ZRAY(J2+1)
	IF(CUT2.LT.Z)GO TO 120
	S=S+Z
	SS=SS+Z*Z
	J2=J2+1
	GO TO 110
C
  120	NZ2=J2-J1
C
C-----TEST TO EXIT LOOP:
	IF(NZ2.EQ.0)GO TO 190
	IF(J1.NE.J1L)GO TO 40
	IF(NZ2.NE.NZL)GO TO 40
C
C
C-----THATS ALL, FOLKS:
  190	NZ3=NZL
	ZMEAN=ZBAR
	ZMEDIAN=ZMED
	ZMODE=ZMOD
	ZSIGMA=ZSIG
	IF (ZSIG.GT..00001)THEN
	ZSKEW=(ZBAR-ZMOD)/ZSIG
	ELSE
	ZSKEW=1.E09
	ENDIF
	ZREJECT=R
	NITER=NIT
	RETURN
	END

	SUBROUTINE QUIK1(NNN,KKK,RRR,IRRR,JRRR)
C
C     PARTITION EXCHANGE SORT BY C.A.R. HOARE (COMP.J.5,10-15,1962).
C     FROM: ALGORITHM 'Q', PP114-123 IN VOL.3 OF 'THE ART OF COMPUTER
C     PROGRAMMING' BY D.E. KNUTH (1973).
C     ASSUMES ARTIFICIAL KEYS: KKK(0) .LE. ALL KKK(I) .LE. KKK(NNN+1)
C
	IMPLICIT INTEGER (A-Z)
	REAL KKK(NNN),RRR(IRRR,JRRR),RR(64),STACK(30)
	DATA MMM/9/
	DATA JRRRM/64/
C
C
C-----CRASH THE JOB IF JRRR IS TOO BIG:
	IF ( JRRR .GT. JRRRM ) S = KKK(50000)
C     IF (JRRR.GT.JRRRM) CALL SYSTEM (52,
C    $                        ' JRRR.GT.JRRRM, SEE DON WELLS')
C
C-----INITIALIZE:
   10	S=0
	L=1
	R=NNN
C-----BEGIN NEW STAGE:
   20	IF((R-L).LT.MMM)GO TO 80
	I=L
	J=R
C     CHOOSE NEW KEY:  (ALGORITHM FROM P.123 OF KNUTH,         )
C                      (SEE R.C. SINGLETON, CACM12,185-187,1969)
C                      (GETS MEDIAN OF KKK[L],KKK[LR],KKK[R]   )
	LR=(L+R)/2
	Q=LR
	A=L
	IF(KKK(Q).GE.KKK(A))GO TO 21
	Q=L
	A=LR
   21	IF(KKK(Q).LE.KKK(R))GO TO 22
	Q=R
   22	IF(KKK(Q).GE.KKK(A))GO TO 23
	Q=A
   23	CONTINUE
C     Q NOW POINTS AT THE MEDIAN OF THE THREE VALUES:
	KK=KKK(Q)
	DO 25 W=1,JRRR
	RR(W)=RRR(Q,W)
   25	RRR(Q,W)=RRR(L,W)
C-----COMPARE KK TO KKK(J):
   30	IF(.NOT.(KK.LT.KKK(J)))GO TO 40
	J=J-1
	GO TO 30
C-----TRANSFER TO RRR(I):
   40	IF(.NOT.(J.LE.I))GO TO 45
	DO 42 W=1,JRRR
   42	RRR(I,W)=RR(W)
	GO TO 70
   45	DO 46 W=1,JRRR
   46	RRR(I,W)=RRR(J,W)
   49	I=I+1
C-----COMPARE KKK(I) TO KK:
   50	IF(KKK(I).LT.KK)GO TO 49
C-----TRANSFER TO RRR(J):
   60	IF(J.LE.I)GO TO 65
	DO 62 W=1,JRRR
   62	RRR(J,W)=RRR(I,W)
	J=J-1
	GO TO 30
   65	DO 66 W=1,JRRR
   66	RRR(J,W)=RR(W)
	I=J
C-----PUT ON STACK:
   70	IF((R-I).GE.(I-L))GO TO 75
	S=S+2
	STACK(S-1)=L
	STACK(S  )=I-1
	L=I+1
	GO TO 20
   75	S=S+2
	STACK(S-1)=I+1
	STACK(S  )=R
	R=I-1
	GO TO 20
C-----STRAIGHT INSERTION SORT:
   80	J=L
   81	J=J+1
	IF(J.GT.R)GO TO 90
	KK=KKK(J)
	DO 82 W=1,JRRR
   82	RR(W)=RRR(J,W)
	I=J-1
   83	IF(KKK(I).LE.KK)GO TO 85
	DO 84 W=1,JRRR
   84	RRR(I+1,W)=RRR(I,W)
	I=I-1
	IF(I.LT.0) GO TO 99
	GO TO 83
   85	DO 86 W=1,JRRR
   86	RRR(I+1,W)=RR(W)
	GO TO 81
C-----TAKE OFF STACK:        (EXIT IF STACK IS EMPTY)
   90	IF(S.EQ.0)RETURN
	L=STACK(S-1)
	R=STACK(S)
	S=S-2
	GO TO 20
   99	PRINT *,' SORT RUNAWAY'
	CALL SLOW1(NNN,KKK)
	RETURN
	END

	SUBROUTINE SLOW1(N,KKK)
	REAL KKK(N),M
	DO I=1,N
	  DO J=1,N
	    IF(KKK(I).LT.KKK(J))THEN
	      M=KKK(I)
	      KKK(I)=KKK(J)
	      KKK(J)=M
	    END IF
	  END DO
	END DO
	RETURN
	END
