C
C///////////////////////////////////////////////////////////////////////
C
C  DRIVING ROUTINE FOR FINDING ACCURATE CENTROID
C
C///////////////////////////////////////////////////////////////////////
C
	SUBROUTINE DPCENT(*,NFRA,IX,NU,NV,KF,IPAR)
c	INTEGER*2 IX(NU,NV,KF),II,JJ
	INTEGER IX(NU,NV,KF),II,JJ
	CHARACTER*2 IAN
	DIMENSION NFRA(5)
	INCLUDE 'ppparm.inc'
  	INCLUDE 'picdir.inc'
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*554)
 554	IF (NFRA(2).LE.0.OR.NFRA(3).LE.0) THEN
 600	  WRITE(6,10) IIT,JJT
 10	FORMAT('   Enter interger pixel centroid [I,J:',2I5,
     *         ']: ',$)
	  CALL READ2I(IIT,JJT,*999,*600)
	ELSE
	  IIT=NFRA(2)
	  JJT=NFRA(3)
	END IF
	II=IIT
	JJ=JJT
	IF (II.LT.1.OR.II.GT.NII(NFR).OR.JJ.LT.1.OR.JJ.GT.NJJ(NFR)) THEN
	  WRITE(6,*) '  ***** CO-ORDINATES TOO LARGE OR <0 ****'
	  RETURN1
	END IF
	IF (NFRA(4).LE.0.OR.NFRA(5).LE.NFRA(4)) THEN
 601	  WRITE(6,11) RIRO,RIRS
 11	FORMAT('   Enter inner obj (fractional pix) and outer sky'
     *         ,' diameters (int pix)'/'   [',F5.1,F6.0,']: ',$)
	  CALL READ2R(RIRO,RIRS,*999,*601)
	  IRS=NINT(RIRS)
	ELSE
	  RIRO=NFRA(4)
	  IRS=NFRA(5)
	  RIRS=IRS
	END IF
 555	CALL PCENTR(NFR,1,IX,NU,NV,KF,REALI,REALJ,RMAG,SKY,
     *                 II,JJ,1,RIRO,IRS,1,ITERCEN)
	IF (IPAR.EQ.0) THEN
	  RETURN1
	ELSE
 603	  WRITE(6,13)
 13	FORMAT('   For change: c=Co-ord., a=aperture, ac=both, <cr>=out:'
     *            ,$)
	  call readstr(2,ian,*999,*603)
	  IF (IAN.EQ.'c') THEN
 604	    WRITE(6,21)
 21	FORMAT('   Enter new interger pixel centroid: ',$)
	    call read2i(iit,jjt,*999,*604)
	    II=IIT
	    JJ=JJT
	    GO TO 555
	  ELSE IF(IAN.EQ.'a') THEN
 605	    WRITE(6,22) 
 22	FORMAT('   Enter new inner (obj) and outer sky diameters: ',$)
	    call read2r(riro,rirs,*999,*605)
	    IRS=NINT(RIRS)
	    GO TO 555
	  ELSE IF (IAN.EQ.'ac'.OR.IAN.EQ.'ca') THEN
	    DO 100 I=2,5
 100	      NFRA(I)=0
	    GO TO 554
	  END IF
	END IF
 999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR DETERMINING CENTROID using fractional pixel, 
C     AUTOPHO is used for a first estimate
c   
c  nfr=frame number
c  ipo=output parameter, 0=supressed
c  ix(nu,nv,kf)= image data
c  reali, realj= returned centroid
c   rmag = mag within aperture
c   sky = sky used
c   ijoi,ijoj= integer*2 position array, size NN
c   NN = number of objects to be computed
c   robjt - inner diameter of ring (real pixel)
c   iia2  - outer diameter of ring (sky)
c   iconv - if =1, interate, if not, compute first centroid and return
c   itcen= max interation step
C
C
	SUBROUTINE PCENTR(NFR,IPO,IX,NU,NV,KF,REALI,REALJ,RMAG,SKY,
     *                 IJOI,IJOJ,NN,ROBJT,IIA2,ICONV,ITCEN)
c	INTEGER*2 IX(NU,NV,KF),IJOI(1),IJOJ(1)
	INTEGER IX(NU,NV,KF),IJOI(*),IJOJ(*)
	DIMENSION RI(30),REALI(*),REALJ(*),RMAG(*)
  	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	include 'apert.inc'
	NI=NII(NFR)
	NJ=NJJ(NFR)
	IPAR=0
	ICUT=2
	CUT=ICUT*2.+1.
	CUTSQ=CUT*CUT
	ROBJ=ROBJT
C if sky diameters =0, use exiting values in APERT block
	IF (ROBJ.lt.0.01.AND.IIA2.EQ.0) THEN
	  ROBJ=FLOAT(IAP1(1))
	ELSE
C calculate mask
	  IAP1(1)=INT(ROBJ+.5)
	  IAP2=IIA2
	  IAP1(2)=MAX0(IAP1(1),IAP2-MAX0(6,IAP2/6))
	CALL APARAY(IAP1(1),IT1(1,1),IROW1(1),QQ(1),RR(1),PP(1),NA(1),0)
	CALL APARAY(IAP1(2),IT1(1,2),IROW1(2),QQ(2),RR(2),PP(2),NA(2),0)
	  CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	  X1(1)=(PP(1)-RR(1))*QQ(1)
	  X2(1)=QQ(1)*QQ(1)-NA(1)*PP(1)
	  X3(1)=QQ(1)*QQ(1)-NA(1)*RR(1)
	  X4(1)=X1(1)*(X2(1)+X3(1))/QQ(1)
	END IF
C IRC is the max size of the area around the initial interger centroid
C to be allowed for iterating on the centroid
C IRC is oversized by 1 compared to the radius of the object circle
	  SQR=.25*ROBJ*ROBJ
	  SQRL=(.5*ROBJ-0.707)**2
	  SQRU=(.5*ROBJ+0.707)**2
	  IRC=(ROBJ+1.5)/2
C  do for NN objects
	DO 100 I=1,NN
C first guess from integer centroid, use AUPHOT
c	 write(6,*) '  Doing ',i,ijoi(i),ijoj(i)
	  if (ijoi(i).lt.1.or.ijoi(i).gt.ni.or.ijoj(i).lt.1.or.
     *          ijoj(i).gt.nj) then
c out of bound object
	    reali(i)=float(ijoi(i))
	    realj(i)=float(ijoj(i))
	    rmag(i)=99.
	    goto 100
	  end if
	  CALL AUPHOT(NFR,IJOI(I),IJOJ(I),RI,ANG,ELL,PEAK,1,RAD,
     *	  DELI,DELJ,DELIN,DELJN,1,NI,NJ,SKY,ZSIG,IPAR,IX,NU,NV,KF,0,0)
c  case for no photometry done
	  if (abs(ri(1)).lt.0.0001) then
	    if (nn.eq.1) return 
	    goto 100
	  end if
	  IF (ICT.EQ.0) THEN
	    REALI(I)=IJOI(I)+DELI
	    REALJ(I)=IJOJ(I)+DELJ
	  ELSE
	    REALI(I)=IJOI(I)+DELIN
	    REALJ(I)=IJOJ(I)+DELJN
	  END IF
C  store initial centroid
	  TEMPI=REALI(I)
	  TEMPJ=REALJ(I)
	  ITER=1
	  RMAG(I)=-2.5*ALOG10(AMAX1(RI(1),1.))
 555	  IF (IPO.EQ.1) WRITE(6,10) ITER,REALI(I),REALJ(I)
 10	FORMAT(' .... Estimate # ',I2,'  : ',2F10.4)
C   obtain better answer using fractional pixel circle:
c !  large circle, no new estimate
	  IF (ROBJ.GT.25.) GO TO 100 
	  SUMI=0.
	  SUMXI=0.
 	  SUMYI=0.
	  IJTI=NINT(REALI(I))
	  IJTJ=NINT(REALJ(I))
	  DO 101 M=MAX0(IJTJ-IRC,1),MIN0(IJTJ+IRC,NJ)
	    RRJ=(REALJ(I)-M)*(REALJ(I)-M)
	    DO 101 L=MAX0(IJTI-IRC,1),MIN0(IJTI+IRC,NI)
C condition for partial pixel is if sqrt(RR)-radius is +/-0.707 from radius
	      RRT=(REALI(I)-L)*(REALI(I)-L)+RRJ
	      IF (RRT.LE.SQRL) THEN
C  pixel is in completely  
	        WT=IX(L,M,NFR)-SKY
	        SUMXI=SUMXI+WT*L
	        SUMYI=SUMYI+WT*M
	      ELSE IF (RRT.GE.SQRU) THEN
C  pixel is completely out
	        GO TO 101
	      ELSE 
C case for partial pixel
C	        
C  cut pixel into CUT X CUT and compute the number of sector within circle
	        WTT=0.
	        TSUMY=0.
	        TSUMX=0.
	        DO 102 LJ=-ICUT,ICUT
	          TEMJ=M+FLOAT(LJ)/CUT
	          TTJ=(REALJ(I)-TEMJ)*(REALJ(I)-TEMJ)
	          DO 102 LI=-ICUT,ICUT
	            TEMI=L+FLOAT(LI)/CUT
	            TTR=(REALI(I)-TEMI)*(REALI(I)-TEMI)+TTJ
	            IF (TTR.LE.SQR) THEN  
c! cut is in. Each part is wieghted as 1 part in CUTSQ
C   TSUM''s determine the centroid of the partial pixel itself
	              WTT=WTT+1.
	              TSUMY=TSUMY+LJ
	              TSUMX=TSUMX+LI
	            END IF
 102	        CONTINUE
	        IF (abs(WTT).LE.0.00001) THEN
	          WT=0.
	        ELSE
C  sum the partial pixel to the total
	          WT=WTT*(IX(L,M,NFR)-SKY)/CUTSQ
	          SUMXI=SUMXI+(L+TSUMX/WTT)*WT
	          SUMYI=SUMYI+(M+TSUMY/WTT)*WT
	        END IF
	      END IF
	      SUMI=SUMI+WT
 101	  CONTINUE
	  TEMI=REALI(I)
	  TEMJ=REALJ(I)
	  IF (ABS(SUMI).GT.0.00001) THEN
	    REALI(I)=SUMXI/SUMI
	    REALJ(I)=SUMYI/SUMI
	  END IF
	  IF (ICONV.EQ.1) THEN
C Iterate
	    ITER=ITER+1
c ! max. iteration
	    IF (ITER.GT.ITCEN) THEN 
	      IF (IPO.EQ.1) WRITE(6,16) SKY
 16	FORMAT('   +++ Non-converging centroid +++   sky: ',F10.2)
C  reset centroid to first guess
	      REALI(I)=TEMPI
	      REALJ(I)=TEMPJ
	    ELSE
C check 
c ! try again
	      IF (ABS(TEMI-REALI(I)).GT.CENSTEP.OR.
     *             ABS(TEMJ-REALJ(I)).GT.CENSTEP) GO TO 555 
C converged centroid
 	      IF (IPO.EQ.1) WRITE(6,15) REALI(I),REALJ(I),SKY
 15	FORMAT('  Final CONVERGED centroid: ',2F10.4,'    sky: ',F10.2)
	    END IF
	  END IF
 100	CONTINUE
	RETURN
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR DETERMINING CENTROID using fractional pixel, 
C     AUTOPHO is used for a first estimate
C   BILINEARLY ITERPOLATED SUB-PIXELS ARE USED PARTIAL PIXEL 
C
	SUBROUTINE PCENTR2(NFR,IPO,IX,NU,NV,KF,REALI,REALJ,RMAG,SKY,
     *                 IJOI,IJOJ,NN,ROBJT,IIA2,ICONV,ITCEN)
c	INTEGER*2 IX(NU,NV,KF),IJOI(1),IJOJ(1)
 	INTEGER IX(NU,NV,KF),IJOI(1),IJOJ(1)
	DIMENSION RI(20),REALI(1),REALJ(1),RMAG(1),IX0(3,3),PPRAY(10,10)
  	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
	include 'apert.inc'
	NI=NII(NFR)
	NJ=NJJ(NFR)
	IPAR=0
	ICUT=2
	CUT=ICUT*2.+1.
	CUTSQ=CUT*CUT
	ROBJ=ROBJT
C if sky diameters =0, use exiting values in APERT block
	IF (ROBJ.EQ.0..AND.IIA2.EQ.0) THEN
	  ROBJ=FLOAT(IAP1(1))
	ELSE
C calculate mask
	  IAP1(1)=INT(ROBJ+.5)
	  IAP2=IIA2
	  IAP1(2)=MAX0(IAP1(1),IAP2-MAX0(6,IAP2/6))
	CALL APARAY(IAP1(1),IT1(1,1),IROW1(1),QQ(1),RR(1),PP(1),NA(1),0)
	CALL APARAY(IAP1(2),IT1(1,2),IROW1(2),QQ(2),RR(2),PP(2),NA(2),0)
	  CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	  X1(1)=(PP(1)-RR(1))*QQ(1)
	  X2(1)=QQ(1)*QQ(1)-NA(1)*PP(1)
	  X3(1)=QQ(1)*QQ(1)-NA(1)*RR(1)
	  X4(1)=X1(1)*(X2(1)+X3(1))/QQ(1)
	END IF
C IRC is the max size of the area around the initial interger centroid
C to be allowed for iterating on the centroid
C IRC is oversized by 1 compared to the radius of the object circle
	  SQR=.25*ROBJ*ROBJ
	  SQRL=(.5*ROBJ-0.707)**2
	  SQRU=(.5*ROBJ+0.707)**2
	  IRC=(ROBJ+1.5)/2
C  do for NN objects
	DO 100 I=1,NN
C first guess from integer centroid, use AUPHOT
	  CALL AUPHOT(NFR,IJOI(I),IJOJ(I),RI,ANG,ELL,PEAK,1,RAD,
     *	  DELI,DELJ,DELIN,DELJN,1,NI,NJ,SKY,ZSIG,IPAR,IX,NU,NV,KF,0,0)
	  IF (ICT.EQ.0) THEN
	    REALI(I)=IJOI(I)+DELI
	    REALJ(I)=IJOJ(I)+DELJ
	  ELSE
	    REALI(I)=IJOI(I)+DELIN
	    REALJ(I)=IJOJ(I)+DELJN
	  END IF
C  store initial centroid
	  TEMPI=REALI(I)
	  TEMPJ=REALJ(I)
	  ITER=1
	  RMAG(I)=-2.5*ALOG10(AMAX1(RI(1),1.))
 555	  IF (IPO.EQ.1) WRITE(6,10) ITER,REALI(I),REALJ(I)
 10	FORMAT(' .... Estimate # ',I2,'  : ',2F10.4)
C   obtain better answer using fractional pixel circle:
c !  large circle, no new estimate
	  IF (ROBJ.GT.25.) GO TO 100 
	  SUMI=0.
	  SUMXI=0.
 	  SUMYI=0.
	  IJTI=NINT(REALI(I))
	  IJTJ=NINT(REALJ(I))
	  DO 101 M=MAX0(IJTJ-IRC,1),MIN0(IJTJ+IRC,NJ)
	    RRJ=(REALJ(I)-M)*(REALJ(I)-M)
	    DO 101 L=MAX0(IJTI-IRC,1),MIN0(IJTI+IRC,NI)
C condition for partial pixel is if sqrt(RR)-radius is +/-0.707 from radius
	      RRT=(REALI(I)-L)*(REALI(I)-L)+RRJ
	      IF (RRT.GE.SQRU) THEN
C  pixel is completely out
	        GO TO 101
	      ELSE 
	        PFX=(IX(L,M,NFR)-SKY)
	        IF (RRT.LE.SQRL) THEN
C  pixel is in completely  
	          SUMI=SUMI+PFX
	          SUMXI=SUMXI+PFX*L
	          SUMYI=SUMYI+PFX*M
	        ELSE  
C case for partial pixel
C	        
C  cut pixel into CUT X CUT and compute the number of sector within circle
	          DO 130 MM=1,3
	            MM1=IJTJ+MM-2
                    DO 130 LL=1,3
 130	              IX0(LL,MM)=IX(IJTI+LL-2,MM1,NFR)
	          CALL DIVPIX(5,IX0,PPRAY)
	          DO 102 LJ=-ICUT,ICUT
	            TEMJ=M+FLOAT(LJ)/CUT
	            TTJ=(REALJ(I)-TEMJ)*(REALJ(I)-TEMJ)
	            DO 102 LI=-ICUT,ICUT
	              TEMI=L+FLOAT(LI)/CUT
	              TTR=(REALI(I)-TEMI)*(REALI(I)-TEMI)+TTJ
c ! cut is in
	              IF (TTR.LE.SQR) THEN 
	                FLUX=PFX*PPRAY(LI+ICUT+1,LJ+ICUT+1)
	                SUMI=SUMI+FLUX
	                SUMXI=SUMXI+(L+1.*LI/CUT)*FLUX
	                SUMYI=SUMYI+(M+1.*LJ/CUT)*FLUX
	              END IF
 102	          CONTINUE
	        END IF
	      END IF
 101	  CONTINUE
	  TEMI=REALI(I)
	  TEMJ=REALJ(I)
	  IF (ABS(SUMI).GT.0.00001) THEN
	    REALI(I)=SUMXI/SUMI
	    REALJ(I)=SUMYI/SUMI
	  END IF
	  IF (ICONV.EQ.1) THEN
C Iterate
	    ITER=ITER+1
c ! max. iteration
	    IF (ITER.GT.ITCEN) THEN 
	      IF (IPO.EQ.1) WRITE(6,16) SKY
 16	FORMAT('   +++ Non-converging centroid +++   sky: ',F10.2)
C  reset centroid to first guess
	      REALI(I)=TEMPI
	      REALJ(I)=TEMPJ
	    ELSE
C check 
c ! try again
	      IF (ABS(TEMI-REALI(I)).GT.CENSTEP.OR.
     *             ABS(TEMJ-REALJ(I)).GT.CENSTEP) GO TO 555 
C converged centroid
 	      IF (IPO.EQ.1) WRITE(6,15) REALI(I),REALJ(I),SKY
 15	FORMAT('  Final CONVERGED centroid: ',2F10.4,'    sky: ',F10.2)
	    END IF
	  END IF
 100	CONTINUE
	RETURN
	END
c///////////////////////////////////////////////////////////
c
c   subroutine to find intensity centroid of an object in a
c      slit
	subroutine centslit(*,nfr,ix,nu,nv,kf)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'ppparm.inc'
  	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,0,*999,*600)
 600	WRITE(6,10) xx,yy
 10	FORMAT('   Enter real pixel center of slit [',2f10.4,
     *         ']: ',$)
	CALL READ2r(xx,yy,*999,*600)
	ii=nint(xx)
	jj=nint(yy)
	IF (II.LT.1.OR.II.GT.NII(NFR).OR.JJ.LT.1.OR.JJ.GT.NJJ(NFR)) THEN
	  WRITE(6,*) '  ***** CO-ORDINATES TOO LARGE OR <0 ****'
	  RETURN1
	END IF
 601	WRITE(6,11) rwid,rlen
 11	FORMAT('   Enter slit width & length in pixels [',
     *     2F9.3,']: ',$)
	CALL READ2R(rwid,rlen,*999,*601)
 602	write(6,21) sky
 21	format('  Enter sky ADU value [',f10.2,']: ',$)
	call read1r(sky,*999,*601)
c compute centroid in a box centered on (xx,yy), size rwid*(2rwid)
c  max extend of box in integer pixels
	if (rlen.eq.0.) rlen=2*rwid
	xmin=xx-.5*rlen
	xmax=xx+.5*rlen
	ymin=yy-0.5*rwid
	ymax=yy+0.5*rwid
	imin=nint(xmin)
	imax=nint(xmax)
	jmin=nint(ymin)
	jmax=nint(ymax)
	sumx=0.
	sumy=0.
	sumflux=0.
	do 100 j=jmin,jmax
	  rj=float(j)
	  do 100 i=imin,imax
	    ri=float(i)
	    flux=float(ix(i,j,nfr))-sky
c determine where the pixel is
	    if ((ri.gt.xmin.and.ri.lt.xmax).and.
     *            (rj.gt.ymin.and.rj.lt.ymax)) then
	      sumflux=sumflux+flux
	      sumx=sumx+ri*flux
	      sumy=sumy+rj*flux
	    else
c determine fractional pixel flux and equivalent x,y co-ordinate
	      if (ri.lt.xmin) then
	        dx=(ri+0.5)-xmin
	        xeq=ri+0.5-0.5*dx
	      else if (ri.gt.xmax) then
	        dx=xmax-(ri-0.5)
	        xeq=ri-0.5+0.5*dx
	      else
	        dx=1.
	        xeq=ri
	      end if
	      if (rj.lt.ymin) then
c corner pixel to right
	        dy=rj+0.5-ymin 
	        yeq=rj+0.5-0.5*dy
	      else if (rj.gt.ymax) then
c corner pixel to left
	        dy=ymax-(rj-0.5)
	        yeq=rj-0.5+0.5*dy
	      else
c j is a full pixel
	        dy=1.
	        yeq=rj
	      end if
	      dsum=flux*dx*dy
	      sumflux=sumflux+dsum
	      sumx=sumx+dsum*xeq
	      sumy=sumy+dsum*yeq
	    end if
 100	continue
	write(6,1) sumx/sumflux,sumy/sumflux,sumflux
 1	format('  Centroid in slit: ',2f9.4,', Flux sum',f11.1)
 999	return1
	end
