C*******************************************************************
C
C SUBROUTINE PACKAGE TO DO OBJECT RECOGNITION, PHOTOMETRY AND
C   CLASSIFICATION FOR PICTURE ARRAYS FROM PPP
C******************************************************************* 
C
C DRIVING SUBROUTINE FOR PHOTOM
C    IKKKK=0 OBJECT POSITION FILE
C    IKKKK=1 SINGLE OBJECT
C    IKKKK=2 SINGLE OBJECT WITH LOOP
C    ISAVE=1 SAVE
C    ISAVE=0 NO SAVE
C
	SUBROUTINE PHODRI(*,NFRA,STRF,STRC,IKKKK,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),IJIT,IJJT
	INTEGER IX(NU,NV,KF),IJIT,IJJT
	DIMENSION RI(30),NFRA(5)
	CHARACTER*60 STRF,STRC,COMMENT
	CHARACTER*2 IANS
	CHARACTER*18 FILOUT,FILT
	common/photdata/reali,realj,counts,terr
	INCLUDE 'ppparm.inc'
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	include 'apert.inc'
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.6) THEN
	  WRITE(6,*) ' ***FRAME NUMBER MUST >=6 FOR PHOTOMETRY***'
	  RETURN1
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	IPAR=0
	NOBB=NOB(NFR)
	ISAVE=0
c save the value  the 1st obj in posfil to put back later.
	IJIT=IJOI(1,NFR)
	IJJT=IJOJ(1,NFR)
 699	IF (IKKKK.NE.0) THEN 
c  ! single object; use ijoi/j(1) position;
 600	  IF (NFRA(2).EQ.0.AND.NFRA(3).EQ.0) THEN
 6001	    WRITE(6,12) IJITT,IJJTT
 12	FORMAT('   Enter pixel co-ord (int) of object (default',2I5,
     *             '): ',$)
	    CALL READ2I(IJITT,IJJTT,*900,*6001)
	    IJOI(1,NFR)=IJITT
	    IJOJ(1,NFR)=IJJTT
	    IF (IJOI(1,NFR).GT.(NI+10).OR.IJOJ(1,NFR).GT.(NJ+10)) GO TO
     *      6001
	  ELSE    
	    IJOI(1,NFR)=NFRA(2)
	    IJOJ(1,NFR)=NFRA(3)
	    IJITT=NFRA(2)
	    IJJTT=NFRA(3)
	    NFRA(2)=0
	    NFRA(3)=0
	  END IF
	  NOBB=1
c  ! postion file
	ELSE  
 6004	  CALL READFN(FILT,STRF(1:18),FILOUT,'phm','o',11,*900,*6004,
     &          *20003)
20003	  IF (FILOUT.NE.'n') THEN
	    ISAVE=1
	    IF (STRC.EQ.' ') THEN
 6005	      WRITE(6,1) COMMENT
 1	FORMAT(' ENTER comment, <=60 characters, default:'/' (',A60,')'
     *        /' :',$)
 	      CALL READSTRD(60,COMMENT,*900,*6005)
	    ELSE
	      COMMENT=STRC
	    END IF
	  END IF
 	END IF
 203	IF (NFRA(4).EQ.0.AND.NFRA(5).EQ.0) THEN
 2031	  WRITE(6,11) IAP1(1),IAP2
 11	FORMAT('   Default inner and outer diameter:',2I5,
     *         /'   Enter inner (OBJECT) and outer'
     *	       ,' diameter (SKY), INTEGERS: ',$)
	  CALL READ2I(IAP1(1),IAP2,*900,*2031)
	ELSE IF (NFRA(4).GT.0) THEN
	  IAP1(1)=NFRA(4)
	  IAP2=NFRA(5)
	  NFRA(4)=0
	  NFRA(5)=0
	END IF
	IF (IAP1(1).GE.IAP2.OR.IAP1(1).GT.MIN0(NI,NJ).OR.IAP2.GT.
     *           MAX0(NI,NJ).OR.IAP1(1).LE.0) THEN
	  WRITE(6,*) ' **** ILLEGAL APERTURE SIZE **** '
	  NFRA(4)=0
	  GO TO 203
	END IF
	IAP1(2)=MAX0(IAP1(1),IAP2-MAX0(6,IAP2/6))
	CALL APARAY(IAP1(1),IT1(1,1),IROW1(1),QQ(1),RR(1),PP(1),NA(1)
     *               ,IPRT)
	CALL APARAY(IAP1(2),IT1(1,2),IROW1(2),QQ(2),RR(2),PP(2),NA(2)
     *               ,IPRT)
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,IPRT)
	X1(1)=(PP(1)-RR(1))*QQ(1)
	X2(1)=QQ(1)*QQ(1)-NA(1)*PP(1)
	X3(1)=QQ(1)*QQ(1)-NA(1)*RR(1)
	IF (QQ(1).NE.0) THEN
	  X4(1)=X1(1)*(X2(1)+X3(1))/QQ(1)
	ELSE 
	  X4(1)=X1(1)*(X2(1)+X3(1))
	END IF
	IF (ISKYSEC.EQ.0) THEN
	  IPRT1=1
	ELSE
	  IPRT1=IPRT
	END IF
	IF (ISAVE.EQ.1) call opennew(28,1,18,filout,*900)  
c            OPEN(UNIT=28,FILE=FILOUT,status='NEW',ERR=900)
	AM=0.00
	DO 100 I=1,NOBB
	  CALL AUPHOT(NFR,IJOI(I,NFR),IJOJ(I,NFR),RI,ANG,ELL,PEAK,1,RAD,
     *	    DELI,DELJ,DELIN,DELJN,1,NI,NJ,SKY,ZSIG,IPAR,IX,NU,NV,KF,
     *      IPRT1,ISKYSEC)
	  REALI=IJOI(I,NFR)+DELI
	  REALJ=IJOJ(I,NFR)+DELJ
	  REALIN=IJOI(I,NFR)+DELIN
	  REALJN=IJOJ(I,NFR)+DELJN
	  RMAG=99.0
	  TERR=RI(1)/(ZSIG*SQRT(FLOAT(NA(1))))
	  IF (RI(1).GT.0.) RMAG=-2.5*ALOG10(RI(1))+AM
	  IF (IKKKK.EQ.0) THEN
	   WRITE(6,3) I,REALI,REALJ,RI(1),RMAG,TERR,ELL,ANG,RAD,SKY,ZSIG
	    IF (ISAVE.EQ.1) WRITE(28,3) I,REALI,REALJ,RI(1),RMAG,
     *           TERR,ELL,ANG,RAD,SKY,ZSIG
	  ELSE
	    WRITE(6,9) REALIN,REALJN,RI(1),RMAG,TERR,NA(1),ELL,ANG,RAD,
     *               REALI,REALJ
	    counts=ri(1)
	  END IF
 100	CONTINUE
 9	FORMAT(3X,'centroid:',2F8.2,'  cts:',F9.0,'  mag:',F8.3,
     *        '  S/N:',F7.1,/,3X,'  No. of pix.:',I6,'   e:',F5.2,
     *     '  ang:',F6.2,'  rad:',F6.2,' fc:',2F8.2)
 3	FORMAT(1X,I3,1X,2(F6.2,1X),E10.4,1X,F7.3,F8.1,5F10.3)
	IF (ISAVE.EQ.1) THEN
	  CLOSE(UNIT=28)
	ELSE IF (IKKKK.EQ.2) THEN
 6100	  WRITE(6,13) 
 13	FORMAT('   ENTER: a=change aper., c=co-ord, ac=both, <cr>'
     *           ,'=out: ',$)
	  call readstr(2,ians,*900,*6100)
c 10	FORMAT(A2)
	  IF (IANS.EQ.'a') THEN
	    NFRA(4)=0
	    GO TO 203
	  ELSE IF (IANS.EQ.'c') THEN
	    NFRA(4)=-1
	    nfra(2)=0
	    nfra(3)=0
	    GO TO 699
	  ELSE IF (IANS.EQ.'ac'.OR.IANS.EQ.'ca') THEN
	    NFRA(4)=0
	    nfra(2)=0
	    nfra(3)=0
	    GO TO 699
	  END IF
	END IF
 900	IJOI(1,NFR)=IJIT
	IJOJ(1,NFR)=IJJT
 999	RETURN1
	END
C////////////////////////////////////////////////////////////////////
C
C   DRIVING ROUTINE FOR AUTOPHOT
C
C               IKIND=0 DO A POSITION FILE (AUPH)
C 		IKIND=1 DO ONE OBJECT      (1AUP)
C               IKIND=2 DO LOOP            (LAUP)
C	        IKIND=3 DO 1AUP AND DETERMINE SEEING
C               ISAVE=1 SAVE RESULTS
C               ISAVE=0 NO WRITE
	SUBROUTINE APDRI(*,NFRA,STRF,TCOMMENT,IKIND,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),IDS(3000),ICLP(3000),ICLS(3000),itt,jtt
	INTEGER IX(NU,NV,KF),IDS(3000),ICLP(3000),ICLS(3000),itt,jtt
	DIMENSION  NFRA(5),RI(30),RMAG(30,3000),PK(3000),
     *     REALI(3000),REALJ(3000),SKY(3000),ZSIG(3000),ELL(3000),
     *     ANG(3000),RAD(3000),DELMAG(3000),EXMAG(3000),SP(0:30,3000)
     *     ,SKYERR(3000),RZ(3000),SZ(3000),RSQ(3000),PKF(3000),
     *     SUMDEL(3000),PIXN(30),REFST(30),IREF(10),CLSCT(3),
     *     SPL(0:30,3000)
	CHARACTER*18 FILOUT,FILT,HPLOT,SPLOT,DEV
c	CHARACTER*18 STR
	CHARACTER*1 IANS,IANS2
	CHARACTER*60 COMMENT,STRF,TCOMMENT
c	CHARACTER*9 ADATE
c	CHARACTER*8 ATIME,fil
	character*24 fdate,fil*8
	character*64 fstr24,fstr27,string1,string2
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	COMMON/PLOTDEV/ HPLOT,SPLOT,ipinit
	INCLUDE 'picdir.inc'
	include 'objcat.inc'
	include 'apert.inc'
	equivalence (iscr(1),RMAG(1,1)),
     *     (iscr(200001),PK(1)),(iscr(210001),REALI(1)),
     *     (iscr(220001),REALJ(1)),(iscr(230001),SKY(1)),
     *     (iscr(240001),ZSIG(1)),(iscr(260001),ELL(1)),
     *     (iscr(280001),ANG(1)),(iscr(300001),RAD(1)),
     *     (iscr(320001),DELMAG(1)),(iscr(340001),SUMDEL(1)),
     *     (iscr(360001),EXMAG(1)),(iscr(380001),PKF(1)),
     *     (iscr(400001),SKYERR(1)),(iscr(420001),RZ(1)),
     *     (iscr(440001),SZ(1)),(iscr(460001),RSQ(1)),
     *     (iscr(480001),ids(1)),(iscr(485001),iclp(1)),
     *     (iscr(490001),icls(1)),
     *     (iscr(500001),SP(0,1)),(iscr(700001),SPL(0,1))
	NFR=NFRA(1)
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.6) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST >=6 FOR PHOTOMETRY'
	  RETURN1
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	NOBB=NOB(NFR)
	IPAR=1
	ISAVE=0
c !single object
599	IF (IKIND.GE.1) THEN  
601	  IF (NFRA(2).EQ.0.AND.NFRA(3).EQ.0) THEN
600	    WRITE(6,34) IJOII,IJOJJ
 34	FORMAT('   Default co-ord:',2I5,
     *      /'   Enter pixel co-ordinate of object (INTEGERS): ',$)
	    CALL READ2I(IJOII,IJOJJ,*999,*600)
	  ELSE 
	    IJOII=NFRA(2)
	    IJOJJ=NFRA(3)
	    NFRA(2)=0
	    NFRA(3)=0
	  END IF
	  IF (IJOII.GT.(NI+10).OR.IJOJJ.GT.(NJ+10)) RETURN1
	  NOBB=1
c ! file
	ELSE IF (IKIND.EQ.0) THEN  
 6001	  CALL READFN(FILT,STRF(1:18),FILOUT,'phm','o',11,*999,
     &       *6001,*20003)
20003	  IF (FILOUT.NE.'n') THEN
	    ISAVE=1
	    IF (TCOMMENT.EQ.' ') THEN
 6005	      WRITE(6,1) COMMENT
 1	FORMAT(' ENTER comment, <=60 characters, default:'/' (',A60,')'
     *        /' :',$)
	      CALL READSTRD(60,COMMENT,*999,*6005)
	    ELSE
	      COMMENT=TCOMMENT
	    END IF
	  END IF
 	END IF
 203	K=4
	IF (FILOUT.EQ.'n'.OR.IKIND.EQ.3) K=3
	IF (NFRA(K).LE.IAPMIN+4) THEN
	  WRITE(6,10) IAPMIN,IAPIS,IAPMAX
 10	FORMAT(' Initial obj diameter:',I2,', Max sky diam=(max obj dia'
     *        ,'m)+',I2,' dflt max obj diam=',I3,
     *	      /'   Enter MAX obj DIAMETER in integer pixels: ',$)
	  CALL READ1I(IAPMAX,*999,*203)
	ELSE
	  IAPMAX=NFRA(K)
	  NFRA(K)=0
	END IF
	IF (IAPMAX.LE.IAPMIN) GO TO 203
	IAP2=IAPMAX+IAPIS+3
	IF (IAP2.GT.maxap) THEN
	  WRITE(6,*) '  **** Diameter too large ******'
	  GO TO 203
	END IF
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,IPRT)
C number of apertures
	if (ideld.le.1) then
	  write(6,*) ' +++ Can''t do auph with IDELD=1, changing to 2'
	  ideld=2
	end if
	NAP=MIN0(30,(IAPMAX-IAPMIN+ideld)/ideld)
	iexapf=min0(iexap,nap-1)
	IEXAP1=MIN0(IEXAP,NAP)
C
C   MAKE APERTURES
C
C	NPC=3
	DO 80 I=1,NAP
	  IAP1(I)=IAPMIN+(I-1)*ideld
	CALL APARAY(IAP1(I),IT1(1,I),IROW1(I),QQ(I),RR(I),PP(I),NA(I),
     *           IPRT)
	  PIXN(I)=FLOAT(NA(I))
	  X1(I)=(PP(I)-RR(I))*QQ(I)
	  X2(I)=QQ(I)*QQ(I)-NA(I)*PP(I)
	  X3(I)=QQ(I)*QQ(I)-NA(I)*RR(I)
 80	  X4(I)=X1(I)*(X2(I)+X3(I))/QQ(I)
C
C  DO PHOTOMETRY FOR NOBB OGJECTS
C
	IF (ISKYSEC.EQ.0) THEN
	  IPRT1=1
	ELSE
	  IPRT1=IPRT
	END IF
	INDCEN=MAX0(1,(NAPCEN-IAPMIN)/ideld)
	DO 100 I=1,NOBB
	  IF (IKIND.EQ.0) THEN
	    IJOII=IJOI(I,NFR)
	    IJOJJ=IJOJ(I,NFR)
	    WRITE(6,29) I
 29	FORMAT(/'  Object #',I4)
	  END IF
	  itt=ijoii
	  jtt=ijojj
	  CALL AUPHOT(NFR,itt,jtt,RI,ANG(I),ELL(I),PKF(I),NPC,RAD(I)
     *	   ,DELI,DELJ,DELIN,DELJN,INDCEN,NI,NJ,SKY(I),ZSIG(I),
     *        IPAR,IX,NU,NV,KF,IPRT1,ISKYSEC)
c ! Temp. for checking
	  REALI(I)=IJOII+DELIN  
	  REALJ(I)=IJOJJ+DELJN
	  SKYERR(I)=(ZSIG(I)*SQRT(FLOAT(NA(ISE)))) 
	  IF (SKYERR(I).NE.0) SKYERR(I)=RI(ISE)/SKYERR(I)
C  calculate growth curve in mag and linear surface profile
	  PK(I)=FLOAT(IX(IJOII,IJOJJ,NFR))-SKY(I)
	  SP(0,I)=PK(I)
	  SP(1,I)=(RI(1)-PK(I))/(PIXN(1)-1.)
 	  IF (RI(1).GT.0.) THEN
	    RMAG(1,I)=-2.5*ALOG10(RI(1))
	  ELSE
	    RMAG(1,I)=99.0
	  END IF
	  DO 82 L=2,NAP
 	    IF (RI(L).GT.0.) THEN
	      RMAG(L,I)=-2.5*ALOG10(RI(L))
	    ELSE
	      RMAG(L,I)=99.0
	    END IF
	    SP(L,I)=(RI(L)-RI(L-1))/(PIXN(L)-PIXN(L-1))
 82	  CONTINUE
C
C    DERIVE THE MOST LIKELY MAGNITUDE FROM CURVE OF GROWTH
C      USING INFOMATION FROM DERIVATIVES
C
	  CALL IDSDET(NAP,RMAG(1,I),RI,PIXN,ZSIG(I),DER1X,DER2X,NSTOP)
 	  IDS(I)=MAX0(1,NSTOP)
c 	  IDS(I)=MAX0(1,MIN0(IEXAP,NSTOP))
C
C  output results
C
 	  WRITE(6,14) REALI(I),REALJ(I),RI(IDS(I)),RMAG(IDS(I),I),
     *      SKYERR(I),PK(I)
 14	FORMAT(3X,'centroid:',2F7.2,'  cts:',F8.0,'  mag:',F8.3,
     *        '  S/N:',F7.1,'  Npk:',F8.2)
	  WRITE(6,15) (RMAG(L,I), L=1,MIN0(10,NAP))
	  IF (NAP.GT.10) WRITE(6,16) (RMAG(L,I),L=11,NAP)
 15	FORMAT(3X,'m(rad):',10F7.2)
 16	FORMAT(10X,10F7.2)
 100	CONTINUE
	IF (IKIND.EQ.1) THEN
c  !  end for 1AUP
	  RETURN1                    
c  !  for LAUP
	ELSE IF (IKIND.EQ.2) THEN    
 6100	  WRITE(6,*) ' ENTER: a - change aper., c - co-ord, cr - OUT'
	  call readstr(1,ians,*999,*6100)
 	  IF (IANS.EQ.'a') GO TO 203
	  IF (IANS.EQ.'c') GO TO 599
	  RETURN1
c !  for command SEE 
	ELSE IF (IKIND.EQ.3) THEN  
	  CALL SEEING1(SP(0,1),IAPMIN,IDS(1),IDELD,SEE)
	  WRITE(6,46) IREF(NREF),SEE
	  RETURN1
	END IF
C  put differential profile in mag
	DO 81 I=1,NOB(NFR)
	  DO 81 L=0,NAP
	    IF (SP(L,I).GT.0.0001) THEN
	      SPL(L,I)=-2.5*ALOG10(SP(L,I))
	    ELSE
	      SPL(L,I)=99.
	    END IF
 81	  CONTINUE
C
C determine reference star
C
 606	CALL REFSTAR(REFST,REFPK,IDSREF,SKYERR,NAP,RMAG,PK,IDS,SKY
     *    ,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),IREF,NREF,0,
     *    ADUSAT-250.,IREFMIN,iexapf,*999)
	IDSREF=MIN0(IDSREF,IEXAP1)
C  determine FWHM
	CALL SEEING1(SP(0,IREF(NREF)),IAPMIN,IDS(IREF(NREF)),IDELD,SEE)
	WRITE(6,46) IREF(NREF),SEE
 46	FORMAT(/'  Estimated FWHM from object',I5,':',F7.3,' pix'
     *          /'  Classification:')
	AA=REFST(IDSREF)+2.5*ALOG10(AMAX1(.0001,REFPK))
	IEXAP1=MIN0(IEXAP1,IDSREF)
	DO 199 KK=1,3
	  CLSCT(KK)=CLSC(KK)
199	CONTINUE
	IF (IKIND.EQ.3) RETURN1
C
C
C    BIG LOOP FOR EACH OBJECT TO DETERMINE EXTRAPOLATED MAG,
C      SURFACE PROFILE AND PARAMETERS, AND TWO CLASSIFICATIONS
C
C check IDS of objects with close neighbour
	IF (IDCOR.EQ.1)	CALL IDSCOR(NOB(NFR),NAP,IDS,REALI,REALJ,SPL)
	ISDAPT=MIN0(2,MAX0(ISDAP,1))
	DO 309 I=1,NOB(NFR)
C 
C Determine first order extrapolated magnitude : up to aperture IEXAP
C
	  CALL MAGEXT(IDS(I),IDSREF,EXMAG(I),RMAG(IDS(I),I),REFST)
C  calculate exponential fit to profile, starting from apt 3 to NSTOP
C	  CALL EXPFITP(SP(0,I),IDS(I),IAP1,SZ(I),RZ(I),RSQ(I))
C
C  classification
	  CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),REFST,IDSREF,
     *                 AA,SKY(I),ADUSAT,ISDAPT,
     *                CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
	  WRITE(6,41) I,EXMAG(I),IDS(I),SUMDEL(I),ICLS(I)
 41	FORMAT(2X,'#',I4,'  mag:',F6.2,'  apert.:',I2,'  C2:',F7.3,
     *        '   Cl:',I2)
 309	CONTINUE
C
C  plotting options
C
 160	CONTINUE
 603 	  WRITE(6,17) 
 17	FORMAT('  Do you want PLOT of classifier vs mag?'
     *            ,' y=dflt/n/p: ',$)
	  call readstr(1,ians2,*999,*603)
 	  IF (IANS2.NE.'n') THEN
	    IF (IANS2.EQ.'p') THEN
	      DEV=HPLOT
	      CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOB(NFR),IREF,NREF,
     *                CLSCT,icls,FILOUT,DEV,nsct(nfr))
	    ELSE
	      DEV=SPLOT
	      CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOB(NFR),IREF,NREF,
     *                CLSCT,icls,FILOUT,DEV,nsct(nfr))
 604	      WRITE(6,19) 
 19	FORMAT('  Do you want to change ref. star (s) or '
     *        ,'class criteria (c)? (n(o)/s/c): ',$)
	      call readstr(1,ians2,*999,*604)
	      IF (IANS2.EQ.'c') THEN
 605	        WRITE(6,20) CLSCT(3),CLSCT(2),CLSCT(1)
 20	FORMAT('   C2 default values:',3F7.3,' for division of class'
     *        ,' 0,3,2,1'/'   Enter 3 (temporary) values: ',$)
	        CALL READR4(3,CLSCT(3),CLSCT(2),CLSCT(1),*999,*605,
     &      *20006,*20006)
C
C  re classification
20006	        DO 159 I=1,NOB(NFR)
	          CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *                 REFST,IDSREF,AA,SKY(I),ADUSAT,ISDAPT,
     *                CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
	          WRITE(6,41) I,EXMAG(I),IDS(I),SUMDEL(I),ICLS(I)
 159	        CONTINUE
	        GO TO 160
	      ELSE IF (IANS2.EQ.'s') THEN
 	        GO TO 606
	      ELSE IF (IANS2.NE.'n'.AND.IANS2.NE.' ') THEN
	        GO TO 604
	      END IF
	    END IF
	  END IF
 607	  WRITE(6,21) 
 21	FORMAT('  Do you want PLOT of MAG versus APERTURE? '/
     *         '   (PRINTRONIX PLOT FILE ONLY) y/n (dflt:n): ',$)
	  call readstr(1,ians,*999,*607)
	  IF (IANS.EQ.'y') THEN
 608	    WRITE(6,22)
 22	format('  Enter title (<=8 characters): ',$)
	    call readstr(8,fil,*999,*608)
c	    CALL PLTPHO(IAP1,RMAG,SPL,IDS,ICLS,EXMAG,NOB(NFR),
c     *               NAP,FIL,FILOUT,SEE)
	  END IF
 	IF (FILOUT.EQ.'n') RETURN1
C save results in disk
	KAP=MIN0(10,NAP)
	call opennew(28,1,18,filout,*999)
c	OPEN(UNIT=28,FILE=FILOUT,status='NEW',ERR=999)
	IF (COMMENT.EQ.'c') COMMENT=PCOMMENT(NFR)
c	CALL DATE(ADATE)
c	CALL TIME(ATIME)
C attach date and time to comment
	DO 300 JN=60,1,-1
 300	  IF (COMMENT(JN:JN).NE.' ') GO TO 301
 301	COMMENT=COMMENT(1:MIN0(39,JN+1))//fdate()//' '//'auph'
C Write 2 line header
	istatus=encode(string1,float(max0(1,min0(7,nref))),1,0,idum)
	istatus=encode(string2,float(max0(1,4*(7-nref)+1)),1,0,idum)
	fstr24='(1X,A60,1X,''REF *:'','//string1(1:lnblnk(string1))
     &  //'I4,'//string2(1:lnblnk(string2))//'X,'' C2'',3F6.3)'
	WRITE(28,fstr24) COMMENT,(IREF(K),K=NREF,MAX0(NREF-6,1),-1)
     *               ,CLSCT(3),CLSCT(2),CLSCT(1)
c
c 24	FORMAT(1X,A60,1X,'REF *:',<MAX0(1,MIN0(7,NREF))>I4,
c     *                  <MAX0(1,4*(7-NREF)+1)>X,' C2',3F6.3)
c
	WRITE(28,25) IAP2,IAP1(1),IAP1(NAP),ideld,NI,NJ,ISE,IEXAP1,SEE
 25	FORMAT(1X,'SKY APERT:',I3,'  1ST APERT:',I3,'  LAST APERT:',I3
     *     ,1X,i1,1x,'SIZE:',2I5,3X,'ERR APER ',I2,3X,'EXTRP APER ',I2,
     *      3X,'FWHM:',F5.2,' PIX')
	DO 302 I=1,NOB(NFR)
C  calculate sky err for adopted best aperture
	  TERR=10.**(-RMAG(IDS(I),I)/2.5)
     *              /(ZSIG(I)*SQRT(AMAX1(1.,PIXN(IDS(I)))))
	  if (reali(i).gt.999.99.or.realj(i).gt.999.99) then
	    WRITE(28,261)I,REALI(I),REALJ(I),RMAG(IDS(I),I),EXMAG(I),
     *        TERR,SKYERR(I),PK(I),ELL(I),ANG(I),SKY(I),
     *        ZSIG(I),DELMAG(I),ICLP(I),SUMDEL(I),ICLS(I)
	  else	
	    WRITE(28,26)I,REALI(I),REALJ(I),RMAG(IDS(I),I),EXMAG(I),
     *        TERR,SKYERR(I),PK(I),ELL(I),ANG(I),SKY(I),
     *        ZSIG(I),DELMAG(I),ICLP(I),SUMDEL(I),ICLS(I)
	  end if
	  istatus=encode(string1,float(kap),1,0,idum)
	  istatus=encode(string2,float(8*(10-kap)+3),1,0,idum)
	  fstr27='(4X,2(I4,3X),I2,3X,'//string1(1:lnblnk(string1))//
     &         'F8.3,'//string2(1:lnblnk(string2))//'X,I2)'
	  WRITE(28,fstr27) IJOI(I,NFR),IJOJ(I,NFR),IDOB(I,NFR)
     *	                   ,(RMAG(L,I), L=1,KAP),IDS(I)
	  WRITE(28,28) RZ(I),SZ(I),RSQ(I),(RMAG(L,I),L=11,NAP)
 302	CONTINUE
 	CLOSE(UNIT=28)
c 27	FORMAT(4X,2(I4,3X),I2,3X,<KAP>F8.3,<8*(10-KAP)+3>X,I2)
 28	FORMAT(1X,F8.1,F6.2,F5.2,3X,10F8.3)
c 3	FORMAT(1X,I3,1X,2(F6.2,1X),E10.4,F7.2,F7.1,F9.1,3F7.3,F9.3,
c    *      F8.3,1X,F6.2,I2,F6.2,I2)
 26	FORMAT(I4,1X,2(F6.2,1X),2F7.2,F7.1,F7.1,F8.1,7X,F7.3,F7.1,
     *      F10.3,F8.3,1X,F6.2,I2,F6.2,I2)
 261	FORMAT(I4,1X,2(F6.1,1X),2F7.2,F7.1,F7.1,F8.1,7X,F7.3,F7.1,
     *      F10.3,F8.3,1X,F6.2,I2,F6.2,I2)
 999	RETURN1
	END
C////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR NUMERICAL DERIVATIVES
C
	SUBROUTINE DERIV(Y,DER1,DER2,DX,NOP)
	DIMENSION Y(*),DER1(*),DER2(*)
	DH=.5/DX
	DD=1./(DX*DX)
	DER1(1)=(-3.*Y(1)+4.*Y(2)-Y(3))/DX
	DER2(1)=(Y(1)-2.*Y(2)+Y(3))*DD
	DO 100 I=2,NOP-1
	DER1(I)=(Y(I+1)-Y(I-1))*DH
 100	DER2(I)=(Y(I-1)-2.*Y(I)+Y(I+1))*DD
	DER1(NOP)=(Y(NOP-2)-4.*Y(NOP-1)+3.*Y(NOP))/DX
	DER2(NOP)=(Y(NOP-2)-2.*Y(NOP-1)+Y(NOP))*DD
	RETURN
	END

C//////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR AUTO PHOTOMETRY
C
C      CALCULATE TOTAL INTENSITY WITH MODAL SKY SUBTRACTION, (SKY
C      DETERMINED IN RING WITH OUTER DIAMETER IAP2, INNER, IAP1 =
C      PHOTOMETRY APERTURE);   CALCULATE PARAMETERS : 
C      PEAK, ELLIPTICITY, RADIUS,
C      ROTATION ANGLE, OFFSET OF CENTROID FROM LOCAL MAXIMUM PIXEL
C      LOCATION BY FITTING PARABOLOID TO OBJECT (SEBOK THESIS)
C
C
C
	SUBROUTINE AUPHOT(NFR,IO,JO,RI,ANG,ELL,PEAK,NPE,RAD,DELI,DELJ,
     *    DELIN,DELJN,NCED,NI,NJ,SKY,ZSIG,IPAR,IX,NU,NV,KF,IW,ISKYSEC)
	DIMENSION RI(*),SKARAY(50000)
c 	DIMENSION AA(6)
c	INTEGER*2 IX(NU,NV,KF),IO,JO
	INTEGER IX(NU,NV,KF),IO,JO
c	CHARACTER*1 IANS
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
c	EQUIVALENCE (iscr(900001),SKARAY(1))
	include 'apert.inc'
C  set inner sky aperture radius
	IF (IPAR.EQ.0) THEN
	  NNAP=2
	ELSE
	  IF (IAP2-IAP1(NAP).GT.8) THEN
	    NNAP=NAP
	  ELSE
	    NNAP=NAP-1
	  END IF
	END IF
	IO1=IO
	JO1=JO
C	TYPE*, IO1,JO1
	ipr=0
c  turn off sky value printing
c       iwt=iw
	iwt=0
	if (IO1.lt.1.or.IO1.gt.nii(nfr)) then
	   ipr=2
	   write(6,*) ' **out of bound obj :',IO1,JO1
	   goto 302
	end if
	if (JO1.lt.1.or.JO1.gt.njj(nfr)) then
	   ipr=2
	   write(6,*) ' **out of bound obj :',IO1,JO1,
     *               '  Photometry not done ***'
	   goto 302
	end if
	IF (ISKYSEC.EQ.0) THEN
	  CALL RCSKY(1,SKY,ZSIG,NNAP,IO1,JO1,NI,NJ,IX(1,1,NFR),NU,NV
     *                    ,SKARAY,50000,nsky,IWT,IPR)
	ELSE
	  CALL RING8SKY(SKY,ZSIG,NNAP,IO1,JO1,NI,NJ,IX(1,1,NFR),NU,NV
     *                    ,SKARAY,50000,nsky,IWT,IPR)
	END IF
 302	continue
	IF (IPR.NE.0) THEN
c	  WRITE(6,*) ' ****  photometry not done *****'
	  DO 301 JK=1,30
	    RI(JK)=0.0000
 301 	  continue
	  DELI=0.
	  DELJ=0.
	  DELIN=0.
	  DELJN=0.
	  ZSIG=0.
	  RETURN
	END IF
	NAPP=NAP
C  CALCULATE MOMENTS for two apertures: NPE= aperture index for fitting
C     peak, NCED = index for obtaining centroid
 256	NMOM=2  
c ! same index, do only once
	IF (NCED.EQ.NPE) NMOM=1   
	DO 257 KK=1,NMOM
	  IF (KK.EQ.1) NCE=NPE
	  IF (KK.EQ.2) NCE=NCED
	  JR1=JO-IROW1(NCE)
	  JR2=JO+IROW1(NCE)
	  RMI=0.
	  RMJ=0.
 	  RMII=0.
	  RMJJ=0.
	  RMIJ=0.
	  RI(NCE)=0.
	  K=0
	  DO 200 J=MAX0(1,JR1), MIN0(NJ,JR2)
	    K=K+1
	    DO 201 I=MAX0(1,IO-IT1(K,NCE)/2), MIN0(NI,IO+IT1(K,NCE)/2)
	      SS=FLOAT(IX(I,J,NFR))-SKY
	      II=I-IO
	      JJ=J-JO
	      S1=SS*II
	      S2=SS*JJ
	      RI(NCE)=RI(NCE)+SS
	      RMI=RMI+S1
	      RMJ=RMJ+S2
	      RMII=RMII+S1*II
	      RMJJ=RMJJ+S2*JJ
	      RMIJ=RMIJ+S2*II
 201	    CONTINUE
 200	  CONTINUE
C  intensity centroid within aperture
	  IF (RI(NCE).NE.0.) THEN
	    DELIN=RMI/RI(NCE)
	    DELJN=RMJ/RI(NCE)
	  ELSE
	    DELIN=0.
	    DELJN=0.
	  END IF
C PARAMETERS FOR PARABOLOID FIT:
C ---- IX(IJ)  =  AI**2{BIJ+CJ**2+DI+EJ+F  -----
	  B=RMIJ/RR(NCE)
	  D=RMI/QQ(NCE)
	  E=RMJ/QQ(NCE)
	  A=(X1(NCE)*RI(NCE)+X2(NCE)*RMII-X3(NCE)*RMJJ)/X4(NCE)
	  C=(X1(NCE)*RI(NCE)+X2(NCE)*RMJJ-X3(NCE)*RMII)/X4(NCE)
	  F=(RI(NCE)-QQ(NCE)*(A+C))/FLOAT(NA(NCE))
C   CALCULATE OBJECT PARAMETERS
C     the first pass all parameters are calculated, the second
C      pass (if peak aperture NPE and centroid aperture NCED
C      are not equal) all parameters are recalculated except
C      the peak
	  DEL=4.*A*C-B*B
	  RAD=0.
	  ANG=0.
	  IF (DEL.EQ.0.) THEN
	    IF (KK.EQ.1) PEAK=0.
	    ELL=0.
	    DELI=0.
	    DELJ=0.
c	    WRITE(6,*) ' ***** WARNING NO PARABOLIC FIT TO OBJECT ****'
	    GO TO 257
	  END IF
	  IF ((A-C).NE.0.) ANG=0.5*ATAN(B/(A-C))
	  ELL=SQRT((A+C)*(A+C)-DEL)
	  ELL=0.5*ELL*(A+C-ELL)/DEL
	  PEAKT=F+(B*D*E-C*D*D-A*E*E)/DEL
	  IF (KK.EQ.1) PEAK=PEAKT
	  IF (DEL.GT.0..AND.PEAKT.GE.0.) RAD=SQRT(PEAKT/SQRT(DEL))
	  DELI=(E*B-2.*D*C)/DEL
	  DELJ=(D*B-2.*E*A)/DEL
 257	CONTINUE
 878	IF (NAP.EQ.1.OR.IPAR.EQ.0) RETURN
C   calculate flux for all apertures
C 	IO1=IO+DELI+.45
C	JO1=JO+DELJ+.45
C	IF (DELI.GE.2.OR.DELJ.GE.2.) THEN
	  IO1=IO
	  JO1=JO
C	END IF
	DO 250 I=1,NNAP
	  JR1=JO1-IROW1(I)
	  JR2=JO1+IROW1(I)
	   K=0
  	  RI(I)=0.
	  DO 250 J=MAX0(1,JR1), MIN0(NJ,JR2)
	    K=K+1
	    DO 250 L=MAX0(1,IO1-IT1(K,I)/2), MIN0(NI,IO1+IT1(K,I)/2)
 250	      RI(I)=RI(I)+FLOAT(IX(L,J,NFR))-SKY
	RETURN
 	END
C//////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO CREATE CIRCULAR APERTURE AND CALCULATE OTH,
C    2ND AND 4TH MOMENTS OF APERTURE WITH INTENSITY OF 1
C
C   ia=diameter
c   it=matrix containing the number of pixels in each row
c   irow= number of rows
	SUBROUTINE APARAY(IA,IT,IROW,QQ,RR,PP,N,IW)
	INTEGER IT(*)
	IF (IA.GT.455) THEN
	  WRITE(6,*) '  **** APERTURE TOO LARGE ***** '
	  N=-1
	  RETURN
	END IF
	N=0
	QQ=0
	PP=0
	RR=0
	IAA=IA*IA+1
	IROW=IA/2
	KI=IROW+2
	DO 100 J=1, IROW+1
	  KI=KI-1
	  KK=J-1
	  IT(KI)=2*(INT(.5*SQRT(FLOAT(IAA-4*KK*KK))))+1
 100	CONTINUE
	KI=2*IROW+2
	DO 101 J=1, IROW
	  KI=KI-1
	  IT(KI)=IT(J)
 101	CONTINUE
	IJ=IROW+1
	DO 200 I=1, 2*IROW+1
	  N=N+IT(I)
	  JC=(IT(I)+1)/2
	  REALII=FLOAT((I-IJ)*(I-IJ))
	  DO 201 J=1, IT(I)
	    QQ=QQ+REALII
	    PP=PP+REALII*REALII
	    RR=RR+REALII*(J-JC)*(J-JC)
 201	  CONTINUE
 200	CONTINUE
	IF (IW.EQ.1) WRITE(6,*) IA,N
	RETURN
	END
C////////////////////////////////////////////////////////////////////////
C
C     SUBROUTINE TO PRODUCE COLOUR MAP
C
C
	SUBROUTINE CMAP1(*,NFR,NFR2,NRES,SCAL,IC,IPAR,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
 	INTEGER IX(NU,NV,KF)
c	CHARACTER*1 IQUERY
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR,KF,1,*900,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*900,*20002)
20002	CALL QUERYNFR(NRES,KF,4,*900,*20003)
20003	IF (IC.EQ.0) THEN
 610	  WRITE(6,*) ' ENTER cutoff point (INTEGER), CTR d OUT'
	  call read1i(icut,*900,*610)
	ELSE
	  ICUT=IC
	END IF
	IF (SCAL.EQ.0.) THEN
 620	  WRITE(6,*) ' ENTER scaling factor'
	  call read1r(sca,*900,*620)
	ELSE
	  SCA=SCAL
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	NII(NRES)=NI
	NJJ(NRES)=NJ
	DO 100 J=1,NJ
	DO 100 I=1,NI
	  IF (IX(I,J,NFR2).LT.ICUT) GO TO 120
	  TEM=SCA*FLOAT(IX(I,J,NFR))/FLOAT(IX(I,J,NFR2))
	  IF (ABS(TEM).GT.32767.) GO TO 120
	  IX(I,J,NRES)=TEM
	  GO TO 100
 120	  IX(I,J,NRES)=1
 100	CONTINUE
 900	RETURN1
	END	
C///////////////////////////////////////////////////////////////////////////
C
C    SUBROUTINE TO APPLY COLOUR TERM PIXEL BY PIXEL
C          PICTURES ARE ALREADY ALIGNED
C
	SUBROUTINE CC1(*,NFR1,NFR2,NFRC,IPAR,IX,NU,NV,KF)
	DIMENSION C(2),SC(2),NFC(2)
	CHARACTER*1 ANS
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR1,KF,1,*900,*20001)
20001	CALL QUERYNFR(NFR2,KF,1,*900,*20002)
20002	IF (NFRC.EQ.0) NFRC=KF-1
	WRITE(6,10) NFRC
 10	FORMAT(' **Frame ',I2,'** will be used as colour map')
 600	WRITE(6,11) NFR1,NFR2,NFR1
 11	FORMAT('  ENTER colour term for frame',I2, '(',I1,'-',
     *       I1,')','   CRT d OUT')
	call read1r(c(1),*900,*600)
	IF (C(1).EQ.999.) RETURN1
 601	WRITE(6,11) NFR2,NFR1,NFR2
	call read1r(c(2),*900,*601)
	IF (C(2).EQ.999.) RETURN1
 6011	WRITE(6,*) '  Do you want to scale sky colour to 0? (y/n)'
	call readstr(1,ans,*900,*6011)
	NFC(1)=NFR1
	NFC(2)=NFR2
	IF (ANS.EQ.'y') THEN
	  DO 219 I=1,2
 	    CALL PSTAT(*220,NFC(I),NII(NFC(I))/3,0,0,0,TAV1,DUM,NDUM,9,
     *                  IX,NU,NV,KF)
 220	    CALL PSTAT(*219,NFC(I),2*NII(NFC(I))/3,0,0,0,TAV2,DUM,NDUM,
     *                  9,IX,NU,NV,KF)
 219	  SC(I)=.5*(TAV1+TAV2)
	ELSE
	  SC(1)=1.
	  SC(2)=1.
	END IF
	SCALE=1000.*SC(2)/SC(1)
	CALL MOVE(NFR1,NFRC,IX,NU,NV,KF)
	CALL SMOOTH(*90,NFRC,3,0,IX,NU,NV,KF)
 90	CALL SMOOTH(*91,NFR2,3,2,IX,NU,NV,KF)
 91	CALL CMAP1(*92,NFRC,KF,NFRC,SCALE,10,IDUM,IX,NU,NV,KF)
 92	IF (C(1).EQ.0.) GO TO 120
	C(1)=10.**(-.4*C(1))/1000.
	DO 100 J=1,NJJ(NFR1)
	  DO 100 I=1,NII(NFR1)
	    IXX=nint(FLOAT(IX(I,J,NFR1))*C(1)*FLOAT(IX(I,J,NFRC)))
 100	    IX(I,J,NFR1)=INTLIMR(IXX)
 120	IF (C(2).EQ.0.) GO TO 121
	C(2)=1000.*(10.**(-.4*C(2)))
	DO 101 J=1,NJJ(NFR2)
	  DO 101 I=1,NII(NFR2)
	    IXX=nint(FLOAT(IX(I,J,NFR2))*C(2)/FLOAT(IX(I,J,NFRC)))
 101	    IX(I,J,NFR2)=INTLIMR(IXX)
 900	CONTINUE
 121	RETURN1
	END
C//////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CORRECT COLOUR TERM PIXEL BY PIXLE
C   ORINGINAL PICTURES ARE NOT ALIGNED (IN X-Y)
C   AND NO SHIFTING OF THE ORIGINAL IS DESIRED
C
C
	SUBROUTINE CC2(*,NFR1,NFR2,NFRC,IPAR,IX,NU,NV,KF)
	DIMENSION C(2),SC(2),NFC(2)
	CHARACTER*1 ANS
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	CALL QUERYNFR(NFR1,KF,1,*900,*20001)
20001	CALL QUERYNFR(NFR2,KF,2,*900,*20002)
20002	IF (NFRC.EQ.0) NFRC=KF-1
	WRITE(6,10) NFRC
 10	FORMAT(' **Frame ',I2,'** will be used as colour map')
 600	WRITE(6,11) NFR1,NFR2,NFR1
 11	FORMAT('  ENTER colour term for frame',I2, '(',I1,'-',I1,')')
	call read1r(c(1),*900,*600)
 601	WRITE(6,11) NFR2,NFR1,NFR2
	call read1r(c(2),*900,*601)
 602	WRITE(6,*) '  ENTER shift of F2 wrt F1, (ij(F2)-ij(F1))'
     *            ,'  REAL'
	call read2r(di1,di2,*900,*602)
	IF (DI1.EQ.999.) RETURN1
 670	WRITE(6,*) '  Do you want to scale sky colour to 0? (y/n)'
	call readstr(1,ans,*900,*670)
	NFC(1)=NFR1
	NFC(2)=NFR2
	IF (ANS.EQ.'y') THEN
	  DO 219 I=1,2
 	    CALL PSTAT(*220,NFC(I),NII(NFC(I))/3,0,0,0,TAV1,DUM,NDUM,9,
     *                 IX,NU,NV,KF)
 220	    CALL PSTAT(*219,NFC(I),2*NII(NFC(I))/3,0,0,0,TAV2,DUM,NDUM,
     *                 9,IX,NU,NV,KF)
 219	  SC(I)=.5*(TAV1+TAV2)
	ELSE
	  SC(1)=1.
	  SC(2)=1.
	END IF
	K1=1
	K2=2
	IF (C(1).EQ.0.) K1=2
	IF (C(2).EQ.0.) K2=1
	DO 101 K=K1,K2
 	IF (K.EQ.1) THEN
	  SCALE=1000.*SC(1)/SC(2)
 	  CALL MOVE(NFC(2),NFRC,IX,NU,NV,KF)
	  CALL SHIFTP(*86,NFRC,-DI1,-DI2,1,IX,NU,NV,KF,0)
 86	  CONTINUE
	ELSE
	  SCALE=1000.*SC(2)/SC(1)
	  CALL MOVE(NFC(1),NFRC,IX,NU,NV,KF)
	  CALL SHIFTP(*87,NFRC,DI1,DI2,1,IX,NU,NV,KF,0)
 87	END IF
 	CALL SMOOTH(*92,NFRC,3,0,IX,NU,NV,KF)
 92	CALL SMOOTH(*85,NFC(K),3,2,IX,NU,NV,KF)
 85	CALL CMAP1(*91,NFRC,KF,NFRC,SCALE,10,IDUM,IX,NU,NV,KF)
 91	DO 102 J=1,NJJ(NFC(K))
	  DO 103 I=1,NII(NFC(K))
	  IF (IX(I,J,NFRC).GT.0.) THEN
	    XX=FLOAT(IX(I,J,NFC(K)))*
     *         (FLOAT(IX(I,J,NFRC))/1000.)**C(K)
	IF (XX.GT.2E9) write(6,*) NFC(K),I,J,XX
 	    IX(I,J,NFC(K))=INTLIMR(nint(XX))
	  END IF
103	continue
102	continue
 101	CONTINUE	
 900	RETURN1
	END
C/////////////////////////////////////////////////////////////////
C 
C  SUBROUTINE TO CHECK CENTROID OF POSITION FILE
C      ICCEN=0 2nd round is not automatically accepted
C
	SUBROUTINE CHCKCN(*,NFR,IPO,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF),II(0:35),IJ(0:35)
	INTEGER IX(NU,NV,KF),II(0:35),IJ(0:35)
	INTEGER KFR(5)
	CHARACTER*1 IAN
	CHARACTER*20 IANS
	character*64 string,fstr85,fstr55
	CHARACTER*60 DSC1,DSC2
	INCLUDE 'picdir.inc'
	INCLUDE 'ppparm.inc'
        include 'objcat.inc' 
	include 'apert.inc'
	DIMENSION RI(5),REALI(500),REALJ(500),RMAG(500),RJ(5),IB(11)
     *                  ,IE(11),JRG(8),RRMAG(35),DSQ(8),DII(8),DJJ(8)
	CALL QUERYNFR(NFR,KF,0,*900,*20001)
20001	DSC1=' '
	DSC2=' '
	WRITE(6,1200) PCOMMENT(NFR)
 1200	FORMAT(1X,A60)
C first call to set up aperture array for ring of 7,31
	CALL PCENTR(NFR,0,IX,NU,NV,KF,REALI(1),REALJ(1),RMAG(1),DUM,
     *              IJOI(1,NFR),IJOJ(1,NFR),1,FLOAT(2*NAPCEN+1),31,0,4)
	CALL PCENTR(NFR,0,IX,NU,NV,KF,REALI(2),REALJ(2),RMAG(2),DUM,
     *              IJOI(2,NFR),IJOJ(2,NFR),NOB(NFR)-1,0.,0,0,4)
	WRITE(6,*) '  OBJECTS WITH CENTROID > 2 PIXEL FROM INT POSITON'
	DO 100 I=1,NOB(NFR)
	  DELI=REALI(I)-FLOAT(IJOI(I,NFR))
	  DELJ=REALJ(I)-FLOAT(IJOJ(I,NFR))
	  IF (ABS(DELI).GT.2..OR.ABS(DELJ).GT.2.) THEN
            WRITE(6,1) I,IJOI(I,NFR),IJOJ(I,NFR),REALI(I),REALJ(I),
     *                 DELI,DELJ,IDOB(I,NFR)
	  END IF
 100	CONTINUE
	CALL RBELL(IBELL)
 5991	WRITE(6,*) ' Do you want to improve the bad positions '
     *            ,'by iterative centroiding? y/n'
	call readstr(1,ian,*900,*5991)
	IF (IAN.NE.'y') RETURN1
C
C   big loop for checking every object
	DO 101 I=1,NOB(NFR)
	  DO 1011 KK=1,3
	    RI(KK)=0.
 1011	    RJ(KK)=0.
	  IAUTO=0
	  RI(4)=REALI(I)
	  RJ(4)=REALJ(I)
	  DI=RI(4)-IJOI(I,NFR)
	  DJ=RJ(4)-IJOJ(I,NFR)
	  IF (ABS(DI).LE.0.5.AND.ABS(DJ).LE.0.5) GO TO 101
C
C  one of the co-ords is off by >0.5
	  II(0)=IJOI(I,NFR)
	  IJ(0)=IJOJ(I,NFR)
	  WRITE(6,5) I,IJOI(I,NFR),IJOJ(I,NFR),REALI(I),REALJ(I),
     *      DI,DJ,RMAG(I),IDOB(I,NFR),IX(IJOI(I,NFR),IJOJ(I,NFR),NFR)
 5	FORMAT(/' OBJ# ',I3,2X,2I4,2(2X,2F7.2),F8.3,I3,1X,I6)
C
C  iterate on object I
	  J1=1
	  J2=10
 350	  CONTINUE
	  DO 102 J=J1,J2
C
C For discrepancies bewteen 2.1 and 3.5, the correction is 1/2 only
C
	    DDI=0.
	    DDJ=0.
	    IF (ABS(DI).GT.2.1) DDI=DI*.5
	    IF (ABS(DJ).GT.2.1) DDJ=DJ*.5
C 
C  for large discrepancies, a new co-ord, changed by only 1 pixel is tried
	    IF (ABS(DI).GT.3.5.OR.ABS(DJ).GT.3.5) THEN
	      WRITE(6,*) ' +++ DELTA POS TOO LARGE, NEXT POSITION EST+++'
	      II(J)=II(J-1)+SIGN(AMIN1(1.,ABS(DI)),DI)+.49
	      IJ(J)=IJ(J-1)+SIGN(AMIN1(1.,ABS(DJ)),DJ)+.49
	    ELSE
	      II(J)=RI(4)+.49-DDI
	      IJ(J)=RJ(4)+.49-DDJ
	    END IF
C  check if the new position is too far from the very original one
	    IDI=II(J)-IJOI(I,NFR)
	    IDJ=IJ(J)-IJOJ(I,NFR)
	    IF (IABS(IDI).GT.4.OR.IABS(IDJ).GT.4) GO TO 109
	    CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(5),RJ(5),RRMAG(J),DUM,
     *            II(J),IJ(J),1,0.,0,0,4)
	    DI=RI(5)-FLOAT(II(J))
	    DJ=RJ(5)-FLOAT(IJ(J))
	    WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *            ,IX(II(J),IJ(J),NFR)
 9	FORMAT(' ITN#',I2,2X,2I4,2X,2F9.2,2X,2F8.2,F9.3,1X,I6)
C check delta position, exit if <.051, otherwise, set up for 
C   next iteration
	    IF (ABS(DI).LE..51.AND.ABS(DJ).LE..51) GO TO 1031
	    IF (II(J).EQ.IJOI(I,NFR).AND.IJ(J).EQ.IJOJ(I,NFR))
     *        GO TO 111
	    DO 105 M=1,4
	      IF (RI(5).EQ.RI(M).AND.RJ(5).EQ.RJ(M)) THEN
	        GO TO 111
	      END IF
	      RI(M)=RI(M+1)
	      RJ(M)=RJ(M+1)
 105	    CONTINUE
 102	  CONTINUE     
C   end of iterative checking, type out final result 
	  J=J-1
 109	  WRITE(6,*) ' ****NON-CONVERGING****'
	  GO TO 1032
 111	  WRITE(6,*) '  **** OSCILLATING CO-ORDS, ITN STOPPED ***'
C iterations fail to find a stable position, set up to go around 
C     the original position to check for possible stable position
 1032	  IF (J1.EQ.1.AND.IDOB(I,NFR).LT.4) THEN
 	    IAN='s'
	    WRITE(6,91)
 91	FORMAT( 1X,'  ----Going around the original position---')
	    GO TO 861
	  ELSE
	    GO TO 103
	  END IF  
C   Successfully found stable position, now check:
C   1 :  if original magnitude = 0.0, unacceptable
 1031	  IF (J1.NE.1.OR.IDOB(I,NFR).GE.4) GO TO 103
	  IF (RMAG(I).EQ.0.) THEN
	    IAN='r'
	    WRITE(6,91)
	    JPP=J
	    RMAGB=RRMAG(J)
	    GO TO 861
	  END IF  
C and 2: if obj has mag within .075 of original AND new pos within
C        one pixel of original, if not, try going around.
	  IF (IABS(II(J)-IJOI(I,NFR)).LE.1.AND.IABS(IJ(J)-IJOJ(I,NFR))
     *        .LE.1.AND.RRMAG(J).LT.(RMAG(I)+0.075)) THEN
	    WRITE(6,*) '  ----- NEW CO-ORDINATED ACCEPTED ---- '
	    GO TO 107
	  ELSE
	    IF (IABS(II(J)-IJOI(I,NFR)).LE.2.AND.IABS(IJ(J)-IJOJ(I,NFR))
     *          .LE.2.AND.RRMAG(J).LT.(RMAG(I)+0.075)) IAUTO=1
	    IAN='s'
	    WRITE(6,91)
	    JPP=J
	    RMAGB=RRMAG(J)
	  GO TO 861
	  END IF  
 103	  WRITE(6,6) I,IJOI(I,NFR),IJOJ(I,NFR),IX(IJOI(I,NFR),
     *        IJOJ(I,NFR),NFR),II(J),IJ(J),IX(II(J),IJ(J),NFR)
 6	FORMAT(' OBJ#',I3,'  OLD ',2I4,2X,I6,3X,'NEW ',2I4,2X,I6)
 61	FORMAT(' OBJ#',I3,'  OLD ',2I4,2X,I6,3X,'SAVED NEW J=',I2,3X,
     *            2I4,2X,I6)
C   operator intervention
 24	FORMAT('   Various options: y - save latest co-ord'/
     *  '                    n - no change, retain orignial position'/
     *  '                    d - dispaly frame around obj using sdis'/
     *  '                    Integer 1-35 - save the Jth co-ord'/
     *  '                    t i j - TRY the co-ord (i,j)'/
     *  '                    r - ROUND: go around the oringal co-ord'/
     *  '                    g i j - GO: iterate starting from (i,j)')
 201	  CALL RBELL(1)
 5992	  WRITE(6,87) 
 87	FORMAT('  Inconclusive result, enter h(elp),1-25,n(o): ',$)
	  call readstr(20,ians,*900,*5992)
	  READ(IANS(1:1),2) IAN
 2	  format(a1)
	  IF (IAN.EQ.'y') GO TO 107
	  CALL FSTR(IANS,20,IB,IE,NB)
	  IF (IAN.EQ.'d') THEN
	    KFR(1)=-NFR
	    KFR(2)=MAX0(1,IJOI(I,NFR)-70)
	    KFR(3)=MAX0(1,IJOJ(I,NFR)-70)
	    KFR(4)=MIN0(NII(NFR),KFR(2)+100)
	    KFR(5)=MIN0(NJJ(NFR),KFR(3)+100)
	    CALL SCRDIS(*201,KFR,NDUM1,NDUM2,IX,NU,NV,KF)
	  ELSE IF (IAN.EQ.'h') THEN
	    WRITE(6,24)
	    GO TO 201
C
C   try other random supplied co-ordinates
	  ELSE  IF (IAN.EQ.'t') THEN
	    J=11
	    IF (NB.LE.2) THEN
 202	      WRITE(6,88) 
 88	FORMAT(' Enter desired co-ordinate I,J: ',$)
	      call read2i(iil,jjl,*201,*202)
	      ii(j)=iil
	      ij(j)=jjl
	    ELSE
	      ICL=IE(2)-IB(2)+1
	      istatus=encode(string,float(icl),1,0,idum)
	      fstr85='(I'//string(1:lnblnk(string))//')'
	      READ(IANS(IB(2):IE(2)),fstr85,ERR=201) II(J)
	      ICL=IE(3)-IB(3)+1
	      istatus=encode(string,float(icl),1,0,idum)
	      fstr85='(I'//string(1:lnblnk(string))//')'
	      READ(IANS(IB(3):IE(3)),fstr85,ERR=201) IJ(J)
	    END IF
c 85	FORMAT(I<ICL>)
	    CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(5),RJ(5),RRMAG(J),DUM,
     *            II(J),IJ(J),1,0.,0,0,4)
	    DI=RI(5)-FLOAT(II(J))
	    DJ=RJ(5)-FLOAT(IJ(J))
	    WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *            ,IX(II(J),IJ(J),NFR)
	    GO TO 201
	  END IF
C
C   going around the original pixel
 861	  IF (IAN.EQ.'r'.OR.IAN.EQ.'s') THEN
 	    I1=MAX0(1,IJOI(I,NFR)-1)
	    I2=MIN0(NII(NFR),IJOI(I,NFR)+1)
	    J1=MAX0(1,IJOJ(I,NFR)-1)
	    J2=MIN0(NJJ(NFR),IJOJ(I,NFR)+1)
	    J=11
	    IRG=0
	    NN=0
	    DO 300 L=I1,I2
	    DO 300 M=J1,J2
	      IF (L.EQ.IJOI(I,NFR).AND.M.EQ.IJOJ(I,NFR)) GO TO 300
	      NN=NN+1
	      J=J+1
	      II(J)=L
	      IJ(J)=M
	      CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(5),RJ(5),RRMAG(J),DUM,
     *                  II(J),IJ(J),1,0.,0,0,4)
	      DI=RI(5)-FLOAT(II(J))
	      DJ=RJ(5)-FLOAT(IJ(J))
	      DII(NN)=DI
	      DJJ(NN)=DJ
	      WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *            ,IX(II(J),IJ(J),NFR)
	      IF (ABS(DI).LT.0.51.AND.ABS(DJ).LT.0.51.AND.
     *             RRMAG(J).LT.(RMAG(I)+0.075)) THEN
	        IRG=IRG+1
	        JRG(IRG)=J
	      END IF
300	    CONTINUE
	    IF (RMAG(I).EQ.0.) GO TO 201
	    IF (IRG.EQ.0) THEN
c ! niether R nor iter found stable pos
	      IF (IAUTO.EQ.0) GO TO 399
	      J=JPP
	      WRITE(6,*) '  ////PREVIOUS BEST VALUE ACCEPTED'
	      GO TO 107
	    ELSE
	      IF (IRG.EQ.1.AND.IAUTO.EQ.0) THEN
	        J=JRG(1)
	        WRITE(6,*) '  ////NEW CO-ORDINATED ACCEPTED '
	        GO TO 107
	      ELSE
	        istatus=encode(string,float(irg),1,0,idum)
		fstr55='(''  ---- Good centroids: '','
     &   //string(1:lnblnk(string))//'(''# '',I2,3X))'
	        WRITE(6,fstr55) (JRG(KK),KK=1,IRG)
c 55	FORMAT('  ---- Good centroids: ', <IRG>('# ',I2,3X))
	        J=JRG(1)
	        BEST=RRMAG(JRG(1))
	        DO 330 KK=2,IRG
	          IF (RRMAG(JRG(KK)).LT.BEST) THEN
	            J=JRG(KK)
	            BEST=RRMAG(J)
	          END IF
 330	        CONTINUE
	        WRITE(6,*) '/// NEW CO-ORDS. # ',J,' ACCEPTED ///' 
	        GO TO 107
	      END IF
	    END IF	        
C
C  going around unsucessful, now try the outer 16 pixel
 399	    IF (IAN.EQ.'s') THEN
	      WRITE(6,*) '    --- going around 2 pixels out ----'
 	      I1=MAX0(1,IJOI(I,NFR)-2)
	      I2=MIN0(NII(NFR),IJOI(I,NFR)+2)
	      J1=MAX0(1,IJOJ(I,NFR)-2)
	      J2=MIN0(NJJ(NFR),IJOJ(I,NFR)+2)
	      J=19
	      IRG=0
	      DO 390 L=I1,I2
	        DO 390 M=J1,J2
	          IF ((L.GE.(I1+1).AND.L.LE.(I2-1)).AND.
     *              (M.GE.(J1+1).AND.M.LE.(J2-1))) GO TO 390
	          J=J+1
	          II(J)=L
	          IJ(J)=M
	          CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(5),RJ(5),RRMAG(J),
     *                  DUM,II(J),IJ(J),1,0.,0,0,4)
	          DI=RI(5)-FLOAT(II(J))
	          DJ=RJ(5)-FLOAT(IJ(J))
	          IF ((ABS(DI).LE.2..AND.ABS(DJ).LE.2.).AND.
     *                 (RRMAG(J).LT.(RMAG(I)+.15))) THEN
                    WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *                 ,IX(II(J),IJ(J),NFR)
	          ELSE
	            IF (ABS(DI).LE.1.0.AND.ABS(DJ).LE.1)
     *               WRITE(6,9) J,II(J),IJ(J),RI(5),RJ(5),DI,DJ,RRMAG(J)
     *                 ,IX(II(J),IJ(J),NFR)
 	          END IF
	          IF (ABS(DI).LT.0.51.AND.ABS(DJ).LT.0.51.AND.
     *                   RRMAG(J).LT.(RMAG(I)+0.075)) THEN
	            IRG=IRG+1
	            JRG(IRG)=J
	          END IF
390	      CONTINUE
C  No good positions are found, relax conditions for acceptance 
C    for the central 9 pixels
	      IF (IRG.EQ.0) THEN
	        DELI=REALI(I)-IJOI(I,NFR)
	        DELJ=REALJ(I)-IJOJ(I,NFR)
	        DSQO=DELI*DELI+DELJ*DELJ
C       original pixel
	        IF (DSQO.LE..6) THEN
c  !  no change
	          IAN='n' 
	          GO TO 121
	        ELSE
C   RECHECK 8 pixels around
	          WRITE(6,*) '  ....Rechecking the central 8 pixels..'
C first see if any position within 0.84 (rsq 0.7) pixel and no decrease
C in mag
	          DO 398 NN=1,8
 398	            DSQ(NN)=DII(NN)*DII(NN)+DJJ(NN)*DJJ(NN)
	          DO 3982 LL=1,3
	            DCRIT=.45+LL*.25
	            DMAGC=LL*.05
	            DMIN=2.
	            DO 3981 NN=1,8
	              IF (DSQ(NN).LE.DCRIT.AND.
     *	                  RRMAG(NN+11).LT.(RMAG(I)+DMAGC) ) THEN
	                IRG=IRG+1
	                JRG(IRG)=NN
	                IF (DSQ(NN).LT.DMIN) THEN
                          DMIN=DSQ(NN)
	                  JRGDMIN=NN
	                END IF
	              END IF
 3981	            CONTINUE
	WRITE(6,*) ' TURN',LL,IRG
	            IF (IRG.EQ.0) THEN
C  check original pixel again
	              IF (DSQO.LT.DCRIT) THEN
c !  no change
	                IAN='n'  
	                GO TO 121
	              END IF
C  Success in finding a candidate position
c! first check brightness
	            ELSE      
	              BRIGHT=0.
	              DO 3983 NN=1,IRG
	WRITE(6,*) JRG(NN)+11,DSQ(JRG(NN)),RRMAG(JRG(NN)+11)
	                IF (RRMAG(JRG(NN)+11).LT.BRIGHT) THEN
	                  JRGBMAX=JRG(NN)
	                  BRIGHT=RRMAG(JRG(NN)+11)
	                END IF
 3983	              CONTINUE
C  check if closeset pos. is within .1 mag of brightest pos.
	              IF (RRMAG(JRGDMIN+11).LT.(RMAG(I)+.02)) THEN
	                J=JRGDMIN+11
	              ELSE IF (RRMAG(JRGDMIN+11).LT.BRIGHT+0.1) THEN
	                J=JRGDMIN+11
	              ELSE
	                J=JRGBMAX+11
	              END IF
C      final check against original pixel
	              IF (DSQO.LT.DCRIT.AND.RRMAG(J).GT.RMAG(I)) THEN
c !  no change
	                IAN='n'  
	                GO TO 121
	              ELSE
	                WRITE(6,15) 
 15	FORMAT('  ///Best Co-ord from inner 8 pixels accepted')
	                GO TO 107
	              END IF
	            END IF
 3982	          CONTINUE
C   Not successful in finding good postion in inner 8
	          GO TO 201
	        END IF
	      END IF
	      IF (IDOB(I,NFR).EQ.1.AND.ICCEN.EQ.1) THEN
	        IF (IRG.EQ.1.AND.IAUTO.EQ.0) THEN
	          J=JRG(1)
	          WRITE(6,*) '  ////NEW CO-ORDINATED ACCEPTED '
	          GO TO 107
	        ELSE
	          WRITE(6,fstr55) (JRG(KK),KK=1,IRG)
	          J=JRG(1)
	          BEST=RRMAG(JRG(1))
	          DO 393 KK=2,IRG
	            IF (RRMAG(JRG(KK)).LT.BEST) THEN
	              J=JRG(KK)
	              BEST=RRMAG(J)
	            END IF
 393	          CONTINUE
	          WRITE(6,*) '/// NEW CO-ORDS. # ',J,' ACCEPTED ///' 
	          GO TO 107
	        END IF
	      ELSE
	        WRITE(6,fstr55) (JRG(KK),KK=1,IRG)
	        GO TO 201
	      END IF
	    ELSE
	      GO TO 201
	    END IF
	  END IF
	  IF (IAN.EQ.'g') THEN
	    J=20
	    IF (NB.LE.1) THEN
 252	      WRITE(6,88) 
	      call read2i(iil,jjl,*201,*252)
	      ii(j)=iil
	      ij(j)=jjl
	    ELSE
	      ICL=IE(2)-IB(2)+1
	      READ(IANS(IB(2):IE(2)),fstr85,ERR=201) IJNUM
	      IF (NB.EQ.2) THEN
	        IF (IJNUM.GT.35) GO TO 201
	        II(J)=II(IJNUM)
	        IJ(J)=IJ(IJNUM)
	      ELSE
	        II(J)=IJNUM
	        ICL=IE(3)-IB(3)+1
	        READ(IANS(IB(3):IE(3)),fstr85,ERR=201) IJ(J)
	      END IF
	    END IF
	    CALL PCENTR(NFR,0,IX,NU,NV,KF,RI(4),RJ(4),RRMAG(J),DUM,
     *                  II(J),IJ(J),1,0.,0,0,4)
	    DI=RI(4)-II(J)
	    DJ=RJ(4)-IJ(J)
C
C  one of the co-ords is off by >0.5
	    II(0)=IJOI(I,NFR)
	    IJ(0)=IJOJ(I,NFR)
	    WRITE(6,9) J,II(J),IJ(J),RI(4),RJ(4),DI,DJ,RRMAG(J)
     *            ,IX(II(J),IJ(J),NFR)
	    IF (ABS(DI).LE.0.5.AND.ABS(DJ).LE.0.5) GO TO 201
	    J1=21
	    J2=30
	    GO TO 350
	  END IF
C code starts with a number assuming it is J to be saved
	  IF (NB.EQ.1) THEN
	    ICL=IE(1)-IB(1)+1
	    READ(IANS(IB(1):IE(1)),fstr85,ERR=121) J
	    IF (J.GT.35) GO TO 201
	  ELSE
	    GO TO 201
	  END IF
 107	  WRITE(6,61) I,IJOI(I,NFR),IJOJ(I,NFR),IX(IJOI(I,NFR),
     *        IJOJ(I,NFR),NFR),J,II(J),IJ(J),IX(II(J),IJ(J),NFR)
 	    IJOI(I,NFR)=II(J)
	    IJOJ(I,NFR)=IJ(J)
	    IDOB(I,NFR)=IDOB(I,NFR)+4
	  GO TO 101
C 110	  WRITE(6,*) '  **** DELTA CO-ORDS TOO LARGE ****'
 121	  IF (IAN.NE.'n') GO TO 201
	    WRITE(6,*) '    --- NO CHANGE MADE ----'
 101	CONTINUE
 1	FORMAT(' **',I4,'**',3X,2I4,2X,2F7.2,3X,2F7.2,3X,I2)
	WRITE(6,19) 
 19	FORMAT(/'  DONE!! Do you want to save? ')
C	WRITE(6,*) ' !! DONE !! Do you want to save',
C   *   ' the new position file on DISK? Y/N:'
	CALL RBELL(IBELL)
C	READ(5,2,END=900) IAN
	CALL PTYPE(*900,NFR,DSC1,DSC2,0,0,2,IX,NU,NV,KF)
C	IF (IAN.EQ.'y') CALL PTYPE(*900,NFR,DSC1,DSC2,1,IX,NU,NV,KF)
 900	RETURN1
	END
