C///////////////////////////////////////////////////////////////////////
C
C    SUBROUTINE  PACKAGE TO DO CROWDED FIELD GALAXY PHOTOMETRY
C     	USING PARTIAL PIXEL APERTURES
C
C***********************************************************************
C////////////////////////////////////////////////////////////////////
C
C   DRIVING ROUTINE FOR AUTOPHOT, WITH OBJECT MASKING FOR CROWDED FIELDS
C
C               IPRT=0 DO NOT PRINT INTERMEDIATE RESULTS
C 		IPR1=1 PRINT ALL INTERMEDIATE STEPS
C               IPO=0 SAVE RESULTS
C               IPO>0 NO WRITE
C               IPAR=1 automatic choice for reference objects and
C                      automatic /PRI plot of PC2
c                   =2 same as 1 but check transformation pixel map
c
c   Jan 1 2005, modified for RCS pipe
c
	SUBROUTINE PPPDRI(*,NFRA,STRF,TCOMMENT,IPART,IX,NU,NV,KF)
c maximum objects (must be less or equal to maxobj in objcat.inc
	parameter(nmax=100000)
c maximum psfs
	parameter(nfmax=3000)
	INTEGER IX(NU,NV,KF),IDS(nmax),ICLP(nmax),ICLS(nmax),
     *    NMASK(500,500),NNEI(nmax),IDBR(nmax)
	integer nng(200),nhalo(500)
	DIMENSION  NFRA(5),RI(30),RMAG(30,nmax),PK(nmax),
     *   REALI(nmax),REALJ(nmax),SKY(nmax),ZSIG(nmax),
     *    DELMAG(nmax),EXMAG(nmax),SP(0:30,nmax)
     *     ,SKYERR(nmax),SUMDEL(nmax),RAD(nmax),
     *    SKARAY(50000),CLSCT(3),PIXN(30),REFST(30,5,5),IREF(10,5,5),
     *    RMAGBR(30),idsref(5,5),nref(5,5),refpk(5,5),refstt(30),
     *     irefv(nfmax),see(5,5),psfpx(5,5),psfpy(5,5),refstv(30,nfmax)
     *     ,idsrefv(nfmax),psfpxv(nfmax),psfpyv(nfmax),refpkv(nfmax),
     *     index(nfmax),distpsf(nfmax),xline(250),dlograd(29)
c    *       ELL(nmax),ANG(nmax),RSQ(nmax)
	CHARACTER*18 FILOUT*28,FILT*28,DEV,HPLOT,SPLOT
	CHARACTER*1 IANS,IANS2,secstr
	CHARACTER*60 COMMENT,STRF,TCOMMENT
	character*64 string1,string2,fstr24,fstr27
c	CHARACTER ADATE*9,ATIME*8
	character*24 fdate,ian*1
	REAL*8 FIL
        common/imagestats/imstatspar(50),ich_id,ch_rms(50),ch_sky(50),
     *     nbstar_ch(50),ch_bsmag(15,50),ch_bsx(15,50),ch_bsy(15,50)
	INCLUDE 'pppcore.inc'
	INCLUDE 'ppparm.inc'
	COMMON/PLOTDEV/ HPLOT,SPLOT,ipinit
	INCLUDE 'picdir.inc'
        include 'objcat.inc' 
	include 'apert.inc'
	include 'imagepar.inc'
	include 'pipeparm.inc'
c  *** need to change equivalence 2*nmax*30 for changing nmax
c   the equivalence for rmag and sp is good only if nmax<=15000
 	equivalence (iscr(1900001),skaray(1))
c    *        ,(iscr(1),rmag(1,1))
c    *	     ,(iscr(900001),sp(0,1))
      
c     *     ,(iscr(300001),PK(1)),(iscr(310001),REALI(1)),
c     *     (iscr(320001),REALJ(1)),(iscr(330001),SKY(1)),
c     *     (iscr(845001),ZSIG(1)),(iscr(861001),ELL(1)),
c     *     (iscr(874001),ANG(1)),(iscr(887001),RAD(1)),
c     *     (iscr(380001),DELMAG(1)),(iscr(390001),EXMAG(1)),
c     *     (iscr(400001),SKYERR(1)),(iscr(410001),nnei(1)),
c     *     (iscr(415001),IDS(1)),(iscr(420001),ICLP(1)),
c     *     (iscr(425001),ICLS(1)),(iscr(430001),idbr(1)),
c     *     (iscr(435001),rsq(1)),(iscr(445001),sumdel(1)),
c     *     (iscr(455001),refstv(1,1)),(iscr(460001),ri(1)),
c     *     (iscr(460101),pixn(1)),(iscr(460201),index(1)),
c     *     (iscr(460401),see(1,1)),(iscr(460501),distpsf(1)),
c     *     (iscr(463001),iref(1,1,1)),(iscr(464001),irefv(1)),
c     *     (iscr(500001),APERMASK(1,1)),(iscr(540001),NMASK(1,1))
c     *     ,(iscr(610001),sp(0,1)),(iscr(920001),skaray(1))
 	equivalence (refstv(1,1),refst(1,1,1)),(psfpxv(1),psfpx(1,1)),
     *               (psfpyv(1),psfpy(1,1)),(idsrefv(1),idsref(1,1)),
     *               (refpkv(1),refpk(1,1))
c	iprt=1
	CDIAM=NAPCEN
	NFR=NFRA(1)
	IPAR=IPART
	if (ipipercs.eq.1) iwt=0
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (NFR.GT.nposfil) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST <=6 FOR POSITION FILE'
	  RETURN1
	END IF
	NI=NII(NFR)
	NJ=NJJ(NFR)
	NOBB=NOB(NFR)
	IF (NOBB.GT.nmax) THEN
          WRITE(6,*) '  *** Warning, number of objects > ',nmax
	  write(6,*) '    photometry for object# >',nmax,
     *             ' may be incorrect'
	ELSE IF (NOBB.LE.0) THEN
	  WRITE(6,*) '  **** Position file contains zero object ***'
	  RETURN1
	END IF
 600	CALL READFN2(FILT,STRF(1:28),FILOUT,'phm','o',28,*999,*600,*20010)
20010	IF (FILOUT.NE.'n') THEN 
	  IF (TCOMMENT.EQ.' ') THEN
 601	    WRITE(6,10) COMMENT
 10	FORMAT('   ENTER comment, <=60 characters: Default: '/,' (',
     *        A60,')'/' :',$)
	    CALL READSTRD(60,COMMENT,*999,*601)
	  ELSE
	    COMMENT=TCOMMENT
	  END IF
	  if (nsct(nfr).ne.0) then
	    istatus=encode(secstr,float(nsct(nfr)),1,0,idum)
	    filout=filout(1:lnblnk(filout))//'.'//secstr
	  end if
	END IF
 602	K=4
	IF (FILOUT.EQ.'n') K=3
c aperture info
	if (ircspipe.eq.0) then
	  IF (NFRA(K).LE.IAPMIN+4) THEN
	    WRITE(6,11) IAPMIN,IAPIS,IAPMAX
 11	FORMAT(' Initial obj diameter:',I2,', Max sky diam=(max obj dia'
     *          ,'m)+',I2,
     *	    /'   Enter MAX obj DIAMETER in integer pixels [',i3,']: ',$)
	    CALL READ1I(IAPMAX,*999,*602)
	  ELSE
	    IAPMAX=NFRA(K)
	    NFRA(K)=0
	  END IF
c
c  added Jun 10 2008, a switch to allow the psf growth curve to grow to
c       iexpap for all psfs, using the sign of IAPMAX
c   to set the parameter ipsfextend 
	  if (iapmax.lt.0) then
	    iapmax=iabs(iapmax)
	    ipsfextend=1 
	  else
	    ipsfextend=0
	  end if
	else
	  iapmax=iapmaxpipe
        end if
	IF (IAPMAX.LE.IAPMIN) GO TO 602
	IAP2=IAPMAX+IAPIS+3
	IF (IAP2.GT.maxap) THEN
	  WRITE(6,*) '  **** Diameter too large ******'
	  GO TO 602
	END IF
	if (ircspipe.eq.0) then
 599	  WRITE(6,5)
 5	FORMAT('  Do you want automatic iterative re-centroding ('
     *         ,'y=dflt/n): ',$)
	  call readstr(1,ian,*999,*599)
	else
	  ian='y'
	end if
	IF (IAN.NE.'n') THEN
	  CALL CCENTER(*5994,NFR,0,IX,NU,NV,KF)
 5994	  IF (IPAR.LT.1) THEN
	    if (ircspipe.eq.0) then
 	      CALL RBELL(1)
 5991	      WRITE(6,29)
 29	FORMAT('  Proceed with photometry? y(=<cr>)/n: ',$)
	      call readstr(1,ian,*999,*5991)
	      IF (IAN.EQ.'n') RETURN1 
	    end if
	  END IF
C reset sky aperture
	  IAP2=IAPMAX+IAPIS+3
	END IF
	WRITE(6,*) 
	WRITE(6,*) '  --- Photometry starts ... '
C create sky aperture
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,IPRT)
C number of apertures
	NAP=MIN0(30,(IAPMAX-IAPMIN+IDELD)/IDELD)
	IEXAP1=MIN0(IEXAP,NAP)
C
C   MAKE APERTURES
C
	DO 100 I=1,NAP
 100	  IAP1(I)=IAPMIN+(I-1)*IDELD
	IAP1(31)=IAP1(NAP)+3
C  set inner sky aperture radius
	IF (IAP2-IAP1(NAP).GT.8) THEN
	  NNAP=31
	ELSE
	  NNAP=NAP
	END IF
	CALL APARAY(IAP1(NNAP),IT1(1,NNAP),IROW1(NNAP),QDUM,RDUM,PDUM
     *                 ,NA(NNAP),IPRT)
c    !Max radius
	IRMAX=IAP1(NAP)          
	IRMAXSQ=IRMAX*IRMAX          
c  ! array size for neighbor mask
	MASKSIZE=MIN0(500,2*IAP1(NAP)+1)     
	iexapf=min0(iexap,nap)
c  compute average sky for purpose of checking in case
c   bright stars or bad columns
c backup sky from circle, from 2 positions 
c       I1=NI/3
c       J1=NJ/3
c       CALL RCSKY(1,BKG1,BSIG1,1,I1,J1,NI,NJ,IX,NU,NV,SKARAY,
c    *           50000,nsky,0,IPR)
c       I1=2*NI/3
c       CALL RCSKY(1,BKG,BSIG,1,I1,J1,NI,NJ,IX,NU,NV,SKARAY,
c    *             50000,nsky,0,IPR)
c       J1=2*NJ/3
c       CALL RCSKY(1,BKG2,BSIG2,1,I1,J1,NI,NJ,IX,NU,NV,SKARAY,
c    *             50000,nsky,0,IPR)
c  backup is the middle one
c       if (bkg.gt.bkg1.and.bkg2.gt.bkg1) then
c         if (bkg.gt.bkg2) then
c           bkg1=bkg2
c         else
c           bkg1=bkg
c         end if
c       else if (bkg.lt.bkg1.and.bkg2.lt.bkg1) then
c         if (bkg.gt.bkg2) then
c           bkg1=bkg
c         else
c           bkg1=bkg2
c         end if
c       end if
c	bsig=0.3333*(bsig+bsig1+bsig2)
c
c  modification
c  July 05 2007: the simple backup background computation used
c      causes problem when there is a bright star in the wrong place
c   this is replaced using the same computation used in computing
c    average sky in object finding.
c  compute average sky, assume no masking for now (mask frame number nfm=0)
c             nfm=ibl
c
c take background from stored value, if in a pipeline
	if (ircspipe.eq.1.and.ich_id.ne.0.and.
     *           imstatspar(ich_id).ne.0) then
	  bkg=ch_sky(ich_id)
	  bsig=ch_rms(ich_id)
	  write(6,*) ' Back-up sky value from imagestats: ',bkg,bsig
	else
	  nfm=0
	  call rowskyval(nfr,nfm,100,50,nii(nfr)-40,bkg,bsig,ix,nu,
     *               nv,kf,*821)
 821      WRITE(6,*) '  Computed Back-up sky value: ',BKG,bsig
	end if
	iskyaper=0
c set up delta log radius
	do 144 i=1,nap-1
	  itemp=iapmin+i*ideld
	  dlograd(i)=alog10(float(itemp)/float(itemp-ideld))
 144	continue
c multiply by .5 for testing
	bkg=bkg*.5
	mh=0
	nvpsf=min0(4,nvpsf)
C
C...............................................................
C  Big loop #1
C  do photometry for each objects
C
	DO 101 I=1,NOB(NFR)
c ! Maximum allowable final aperture
	  MAXIDS=nap         
	  II=IJOI(I,NFR)
	  JJ=IJOJ(I,NFR)
	  if (ii.le.0.or.ii.gt.ni.or.jj.le.0.or.jj.gt.nj) then
	    write(6,87) i,ii,jj
 87	format(' ++obj#',i6,' at',2i5,
     *             ' outside image: photometry not done ')
	    reali(i)=float(ii)
	    realj(i)=float(jj)
	    do 1011 k=1,nap
	      rmag(k,i)=99.
 1011	    continue
	    nnei(i)=0
	    sky(i)=-99.0
	    zsig(i)=0.
	    pk(i)=0.
	    skyerr(i)=0.
	    go to 101
	  end if
C  check for neighbours
	  CALL NNEIGH(NNEI(I),NNG,II,JJ,NOBB,IJOI(1,NFR),IJOJ(1,NFR),
     *          I,IRMAX,IRMAXSQ)
c105	  WRITE(6,12) I,NNEI(I)
 105	  if (ircspipe.eq.0) WRITE(6,12) I,NNEI(I)
c12	FORMAT(/' Obj#',I6,' N_neigh:',I3)
 12	FORMAT(' Obj#',I6,' N_neigh:',I3)
C  determine sky
	  IF (ISKYSEC.EQ.0) THEN
	    CALL RCSKY(1,SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,NFR)
     *                    ,NU,NV,SKARAY,50000,nsky,iwt,IPR)
	  ELSE
	    CALL RING8SKY(SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,NFR)
     *                    ,NU,NV,SKARAY,50000,nsky,IPRT,IPR)
	  END IF
c check if sky is reasonable (ie > 0.5 of average)
c  May 20 1997: do not quite understand why this is used. Apparently
c     it causes problems.   Jun 3 1999, the problem could be due
c         to not resetting the aperture; this has been added.
	  if (sky(i).lt.bkg) then
c  reduce aperture to 2/3 max aperture to max aperture
	    iap2=iapmax
C create sky aperture
	    CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	    nnaptem=nap*2/3
	    write(6,*) '  ... sky too low, reduced sky aperture used '
	    CALL RCSKY(1,SKY(I),ZSIG(I),NNAPTEM,II,JJ,NI,NJ,
     *                 IX(1,1,NFR),NU,NV,SKARAY,50000,nsky,1,IPR)
C reset sky aperture
	    IAP2=IAPMAX+IAPIS+3
	    CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
c  if there still is a problem, use  average
	    if (sky(i).lt.bkg) then
	      sky(i)=2*bkg
	      zsig(i)=3*bsig
	    end if
	    write(6,*) '    +++ sky problem, recomputed: ',sky(i)
	  end if
 	  IF (IPR.NE.0) THEN
	    WRITE(6,*) ' ****  photometry not done *****'
	    DO 106 JK=1,30
	      RI(JK)=0.
 106	    CONTINUE
	    ZSIG(I)=0.
	    REALI(I)=II
	    REALJ(I)=JJ
	    GO TO 107
	  END IF
C  set up mask
	  CALL MAKEMASK(500,MASKSIZE,NMASK,NNEI(I),NNG,
     *        IJOI(1,NFR),IJOJ(1,NFR),II,JJ,
     *      SKY(I),IRMAX,IX(1,1,NFR),NU,NV,NI,NJ,maxids,iapmin)
C Determine fractional pixel centroid
 399	  CALL PHOTCEN(II,JJ,REALI(I),REALJ(I),SKY(I),IRMAX,NMASK,CDIAM,
     *         IX(1,1,NFR),NU,NV,NI,NJ,CENSTEP,ITERCEN,IPRT)
C	write(6,*) ' adopted centroid: ',REALI(I),REALJ(I)
C  Do photometry
	  CALL PPPHOT(RI,SP(0,I),REALI(I),REALJ(I),SKY(I),IRMAX,NMASK,
     *           NAP,IAP1,IX(1,1,NFR),NU,NV,NI,NJ,PIXN,IPRT)
 107	  PK(I)=IX(NINT(REALI(I)),NINT(REALJ(I)),NFR)-SKY(I)
	  SKYERR(I)=amin1(999.9,RI(ISE)/
     *             (AMAX1(.0001,ZSIG(I)*SQRT(AMAX1(0.,PIXN(ISE))))))
C  convert integrated and surface profile to magnitudes
	  DO 120 L=1,NAP
 	    IF (RI(L).GT.0.0000001) THEN
	      RMAG(L,I)=-2.5*ALOG10(RI(L))
	    ELSE 
	      RMAG(L,I)=99.
	    END IF
 120	  CONTINUE
C determine best integration magnitude
	  CALL IDSDET(NAP,RMAG(1,I),RI,PIXN,ZSIG(I),DER1X,DER2X,NSTOP)
C check that it is smaller than MAXIDS (dependent on neigbour distance)
	  IDS(I)=MAX0(1,MIN0(MAXIDS,NSTOP))
c
c  added June 1999: check log slope of last 4 points: if their
c   mean is >1.9, or if >1.7 and greater than the average of the
c    pts 2 and 3, then re-do photometry with adjusted sky
	  if (ids(i).gt.8.and.iskypar.eq.0) then
	    call chkslope(rmag(1,i),ids(i),dlograd,iskypar)
	    if (iskypar.eq.1) then
c  set sky aperture to 2/3 of current, and redo photometry with
c      sky=median instead of mode
	      iap2=iapmax+iapis*.6 
	      nnaptem=nap*2/3
	      skcmedtem=skcmed
	      skcmeantem=skcmean
	      skcmed=1.
	      skcmean=0.
	      CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	      CALL RCSKY(1,SKY(I),ZSIG(I),NNAPTEM,II,JJ,NI,NJ,
     *                 IX(1,1,NFR),NU,NV,SKARAY,50000,nsky,1,IPR)
C reset sky aperture
	      IAP2=IAPMAX+IAPIS+3
	      CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,0)
	      skcmed=skcmedtem
	      skcmean=skcmeantem
	      mh=mh+1
	      if (mh.lt.500) nhalo(mh)=i
	      goto 399
	    end if
	  end if
	  iskypar=0
C
C  output results
C
c	  WRITE(6,14) REALI(I),REALJ(I),RI(IDS(I)) 
 	  if (ircspipe.eq.0) WRITE(6,14) REALI(I),REALJ(I),RI(IDS(I)) 
     *      ,RMAG(IDS(I),I),SKYERR(I),PK(I)
 14	FORMAT(1X,'centroid:',2F7.2,'  cts:',F8.0,'  mag:',F8.3,
     *        '  S/N:',F7.1,'  Npk:',F7.1)
	  if (ircspipe.eq.0) then
	    WRITE(6,15) (RMAG(L,I), L=1,MIN0(10,NAP))
	    IF (NAP.GT.10) WRITE(6,16) (RMAG(L,I),L=11,NAP)
	  end if
 15	FORMAT(3X,'m(rad):',10F7.2)
 16	FORMAT(10X,10F7.2)
 101	CONTINUE
C
C   End of loop for photometry for each object
c
C  ...........................................
c   loop #1A
c  new section added Jan 1995 to limit IDS for objects in the
c   halos of bright objects
c    procedure: (1) see if object is within IDS of another object
c                    which is 2 mag or more brighter
c               (2) redefine mask and limit IDS of the object to
c                    mask radius +ideld.
c               (3) redo-classification if final IDS>2
	write(6,*) '  ..... checking for objects near bright objects'
	rmax1=irmax*.75
	rmax2=irmax*.5
	irmax1=nint(rmax1)
	irmaxsq1=nint(rmax1*rmax1)
	irmaxsq2=nint(rmax2*rmax2)
c  beginning of loop 1A
	do 1800 i=1,nob(nfr)
	  jj=ijoj(i,nfr)
	  ii=ijoi(i,nfr)
	  if (ii.le.0.or.ii.gt.ni.or.jj.le.0.or.jj.gt.nj) goto 1800
c  determine if there is any bright object near-by
	  kk=0
	  dist1=1000000.
c  going backward to determine beginning of search
	  do 1801 k=i-1,1,-1
	    jrt=jj-ijoj(k,nfr)
c  out of range, end search
 	    if (jrt.gt.irmax1) go to 1803
 1801	  continue
 1803	  kend=max0(1,k)
	  do 1804 k=kend,nob(nfr)
	    jrt=ijoj(k,nfr)-jj
	    if (jrt.gt.irmax1) go to 1805
            IRT=IABS(II-IJOI(K,nfr))
            IF (IRT.LE.IRMAX1) THEN
c else see if it is 2 mag brighter
	      if (rmag(ids(k),k).le.bgmag+0.5.and.
     *               rmag(ids(i),i)-rmag(ids(k),k).gt.2.0) then
c determine the exact distance
	        dist=irt*irt+jrt*jrt
                IF (dist.LE.float(IRMAXSQ1)) then
c  for fainter object, use more strigent criterion
                  if (rmag(ids(k),k).gt.bgmag.and.
     *              dist.gt.float(irmaxsq2)) go to 1804
c determine the closest objec
	          if (dist.lt.dist1) then
	            dist1=dist
	            kk=k
	          end if
	        end if
	      end if
	    end if
 1804	  continue
 1805	  if (kk.gt.0) then
c set new ids
	    iin=ijoi(kk,nfr)
	    jjn=ijoj(kk,nfr)
	    call mkline(iin,jjn,ii,jj,npt,250,xline,ni,
     *                   nj,ix(1,1,nfr),nu,nv)
c  check for minimum in xline. Since it is a bright object,
c    assume the minimum will not be the first point
	    iminrr=1
c take care of funny shape of saturated stars
	    if (ix(iin,jjn,nfr).gt.nint(adusat)) then
	      nstart=5
	    else
	      nstart=2
	    end if
	    xlmin=xline(nstart-1)
	    DO 1810 M=nstart,NPT-1
c smooth the current point
              xlts=.25*xline(m-1)+.5*xline(m)+.25*xline(m+1)
              xlt=xline(m)
              IF (XLT.LT.XLMIN) THEN
                XLMIN=XLT
                IMINRR=M
c	      else 
c if the point is going up relative to the last point, stop here
c	        go to 1812
              END IF
c if xline reach sky, stop there
              IF (XLTS.LT.SKY(i)) THEN
                XLMIN=XLINE(M)
                IMINRR=M
                GO TO 1812
              END IF
 1810       CONTINUE
c  distance from faint object to boundry
 1812	    ndist=npt-iminrr
c  compare with ids
	    idsdis=0.5*(iapmin+(ids(i)-1)*ideld)
	    iolddis=ids(i)
	    if (idsdis.gt.ndist) then
c change ids
	      ids(i)=min0(ids(i),
     *             nint((ndist*2.-iapmin+ideld*0.5)/ideld+1))
	      if (iolddis.gt.2) ids(i)=max0(ids(i),2)
	      ids(i)=max0(1,ids(i))
	      write(6,1833) i,ii,jj,kk,iin,jjn,ndist,iolddis,ids(i)
 1833	format(' #',i5,'@',2I5,' N#',i5,'@',2i5,'  d_max:',i3,
     *    ' old ids:',i3,'  new ids:',i3)
	    else if (ircspipe.eq.0) then
	      write(6,1834) i,ii,jj,kk,iin,jjn,ndist,ids(i)
 1834	format(' #',i5,'@',2I5,' N#',i5,'@',2i5,'  d_max:',i3,
     *    ' ids:',i3, ' NO change')
	    end if
	  end if
1800	continue
c end of loop 1A
c
c..............................................................
c   Star-Galaxy classification
C
C    create reference stars for the N X N sections
c
c.......
c  if npsfsec>=1, sectioned psf (npsfsec=1: equivalent to uniform
c                                psf over the whole field).
c   
 606	continue
	if (npsfsec.ge.1) then
	  dx=float(ni)/float(npsfsec)
	  dy=float(nj)/float(npsfsec)
	  delx=0.15*dx
	  dely=0.15*dy
	  naa=npsfsec/2+1
	  do 270 l=1,npsfsec
	    jy1=nint((l-1)*dy)
	    jy2=nint(l*dy)
	    do 270 m=1,npsfsec
	      ix1=nint((m-1)*dx)
	      ix2=nint(m*dx)
	      write(6,64) m,l,ix1,ix2,jy1,jy2
 64	format(/'  Reference stars for sector (',i1,',',i1,')'/
     *        '  Boundry: I:',2i5,' J:',2i5)
	      iparref=ipar
	      CALL REFSTAR(REFST(1,m,l),REFPK(m,l),IDSREF(m,l),SKYERR,
     *            NAP,RMAG,PK,IDS,SKY,IJOI(1,NFR),IJOJ(1,NFR),NOB(NFR),
     *         IREF(1,m,l),NREF(m,l),IPARREF,ADUSAT,IREFMIN,
     *           iexapf,ix1,ix2,jy1,jy2,npsfsec,nmax,*999)
	      IDSREF(m,l)=MIN0(IDSREF(m,l),IEXAP1)
C  determine FWHM
	      CALL SEEING1(SP(0,IREF(NREF(m,l),m,l)),IAPMIN,
     *             IDS(IREF(NREF(m,l),m,l)),IDELD,SEE(m,l))
	      WRITE(6,46) IREF(NREF(m,l),m,l),SEE(m,l)
 46	FORMAT('  Estimated FWHM from object',I5,':',F7.3,' pix')
	  write(6,*) ' REFSTAR',(refst(mm,m,l),mm=1,5)
 270	  continue
	  ipar=iparref
	else
c.........
c  variable psf, no grids, but from individual objects over the fields
c    the psfs are always read from a .ref file
c
	  naa=1
	  call inrefst(refstv,refpkv,idsrefv,psfpxv,psfpyv,skyerr,
     *        NAP,RMAG,PK,IDS,reali,realj,irefv,nrefv,nob(nfr),npsfsec
     *     ,ADUSAT,IREFMIN,nfmax,nmax,nsct(nfr),ipsfextend,iexap,*999)
c find the most central star and compute the estimated fwhm
	write(6,*) '  coming out of inrefst, # of ref ',nrefv
	  do 271 m=1,nrefv
	    distpsf(m)=(psfpxv(m)-0.5*ni)**2+(psfpyv(m)-0.5*nj)**2
 271	  continue
c sort them in order from the center
 	  call indexx(nrefv,distpsf,index)
	  CALL SEEING1(SP(0,IREFV(index(1))),IAPMIN,
     *             IDS(IREFV(index(1))),IDELD,SEE(1,1))
	  WRITE(6,46) IREFV(index(1)),SEE(1,1)
	end if
	DO 199 KK=1,3
	  CLSCT(KK)=CLSC(KK)
199	CONTINUE
c......................................................
C   Loop # 2
C    BIG LOOP FOR EACH OBJECT TO DETERMINE EXTRAPOLATED MAG,
C      SURFACE PROFILE AND PARAMETERS, AND TWO CLASSIFICATIONS
C
c   .................................................................
	ISDAPT=MIN0(2,MAX0(1,ISDAP))
	IBRIGHT=0
	write(6,*) '  Classification:'
c fixed psf
	if (npsfsec.gt.0) then
	  AA=REFST(IDSREF(naa,naa),naa,naa)+
     *       2.5*ALOG10(AMAX1(.0001,REFPK(naa,naa)))
	else
c variable psf
	  aa=0.
	  do 273 kk=1,nrefv
	    aa=aa+refstv(idsrefv(kk),kk)+
     *             2.5*alog10(amax1(.0001,refpkv(kk)))
 273	  continue
	  aa=aa/float(kk)
	  rmaxsq=rrefmax*rrefmax*ni*nj
	  delx=10.
	  dely=10.
	  write(6,*) ' max dist sq',rmaxsq
	end if
c compute average position of the grid of psfs
	if (npsfsec.ge.3) then
	  call 
     *     psfgridp(npsfsec,reali,realj,iref,nref,psfpx,psfpy)
	  rmaxsq=rrefmax*rrefmax*ni*nj
	  write(6,*) ' max dist sq',rmaxsq
	end if
c...................................................
c
c   begin of do loop2: determine extrapolation mag and 
c                         star-galaxy classification
	DO 200 I=1,NOB(NFR)
C
C	  CALL EXPFITP(SP(0,I),IDS(I),IAP1,SZ(I),RZ(I),RSQ(I))
C 	IF (IPO.NE.0) RETURN1
C
	  ii=ijoi(i,nfr)
	  jj=ijoj(i,nfr)
	  if (ii.le.0.or.ii.gt.ni.or.jj.le.0.or.jj.gt.nj) then
	    reali(i)=float(ii)
	    realj(i)=float(jj)
	    iclp(i)=0
	    icls(i)=0
	    ids(i)=0
	    exmag(i)=99.0
	    sumdel(i)=9.0
	    goto 200
	  end if
	  if (npsfsec.eq.1) then
c   fixed psf
C Determine first order extrapolated magnitude : up to aperture IEXAP
	    CALL MAGEXT(IDS(I),IDSREF(1,1),EXMAG(I),RMAG(IDS(I),I),
     *                  REFST(1,1,1))
C  classification
	    CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *        REFST(1,1,1),IDSREF(1,1),AA,SKY(I),ADUSAT*raduclas,
     *        ISDAPT,CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
	  else 
	    if (npsfsec.gt.1) then
c  gridded psf
c      determine sector of object
	      call refstcur(reali(i),realj(i),refst,idsref,psfpx,psfpy,
     *           refstt,idsreft,npsfsec,delx,dely,rmaxsq,iexapf)
	    else if (npsfsec.lt.1) then
c  variable psf
c  determine average refstar from 4*nvpsf nearest 
	      if (nvpsf.eq.1) then
	        call refstcurv1(reali(i),realj(i),refstv,idsref,psfpxv,
     *             psfpyv,nrefv,refstt,idsreft,delx,dely,rmaxsq,
     *             iexapf,nfmax)
	      else
	        call refstcurv(reali(i),realj(i),refstv,idsref,psfpxv,
     *             psfpyv,nrefv,refstt,idsreft,delx,dely,rmaxsq,
     *             iexapf,nvpsf,nfmax)
	      end if
	    end if
	    CALL MAGEXT(IDS(I),IDSREFT,EXMAG(I),RMAG(IDS(I),I),REFSTT)
	    CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *        REFSTT,IDSREFT,AA,SKY(I),ADUSAT*raduclas,
     *        ISDAPT,CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
	  end if
c  determine best reference curve to use
	  if (ircspipe.eq.0) WRITE(6,41) I,reali(i),realj(i),
     *         EXMAG(I),IDS(I),SUMDEL(I),ICLS(I)
 41	FORMAT(1X,'#',I5,'@',2f7.1,' mag:',F6.2,'  apert.:',I2,
     *        '  C2:',F7.3,'   Cl:',I2)
	  IF (EXMAG(I).LT.BGMAG.AND.ICLS(I).EQ.1) IBRIGHT=1
  200	CONTINUE
c..............big loop #3... only done for variable psf
c         ie npsfsec=-1
c  May 6, 97 : reclassify class 2 objects in a wedge where bright stars
c             are expected to stars
c
c  determine decision line equation
c    (1) point #1: y=cls(1) and x=mag of faintest class 4 object
c                   below cls(2) and greater than .5, if there are no 
c                   such object, the brightest star is used
c        point #2: y=cls(2)-0.03, x=mag of the faintest ref star, but less
c                     than 4 mag from x1
c           
	if (npsfsec.ne.-1) go to 160
c	  call brstcrit(nob(nfr),sumdel,exmag,icls,nrefv,irefv,clsct,
c    *                   slope,cc)
c search for bright end mag: x1
	xs1=-100
	do 210 i=1,nob(nfr)
	  if (icls(i).eq.4) then
	    if (sumdel(i).lt.clsct(2).and.sumdel(i).gt.-.5) then
	      if (exmag(i).gt.xs1) xs1=exmag(i)
	    end if
	  end if
 210	continue
c no saturated star, search for brigtest star
	if (xs1.lt.-17.) then
	  xs1=100
	  do 221 i=1,nob(nfr)
	    if (icls(i).eq.3) then
	      if (exmag(i).lt.xs1) xs1=exmag(i)
	    end if
 221	  continue
	end if
c search for faint end mag, x2
	xs2=-100
	do 212 i=1,nrefv
	  if (exmag(irefv(i)).gt.xs2) xs2=exmag(irefv(i))  
 212	continue
	xs2=amin1(xs2+.5,xs1+4)
c added July 20 1999, to allow the fainter magnitude to be set
c  by a parameter
c	write(6,*) 'xs2,sseqmag',xs2,sseqmag
	xs2=amax1(xs2,sseqmag)
c  equation:  slope
	slope=(clsct(2)-0.03-clsct(1)+.03)/(xs2-xs1)
c     intercept c=(x1y2-x2y1)/(x1-x2)
c	cc=(xs1*(clsct(2)-0.03)-xs2*(clsct(1)-.03))/(xs1-xs2)
 	cc=clsct(2)-0.03-slope*xs2
c loop for objects
	newc=0
	do 213 i=1,nob(nfr)
	  if (icls(i).eq.2) then
c  decision point
	    clcrit=exmag(i)*slope+cc
	    if (sumdel(i).gt.clcrit.and.exmag(i).lt.xs2) then
	      icls(i)=3
	      newc=newc+1
	    end if
	  end if
 213	continue
	write(6,*) '  ... ',newc,' class 2 obj reclassifed as 3'
	write(6,*) '  crit eqn: xs1,y1,xs2,y2,slope,c'
	write(6,*) xs1,clsct(1)-.03,xs2,clsct(2)-.03,slope,cc
C  
C
C  plotting options
C
 160	CONTINUE
c  for plotting, the reference star numbers are put into a
c        single temporaray array
c
c  added July 6 2001, do not plot when #of object>45000
c	if (nob(nfr).gt.40000) go to 777
	if (npsfsec.ge.1) then
	  nrefv=0
	  do 192 l=1,npsfsec
	    do 192 m=1,npsfsec
	      do 192 n=1,nref(m,l)
	        nrefv=nrefv+1
	        irefv(nrefv)=iref(n,m,l)
 192	  continue
	end if
	IF (IPAR.LT.1) THEN
	  if (ircspipe.eq.0) then
 603 	    WRITE(6,17) 
 17	FORMAT('  Do you want PLOT of classifier vs mag?'
     *            ,' y=dflt/n/p: ',$)
	    call readstr(1,ians2,*999,*603)
	  else
	    ians2='p'
	  end if
 	  IF (IANS2.EQ.'n') THEN
	    GO TO 604
	  ELSE
	    IF (IANS2.EQ.'p') THEN
	      DEV=HPLOT
	      CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOB(NFR),IREFV,nrefv,
     *                CLSCT,icls,FILOUT,DEV,nsct(nfr))
	    ELSE
	      DEV=SPLOT
	      CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOB(NFR),IREFV,nrefv,
     *                CLSCT,icls,FILOUT,DEV,nsct(nfr))
 604	      WRITE(6,19) 
 19	FORMAT('  Do you want to change ref. star (s) or '
     *        ,'class criteria (c)? (n(o)/s/c): ',$)
	      call readstr(1,ians2,*999,*604)
	      IF (IANS2.EQ.'c') THEN
 605	        WRITE(6,20) CLSCT(3),CLSCT(2),CLSCT(1)
 20	FORMAT('   C2 default values:',3F7.3,' for division of class'
     *         ,' 0,3,2,1'/'   Enter 3 (temporary) values: ',$)
	        CALL READR4(3,CLSCT(3),CLSCT(2),CLSCT(1),*999,*605,
     * 	               *20004,*20004)
C  re-classification
20004	        DO 159 I=1,NOB(NFR)
                  if (npsfsec.eq.1) then
C  classification
                    CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *                REFST(1,1,1),IDSREF(1,1),AA,SKY(I),
     *                ADUSAT*raduclas,ISDAPT,
     *                CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
                  else
c      determine sector of object
	            if (npsfsec.gt.1) then
                    call refstcur(reali(i),realj(i),refst,idsref,psfpx,
     *         psfpy,refstt,idsreft,npsfsec,.15*dx,.15*dy,rmaxsq,iexapf)
	            else
	              if (nvpsf.eq.1) then
	                call refstcurv1(reali(i),realj(i),refstv,idsref,
     *                   psfpxv,psfpyv,nrefv,refstt,idsreft,delx,
     *                   dely,rmaxsq,iexapf,nfmax)
	              else
	                call refstcurv(reali(i),realj(i),refstv,idsref,
     *                   psfpxv,psfpyv,nrefv,refstt,idsreft,delx,
     *                   dely,rmaxsq,iexapf,nvpsf,nfmax)
	              end if
	            end if
                    CALL CLASSIF(NAP,PK(I),RMAG(1,I),EXMAG(I),IDS(I),
     *                REFSTT,IDSREFT,AA,SKY(I),ADUSAT*raduclas,ISDAPT,
     *                CLPC,ICLP(I),DELMAG(I),CLSCT,ICLS(I),SUMDEL(I))
                  end if
 159	          WRITE(6,41) I,EXMAG(I),IDS(I),SUMDEL(I),ICLS(I)
	        GO TO 160
	      ELSE IF (IANS2.EQ.'s') THEN
 	        GO TO 606
	      ELSE IF (IANS2.NE.'n'.AND.IANS2.NE.' ') THEN
	        GO TO 604
	      END IF
	    END IF
	  END IF
	ELSE
	  DEV=HPLOT
	  CALL PGLTC2(EXMAG,SUMDEL,SKYERR,NOB(NFR),IREFV,nrefv,CLSCT,
     *                icls,FILOUT,DEV,nsct(nfr))
	END IF
c
c.........................................................
C  NEW section added Oct 1989 -- to search through the object list for
C    class 1 objects brighter than BGMAG, and re-do photometry with
C    enlarged aperture.
C
C  save old aperture data for out put
 777	continue
	iap2old=iap2
	iap11=iap1(1)
	iap1nap=iap1(nap)
	IF (IBRIGHT.EQ.0) GO TO 1601
	WRITE(6,*) '  .... Re-doing bright galaxies'
C  set up new apertures, maximum aperture is increased by factor of BGFAC
 211	IAPMAXB=IAPMAX*BGFAC
	IAPMAXB=IAPMAXB-MOD(IAPMAXB+1,2)
	IAP2=IAPMAXB+IAPIS+5
	IF (IAP2.GT.maxap) THEN
	  WRITE(6,*) '  **** Diameter too large, BGFAC decreased ',
     *              ' 20% ******'
	  BGFAC=(BGFAC-1.)*.8+1
	  GO TO 211
	END IF
C create sky aperture
	CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,IPRT)
C number of apertures
	IDELDB=(IAPMAXB-IAPMIN)/30+1
	NAPB=MIN0(30,(IAPMAXB-IAPMIN+IDELDB)/IDELDB)
	IEXAP1=MIN0(IEXAP,NAPB)
	WRITE(6,2111) NAPB,IAPMAXB,IDELDB
 2111	FORMAT(' Bright galaxy photometry parameters --'/'   # of apt:',
     *       I3,'  Max diam (pix):',I3,'  Delta D:',I2)
C
C   MAKE APERTURES
C
	DO 2100 I=1,NAPB
 2100	  IAP1(I)=IAPMIN+(I-1)*IDELDB
C  set inner sky aperture radius
	IAP1(31)=IAP1(NAPB)+5
	IF (IAP2-IAP1(NAPB).GT.8) THEN
	  NNAP=31
	ELSE
	  NNAP=NAPB
	END IF
	CALL APARAY(IAP1(NNAP),IT1(1,NNAP),IROW1(NNAP),QDUM,RDUM,PDUM
     *                 ,NA(NNAP),IPRT)
c  !Max radius
	IRMAX=IAP1(NAPB)            
	IRMAXSQ=IRMAX*IRMAX          
c  ! array size for neighbor mask
	MASKSIZE=MIN0(250,2*IAP1(NAPB)+1)     
C
C  do photometry for bright objects
C
	DO 2101 I=1,NOB(NFR)
c note: RAD(i) is used to store the largest diameter for BG
	  RAD(I)=0.0
	  IF (EXMAG(I).GT.BGMAG.OR.ICLS(I).NE.1) GO TO 2101
	  if (ids(i).lt.nap) goto 2101
c	  if (exmag(i).gt.bgmag-0.5.and.ids(i).lt.nap) goto 2101
c
c   check if it was a halo-check object
	  do 2102 nn=1,mh
	    if (nhalo(nn).eq.i) goto 2101
 2102	  continue
c  ! Maximum allowable final aperture
	  MAXIDS=30
	  II=IJOI(I,NFR)
	  JJ=IJOJ(I,NFR)
C  check for neighbours
	  CALL NNEIGH(NNEI(I),NNG,II,JJ,NOBB,IJOI(1,NFR),IJOJ(1,NFR),
     *          I,IRMAX,IRMAXSQ)
c	  if (ircspipe.eq.0) WRITE(6,12) I,NNEI(I)
 	  WRITE(6,12) I,NNEI(I)
C  determine sky
	  IF (ISKYSEC.EQ.0) THEN
	    CALL RCSKY(1,SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,NFR)
     *                    ,NU,NV,SKARAY,50000,nsky,iwt,IPR)
	  ELSE
	    CALL RING8SKY(SKY(I),ZSIG(I),NNAP,II,JJ,NI,NJ,IX(1,1,NFR)
     *                    ,NU,NV,SKARAY,50000,nsky,IPRT,IPR)
	  END IF
	  IF (IPR.NE.0) THEN
	    WRITE(6,*) ' ****  2nd round photometry not done *****'
	    GO TO 2101
	  END IF
C  set up mask
	  CALL MAKEMASK(500,MASKSIZE,NMASK,NNEI(I),NNG,
     *        IJOI(1,NFR),IJOJ(1,NFR),II,JJ,
     *       SKY(I),IRMAX,IX(1,1,NFR),NU,NV,NI,NJ,maxids,iapmin)
C  Do photometry  (use the same centroid as 1st round
	  CALL PPPHOT(RI,SP(0,I),REALI(I),REALJ(I),SKY(I),IRMAX,NMASK,
     *        NAPB,IAP1,IX(1,1,NFR),NU,NV,NI,NJ,PIXN,IPRT)
C  convert integrated and surface profile to magnitudes
	  DO 2120 L=1,NAPB
 	    IF (RI(L).GT.0.0000001) THEN
	      RMAGBR(L)=-2.5*ALOG10(RI(L))
	    ELSE 
	      RMAGBR(L)=99.
	    END IF
 2120	  CONTINUE
C determine best integration magnitude
	  CALL IDSDET(NAPB,RMAGBR,RI,PIXN,ZSIG(I),DER1X,DER2X,NSTOP)
C check that it is smaller than MAXIDS (dependent on neigbour distance)
	  IDST=MAX0(1,MIN0(MAXIDS,NSTOP))
C
C  output results
C
 	  WRITE(6,14) REALI(I),REALJ(I),RI(IDST),RMAGBR(IDST),
     *      SKYERR(I),PK(I)
	  if (ircspipe.eq.0) then
	    WRITE(6,15) (RMAGBR(L), L=1,MIN0(10,NAPB))
	    IF (NAPB.GT.10) WRITE(6,16) (RMAGBR(L),L=11,NAPB)
	   end if
C save the max mag which is the brighter of the previous and new results
	  IF (RMAGBR(IDST).LT.EXMAG(I)) THEN
C new photomtry is successful
	    EXMAG(I)=RMAGBR(IDST)
	    IDBR(I)=IDST
c ! used for storing largest diameter
	    RAD(I)=IAP1(IDST) 
	  END IF  
 2101	CONTINUE
C
C  end of re-computing mag of bright galaxies
C..................................................................
c  output .phm file
C
1601 	IF (FILOUT.EQ.'n') RETURN1
	KAP=MIN0(10,NAP)
C save results in disk
	call opennew(28,1,18,filout,*999)
	IF (COMMENT.EQ.'c') COMMENT=PCOMMENT(NFR)
c	CALL DATE(ADATE)
c	CALL TIME(ATIME)
C attach date and time to comment
	DO 300 JN=60,1,-1
 300	  IF (COMMENT(JN:JN).NE.' ') GO TO 301
 301	COMMENT=COMMENT(1:MIN0(32,JN+1))//fdate()//':ppph'
c
C Write 2 line header
c   only the central section ref stars are recorded in the first line.
c    the other refer stars are recorded in the next npfsecXnpfsec lines
c
	if (npsfsec.gt.0) then
	  istatus=encode(string1,float(max0(1,min0(7,nref(naa,naa)))),
     *              1,0,idum)
c the format statement make sure that C2 entries starts at the same place
c     for all cases
	  istatus=encode(string2,float(max0(1,4*(7-nref(naa,naa))+1)),
     *              1,0,idum)
	  fstr24='(1X,A60,1X,''REF *:'','
     *         //string1(1:lnblnk(string1))//
     *       'I4,'//string2(1:lnblnk(string2))//'X,'' C2'',3F6.3)'
c line 1 of header
	
	  WRITE(28,fstr24) COMMENT,(IREF(K,naa,naa),K=NREF(naa,naa),
     *               MAX0(NREF(naa,naa)-6,1),-1)
     *               ,CLSCT(3),CLSCT(2),CLSCT(1)
c 24	FORMAT(1X,A60,1X,'REF *:',<MAX0(1,MIN0(7,NREF))>I4,
c     *                  <MAX0(1,4*(7-NREF)+1)>X,' C2',3F6.3)
	else
c header out put for non-sectioned psf
c   reference stars are sorted from the distance from center
c
c  if there are reference stars greater than 9999, none are put
c   in first line
	  inoline1=0
	  do 350 kr=1,nrefv
	    if (irefv(kr).gt.9999) then
	      inoline1=1
	      goto 351
	    end if
 350	  continue
 351	  if (inoline1.eq.1) then
	    idum=-1
	    WRITE(28,2411) COMMENT,idum,idum,idum,idum,idum,idum
     *           ,idum,CLSCT(3),CLSCT(2),CLSCT(1)
	    irefbeg=1
2411	FORMAT(1X,A60,1X,'REF *:',7i4,'  C2',3F6.3)
	  else
	    istatus=encode(string1,float(max0(1,min0(7,nrefv))),
     *              1,0,idum)
	    istatus=encode(string2,float(max0(1,4*(7-nrefv)+1)),
     *              1,0,idum)
	    fstr24='(1X,A60,1X,''REF *:'','
     *	       //string1(1:lnblnk(string1))//
     *	     'I4,'//string2(1:lnblnk(string2))//'X,'' C2'',3F6.3)'
	    WRITE(28,fstr24) COMMENT,(IREFV(index(k)),K=1,
     *               min0(NREFV,7))
     *               ,CLSCT(3),CLSCT(2),CLSCT(1)
	    irefbeg=8
	  end if
	end if
c  line 2 of header
	WRITE(28,25) iap2old,iap11,iap1nap,ideld,
     *       NI,NJ,ISE,IEXAP1,SEE(naa,naa)
 25	FORMAT(1X,'SKY APERT:',I3,'  1ST APERT:',I3,'  LAST APERT:',I3
     *     ,i2,' SIZE:',2I5,3X,'ERR APER ',I2,3X,'EXTRP APER ',I2,
     *      3X,'FWHM:',F5.2,' PIX')
c record the other reference stars
	if (npsfsec.gt.1) then
	  do 308 l=1,npsfsec
	    do 308 m=1,npsfsec
	      write(28,24) m,l,see(m,l),(iref(k,m,l),k=1,nref(m,l))
 24	format(' Ref * sector(',i1,',',i1,'): fwhm',f6.2,
     *        ' pix ',10i5)
 308	  continue
	else if (npsfsec.lt.0) then
c  write the remaining stars
	  if (nrefv.gt.irefbeg-1) then
	    nprit=(nrefv-irefbeg+1)/10+1
	    do 324 j=1,nprit
	      write(28,72) (irefv(index(k)),k=irefbeg+(j-1)*10,
     *           min0(nrefv,9+irefbeg+(j-1)*10))
 324	    continue
	  end if
 72	format(' Ref * ',29x,10i5)
	end if
c added Feb 19 1999, write # lines for section and field info
c write section information
        write(28,8)  nsecpos(nfr),isecpos1(nfr),
     *      jsecpos1(nfr),isecpos2(nfr),jsecpos2(nfr),nedgepos(nfr)
 8      format('#secinfo',i2,10x,4I6,9x,i4)
c  determine world co-ordinate of defined area
        if (nsecpos(nfr).gt.0) then
	  call worldpos(nfr,nsecpos(nfr),ip1,jp1,ip2,jp2)
        else
          ip1=ilpos(nfr)
          jp1=jlpos(nfr)
          ip2=iupos(nfr)
          jp2=jupos(nfr)
        end if
        write(28,9) ilpos(nfr),jlpos(nfr),iupos(nfr),jupos(nfr)
     *             ,ip1,jp1,ip2,jp2
 9      format('#posinfo',4i6,5x,4i6)
	ANGT=0.0
        ELLT=0.0
	DO 302 I=1,NOB(NFR)
C  calculate sky err for adopted best aperture
	  TERR=amin1(999.9,10.**(-RMAG(IDS(I),I)/2.5)
     *        /(ZSIG(I)*SQRT(AMAX1(1.,PIXN(IDS(I))))))
c line 1 of data
c	  ioutnum=i-(i/10000)*10000
	  if (reali(i).gt.999.990.or.realj(i).gt.999.990.or.
     *        reali(i).lt.-99.994.or.realj(i).lt.-99.994) then
	    WRITE(28,261)i,REALI(I),REALJ(I),RMAG(IDS(I),I),
     *        EXMAG(I),TERR,SKYERR(I),PK(I),NNEI(I),ELLT,ANGT,SKY(I),
     *        amin1(999.99,ZSIG(I)),DELMAG(I),ICLP(I),SUMDEL(I),ICLS(I)
	  else
	    WRITE(28,26)i,REALI(I),REALJ(I),RMAG(IDS(I),I),
     *        EXMAG(I),TERR,SKYERR(I),PK(I),NNEI(I),ELLT,ANGT,SKY(I),
     *       amin1(999.99,ZSIG(I)),DELMAG(I),ICLP(I),SUMDEL(I),ICLS(I)
	  end if
	  istatus=encode(string1,float(kap),1,0,idum)
	  istatus=encode(string2,float(8*(10-kap)+3),1,0,idum)
	  if (icflag.eq.0) then
	    fstr27='(4X,2(I4,3X),I2,3X,'//string1(1:lnblnk(string1))//
     *      'F8.3,'//string2(1:lnblnk(string2))//'X,I2)'
	  else
	    fstr27='(4X,2(I4,3X),I2,3X,'//string1(1:lnblnk(string1))//
     *      'F8.4,'//string2(1:lnblnk(string2))//'X,I2)'
	  end if
c  2nd line of data
	  WRITE(28,fstr27) IJOI(I,NFR),IJOJ(I,NFR),IDOB(I,NFR)
     *	                   ,(RMAG(L,I), L=1,KAP),IDS(I)
c  3rd line of data  (RAD is used to store max aperture size for big galaxies)
	  if (icflag.eq.0) then
	  IF (RAD(I).GT.0.01) THEN
	    WRITE(28,2811) INT(RAD(I)),IDBR(I),(RMAG(L,I),L=11,NAP)
	  ELSE
	    WRITE(28,28) (RMAG(L,I),L=11,NAP)
	  END IF
	  else
	  IF (RAD(I).GT.0.01) THEN
	    WRITE(28,2281) INT(RAD(I)),IDBR(I),(RMAG(L,I),L=11,NAP)
	  ELSE
	    WRITE(28,228) (RMAG(L,I),L=11,NAP)
	  END IF
	  end if
 302	CONTINUE
 	CLOSE(UNIT=28)
c write out astrometry information if iwcs=1
	if (iwcs.eq.1.and.iastrom.ge.0) 
     *     call astromout(nfr,nob(nfr),reali,realj,filout,iastrom)
c
c 27	FORMAT(4X,2(I4,3X),I2,3X,<KAP>F8.3,<8*(10-KAP)+3>X,I2)
 28	FORMAT(23X,10F8.3)
 2811	FORMAT(9X,'*BG',I4,I4,3X,10F8.3)
 228	FORMAT(23X,10F8.4)
 2281 	FORMAT(9X,'*BG',I4,I4,3X,10F8.4)
c 3	FORMAT(1X,I3,1X,2(F6.2,1X),E10.4,F7.2,F7.1,F9.1,3F7.3,F9.3,
c    *      F8.3,1X,F6.2,I2,F6.2,I2)
 26	FORMAT(I5,2F7.2,2F7.2,F7.1,F7.1,F8.1,I7,F7.3,F7.1,F10.3,
     *      F8.3,1X,F6.2,I2,F6.2,I2)
 261	FORMAT(I5,2(F7.1),2F7.2,F7.1,F7.1,F8.1,I7,F7.3,F7.1,F10.3,
     *      F8.3,1X,F6.2,I2,F6.2,I2)
c  added to check transformation pixel map
c
c make file containing transformation gap info
c    assume mask in frame 2
	if (ipar.eq.2) then
c  remake apertures
	  DO 179 I=1,NAP
 179	    IAP1(I)=IAPMIN+(I-1)*IDELD
	    IAP1(31)=IAP1(NAP)+3
	  call savegappix(nfr,ix,nu,nv,kf,filout,reali,realj,
     *         ids,comment,nap,iap1)
        end if
 999	RETURN1
	END
c/////////////////////////////////////////////////////////////
c  subroutine for checking log slope
c............................................................
c  june 1999: check for growth curves of objects
c   affected by halo light of bright objects:
c     -signature to look for: growth curve growing near r^2
c
c        input: rmag= grow curve
c               dlograd= delta log radius (1= log(2nd aper)/(1st aper)
c    return: iskypar=1 if the slope indicates a bad object
c            iksypar=0 if okay
	subroutine chkslope(rmag,ids,dlograd,iskypar)
c	integer*2 ids
	integer ids
	dimension rmag(*),dlograd(*)
c  compute average of last 4 slope
	slope=0
	do 100 i=1,4
	  slope=slope-0.4*(rmag(ids-i+1)-rmag(ids-i))/dlograd(ids-i)
 100	continue
	slope=0.25*slope
	if (slope.gt.1.9) then
	  iskypar=1
	  write(6,1) slope
 1	format('  log slope > 1.9:',f7.3,', recompute sky ')
	else if (slope.gt.1.6) then
c compute slope from pt 2,3,4; and compare
	  slope1=0
	  do 101 i=2,3
	    slope1=slope1-0.4*(rmag(i+1)-rmag(i))/dlograd(i)
 101	continue
	  slope1=0.5*slope1
	  if (slope-slope1.gt.0.05) then
	    iskypar=1
	    write(6,2) slope,slope1
 2	format('  log slope increasing (',2f7.3,'), recompute sky ')
	  else
	    iskypar=0
	  end if
	else
	  iskypar=0
	end if
	return
	end	
c c
C
C//////////////////////////////////////////////////////////////////
C
C  Subroutine to determine the number of neighbour
C
	SUBROUTINE NNEIGH(NNEI,NNG,II,JJ,NOB,IJOI,IJOJ,I,IRMAX,IRMAXSQ)
	INTEGER NNEI,IJOI(*),IJOJ(*)
	integer NNG(*)
C  check for neighbours
	  NNEI=0
C  a) going backward
	  DO 102 K=I-1,1,-1
	    JRT=JJ-IJOJ(K)
	    IF (JRT.GT.IRMAX) GO TO 103
	    IRT=IABS(II-IJOI(K))
	    IF (IRT.LE.IRMAX) THEN
	      IF (IRT*IRT+JRT*JRT.LE.IRMAXSQ) THEN
	        NNEI=NNEI+1
	        if (nnei.gt.200) 
     *           write(6,*) ' +++ warning too many neighbors '
	        NNG(NNEI)=K
	      END IF
	    END IF
 102	  CONTINUE
C  b) going forward
 103 	  DO 104 K=I+1,NOB
	    JRT=IJOJ(K)-JJ
	    IF (JRT.GT.IRMAX) GO TO 105
	    IRT=IABS(II-IJOI(K))  
	    IF (IRT.LE.IRMAX) THEN
	      IF (IRT*IRT+JRT*JRT.LE.IRMAXSQ) THEN
	        NNEI=NNEI+1
	        if (nnei.gt.200) 
     *           write(6,*) ' +++ warning too many neighbors '
	        NNG(NNEI)=K
	      END IF
	    END IF
 104	  CONTINUE
 105	RETURN
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  subroutine to set up mask for crowded field photometry
c
c  Modified May 29, 1990 to decrease masked area
c           May 25, 1997, increase to 500X500
C
	SUBROUTINE MAKEMASK(NM,MASKSIZE,NMASK,NNEI,NNG,IJOI,IJOJ,II,JJ,
     *        SKY,IRMAX,IX,NU,NV,NII,NJJ,maxids,iapmin)
	INTEGER NMASK(NM,NM),IJOI(*),IJOJ(*),IX(NU,NV),NNEI
	DIMENSION XLINE(500),ITM(500),NNG(*)
	INCLUDE 'ppparm.inc'
 	  DO 108 K1=1,MASKSIZE
	    DO 108 K2=1,MASKSIZE
 108	      NMASK(K2,K1)=0
	IF (NNEI.EQ.0) RETURN
C  average flux inside central 9 pixels of object
	    SUMOBJ=0.
	    DO 109 MM=JJ-1,JJ+1
	      DO 109 NN=II-1,II+1
 109	        SUMOBJ=SUMOBJ+IX(NN,MM)
	    SUMOBJ=SUMOBJ/9.-SKY
C Do loop for each neigbour
	    DO 110 K=1,NNEI
	      IX1=IJOI(NNG(K))
	      IY1=IJOJ(NNG(K))
C determine cut from object to neigbour
	      CALL MKLINE(IX1,IY1,II,JJ,NPT,500,XLINE,NII,NJJ
     *             ,IX,NU,NV)
C seach for minimum,  IMINR is the radius of the circle to be blocked out
	      IMINRR=2
	      XLMIN=XLINE(1)
C smooth with a tapered boxcar of 3 pixel
	      XLT=.25*XLINE(1)+.5*XLINE(2)+.25*XLINE(3)
	      if (xlt.gt.xlmin) then
	        iminrr=1
	        go to 112
	      end if
	      DO 111 M=2,NPT-2
c ! reach sky
c	        IF (XLINE(M).LT.SKY) THEN 
	        IF (XLT.LT.SKY) THEN 
	          XLMIN=XLINE(M)
	          IMINRR=M
	          GO TO 112
	        END IF
	        xltn=.25*xline(m)+.5*xline(m+1)+.25*xline(m+2)
	        IF (XLT.LT.XLMIN) THEN
	          XLMIN=XLT
	          IMINRR=M
	        END IF
c  added May 29, 1990: check for derivative: if the next point is going
C           up, stop here
	          if (xltn.gt.xlt) then
	            iminrr=m
	            xlmin=xlt
	            go to 112
	          else
	            xlt=xltn
	          end if
 111	      CONTINUE
c  a min is not found 
	      if (xline(npt-1).ge.xline(npt)) iminrr=-1     
C mark circle mask on map
C determine co-ord on the mask map
 112	      INCEN=IX1-II+IRMAX+1
	      JNCEN=IY1-JJ+IRMAX+1
c adjust radius of mask
	      if (iminrr.lt.0) then
c for very faint object
	        iminr=npt-1
	        iminrr=iminr
	      else if (iminrr.le.2) then
C  very faint neigbour, do not add extra radius
	        iminr=iminrr
	      else
c  for normal case
	        IMINR=MIN0(NPT-IMROBJ,MAX0(2,IMINRR)+ICRADD)
	      end if
c  iminr is the radius of mask
	      CALL APARAY(2*IMINR,ITM,IROWM,DUM1,DUM2,DUM3,NDUM,0)
	      KK=0
	      DO 113 L=JNCEN-IROWM,JNCEN+IROWM
	        KK=KK+1
	        IF (L.GE.1.AND.L.LE.MASKSIZE) THEN
	          KAP=ITM(KK)/2
	          DO 114 M=MAX0(1,INCEN-KAP),MIN0(MASKSIZE,INCEN+KAP) 
 114	            NMASK(M,L)=NMASK(M,L)+1
	        END IF
 113	      CONTINUE
C if the neighbour is larger than the object, additional masking is made
C  by determining a dividing line orthogonal to the line joining the
C  two object, dividing point is where the surface brightness matches.
C
C  magnitude inside central 9 pixels of neigbour,
	      SUMNEIG=0.
	      DO 119 MM=IY1-1,IY1+1
	        DO 119 NN=IX1-1,IX1+1
 119	          SUMNEIG=SUMNEIG+IX(NN,MM)
	      SUMNEIG=SUMNEIG/9.-SKY
c	      IF ((IMINR.GE.NPT/3.and.sumneig/sumobj.gt.rmaxids)) THEN
c	      IF ((float(npt-IMINR).lt.irmax*.6.and.
	      IF ((float(npt-IMINR).lt.irmax.and.
     *                 sumneig/sumobj.gt.rmaxids).or.(npt.le.4.and.
     *                 sumneig.gt.0.8*sumobj)) THEN
	        CALL DLINES(FLOAT(JNCEN),FLOAT(INCEN),FLOAT(IRMAX+1),
     *                     FLOAT(IRMAX+1),FLOAT(IMINR),A1,B1,A2,B2)
	        IF (ABS(A2).GT.100.) THEN
C  for the case in which the dividing line is VERTICAL
	          IF (JNCEN.LT.IRMAX+1) THEN
	            DO 115 K1=1,min0(masksize,JNCEN+IMINRR)
	              DO 115 K2=1,MASKSIZE
 115	                NMASK(K2,K1)=NMASK(K2,K1)+1
	          ELSE
	            DO 116 K1=JNCEN+IMINRR,MASKSIZE
	              DO 116 K2=1,MASKSIZE
 116	                NMASK(K2,K1)=NMASK(K2,K1)+1
	          END IF
	        ELSE
C slope of dividing line less than 100
	          IF (FLOAT(INCEN).LT.A2*JNCEN+B2) THEN
C above
	            DO 117 K1=1,MASKSIZE
 	              DO 117 K2=1,MIN0(MASKSIZE,NINT(A2*K1+B2))
 117	                NMASK(K2,K1)=NMASK(K2,K1)+1
	          ELSE
C below
	            DO 118 K1=1,MASKSIZE
	              DO 118 K2=MAX0(1,NINT(A2*K1+B2)),MASKSIZE
 118	                NMASK(K2,K1)=NMASK(K2,K1)+1
	          END IF
 	        IF (IPRT.eq.1)
     *	            WRITE(6,*) ' slope 1 ',A1,B1,' SLOPE',A2,B2
C  In addition, if the central 3x3 pixels is brighter, a MAX IDS is set.
	          IF (SUMNEIG/SUMOBJ.GT.RMAXIDS) THEN
C set maximum radius in pixels
	            MITEMP=NPT-IMINRR+MIDSADD
	            maxrad=((maxids-1)*ideld+iapmin)/2
c	if (iprt.eq.1) write(6,*) ' maxrad ',maxrad,mitemp
	            IF (MITEMP.LT.MAXRAD) MAXRAD=MITEMP
	            MAXIDS=MIN0(maxids,((2*MAXRAD+1-IAPMIN)+ideld)/ideld)
	            maxids=max0(maxids,5)
	          END IF
	        END IF
	      END IF
C   change max allowable radius to aperture number
	      IF (IPRT.EQ.1) THEN
	        WRITE(6,13) NNG(K),IX1,IY1,NPT,IMINR,XLMIN,maxrad,
     *                MAXIDS
	      END IF
 13	FORMAT( '  Nghr#',I3,' at',2I5,' dis=',I3,' size:',I3,2X,F8.1,
     *             ' maxIDS:',I3,i5)
C              write(6,*)'  exit to see map'
C	READ(5,3999,END=999,ERR=999) IAAA 
C3999	FORMAT(I1)
C
 110	    CONTINUE
	RETURN
	END
C
C///////////////////////////////////////////////////////////////////////
C
C  Same as MAKEMASK, but creates only an outout file of mask radius
c
C
	SUBROUTINE MAKEMASK2(NNEI,NNG,IJOI,IJOJ,II,JJ,
     *        SKY,IRMAX,IX,NU,NV,NII,NJJ,iminr)
	INTEGER NNG(*),IJOI(*),IJOJ(*),IX(NU,NV),NNEI
	DIMENSION XLINE(500),iminr(*)
	INCLUDE 'ppparm.inc'
	IF (NNEI.EQ.0) RETURN
C  average flux inside central 9 pixels of object
	    SUMOBJ=0.
	    DO 109 MM=JJ-1,JJ+1
	      DO 109 NN=II-1,II+1
 109	        SUMOBJ=SUMOBJ+IX(NN,MM)
	    SUMOBJ=SUMOBJ/9.-SKY
C Do loop for each neigbour
	    DO 110 K=1,NNEI
	      IX1=IJOI(NNG(K))
	      IY1=IJOJ(NNG(K))
C determine cut from object to neigbour
	      CALL MKLINE(IX1,IY1,II,JJ,NPT,500,XLINE,NII,NJJ
     *             ,IX,NU,NV)
C seach for minimum,  IMINR is the radius of the circle to be blocked out
	      IMINRR=2
	      XLMIN=XLINE(1)
C smooth with a tapered boxcar of 3 pixel
	      XLT=.25*XLINE(1)+.5*XLINE(2)+.25*XLINE(3)
	      if (xlt.gt.xlmin) then
	        iminrr=1
	        go to 112
	      end if
	      DO 111 M=2,NPT-2
c ! reach sky
c	        IF (XLINE(M).LT.SKY) THEN 
	        IF (XLT.LT.SKY) THEN 
	          XLMIN=XLINE(M)
	          IMINRR=M
	          GO TO 112
	        END IF
	        xltn=.25*xline(m)+.5*xline(m+1)+.25*xline(m+2)
	        IF (XLT.LT.XLMIN) THEN
	          XLMIN=XLT
	          IMINRR=M
	        END IF
c  added May 29, 1990: check for derivative: if the next point is going
C           up, stop here
	          if (xltn.gt.xlt) then
	            iminrr=m
	            xlmin=xlt
	            go to 112
	          else
	            xlt=xltn
	          end if
 111	      CONTINUE
c  a min is not found 
	      if (xline(npt-1).ge.xline(npt)) iminrr=-1     
C mark circle mask on map
C determine co-ord on the mask map
 112	      INCEN=IX1-II+IRMAX+1
	      JNCEN=IY1-JJ+IRMAX+1
c adjust radius of mask
	      if (iminrr.lt.0) then
c for very faint object
	        iminr(k)=npt-1
	        iminrr=iminr(k)
	      else if (iminrr.le.2) then
C  very faint neigbour, do not add extra radius
	        iminr(k)=iminrr
	      else
c  for normal case
	        IMINR(k)=MIN0(NPT-IMROBJ,MAX0(2,IMINRR)+ICRADD)
	      end if
C
 110	    CONTINUE
	RETURN
	END

C
C////////////////////////////////////////////////////////////////////
C
C  Subroutine to estimate FWHM for a star
C      SP is differential profile in linear scale
	SUBROUTINE SEEING1(SP,IAPMIN,IDS,IDELD,SEE)
	INTEGER IDS
	DIMENSION SP(0:30)
C  first extrapolate peak brightness (at rad=0)
	REALPK=SP(0)+.25*(SP(0)-SP(1)/(0.5*(IAPMIN-1)-.25))
	HALF=.5*REALPK
	WRITE(6,*) HALF,SP(0),SP(1)
	DO 121 K=1,IDS
	  IF (SP(K).LT.HALF) GO TO 122
 121	CONTINUE
 122	IF (K.GT.1) THEN
C  seeing in aperture number
	  SEE=(K-1)+(SP(K-1)-HALF)/(SP(K-1)-SP(K))
C  seeing in pixel value
	  SEE=IAPMIN-1.+(SEE-1.)*IDELD
	ELSE
	  SEE=HALF/(REALPK-SP(1))
	  SEE=SEE*(IAPMIN-1.)
	END IF
	RETURN
	END
C
C////////////////////////////////////////////////////////////////
C
C  Subroutine for classification
c   modified may 6 1997: class 2 objects at bright end are now
c                        classified as stars
C
	SUBROUTINE CLASSIF(NAP,PK,RMAG,EXMAG,IDS,REFST,IDSREF,AA,SKY,
     *                ADUSAT,ISDAP,CLPC,ICLP,DELMAG,CLSC,ICLS,SUMDEL)
	DIMENSION RMAG(30),CLPC(3),CLSC(3),REFST(30)
c	INTEGER*2 IDS,ICLP,ICLS
	INTEGER IDS,ICLP,ICLS
C Calculate distribution of delta mag from reference line
C
	  DELMAG=99.
	  IF (PK.LT.0.00001.OR.RMAG(IDS).EQ.99.) THEN
	    DELMAG=99.
	  ELSE
	    DELMAG=(AA-2.5*ALOG10(AMAX1(1.,PK)))-EXMAG
	  END IF
	  IF (RMAG(IDS).EQ.99.) THEN
	    ICLP=0
	  ELSE
	    IF (DELMAG.GE.CLPC(1)) THEN
c ! .3 default
	      ICLP=1  
	    ELSE IF (DELMAG.LT.CLPC(3)) THEN
c ! -.35 default
	      ICLP=0  
	    ELSE IF (DELMAG.LT.CLPC(2)) THEN
c ! .2 default
	      ICLP=3  
	    ELSE
c !
	      ICLP=2    
	    END IF
	  END IF
C
C classify objects by COMPARING WITH PROFILES OF BRIGHT STAR
C
	  IF (IDS.LE.2) THEN
	    SUMDEL=99.
	    ICLS=0
	  ELSE
C	    IDDS=MIN0(IDS,IDSREF)
C	    DEL=RMAG(1)-REFST(1)
C  use 1/2 more for zero point if there is sufficient # of aperture
C	    IF (NAP.GE.10) DEL=.5*(DEL+RMAG(2)-REFST(2))
C	    SUMDEL=(1-IDDS)*DEL
C	    DO 203 J=2,IDDS
C	      SUMDEL=SUMDEL+(RMAG(J)-REFST(J))
C203	    CONTINUE
C	    SUMDEL=SUMDEL/(FLOAT(IDDS-1))
C  change made May 21 11pm 1989
	    IDDS=MIN0(IDS,IDSREF)
	    DEL=RMAG(1)-REFST(1)
C	    IF (ISDAP.GT.1) DEL=.5*(DEL+RMAG(2)-REFST(2))
	    IF (ISDAP.GT.1) DEL=.66667*DEL+.33333*(RMAG(2)-REFST(2))
c !  this is the constant zero pt
	    SUMDEL=(ISDAP-IDDS)*DEL 
C             scaled by the number of apts used in computing sumdel
	    DO 203 J=ISDAP+1,IDDS
	      SUMDEL=SUMDEL+(RMAG(J)-REFST(J))
203	    CONTINUE
	    SUMDEL=SUMDEL/(FLOAT(IDDS-ISDAP))
c !  saturated object
	    IF ((PK+SKY).GT.ADUSAT) THEN
	      ICLS=4
	    ELSE
	      IF (SUMDEL.LE.CLSC(1)) THEN
c  ! -.175 default, galaxies
	        ICLS=1                  
	      ELSE IF (SUMDEL.GT.CLSC(3)) THEN
c !  noise
	        ICLS=0                   
	      ELSE IF (SUMDEL.GT.CLSC(2)) THEN
c  ! greater than -.075 default, stars
	        ICLS=3                  
	      ELSE 
c ! gt -.175 default, and lt -.075
	        ICLS=2  
	      END IF
	      IF (IDS.LE.3.AND.ICLS.EQ.1) ICLS=2
	    END IF
	  END IF
	RETURN
	END
C////////////////////////////////////////////////////////////////////
C
C  calculate exponential fit to profile, starting from apt 3 to NSTOP
C
	SUBROUTINE EXPFITP(SP,IDS,IAP1,SZ,RZ,RSQ)
	INTEGER IDS
	DIMENSION SP(0:30),IAP1(30),XP(30),YP(30)
C      , limited to points within 8 magnitudes of central brightness
	  ME=0
	  XS=SP(1)+8.
	  DO 202 M=3,IDS
C  this IF statement also takes care of non-data points
	    IF (SP(M).GT.XS) GO TO 202
	    ME=ME+1
	    XP(ME)=.25*(IAP1(M-1)+IAP1(M))
	    YP(ME)=SP(M)
 202	  CONTINUE
	  IF (ME.GT.3) THEN
	    CALL LSQF(ME,XP,YP,SZ,RZ,RSQ)
	    IF (RZ.NE.0.) RZ=1.08574/RZ
	  ELSE
	    SZ=0.
	    RZ=0.
	  END IF
	RETURN
	END
C
C//////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR PARTIAL PIXEL APERTURE PHOTOMETRY WITH CROWDED-FIELD 
C   CORRECTION BY MASKING NEIGHBOURING OBJECTS
C
C
	SUBROUTINE PPPHOT(RI,SP,REALI,REALJ,SKY,MSH,NMASK,NAP,IRARR,
     *                    IX,NU,NV,NI,NJ,PIXN,IW)
	DIMENSION RI(30),SP(0:30),PPRAY(10,10),IX0(3,3),PIXN(30)
     *            ,IRARR(31)
	INTEGER NMASK(500,500),IX(NU,NV)
	INCLUDE 'ppparm.inc'
c ! radius for full interpolation
	NR3=NINT(FLOAT(IRARR(NAP)+1)/3.) 
	ICUT=3
	CUT=ICUT*2.+1.
	NAR=CUT
	CUTSQ=CUT*CUT
	IJTI=NINT(REALI)
	IJTJ=NINT(REALJ)
	IM=1-IJTI+MSH
	JM=1-IJTJ+MSH
	PIXIN1=0.
	PIXOUT1=0.
	PIXIN2=0.
	PIXOUT2=0.
	SP(0)=0.
	SUMIT=0.
	if (iprt.eq.1) then
	  do 400 m=msh-10,msh+12
 400	    write(6,450) (nmask(m,l),l=msh+12,msh-10,-1)
	end if
 450	format(1x,23I2)
	DO 100 I=1,NAP
C  SQR is the radius, then radius squared
	  SUMI=0.
	  IRC=(IRARR(I)+1)/2
	  SQR=.5*IRARR(I)
	  SQRL=(SQR-0.7071068)**2
	  SQRU=(SQR+0.7071068)**2
	  SQR=SQR*SQR
	  DO 107 M=IJTJ-IRC,IJTJ+IRC
	    RRJ=(REALJ-M)*(REALJ-M)
	    DO 101 L=IJTI-IRC,IJTI+IRC
C condition for partial pixel is if sqrt(RR)-radius is +/-0.707 from radius
	      RRT=(REALI-L)*(REALI-L)+RRJ
	      IF (RRT.LE.SQRL) THEN
C  pixel is in completely  
	        FWT=1.
	        PIXWT=1.
	      ELSE IF (RRT.GE.SQRU) THEN
C  pixel is completely out
	        GO TO 101
	      ELSE  
C case for partial pixel
C	        
C  cut pixel into CUT X CUT and compute the number of sector within circle
	        WTT=0.
	        IF (IRARR(I).LE.NR3) THEN
C  Bilinear Interpolation of pixel in to NARxNAR
	          FWT=0.
	          DO 130 MM=1,3
	            MM1=IJTJ+MM-2
                    DO 130 LL=1,3
 130		      IX0(LL,MM)=IX(IJTI+LL-2,MM1)
	          CALL DIVPIX(NAR,IX0,PPRAY)
	          DO 102 LJ=-ICUT,ICUT
	            TEMJ=M+FLOAT(LJ)/CUT
	            TTJ=(REALJ-TEMJ)*(REALJ-TEMJ)
	            DO 102 LI=-ICUT,ICUT
	              TEMI=L+FLOAT(LI)/CUT
	              TTR=(REALI-TEMI)*(REALI-TEMI)+TTJ
c ! cut is in
	              IF (TTR.LE.SQR) THEN 
c  ! 1/cutsq 's worth of flux
	                WTT=WTT+1.          
c  FWT is normalized to 1=total of pixel
	                FWT=FWT+PPRAY(LI+ICUT+1,LJ+ICUT+1)
	              END IF
 102	          CONTINUE
	        ELSE
	          DO 103 LJ=-ICUT,ICUT
	            TEMJ=M+FLOAT(LJ)/CUT
	            TTJ=(REALJ-TEMJ)*(REALJ-TEMJ)
	            DO 103 LI=-ICUT,ICUT
	              TEMI=L+FLOAT(LI)/CUT
	              TTR=(REALI-TEMI)*(REALI-TEMI)+TTJ
c ! cut is in
	              IF (TTR.LE.SQR) THEN 
c  ! 1/cutsq 's worth of flux
	                WTT=WTT+1.          
	              END IF
 103	          CONTINUE
c  normalize flux weight 
	          FWT=WTT/CUTSQ
	        END IF
c normalize pixel wt
	        PIXWT=WTT/CUTSQ
c	if (iprt.eq.1) write(6,455) i,l,m,pixwt,fwt,nmask(im+l,jm+m)
 455	format(1x,i2,'  I,J',2I6,2x,' pwt,fwt ',2F7.3,'  mask ',i2)
	      END IF
C  determine if the partial pixel is in or out on MASK
c ! in
	      IF (NMASK(IM+L,JM+M).EQ.0.AND.L.GE.1.AND.L.LE.NI.AND.
     *            M.GE.1.AND.M.LE.NJ) THEN  
	        PIXIN2=PIXIN2+PIXWT
	        SUMI=SUMI+FWT*IX(L,M)-pixwt*SKY
c	        SUMI=SUMI+FWT*(IX(L,M)-SKY)
c  ! out
	      ELSE               
	        PIXOUT2=PIXOUT2+PIXWT
	      END IF
 101	    CONTINUE
 107	  continue
C determine normalized flux in ring I
	  PIXN(I)=PIXIN2+PIXOUT2
	  IF (PIXIN2.GT.PIXIN1) THEN
	    SP(I)=(SUMI-SUMIT)*(PIXN(I)-(PIXIN1+PIXOUT1))
     *              /(PIXIN2-PIXIN1)
	  ELSE
	    SP(I)=0.
	  END IF
	  IF (IW.EQ.1) WRITE(6,777) I,SP(I),PIXIN2-PIXIN1,
     *              PIXOUT2-PIXOUT1
	  PIXIN1=PIXIN2
	  PIXOUT1=PIXOUT2
	  PIXIN2=0.
	  PIXOUT2=0.
	  SUMIT=SUMI
 100	CONTINUE
C  Calculate growth curve
	RI(1)=SP(1)
	DO 273 I=2,NAP
 273	  RI(I)=RI(I-1)+SP(I)
	SP(0)=(IX(IJTI,IJTJ)-SKY)
	SP(1)=(SP(1)-SP(0))/(PIXN(1)-1.)
	DO 274 I=2,NAP
 274 	  SP(I)=SP(I)/(PIXN(I)-PIXN(I-1))
 777	FORMAT(' ring#',I3,F15.2,'    pix in:',F7.2,'   pix out:',F6.1)
	RETURN
	END
C///////////////////////////////////////////////////////////////////
C
C    DERIVE THE MOST LIKELY MAGNITUDE FROM CURVE OF GROWTH
C      USING INFOMATION FROM DERIVATIVES
C            RMAG = array of growth curve
C            NA   = array of number of pixels in apertures
C            RI   = array of counts in aperture
C            NSTOP = Max acceptable aperture index
C
	SUBROUTINE IDSDET(NAP,RMAG,RI,PIXN,ZSIG,DER1X,DER2X,NSTOP)
	DIMENSION RMAG(30),RI(30),DER1(40),DER2(40),PIXN(30)
	include 'pipeparm.inc'
c	CALL DERIV(RMAG,DER1,DER2,1.,NAP)
C 
C  DER1 is the smoothed derivative, DER2 is the delta mag between successive 
C              aperture
	CALL DERIV1(RMAG,DER1,DER2,1.,NAP)
C  first check for first aperture with negative counts
	NST2=-1
	NST3=-1
	DO 901 K=1,NAP
 901	  IF (RMAG(K).EQ.99.) GO TO 902
 902	NSTOP=K-1
	NST1=NSTOP
	IF (NSTOP.LT.3) GO TO 908
C  2: check for unreasonably large decrease in flux in the next aperture
	DO 903 K=3,NSTOP
C  Calculate sigma of sky (fluctuation expected solely from larger aperture
	SIGI=3.*ALOG10(1.+ZSIG*SQRT(AMAX1(1.,PIXN(K)-PIXN(K-1)))/
     *         RI(K-1))
 903	IF ((RMAG(K)-RMAG(K-1)).GT.SIGI.OR. 
     *        (RMAG(K)-RMAG(K-2)).GT.SIGI) GO TO 904
 904	NS=K-1
C    take brightest nearby  value
	DO 9041 K=NS,MAX0(2,NS-2),-1
	  IF (RMAG(K-1).LE.RMAG(K)) NSTOP=K-1
 9041	CONTINUE
	NST2=NSTOP
	IF (NSTOP.LE.3) GO TO 200
C 3:  Check 2nd derivative for sharp increase
C	DO 905 K=4,NSTOP
C 905	  IF (DER2(K).LT.DER2CRI) GO TO 906
C 906	NSTOP=K-1
C	NST3=NSTOP
C NEW 3: Check for increase between each aperture
	DO 905 K=2,NSTOP-1
C   statement below is pre Mar 22 89 criterior
C	  IF (DER2(K-1).LE.DER2(K)) THEN
C new one
	  IF ((DER2(K)-DER2(K-1)).GT.SIGI*DER2X) THEN
c! if the previous aperture is negative growth, it is okay.
	    IF (DER2(K-1).GT.0.01) THEN   
	      NSTOP=K
	      GO TO 906
	    END IF
	  END IF
 905	CONTINUE
 906	NST3=NSTOP
C 4: check first derivative
 200	IF (NSTOP.LE.2) GO TO 908
C first check if any there is any 2 consecutive increasing delta m
C  ** this is added 6PM apr 8 1989
	DO 909 K=2,NSTOP-2
	  IF (DER2(K-1).LT.-0.0001) GO TO 909
	  IF (DER2(K).GT.DER2(K-1).AND.DER2(K+1).GT.DER2(K-1)) THEN
C  unless the increase is smaller than .01mag in which case check the next
C      delta m also.  Very small increases are attributed to noise
	    IF (DER2(K).LT.0.01.AND.DER2(K+1).LT.0.01) THEN
C	      IF (DER2(K-1).GT.DER2(K+2).OR.DER2(K+2).LT.0.001) 
C    *             GO TO 909
	      GO TO 909
	    END IF
	    NSTOP=K
	    GO TO 910
	  END IF
 909	CONTINUE
 910	CONTINUE
	DSMAL=ABS(DER1(1))
	DO 907 K=2,MIN0(NAP-1,NSTOP)
	  IF (K.GE.4) THEN
	    RAT=DER1X
	  ELSE
	    RAT=2.*DER1X
	  END IF
	  SIGDER=RAT*ALOG10(1.+ZSIG*SQRT(AMAX1(1.,PIXN(K+1)-PIXN(K-1)))
     *                     /RI(K))
	  IF (ABS(DER1(K))-DSMAL.GE.SIGDER) THEN
	    NSTOP=K-1
	    GO TO 908
	  END IF
	  IF (ABS(DER1(K)).LE.DSMAL) DSMAL=ABS(DER1(K))
 907	CONTINUE
 908	CONTINUE
	if (ircspipe.ne.1)
     *	    WRITE(6,10) NST1,NST2,NST3,NSTOP
10	FORMAT('  ....NSTOP:   [1].',I3,'  [2].',I3,'  [3].',I3,
     *            '  [4].',I3)
 900	RETURN
	END

C////////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR FIRST DERIVATIVES
C
	SUBROUTINE DERIV1(Y,DER1,DEVI,DX,NOP)
	DIMENSION Y(*),DER1(*),DEVI(*)
	DH=.5/DX
	DD=1./(DX*DX)
	DER1(1)=(-3.*Y(1)+4.*Y(2)-Y(3))/DX
	DEVI(1)=Y(1)-Y(2)
	DO 100 I=2,NOP-1
	  DER1(I)=(Y(I+1)-Y(I-1))*DH
 100	DEVI(I)=Y(I)-Y(I+1)
	DER1(NOP)=(Y(NOP-2)-4.*Y(NOP-1)+3.*Y(NOP))*DH
	DEVI(NOP)=0.
	RETURN
	END
c///////////////////////////////////////////////////////////
c  subroutine to compute average position of psf in grid
	subroutine psfgridp(npsfsec,reali,realj,iref,nref,psfx,psfy)
	dimension reali(*),realj(*),iref(10,5,5),nref(5,5),psfx(5,5)
     *           ,psfy(5,5)
	do 100 j=1,npsfsec
	  do 100 i=1,npsfsec
	    if (nref(i,j).gt.1) then
	      psfx(i,j)=0.
	      psfy(i,j)=0.
	      do 101 k=1,nref(i,j)
	        psfx(i,j)=psfx(i,j)+reali(iref(k,i,j))
	        psfy(i,j)=psfy(i,j)+realj(iref(k,i,j))
 101	      continue
	      psfx(i,j)=psfx(i,j)/float(nref(i,j))
	      psfy(i,j)=psfy(i,j)/float(nref(i,j))
	    else if (nref(i,j).eq.1) then
	      psfx(i,j)=reali(iref(1,i,j))
	      psfy(i,j)=realj(iref(1,i,j))
	    else
	      psfx(i,j)=-100000.
	      psfy(i,j)=-100000.
	    end if
 100	continue
	do 1000 i=1,3
	  write(6,10) (psfx(j,i),psfy(j,i), j=1,3)
 10	format(6f7.2)
 1000	continue
	return
	end
c////////////////////////////////////////////////////////////////////
c  subroutine to compute interpolated psf curve from a grid of PSFs
c   if the object is within  delx and  dely of the average position
c     of a grid, the refstar is taken as is, otherwise, the average
c     of the closest refstars in each quadrant from the object
c      weighted by distance is taken.
c  
C
	subroutine refstcur(reali,realj,refst,idsref,psfpx,psfpy,
     *        refstt,idsreft,npsfsec,delx,dely,distmaxsq,iexp)
	dimension refst(30,5,5),idsref(5,5),psfpx(5,5),psfpy(5,5)
     *        ,refstt(30),t(4),m(4),l(4) ,idsm(4),index(4)
c	write(6,*) ' in 1',reali,realj
	do 100 j=1,npsfsec
	  do 100 i=1,npsfsec
	    if (abs(reali-psfpx(i,j)).le.delx.and.
     *          abs(realj-psfpy(i,j)).le.dely) then
	      idsreft=idsref(i,j)
	write(6,*) ' restcur',(refst(k,i,j),k=1,3)
	      do 101 k=1,idsreft
	        refstt(k)=refst(k,i,j)
 101	      continue
	write(6,*) ' single  sector ',i,j,idsreft
	      return
	    end if
 100	continue
c  intepolation to be done
c    first determine the nearest grid point in each quadrant
	do 105 i=1,4
	  idsm(i)=0
	  t(i)=10000000.
 105	continue
	kk=1
	do 110 j=1,npsfsec
	  do 110 i=1,npsfsec
	    if (psfpx(i,j).lt.0) go to 110
	    dist=(reali-psfpx(i,j))**2.+(realj-psfpy(i,j))**2.
	    if (dist.gt.distmaxsq) go to 110
	    if (psfpx(i,j).le.reali.and.psfpy(i,j).le.realj) then
c  (1) upper right (smaller i and j)
	      kk=1
	    else if (psfpx(i,j).ge.reali.and.psfpy(i,j).le.realj) then
c  (2) upper right (larger i, smaller j)
	      kk=2
	    else if (psfpx(i,j).le.reali.and.psfpy(i,j).ge.realj) then
c  (3) upper left  (smaller i, larger j)
	      kk=3
	    else if (psfpx(i,j).ge.reali.and.psfpy(i,j).ge.realj) then
c  (4) lower left  (larger i and j)
	      kk=4
	    end if
	    if (dist.lt.t(kk)) then 
	      t(kk)=dist
	      l(kk)=i
	      m(kk)=j
	      idsm(kk)=idsref(i,j)
	    end if
 110	continue
c average the curve, first sort idsm -- the ones with idsm=0 are discarded
	call nindexx(4,idsm,index)
	if (idsm(index(4)).eq.0) then
	  write(6,*) '  +++ error in interpolating psf +++'
	  return
	end if
c  choose the one with the largest ids, and normalize to that one
	write(6,*) '  interpolated from sector (@ dis):',l(index(4)),
     *      m(index(4)),sqrt(t(index(4))),idsm(index(4))
	idsreft=idsm(index(4))
c normalize to the largest common aperture
	do 119 k=3,1,-1
	  if (idsm(index(k)).eq.0) go to 120
 119	continue
 120	if (k.eq.3) then
c  only one reference, just copy it over and return
	  do 131 i=1,idsreft
	    refstt(i)=refst(i,l(index(4)),m(index(4)))
 131	  continue
	  write(6,*)' refstt ',(refstt(i),i=1,5),refstt(idsreft)
	  return
	else
c  more than one, average using the one with largest ids first
c         imin= index of the one with smallest ids
	  imin=index(k+1)
c copy the initial reference, in flux
	  do 114 i=1,idsm(index(4))
	    refstt(i)=10.**(-.4*refst(i,l(index(4)),m(index(4))))
 114	  continue
c flux normalization fiducial (the flux at imin of the first object
	  rnorm=0.5*(refst(idsm(imin),l(index(4)),m(index(4)))+
     *        refst(idsm(imin)-1,l(index(4)),m(index(4))))
c add the others, normalized to same flux, and scaled by inverse distances
	  do 115 i=3,k+1,-1
	    ii=index(i)
            fluxrat=0.5*(refst(idsm(imin),l(ii),m(ii))+
     *        refst(idsm(imin)-1,l(ii),m(ii)))-rnorm
            rat=sqrt(t(index(4))/t(ii))
        write(6,*) '  + (sector,ratio,idsmin)       : ',l(ii),m(ii),
     *              rat,idsm(ii)
            do 116 j=1,idsm(ii)
              refstt(j)=refstt(j)+rat*10.**
     *               (-.4*(refst(j,l(ii),m(ii))-fluxrat))
 116        continue
c add proper flux to remaining points
	    do 117 j=idsm(ii)+1,idsm(index(4))
	      refstt(j)=refstt(j)+rat*10.**
     *               (-0.4*(refst(j,l(index(4)),m(index(4)))))
 117	    continue
 115      continue
c change back to mag
	  do 118 i=1,idsm(index(4))
	    refstt(i)=-2.5*alog10(amax1(.0000001,refstt(i)))
 118	  continue
	  write(6,*)' refstt ',(refstt(i),i=1,5),refstt(idsm(index(4)))
	end if
	return
	end
c////////////////////////////////////////////////////////////////////
c  subroutine to compute interpolated psf curve from a set of PSFs
c   uses the closest refstars in each quadrant from the object
c      weighted by distance is taken.
c  
c  new version Jun 1999, allowing
c    nvpsf= 1, 2 or 3, 4 the number of stars in each quadrant to be used
c
C
	subroutine refstcurv(reali,realj,refst,idsref,psfpx,psfpy,
     *     nref,refstt,idsreft,delx,dely,distmaxsq,iexp,nvpsf,nfmax)
	dimension refst(30,nfmax),idsref(*),psfpx(*),psfpy(*)
     *  ,refstt(*),tdis(nref,4),t(16),l(16),idsm(16),
     *    index(16),nkk(4)
	integer lpsf(nref,4),indx(nref)
	dsq=distmaxsq
	dsmallest=10000000.
	ksmall=0
	itry=1
	iclose=0
	nmax=nvpsf*4
	if (nvpsf.eq.1) nmax=5
 120	continue
	do 105 i=1,nmax
	  idsm(i)=0
	  t(i)=10000000.
	  l(i)=0 
 105	continue
	do 106 i=1,4
	  nkk(i)=0
 106	continue
c sort objects into quardants
	do 100 i=1,nref
c first check the there is no screw up on the psf postion
	  if (psfpx(i).lt.0.0) go to 100
c compute distance to object
	  dist=(reali-psfpx(i))**2+(realj-psfpy(i))**2
c  do not use if it is too far away
	  if (dist.gt.dsq) go to 100
c separate them into quadrants, note that if the object is itself a
c  psf, it will be stored in kk=1
	  if (psfpx(i).le.reali.and.psfpy(i).le.realj) then
c  (1) upper right (smaller i and j)
	    kk=1
	  else if (psfpx(i).ge.reali.and.psfpy(i).le.realj) then
c  (2) upper right (larger i, smaller j)
	    kk=2
	  else if (psfpx(i).le.reali.and.psfpy(i).ge.realj) then
c  (3) upper left  (smaller i, larger j)
	    kk=3
	  else if (psfpx(i).ge.reali.and.psfpy(i).ge.realj) then
c  (4) lower left  (larger i and j)
	    kk=4
	  else 
c  this should not happen, but just in case
	    goto 100
	  end if
c  store the ref star number and distance in the correct bin
	  nkk(kk)=nkk(kk)+1	
	  lpsf(nkk(kk),kk)=i
	  tdis(nkk(kk),kk)=dist
 100	continue
c sort the distance and the corresponding psf number array lpsf
	ntot=0 
	do 101 m=1,4
	  if (nkk(m).gt.1) then    
	    call indexx(nkk(m),tdis(1,m),indx)
	  else if (nkk(m).eq.1) then
	    indx(1)=1
	  else 
c no psf in the quadrant
	    goto 101
	  end if
c now pick the smallest nvpsf and store it in the final array,
c    first check to see that it is not very close to zero
	  if (tdis(indx(1),m).lt.delx) then
c  for the case of 1 psf per quandrand, this object should be used
	    if (nvpsf.eq.1) iclose=lpsf(indx(1),m)
	  end if
c  now save the nearest nvpsf psfs
	  do 102 i=1,min0(nkk(m),nvpsf)
	    ntot=ntot+1
	    l(ntot)=lpsf(indx(i),m)
	    idsm(ntot)=idsref(l(ntot))
	    t(kk)=tdis(indx(i),m)
 102	  continue
 101	continue
c if nvpsf=1, and if there is a really close psf (ie iclose=1)
	if (nvpsf.eq.1.and.iclose.gt.0) then
	    ntot=ntot+1
	  if (idsm(1).gt.0) then
c  fudge t(new) to be 1/2 X the smallest t's (note that t is distance sq'ed)
	    t(ntot)=0.25*t(1)
	  else
	    t(ntot)=1.
	  end if
	  l(ntot)=iclose
	  idsm(ntot)=idsref(l(ntot))
	end if
c  now check if there are any psf''s, (at least 1 if nvpsf=1, or
c   2 if nvpsf>1) if not, expend the search radius
	if (ntot.le.min0(nvpsf,2).and.itry.eq.1) then
	  itry=2
	  dsq=2.*distmaxsq 
	  iclose=0
	  goto 120
	else if (itry.eq.2) then
	  if (ntot.eq.0) then
c still no star, use the whole set (up to 16)
	    ndel=nref/16+1
	    write(6,*) ' +++ no close psf available, using whole ste ++'
	    do 125 i=ndel,nref,ndel
	      ntot=ntot+1
	      if (ntot.gt.16) goto 132
	      l(ntot)=i
	      t(ntot)=1.
	      idsm(ntot)=idsref(i)
 125	    continue
	  end if
	end if
c average the curve, first sort idsm -- the ones with idsm=0 are discarded
 132	call nindexx(ntot,idsm,index)
c  choose the one with the largest ids, and normalize to that one
c	write(6,*) '  interpolated from object(@ dis):',l(index(5)),
c     *      sqrt(t(index(5))),idsm(index(5)),psfpx(l(index(5))),
c     *        psfpy(l(index(5)))
	idsreft=idsm(index(ntot))
c normalize to the largest common aperture
	if (ntot.eq.1) then
c  only one reference, just copy it over and return
	  do 131 i=1,idsreft
	    refstt(i)=refst(i,l(index(1)))
 131	  continue
c	  write(6,*)' refstt ',(refstt(i),i=1,5),refstt(idsreft)
	  return
	else
c  more than one, average using the one with largest ids first
c copy the initial reference, in flux
	  do 114 i=1,idsm(index(ntot))
	    refstt(i)=10.**(-.4*refst(i,l(index(ntot))))
 114	  continue
c flux normalization fiducial (the flux at smallest ids)
c  imin is the smallest aperture
	  imin=idsm(index(1))
c the normalization in aveaged over two apertures
	  rnorm=0.5*(refst(imin,l(index(ntot)))+
     *                refst(imin-1,l(index(ntot))))
c add the others, normalized to same flux, and scaled by inverse distances sq
	  do 115 i=ntot-1,1,-1
	    ii=index(i)
            fluxrat=0.5*(refst(imin,l(ii))+refst(imin-1,l(ii)))-rnorm
c           rat=sqrt(t(index(ntot))/t(ii))
            rat=t(index(ntot))/t(ii)
c       write(6,*) '  + (object,ratio,idsmin)       : ',l(ii),
c    *              rat,idsm(ii),psfpx(l(ii)),psfpy(l(ii))
c add each aperture, up to idsm(ii), the largest aperture of the psf
            do 116 j=1,idsm(ii)
              refstt(j)=refstt(j)+rat*10.**
     *                    (-.4*(refst(j,l(ii))-fluxrat))
 116        continue
c add proper flux to remaining aperture larger than idsm(ii)
	    do 117 j=idsm(ii)+1,idsreft
	      refstt(j)=refstt(j)+rat*10.**(-0.4*refst(j,l(index(ntot))))
 117	    continue
 115      continue
c change BACK to mag
	  do 118 i=1,idsreft
	    refstt(i)=-2.5*alog10(amax1(.0000001,refstt(i)))
 118	  continue
c	  write(6,*)' refstt ',(refstt(i),i=1,5),refstt(idsreft)
	end if
	return
	end
c////////////////////////////////////////////////////////////////////
c  subroutine to compute interpolated psf curve from a set of PSFs
c   if the object is within  delx and  dely of the average position
c     of a grid, the refstar is taken as is, otherwise, the average
c     of the closest refstars in each quadrant from the object
c      weighted by distance is taken.
c  
c  old version, only allow 4 stars
C
	subroutine refstcurv1(reali,realj,refst,idsref,psfpx,psfpy,
     *     nref,refstt,idsreft,delx,dely,distmaxsq,iexp,nfmax)
	dimension refst(30,nfmax),idsref(1),psfpx(1),psfpy(1)
     *        ,refstt(1),t(5),l(5),idsm(5),index(5)
c	write(6,*) ' position ',reali,realj
c	do 100 j=1,nref
c	    if (abs(reali-psfpx(j)).le.delx.and.
c     *          abs(realj-psfpy(j)).le.dely) then
c	      idsreft=idsref(j)
c	      do 101 k=1,idsreft
c	        refstt(k)=refst(k,j)
c 101	      continue
c	write(6,*) ' single reference ',j,idsreft,psfpx(j),psfpy(j)
c	write(6,*) ' refstt',(refstt(k),k=1,5)
c	      return
c	    end if
c 100	continue
	dsq=distmaxsq
	dsmallest=10000000.
	ksmall=0
	itry=1
	do 105 i=1,5
	  idsm(i)=0
	  t(i)=10000000.
 105	continue
 130	continue
	do 110 i=1,nref
	  if (psfpx(i).lt.0.) go to 110
	  if (abs(reali-psfpx(i)).le.delx.and.
     *          abs(realj-psfpy(i)).le.dely) then
c the object is very close to one of the reference,
c     put the reference in kk=5, and assign a weight of twice
c     of the closeset
c     and then go and find 4 other references
	    t(5)=-1.
	    l(5)=i
	    idsm(5)=idsref(i)
c	write(6,*) i,t(5),' close'
	    go to 110
	  else
	    dist=(reali-psfpx(i))**2.+(realj-psfpy(i))**2.
	    if (itry.eq.1.and.dist.le.dsmallest) then
	      dsmallest=dist
	      ksmall=i
	    end if
	    if (dist.gt.dsq) go to 110
	    if (psfpx(i).le.reali.and.psfpy(i).le.realj) then
c  (1) upper right (smaller i and j)
	      kk=1
	    else if (psfpx(i).ge.reali.and.psfpy(i).le.realj) then
c  (2) upper right (larger i, smaller j)
	      kk=2
	    else if (psfpx(i).le.reali.and.psfpy(i).ge.realj) then
c  (3) upper left  (smaller i, larger j)
	      kk=3
	    else if (psfpx(i).ge.reali.and.psfpy(i).ge.realj) then
c  (4) lower left  (larger i and j)
	      kk=4
	    else 
c  this should not happen, but just in case
	      kk=0
	    end if
	    if (kk.eq.0) go to 110
	    if (dist.lt.t(kk)) then 
	      t(kk)=dist
	      l(kk)=i
	      idsm(kk)=idsref(i)
	    end if
	  end if
 110	continue
c  fudge t(5) to be 1/2 X the smallest t's
	if (t(5).lt.0.0) then
	  call indexx(4,t,index)
	  if (idsm(index(1)).gt.0) then
	    t(5)=0.25*t(index(1))
	  else
	    t(5)=1.
	  end if
c	  write(6,*) (t(index(i)),i=1,4),t(5)
	end if
c check for the case of 2nd try to see if there's more than one star
	if (itry.eq.2) then
	  do 135 j=1,4
	    if (idsm(j).ne.0) then
c set the 5th one back to 0, since it must be one of the other 4
	      idsm(5)=0
	      go to 132
	    end if
 135	  continue
	end if
c average the curve, first sort idsm -- the ones with idsm=0 are discarded
 132	call nindexx(5,idsm,index)
	if (idsm(index(5)).eq.0) then
	  if (itry.eq.1) then
	    write(6,*) '  +++ Can''t find nearby psf, trying again +++'
c accept the closest one, plus others withing 1.5* the limit
	    dsq=2.*distmaxsq 
	    t(5)=dsmallest
	    l(5)=ksmall
	    idsm(5)=idsref(ksmall)
	    itry=2
	    go to 130
	  else
c this should not happen unless there is NO psf at all!
	    write(6,*) ' +++ error in interpolation, no psf available'
	    return
	  end if
	end if
c  choose the one with the largest ids, and normalize to that one
c	write(6,*) '  interpolated from object(@ dis):',l(index(5)),
c     *      sqrt(t(index(5))),idsm(index(5)),psfpx(l(index(5))),
c     *        psfpy(l(index(5)))
	idsreft=idsm(index(5))
c normalize to the largest common aperture
	do 119 k=4,1,-1
	  if (idsm(index(k)).eq.0) go to 120
 119	continue
 120	if (k.eq.4) then
c  only one reference, just copy it over and return
	  do 131 i=1,idsreft
	    refstt(i)=refst(i,l(index(5)))
 131	  continue
c	  write(6,*)' refstt ',(refstt(i),i=1,5),refstt(idsreft)
	  return
	else
c  more than one, average using the one with largest ids first
c         imin= index of the one with smallest ids
	  imin=index(k+1)
c copy the initial reference, in flux
	  do 114 i=1,idsm(index(5))
	    refstt(i)=10.**(-.4*refst(i,l(index(5))))
 114	  continue
c flux normalization fiducial (the flux at imin of the first object
	  rnorm=0.5*(refst(idsm(imin),l(index(5)))+
     *        refst(idsm(imin)-1,l(index(5))))
c add the others, normalized to same flux, and scaled by inverse distances
	  do 115 i=4,k+1,-1
	    ii=index(i)
            fluxrat=0.5*(refst(idsm(imin),l(ii))+
     *        refst(idsm(imin)-1,l(ii)))-rnorm
c           rat=sqrt(t(index(5))/t(ii))
            rat=t(index(5))/t(ii)
c       write(6,*) '  + (object,ratio,idsmin)       : ',l(ii),
c    *              rat,idsm(ii),psfpx(l(ii)),psfpy(l(ii))
            do 116 j=1,idsm(ii)
              refstt(j)=refstt(j)+rat*10.**
     *                    (-.4*(refst(j,l(ii))-fluxrat))
 116        continue
c add proper flux to remaining points
	    do 117 j=idsm(ii)+1,idsreft
	      refstt(j)=refstt(j)+rat*10.**(-0.4*refst(j,l(index(5))))
 117	    continue
 115      continue
c change back to mag
	  do 118 i=1,idsreft
	    refstt(i)=-2.5*alog10(amax1(.0000001,refstt(i)))
 118	  continue
c	  write(6,*)' refstt ',(refstt(i),i=1,5),refstt(idsreft)
	end if
	return
	end

c//////////////////////////////////////////////////////////////////
c   subroutine to input ref stars for variable psf
c
	subroutine inrefst(refst,refpk,idsref,psfpx,psfpy,skyerr
     *            ,NAP,RMAG,PK,IDS,reali,realj,IREF,NREF,nob,npsfsec
     *      ,ADUSAT,IREFMIN,irefmax,nmax,nsec,ipsfextend,iexap,*)
c need to change nfmax to whatever irefmax is comingin
	parameter(nfmax=3000)
        DIMENSION REFST(30,irefmax),SKYERR(*),RMAG(30,nmax),PK(*),
     *            IREF(*),idsref(*),psfpx(*),psfpy(*),refpk(*)
     *            ,reali(*),realj(*)
        INTEGER IDS(*),nfssh(irefmax)
c       INTEGER IDS(*),nfssh(nfmax)
	integer nfs(nmax)
	character string*110,filname*28,secstr*1
	include 'pipeparm.inc'
c  the lower bound changed by -1, May 15 95.
	napp=nap/2-2
	write(6,*) 'napp in inrefst ',napp,'  ircspipe ',ircspipe
	irdref=0
	if (ircspipe.eq.0) then
 601	  write(6,1) irefmax
 1	format('  Enter reference star numbers (max:',i3,') MFO format'
     *    ,', or file name:')
	  read(5,'(a110)',end=999) string
	else
	write(6,*) ' arefname ',arefname
	  string=arefname(1:lnblnk(arefname))
	end if
	irdref=irdref+1
	call mfnum(string,110,nfssh,nfmax,num,1)
c if the string is a name, read position from a file
	if (num.eq.0.and.string.ne.' ') then
	  filname=string(1:lnblnk(string))
c check filename: if there is no extension, add .ref
	  len=lnblnk(filname)
	  do 200 i=1,len
	    if (filname(i:i).eq.'.') goto 201
 200	  continue
c  no '.', add '.ref'
	  filname=filname(1:len)//'.ref'
	write(6,*) ' filname ',filname
	  len=len+4
c add section extension if the name is standard .ref
 201      if (filname(len-3:len).eq.'.ref') then
	    if (nsec.ne.0) then
	      istatus=encode(secstr,float(nsec),1,0,idum)
	      filname=filname(1:len)//'.'//secstr
	    end if
	  end if
	  write(6,8) filname
 8	format('  .... ref star file name: ',a20)
	  open(unit=29,name=filname,status='old',err=701)
	  goto 702
 701	  if (irdref.eq.1) then 
	    write(6,*) ' +++ no .ref file, try again +++ '
	  else
	    write(6,*) ' +++ no .ref file, aborting photometry +++'
	    return1
	  end if
 702	  read(29,'(1x)')
	  if (npsfsec.eq.0) then
	    do 120 i=1,nfmax
 604	      read(29,*,end=121,err=603) nfs(i)
	      goto 120
 603	      write(6,*) ' +++ read error, object ',i
	      go to 604
 120	    continue
	  else
	    do 130 i=1,nfmax
 605	      read(29,*,end=121,err=606) ndum,xtem,ytem
c  check with pos file
	      do 135 k=1,nob
	        if (abs(ytem-realj(k)).le.2.0.and.abs(xtem-reali(k)).
     *                 le.2.0) then
c  object found, and the ppp# is remembered in nfs
	          nfs(i)=k
c	write(6,*) ' object ',ndum,xtem,ytem,nfs(i)
	          go to 130
	        end if
c	        if (realj(k)-ytem.gt.2.) go to 131
 135	      continue
 131	      nfs(i)=-99
 	      write(6,18) i,xtem,ytem,nfs(i)
c  object no found set ppp# to -99
 18	format('  +++  #',i2,'  No object within 2 pix at ',2f6.0)
	      go to 130
 606	      write(6,*) ' +++ read error, object ',i
	      go to 605
 130	    continue
	  end if
 121	  num=i-1
	else
	  do 180 kk=1,num
	    nfs(kk)=nfssh(kk)
 180	  continue
	end if
	nref=0
	do 100 i=1,num
c check stars for the following criteria:
c      (1)  IDS at least 1/2 max  (NAP)
c      (2)  not saturated
c      (3)  s/n greater than 20
	  if (nfs(i).eq.-99) then
	    goto 100
	  else if (ids(nfs(i)).lt.napp) then
	    write(6,2) nfs(i),ids(nfs(i))
 2	format(' ++ obj',i6,' with ids = ',i2,' too small. Not used')
	    go to 100
	  else if (pk(nfs(i)).gt.adusat) then
	    write(6,3) nfs(i),pk(nfs(i))
 3	format(' ++ obj',i6,' saturated (pk:',f7.0,').  Not used')
	    go to 100
	  else if (skyerr(nfs(i)).lt.20.) then
	    write(6,4) nfs(i),skyerr(nfs(i))
 4	format(' ++ obj',i6,' S/N = ',f5.1,' too low.  Not used') 
	    go to 100
	  end if
	  nref=nref+1
	  psfpx(nref)=reali(nfs(i))
	  psfpy(nref)=realj(nfs(i))
	  if (ipsfextend.eq.0) then
	    idsref(nref)=ids(nfs(i))
	  else
c  forced extension of ids for reference star to be the maximum
	    idsref(nref)=iexap
	  end if
	  refpk(nref)=pk(nfs(i))
	  iref(nref)=nfs(i)
	  do 101 k=1,idsref(nref)
	    refst(k,nref)=rmag(k,nfs(i))
 101	  continue
	  write(6,5) nref,iref(nref),psfpx(nref),psfpy(nref),
     *            idsref(nref)
 5	format(' Ref star#',i3,' ppp#',i5,' @',2f8.2,'  ids',i3)
	  if (nref.eq.irefmax) return
 100	continue
	return
 999	return1
	end 
C//////////////////////////////////////////////////////////////////////////
C
C    SUBROUTINE FOR FINDING REFERENCE STAR within an area of
c            x1,x2,y1,y2,
C      With option to average up to 10 stars.
C   IPAR=1 : automatic choice
c
C
	SUBROUTINE REFSTAR(REFST,REFPK,IDSREF,SKYERR,NAP,RMAG,PK,
     *       IDS,SKY,II,IJ,NOB,IREF,NREF,IPART,ADUSAT,NREFMIN,iexap,
     *       ix1,ix2,jy1,jy2,npsfsec,nmax,*)
	DIMENSION REFST(30),SKYERR(*),RMAG(30,nmax),PK(*),
     *            SKY(*),NUM(50),IPK(50),NT(10),IREF(10)
c	INTEGER*2 II(*),IJ(*),IDS(*),IREFT(10),IREFBAD(10)
	INTEGER II(*),IJ(*),IDS(*),IREFT(10),IREFBAD(10)
	CHARACTER STR*60,ian*1
C  Pick all object with 3*X sky and SKYERR>200
	iexap=min0(iexap,nap-1)
	IPAR=IPART
	ERRCRI=200.
	SKYMUL=3.
	CRILIM=50.
	MAXAUTO=6
	IBADREF=0
	ITIME=0
 599	K=0
c pick candidate objects, saved in num(k): initial criteria:
c         (1) s/n>200,   (2) peak> 3*sky
c   each pass, s/n and peak criteria is 0.75 of previous
c    The faintest star allowed is s/n=50.
 	DO 305 I=1,NOB
	  if ((ii(i).gt.ix1.and.ii(i).le.ix2).and.
     *        (ij(i).gt.jy1.and.ij(i).le.jy2)) then
	    IF (SKYERR(I).GE.ERRCRI.AND.PK(I).GT.SKYMUL*SKY(I)) THEN
	      K=K+1
	      NUM(K)=I
	      IPK(K)=NINT(PK(I))
	      IF (K.EQ.50) GO TO 306
	    end if
	  END IF
 305	CONTINUE
	IF (K.LT.3) THEN
	  ERRCRI=ERRCRI*.75
	  SKYMUL=SKYMUL*.75
	  IF (ERRCRI.LT.CRILIM) THEN
	    IF (K.EQ.0) THEN
	      CALL RBELL(1)
	    WRITE(6,*) '  ++++ NO SUITABLE REFERENCE CANDIDATE FOUND ++'
	    END IF
	  ELSE 
	    GO TO 599
	  END IF
	END IF
C  sort possible reference stars (faintest first)
 306	IF (K.GT.1) CALL NSORT2(K,IPK,NUM)
	IACCEPT=0
 600	WRITE(6,12) 
 12	FORMAT('   Candidate reference objects (''stars'') '/
     *        '    obj #     I     J      peak     max aperture ...')
	DO 100 I=K,1,-1
 100	  WRITE(6,13) NUM(I), II(NUM(I)),IJ(NUM(I)),PK(NUM(I))+SKY(I)
     *                  ,IDS(NUM(I)),I
 13	FORMAT(3X,I4,2(2X,I5),3X,F8.1,8X,I2,3X,I3)
 801	CONTINUE
	IF (IPAR.NE.1) THEN
c non-automode: request for entering choice
	  CALL RBELL(1)
 610	  WRITE(6,14) 
 14	FORMAT('  Enter REFERENCE STAR #s for classification, Max 10',/
     *         '  <cr>-brightest obj only, more-list more, auto - auto',
     *         ' selection'/'    fix-fixed choices....: ',$)
	  call readstr(60,str,*999,*610)
	  IF (STR.EQ.' ') THEN
	    NREF=1
	    IREF(1)=NUM(K)
	    WRITE(6,*)  '  ___ default ref star # ',NUM(K),' used'
	    GO TO 800
C need lising of fainter objects
	  ELSE IF (STR.EQ.'more') THEN
	    IF (ITIME.LE.2) THEN
	      ERRCRI=ERRCRI*.6
	      SKYMUL=SKYMUL*.6
	      CRILIM=CRILIM*.7
	      ITIME=ITIME+1
	    ELSE
	      WRITE (6,4) 
	      CALL RBELL(2)
 4	FORMAT(/'  +++ SORRY, can''t go any fainter +++'/)
	    END IF
	    GO TO 599
	  ELSE IF (STR.EQ.'auto') THEN
	    IPAR=1
	    GO TO 801
	  ELSE IF (STR.EQ.'fix') THEN
 6101	    WRITE(6,44)
 44	FORMAT('  Enter objects, no warning will be given'/
     *         '  : ',$)
	    call readstr(60,str,*999,*6101)
	    CALL MFNUM(STR,60,IREFT,10,NREF,0)
	    IF (NREF.LT.1) then
	      if (npsfsec.ne.1) then
c it's okay to have no star
	        nref=0
	        ipart=1
	        return
	      else
	         GO TO 610
	      end if
	    end if
	    IACCEPT=2
	    IPART=1
	  ELSE
C  parse string and determine reference object numbers
	    CALL MFNUM(STR,60,IREFT,10,NREF,0)
	    IF (NREF.LT.1) GO TO 610
	  END IF
C check if any new objects are entered, if so check and print warning
C  also mark the brightest object
	  IAGAIN=0
	  DO 101 I=1,NREF
	    DO 102 J=1,K
	      IF (IREFT(I).EQ.NUM(J)) GO TO 1011
 102	    CONTINUE
C  can't find the obj in the recommended list, 
	    WRITE(6,*) '  +++WARNING: Reference star list contains',
     *             ' star not in recommended list'
 	    WRITE(6,13) IREFT(I), II(IREFT(I)),IJ(IREFT(I)),PK(IREFT(I)),
     *                IDS(IREFT(I))
	    IF (PK(IREFT(I)).LE.1.5*SKY(IREFT(I)).OR.IDS(IREFT(I))
     *             .LE.iexap/2) THEN
	      WRITE(6,*) '  ** STAR TOO FAINT OR CROWDED, TRY AGAIN:'
	      IAGAIN=1
	    END IF
 1011	    NT(I)=IDS(IREFT(I))
	    IREF(I)=IREFT(I)
 101	  CONTINUE
	  IF (IAGAIN.EQ.1) THEN
	    IF (IACCEPT.EQ.1) THEN
	      CALL RBELL(1)
	      WRITE(6,*) '   +++ WARNING: Reference list with faint'
     *                 ,' object(s) accepted +++'
	    ELSE IF (IACCEPT.EQ.2) THEN
	      GO TO 800
            ELSE
	      IACCEPT=1
	      GO TO 600
	    END IF
	  END IF
	ELSE
C automatic choice
	  KK=K
 579	  NREF=0
 581	  DO 250 IO=KK,1,-1
C  reject fuzzy objects, if there is any
	    DO 255 L=1,IBADREF
	      IF (NUM(IO).EQ.IREFBAD(L)) GO TO 250
 255	    CONTINUE
C  object+sky must be <ADUSAT-1000, objects with ids<1/2 max are discarded
C   and max of 6 allowed
	    IF ((PK(NUM(IO))+SKY(NUM(IO))).LT.ADUSAT) THEN
	      IF (IDS(NUM(IO)).GT.iexap/2) THEN
	        NREF=NREF+1
	        IREF(NREF)=NUM(IO)
	        NT(NREF)=IDS(IREF(NREF))
	      END IF
	    END IF
	    IF (NREF.GE.MAXAUTO) GO TO 578
 250	  CONTINUE
 577	  IF (NREF.LT.NREFMIN.or.(nref.eq.1.and.itime.le.1)) THEN
 580	    ITIME=ITIME+1
	    IF (ITIME.GE.4) THEN
	      WRITE(6,*) '  **** GAVE UP IN FINDING REFERENCE****'
	      if(inpsfsec.le.1) then
	        WRITE(6,*) '   +++ adopting the brightest object ++++'
	        NREF=1
	        IREF(1)=NUM(K)
	      else
c for multisection, it's okay to have 0 star
	        write(6,*) '   Setting Nref to 0 for this sector'
	        nref=0
	        return
	      end if
	      GO TO 800
	    END IF
	    ERRCRI=ERRCRI*.60
	    SKYMUL=SKYMUL*.60
	    CRILIM=CRILIM*.7
	    GO TO 599
	  END IF
C Check if there is at least one object with ids=iexap
 578	  continue
	  DO 256 L=1,NREF
	    IF (IDS(IREF(L)).GE.iexap) GO TO 800
 256	  CONTINUE
C  No object with ids=nap, increase list
c !  more objects to check
	  IF (IO.NE.0.AND.NREF.NE.10) THEN
	    KK=IO-1
	WRITE(6,*) ' ..no IDS=IEXAP, GETTING THE NEXT CANDIDATE '
	    GO TO 581
	  ELSE IF (IO.NE.0.AND.NREF.EQ.10) THEN 
C chuck the last one and try again
	    KK=IO-1
	    NREF=NREF-1
	WRITE(6,*) ' ..no IDS=IEXAP, switch ref #10 '
	    GO TO 581
c ! lower criteria, 1 time only
	  ELSE IF (MAXAUTO.NE.10) THEN 
	WRITE(6,*) '  ++can''t find object with IDS=IEXAP, try low sig'
	    MAXAUTO=10
	    GO TO 580
c ! otherwise nothing can be done
	  ELSE   
	    WRITE(6,*) '  ++ no reference with IDS>=IEXAP found ++'
	  END IF
	END IF
C  star list accepted
c ! reset IBADREF
 800 	IBADREF=0   
	IFUZZ=0
	IF (NREF.EQ.1) THEN
	  REFPK=PK(IREF(1))
	  DO 119 I=1,IDS(IREF(1))
 119	    REFST(I)=RMAG(I,IREF(1))
C  change to magnitude
	  IDSREF=IDS(IREF(1))
	  WRITE(6,*) '  --- Reference growth curve: (inst. mag)'
	  DO 129 I=1,IDSREF
	    WRITE(6,*) ' Aperture # ',I,REFST(I)
 129	  CONTINUE
	ELSE
C  Shuffle list so that the objects with the largest IDS go first when averaging
C   (sort actually puts smallest first)
	  CALL  NSORT2(NREF,NT,IREF)
C  sum
	  REFPK=0.
	  IDSREF=IDS(IREF(NREF))
C check if object NREF is the brightest of all with IDS>=NAP-1
	  DO 205 I=NREF-1,1,-1
	    IF (IDS(IREF(I)).EQ.IDSREF) THEN
	      IF (PK(I).GT.PK(IREF(NREF))) THEN
C  switch
                TEMP=IREF(I)
	        IREF(I)=IREF(NREF)
	        IREF(NREF)=TEMP
	      END IF
	    END IF
 205	  CONTINUE
	  DO 128 J=1,IDSREF
 128	    REFST(J)=0.
	  DO 120 I=NREF,1,-1
	    WRITE(6,*) I,IREF(I),IDS(IREF(I))
	    REFPK=REFPK+PK(IREF(I))
	    DO 121 J=1,IDS(IREF(I))
 121	      REFST(J)=REFST(J)+10**(-.4*RMAG(J,IREF(I)))
C  objects with fewer points then max
	    IF (J.LE.IDSREF) THEN
	      RAT=REFST(ids(iref(i)))/
     *      (REFST(ids(iref(i)))-10**(-0.4*RMAG(ids(iref(i)),IREF(I))))
	      DO 122 J1=J,IDSREF
 122	        REFST(J1)=REFST(J1)*RAT
	    END IF
 120	  CONTINUE
C  change to magnitude
	  WRITE(6,*) '  --- Reference growth curve: (inst. mag)'
	  DO 123 I=1,IDSREF
 	    REFST(I)=-2.5*ALOG10(AMAX1(REFST(I),0.001))
	    WRITE(6,*) ' Aperture # ',I,REFST(I)
 123	  CONTINUE
C check for objects that deviate from average
	  DO 125 I=1,NREF
	    DEL=RMAG(1,IREF(I))-REFST(1)
	    DEL=.6667*DEL+.3333*(RMAG(2,IREF(I))-REFST(2))
	    SUMDEL=(2-IDS(IREF(I)))*DEL
	    DO 182 J=3,IDS(IREF(I))
	      SUMDEL=SUMDEL+(RMAG(J,IREF(I))-REFST(J))
 182	    CONTINUE
	    SUMDEL=SUMDEL/(FLOAT(IDS(IREF(I)))-2.)
	    IF (SUMDEL.GT..05) THEN
	      CALL RBELL(1)
	      WRITE(6,10)  IREF(I),SUMDEL
 10	FORMAT('  ++++WARNING: Object',I4,', C2=',F7.3,' deviates (too',
     *          ' sharp) from average profile')
	      IBADREF=IBADREF+1
	      IREFBAD(IBADREF)=-IREF(I)
	    ELSE IF (SUMDEL.LT.-0.05) THEN
	      CALL RBELL(1)
	      WRITE(6,11)  IREF(I),SUMDEL
 11	FORMAT('  ++++WARNING: Object',I4,', C2=',F6.3,' deviates (too',
     *          ' fuzzy) from average profile')
	      IBADREF=IBADREF+1
	      IFUZZ=IFUZZ+1
	      IREFBAD(IBADREF)=IREF(I)
	    END IF
 125	  CONTINUE
	WRITE(6,*) ' IBADREF ',IBADREF,IFUZZ
	  IF (IACCEPT.EQ.2) RETURN
	  IF (IBADREF.GT.0) THEN
	    IF (IPAR.NE.1) THEN
	      CALL RBELL(1)
 6100	      WRITE(6,15)
 15	FORMAT(/' Do you want to re-enter reference star list? y/n: ',$)
	      call readstr(1,ian,*999,*6100)
	      IF (IAN.EQ.'y') GO TO 600
	    ELSE
C clear list of fuzzy ones, if there are sharp deviants, it will be accepted!
	      IF (IFUZZ.NE.0) THEN
	        DO 220 L=1,IBADREF
	          DO 221 N=1,NREF
	            IF (IREFBAD(L).EQ.IREF(N)) THEN
	              NREF=NREF-1
	WRITE(6,*) '  eliminated ', IREF(N)
	              DO 222 LK=N,NREF
	                NT(LK)=NT(LK+1)
 222	                IREF(LK)=IREF(LK+1)
	              GO TO 220
	            END IF
 221	          CONTINUE
 220	        CONTINUE
c !  too few reference, lower citeria
	        IF (NREF.LE.1.and.itime.le.2) THEN
	WRITE(6,*) '  ** too few reference after rejection, lower sig'
C	        ERRCRI=200.
C	        SKYMUL=3.
C	        CRILIM=50.
c ! redo reference after rejecting bad ref
	          GO TO 580
c ! recheck remaining list
	        ELSE 
	          WRITE(6,*) ' -- rechecking IDS after rejection --'
	          GO TO 578
	        END IF
	      END IF
	    END IF
	  END IF 
	END IF
	RETURN
 999	RETURN1
	END	
C
C///////////////////////////////////////////////////////////////////
C
C    Subroutine to made interpolation array of a pixel
c       NAR= size of interpolation array
c      input: IX0 = 3X3 INTEGER ARRAY around the pixel
c      return: ARRAY: normalized (to sum=1) interpolation array
c
	SUBROUTINE DIVPIX(NAR,IX0,ARRAY)
	DIMENSION IX0(3,3),ARRAY(10,10)
	SUM=0.
	DD=0.5/FLOAT(NAR)
	KK=NAR-1
	M=0
	DO 100 J=-KK,KK,2
	  DY=J*DD
	  M=M+1
	  L=0
	  ISJ=SIGN(1.,DY)
	  DY=ABS(DY)
	  DO 100 I=-KK,KK,2
	    DX=I*DD
	    L=L+1
	    ISI=SIGN(1.,DX)
	    DX=ABS(DX)
	    ARRAY(L,M)=IX0(2,2)*(1.-DX)*(1.-DY) +
     *	         IX0(2+ISI,2+ISJ)*DY*DX   +
     *           IX0(2,2+ISJ)*DY*(1.-DX)  +
     *           IX0(2+ISI,2)*DX*(1.-DY)
	    SUM=SUM+ARRAY(L,M)
 100	CONTINUE
	IF (ABS(SUM).GT.0.000001) THEN
 	  DO 101 J=1,NAR
	    DO 101 I=1,NAR
 101	      ARRAY(I,J)=ARRAY(I,J)/SUM
	ELSE
c	  WRITE(6,*) '  **warning** zero div in DIVPIX, not normalized'
	END IF
	RETURN
	END
C
C///////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO FIND BEST CENTROID FOR PHOTOMETRY ROUTINE
C
	SUBROUTINE PHOTCEN(II,JJ,REALI,REALJ,SKY,MSH,NMASK,CDIAM,
     *                     IX,NU,NV,NI,NJ,CENSTEP,ITCEN,IW)
	DIMENSION DRI(30),DSP(0:30),IRA(30),DUMPIX(30)
	INTEGER NMASK(500,500),IX(NU,NV),IXT(21,21)
C   check using NMASK if all pixels are in
	IDM=INT(CDIAM)+1
	RSQ=IDM*IDM/4.
	IM=1-II+MSH
	JM=1-JJ+MSH
	M=0
	L=0
	DO 100 J=JJ-IDM,JJ+IDM
	  DO 100 I=II-IDM,II+IDM
 	    IF (NMASK(IM+I,JM+J).EQ.1) THEN
C calculate actual distance
	      IF ((I-II)**2+(J-JJ)**2.LE.RSQ) GO TO 150
	    END IF
 100	CONTINUE
C  case 1, fill temp array, no masked pixels
	DO 110 J=1,21
	  J1=J+JJ-11
	  DO 110 I=1,21
	    I1=I+II-11
 110	    IXT(I,J)=IX(I1,J1)
	GO TO 151
C  case 2, masked pixels
C Calculate profile then fill in masked pixels assumig spherical sym
C create apertures radius
 150	NAPER=IDM+4
	DO 101 I=1,NAPER
 101	  IRA(I)=I+1
C obtain profile
	CALL PPPHOT(DRI,DSP,FLOAT(II),FLOAT(JJ),SKY,MSH,NMASK,NAPER,
     *             IRA,IX,NU,NV,NI,NJ,DUMPIX,IW)
	DO 130 I=1,NAPER
	  DSP(I)=DSP(I)+SKY
C	  WRITE(6,*) ' profile	',I,DSP(I)
 130	CONTINUE
C fill in IXT array
 	DO 104 J=1,21
	  J1=J+JJ-11
	  DO 104 I=1,21
	    I1=I+II-11
 	    IF (NMASK(IM+I1,JM+J1).EQ.1) THEN
C calculate  distance (First point of DSP is at .75 pix, delta=.5 pix)
	      RPIX=SQRT(FLOAT((II-I1)**2)+FLOAT((JJ-J1)**2))
	      NRPIX=INT((RPIX-.75)*2)+1
	      IF (NRPIX.LE.NAPER-1) THEN
C interpolate pixel value from profile
	        IXT(I,J)=INTLIMR(DSP(NRPIX)+2.*(DSP(NRPIX)-DSP(NRPIX+1))
     *                      *((NRPIX-1)*.5+.75-RPIX))
	      ELSE
 	        IXT(I,J)=IX(I1,J1)
	      END IF
	    ELSE
C  No encroaching neighbours, substitute IXT as is
 	      IXT(I,J)=IX(I1,J1)
	    END IF
 104	CONTINUE
C	DO 1001 J=1,21
C	  DO 1001 I=1,21
C1001	    IX(I+NI,J+NJ)=IXT(I,J)
 151	REALI=11.
	REALJ=11.
C do iterative partial pixel centroiding
	CALL PCENTR1(IXT,CDIAM,SKY,ITCEN,CENSTEP,REALI,REALJ,
     *               ICONV,IW)
	REALI=REALI+II-11.
	REALJ=REALJ+JJ-11.
C  check return conditions
	DELI=ABS(REALI-II)
	DELJ=ABS(REALJ-JJ)
	IF (DELI.LE..5.AND.DELJ.LE..5) THEN
	  RETURN
c	ELSE IF (ICONV.EQ.1.AND.DELI.LE.1.0.AND.DELJ.LE.1.0) THEN
c   July 20 1999, changed criteria to del=1.5
	ELSE IF (ICONV.EQ.1.AND.DELI.LE.1.5.AND.DELJ.LE.1.5) THEN
	  RETURN
	ELSE
	  REALI=II
	  REALJ=JJ
	END IF
C	IF (IW.EQ.1) WRITE(6,14) REALI,REALJ
C 14	FORMAT('   Final adopted co-ord for photometery: ',2F8.2)
	RETURN
	END
C
C/////////////////////////////////////////////////////////////////
C
C  Centeroiding routine for PHOTCEN
C do iterative partial pixel centroiding
C do iterative partial pixel centroiding
c
	SUBROUTINE PCENTR1(IX,ROBJ,SKY,ITCEN,CENSTEP,REALI,REALJ,ICONV
     *                     ,IW)
	INTEGER IX(21,21)
	ICUT=2
	CUT=ICUT*2.+1.
	CUTSQ=CUT*CUT
	SQR=.25*ROBJ*ROBJ
	SQRL=(.5*ROBJ-0.707)**2
	SQRU=(.5*ROBJ+0.707)**2
	IRC=(ROBJ+1.5)/2
	REALI=11.
	REALJ=11.
	ITER=0
 555	  IF (IW.EQ.1) WRITE(6,10) ITER,REALI,REALJ
 10	FORMAT(' .... Estimate # ',I2,'  : ',2F10.4)
	SUMI=0.
	SUMXI=0.
 	SUMYI=0.
	IJTI=NINT(REALI)
	IJTJ=NINT(REALJ)
	  DO 101 M=MAX0(IJTJ-IRC,1),MIN0(IJTJ+IRC,21)
	    RRJ=(REALJ-M)*(REALJ-M)
	    DO 101 L=MAX0(IJTI-IRC,1),MIN0(IJTI+IRC,21)
C condition for partial pixel is if sqrt(RR)-radius is +/-0.707 from radius
	      RRT=(REALI-L)*(REALI-L)+RRJ
	      IF (RRT.LE.SQRL) THEN
C  pixel is in completely  
	        WT=IX(L,M)-SKY
	        SUMXI=SUMXI+WT*L
	        SUMYI=SUMYI+WT*M
	      ELSE IF (RRT.GE.SQRU) THEN
C  pixel is completely out
	        GO TO 101
	      ELSE 
C case for partial pixel
C	        
C  cut pixel into CUT X CUT and compute the number of sector within circle
	        WTT=0.
	        TSUMY=0.
	        TSUMX=0.
	        DO 102 LJ=-ICUT,ICUT
	          TEMJ=M+FLOAT(LJ)/CUT
	          TTJ=(REALJ-TEMJ)*(REALJ-TEMJ)
	          DO 102 LI=-ICUT,ICUT
	            TEMI=L+FLOAT(LI)/CUT
	            TTR=(REALI-TEMI)*(REALI-TEMI)+TTJ
	            IF (TTR.LE.SQR) THEN  
c! cut is in. Each part is wieghted as 1 part in CUTSQ
C   TSUM's determine the centroid of the partial pixel itself
	              WTT=WTT+1.
	              TSUMY=TSUMY+LJ
	              TSUMX=TSUMX+LI
	            END IF
 102	        CONTINUE
	        IF (WTT.EQ.0.) THEN
	          WT=0.
	        ELSE
C  sum the partial pixel to the total
	          WT=WTT*(IX(L,M)-SKY)/CUTSQ
	          SUMXI=SUMXI+(L+TSUMX/WTT)*WT
	          SUMYI=SUMYI+(M+TSUMY/WTT)*WT
	        END IF
	      END IF
	      SUMI=SUMI+WT
 101	  CONTINUE
	  TEMI=REALI
	  TEMJ=REALJ
	  IF (ABS(SUMI).GT.0.00001) THEN
	    REALI=SUMXI/SUMI
	    REALJ=SUMYI/SUMI
	  END IF
C Iterate
	  ITER=ITER+1
c ! max. iteration
	  IF (ITER.GT.ITCEN) THEN 
	    IF (IW.EQ.1) WRITE(6,16) 
 16	FORMAT('   +++ Non-converging centroid +++   ')
	    ICONV=0
	  ELSE
C check 
	    IF (ABS(TEMI-REALI).GT.CENSTEP.OR.
c ! try again
     *             ABS(TEMJ-REALJ).GT.CENSTEP) GO TO 555 
C converged centroid
 	    IF (IW.EQ.1) WRITE(6,15) REALI,REALJ
	    ICONV=1
 15	FORMAT('  Final CONVERGED centroid: ',2F10.4)
	  END IF
	RETURN
	END
c///////////////////////////////////////////////////
 	SUBROUTINE LSQF(NO,HBN,OIIIN,A,B,RSQ)
	DIMENSION HBN(*),OIIIN(*)
	REAL*8 X,XX,XY,Y,YY,AA,BB,SEY,T,SXY,SXX,SYY
	XX=0.
	YY=0.
	X=0.
	Y=0.
	XY=0.
	DO 300 I=1,NO
	X=X+HBN(I)
	XX=XX+HBN(I)*HBN(I)
	XY=XY+HBN(I)*OIIIN(I)
	Y=Y+OIIIN(I)
 300	YY=YY+OIIIN(I)*OIIIN(I)
	SXX=XX-X*X/NO
	SXY=XY-X*Y/NO
	SYY=YY-Y*Y/NO
	BB=0.
	RSQ=0.
	IF (SXX.NE.0.) BB=SXY/SXX
	A=(Y-BB*X)/NO
	B=BB
	IF (SYY.NE.0.) RSQ=BB*SXY/SYY
	RETURN
	END
c/////////////////////////////////////////////////////
c
	subroutine savegappix(nfr,ix,nu,nv,kf,filoutt,reali,realj,
     *         ids,comment,nap,irarr)
	integer ix(nu,nv,kf),ids(*)
	dimension irarr(31),reali(*),realj(*)
	character filoutt*18,filout*18,comment*60
        include 'objcat.inc' 
        include 'picdir.inc' 
c  create file name
	if (nfr.eq.2.or.nii(2).eq.0.or.njj(2).eq.0) then
	  write(6,*) '  **** no mask file in frame 2 **** mask marking aborted'
	  return   
	end if
	DO 100 I=1,18
	  IF (FILOUTT(I:I).EQ.'.') GO TO 101
 100	CONTINUE
 101    FILOUT=FILOUTT(1:MIN0(10,I-1))//'.gpx'
	call opennew(31,1,18,filout,*999)
	write(31,2) comment,date
 2	format(' Transformation gap pixel file (in ids apert, in max apert)',/
     *      ,a60,a24,/
     *   ' ppp#         x          y         gap    missing    double')
	iout=0
	IRC=(IRARR(nap)+1)/2
	SQR=.5*IRARR(nap)
	SQR=(SQR+0.7071068)**2
	write(6,*) ' apertures: ',irarr(nap),sqr
	do 102 i=1,nob(nfr)
c  go through each object and see if the aperture contains bad pixels
c   max aperture, and ids aperture results are recorded separately
	  ndoublenap=0
	  ndoubleids=0
	  ngapnap=0
	  ngapids=0
	  nemptynap=0
	  nemptyids=0
c  this accounts for partial pixel
	  sqrids=.5*IRARR(ids(i))
	  sqrids=(sqrids+0.7071068)**2
c   search aperture, do full max aperture search
	  DO 103 M=max0(1,IJOJ(i,nfr)-IRC),min0(IJOJ(i,nfr)+IRC,njj(nfr))
	    RRJ=(REALJ(i)-M)*(REALJ(i)-M)
	    DO 103 L=max0(IJOI(i,nfr)-IRC,1),min0(IJOI(i,nfr)+IRC,nii(nfr))
	      RRT=(REALI(i)-L)*(REALI(i)-L)+RRJ
C  pixel is in
	      IF (RRT.LT.SQR) then
c  check mask
	        if (ix(l,m,2).ge.100) then
c  double pt
	          ndoublenap=ndoublenap+1
	          call checkids(rrt,sqrids,ndoubleids)
	          iout=1
	        else if (ix(l,m,2).eq.-50) then
c  gap pt
	          ngapnap=ngapnap+1
	          call checkids(rrt,sqrids,ngapids)
	          iout=1
	        else if (ix(l,m,2).le.-100) then
c  missing pt
	          nemptynap=nemptynap+1
	          call checkids(rrt,sqrids,nemptyids)
	          iout=1
	        end if
	      end if
 104	    continue
 103	  continue
c output
	  if (iout.eq.1) then
	     write(31,1) i,reali(i),realj(i),ngapids,ngapnap,nemptyids,
     *            nemptynap,ndoubleids,ndoublenap
 1	  format(i6,' @ ',2f8.1,' -- ',6i5)
	     iout=0
	  end if
 102	continue
	close(unit=31)
 999	return
	end
c///////////////////////////////
c
	subroutine checkids(rt,sqr,nn)
	if (rt.le.sqr) nn=nn+1
	return
	end
c//////////////////////////////////////////////////
c  subroutine to out put a astrometry file for the .phm file
c
c   ioutpar=0  decimal format
c           1  dms format
c           2  both
c
	subroutine astromout(nfr,nob,reali,realj,filout,ioutpar)
	dimension reali(*),realj(*)
	real*8 ra,dec
	character filout*18,fdate*24,outname*24,isign*1,comm*44
	outname=filout(1:lnblnk(filout)-4)//'.asm'
	call opennew(29,1,24,outname,*999)
c write comment
	comm=filout(1:lnblnk(filout))//' '//fdate()
	write(29,1) comm
 1	format('# astrometry file for ',a44)	
	do 100 i=1,nob
	  call astrom(nfr,reali(i),realj(i),ra,dec)
c compute hhmmss etc and out put
	  call d2dms(ra,isign,irah,iram,rasec)
	  call d2dms(dec,isign,idec,imin,decsec)
	  if (ioutpar.eq.2) then
	    write(29,2) i,ra,dec,irah,iram,rasec,isign,idec,imin,decsec
 2	format(i5,1x,f10.7,1x,f10.6,2x,i2,':',i2,':',f5.2,1x,
     *          a1,i2,':',i2,':',f4.1)
	  else if (ioutpar.eq.1) then
	    write(29,3) i,irah,iram,rasec,isign,idec,imin,decsec
 3	format(i5,2x,i2,':',i2,':',f5.2,1x,a1,i2,':',i2,':',f4.1)
	  else
	    write(29,4) i,ra,dec
 4	format(i5,2x,f10.7,1x,f10.6)
	  end if
 100	continue
	close(unit=29)
 999	return
	end
c//////////////////////////////////////////////////////////
c  subroutine to compute astrometry: ra and dec in decimal degs and hrs
c         using simple wcs parameters
c
	subroutine astrom(nfr,x,y,ra,dec)
	real*8 ra,dec,crpix1,crpix2,crval1,crval2
        common/wcspar/crpix1(15),crpix2(15),crval1(15),crval2(15),
     *       cd1_1(15),cd1_2(15),cd2_1(15),cd2_2(15),iwcs
     *       ,ra11(15),dec11(15)
	dec=(y-crpix2(nfr))*cd2_2(nfr)+(x-crpix1(nfr))*cd2_1(nfr)
     *            +crval2(nfr) 
	ra=((x-crpix1(nfr))*cd1_1(nfr)+(y-crpix2(nfr))*cd1_2(nfr))/
     *          cos(dec/57.29578)+crval1(nfr) 
	ra=ra/15.000000000000
	return
	end
c//////////////////////////////////////////////////////////
c  subroutine to compute x,y position on CCD chip from  astrometric
c     co-ord using wcs solution
c
c NOTE:   ra is already in degrees
c
	subroutine xypixpos(nfr,x,y,ra,dec)
	real*8 ra,dec,crpix1,crpix2,crval1,crval2
        common/wcspar/crpix1(15),crpix2(15),crval1(15),crval2(15),
     *       cd1_1(15),cd1_2(15),cd2_1(15),cd2_2(15),iwcs
     *        ,ra11(15),dec11(15)
	det=cd1_1(nfr)*cd2_2(nfr)-cd1_2(nfr)*cd2_1(nfr)
	decp=dec-crval2(nfr)+
     *         crpix1(nfr)*cd2_1(nfr)+crpix2(nfr)*cd2_2(nfr)
	rap=(ra-crval1(nfr))*cos(dec/57.29578)+
     *       crpix2(nfr)*cd1_2(nfr)+crpix1(nfr)*cd1_1(nfr)
	x=(rap*cd2_2(nfr)-decp*cd1_2(nfr))/det
	y=(decp*cd1_1(nfr)-rap*cd2_1(nfr))/det
	return
	end
c/////////////////////////////////////////////////////////
c  subroutine to convert decimal deg to deg:min:sec.xx
c
        subroutine d2dms(decim,isign,idec,imin,sec)
        real*8 decim
        character isign*1
        if (decim.lt.-0.000000001) then
          isign='-'
        else
          isign=' '
        end if
        idec=int(decim)
        iadec=iabs(idec)
        if (isign.eq.'-') then
          rmin=60*(idec-decim)
        else
          rmin=60*(decim-float(iadec))
        end if
        imin=int(rmin)
        sec=(rmin-float(imin))*60.
        return
        end
