	character*70 ppp(100),io(100),op(100),
	data/ppp/'   //// Picture Processing Package, APR 1990 ////',
     *' ',
     *' TO RUN, run "ppp". Commands have the following format: ',
     *'       NAME <F1> <F2> <Optional inputs> ',
     *' A maximum of 5 inputs (incl. frame #s) can be accepted; but',
     *' only the name is absolutely necessary. If absent, the program',
     *' will request further information as needed.  The optional',
     *' inputs follow the same sequence as that requested by the',
     *' command.  Optional inputs are indicated by: N=name (no space',
     *' allowed), S=string (enclosed by " if there are spaces), F=',
     *' frame #, I=integer, R=real number.  No explanations to these',
     *' are provided in help, since one can run the program faster by',
     *' simply letting the command do the prompting instead of looking', 
     *' them up in HELP.  For 530X530 (default picture size), a total',
     *' of 9 frames are available in the program core buffer for
     *' immediate operation by the program. A 10th frame is used as
     *' the scratch frame for many of the operations. The use of it is
     *' possible for some commands but it is not recommended.  The',
     *' core picture buffer can be partitioned to larger size, with 
     *' the maximum being 1 (+1 scratch) 1280X1280 pictures.  Up to
     *' 250 pictures can be stored in the DISK directory which can be',
     *' called up to the core by "rdisk" or "rdf". Pictures in 
     *' directory can be operated on directly using "mfo" commands.  
     *' A file of the directory of stored pictures (named pppdir.dat)
     *' is created and continuously updated. 
     *'
     *'   Entering CTRL<d> for any prompt will return you to ppp,
   **NOTE** however, 3 CTRL<d>s in a row in ppp will end ppp.
   Files created by ppp have the following qualifiers:
         Pictures: .pic,   Position file: .pos, 
         Photometry: .phm,   Surface profile: .sph
         Printronix plots: .vec,  C2 vs mag plot: .pc2
         Object map plot: .map,  Simulation file: .sim

   To make a copy of the manual use the command "phelp"

   LIST OF AVAILABLE COMMANDS BY TOPICS
    pp - overview of ppp
    io - I/O COMMANDS
    op - OPERATION COMMANDS
    ds - INTERACTIVE DISPLAY (TV AND GRAPHICS) COMMANDS
    cc - GRAPHICS CURSOR COMMANDS
    st - STATISTICS COMMANDS
    ph - PHOTOMETRY COMMANDS
    ms - MISCELLANEOUS COMMANDS
    pf - OBJECT POSITION FILE MANIPULATION SUBSECTION
    mf - MULTIPLE FILE OPERATOR SUBSECTION
    si - SIMULATION OF IMAGING DATA


 INPUT/OUTPUT
   rpds <F>  - read picture from DAO PDS tape into core.
   rfits <F> - read picture with FITS format  from tapes into core.
   rffd <F>  - read picture with FITS format on disk into core
   rewd      - rewind FITS tape and set file counter to 0.
   rdisk <F> N - read picture from disk into core frame <F>.
   rdf   <F> I - read PPP Directory file no. I into frame <F>.
   rdao/rfig  <F> N - read picture in DAOPHOT/FIGARO format into <F>.

   rvis <F> N - read VISTA FITS format disk picture
   wdao/wfig  <F> N - write <F> to DAOPHOT/FIGARO format
   wdisk <F> N S - write picture to disk and create DIR entry.
   print <F> - print out sub block of the picture on PRINTER.
   tty <F> 4I - type out sub block of the picture on TERMINAL.
   rowp <F> 2I S - plot cut in I (fixed J) direction, .
               Option of sum over J's and Printronix plot.
   colp <F> 2I S - same as ROWP, but in J (fixed I) direction.
   ptsp <F> 4I - plot cut between two pionts (bilinear interp.)
   blck <F>  - type picture in NXN averaged block.


 PICTURE OPERATIONS
   par S S- PICTURE ARITHMETICS, perform a completely generalized
              arithmetical expression with any combination of core frames,
              done in real numbers. 2nd string (BOXn) defines the box number
   car <F> S S- CONSTANT ARITHMETICS, see "par".
   pdiv 3F R - Const*P1/P2, place result in P3, Const, P1,2,3, to be requested.
   aver 3<F> - average frame 1 and 2, store in 3 (same size).
   sum 3<F>  - sum frame 1 and 2, store in 3 (same size).
   ssum 3<F> - add <1> to <2>, diff size, arbitrary int shift.
   ssub 3<F> - same as "ssum", but subtract <2> from <1>.
   amag <F>  - convert pixel by pixel to magnitudes .
   medp S F - create a median frame of 3 or 4 frames (only).
   shift <F> 2R - picture shifting, (conserving intensity).
   sshift <F> 2R - picture shifting using SINC interpolator.
   rot  <F>  3R - picture rotation about a given pixel.
   r90  <F>  - rotate picture by 90 deg clockwise.
   r90c <F>  - rotate picture by 90 deg c-clockwise.
   r180 <F>  - rotate picture by 180 degrees.
   trans <F> - transpose picture.(i.e., (I,J) to (J,I))
   miri  <F>  - mirror picture about I axis. (J==>NJJ-J+1)
   mirj  <F>  - mirror picture about J axis. (I==>NII-I+1)
   medf <F> 4I - median filter a section of frame F, size of filter requested.
   smooth <F> I - smooth with N X N mean filter.
   tsmooth <F> I - smooth with N X N tapered mean filter.
   cmap <F1> <F2> - create colour map using F1 and F2.
   psfs <F1> I - PSF subtraction.
   mpsfs <F1> I - PSF sub of <11 objs of known shifts & scales.
   psfm <F1> - iterative recentroiding of PSF to find best match' with obj.
   cpsf <F1> I - iteratively centering obj to an int. centroid.
   shr <F> R  - shrink image by factor (real) to 0,0 corner.
   shk <F> I  - shrink image by factor (integer) to 0,0 corner
   trim <F>  - trim frame <F>.
   cut  <F> I - cut picture within specified corners.
   paste <F> I - cut part of frame F to put in frame I.
   sscale  <F> - scale a subsection of a picture.
   sflat <F> - self-flattening, using modal value of small blks
   rflat <F>  - self-flattening in J direction using row modes.
   cflat <F>  - self-flattening in I direction using col modes.
   prfl/pcfl  - same as rflat/cflat, but for part of picture.
   fixp <F>  - fix bad pixels for Steward data.
   crbp <F>  - create mask frame for "bpfix".
   bpfix <F> - fix bad pixels using a mask defined by "crbp".
   scbr <F>  - scale bad rows using neighbouring rows.
   scbc <F>  - scale bad columns using neighbouring columns.
   flbc <F>  - fill bad columns using neighbouring columns.
   flbr <F>  - fill bad rows using neighbouring rows.
   clcr <F1> <F2> - suppress cosmic rays using TWO frames.
   snar/np <F> - search and replace all pix less than threshold.
   conv 3<F>  - convolve <1> and kernel <2>, store in <3>.
   fudg <F> 3I - replace a particular pix with entered value..
   crm1 <F1> (F2) BOXn -- create cosmic ray map using 1 frame within BOXn.
   crm2 <F1> <F2> - create a map of cosmic rays using 2 frames.
   cona <F1> <F2> - create a map of connected areaes above a thershold.
   rppi <F1> <F2> - replace pixels from 1 by 2 using a map.
   rppo <F1> <F2> - as  rppi, but exclude area near objects.


 STATISTIC COMMANDS:
   pstat <F> - AVERAGE, SIGMA, MAX and MIN pixel of <F> within window.
   rstat <F> - AVERAGE, SIGMA, MAX and MIN of row.
   cstat <F> I - AVERAGE, SIGMA, MAX and MIN of column.
   pmode <F> I - MODE and MEDIAN of <F> within window or box.
   rmode <F> I - MODE and MEDIAN of row.
   cmode <F> I - MODE and MEDIAN of column.
   rsmode <F> S - MODES and MEDIANS of a number of rows.
   csmode <F> S - MODES and MEDIANS of a number of columns.
   nega <F> I - list all pixels less than I (dflt=0).
   box I -  set box number (1-9) for statistics etc.
   boxc I 4I - set co-ord of box I, entering central pix+extend
   boxa I 4I - set co-ord of box I, entering edge pix+extend
   boxe I 4I - set co-ord of box I, entering ending pix co-ords
   sky  <F>  - Calculate sky value using various geomteric shapes.


 PHOTOMETRY COMMANDS
   qfind <F> N S R - Quick object finding routine.
   find <F> " - locate objects above a threshold (KRON).
   fins <F> " - same as "find", but uses a shrunken array.
   afin <F> " - same as "find", but uses ring aperture for sky.
   afim <F> " - Same as "afin", with masking capability.
   sfin <F> " - Same as "afin", but uses a shrunken array.
   cfin <F> N S - object finding by area connection.
   ccen <F>  - semi-automatic iterative routine for finding
               the best centroids for objects in POS file.
   acen <F>  - completely automatic version of "ccen".
   cent <F> 4I - determine centroid using fractional pixels.
   phot <F> N S 2I - Derive total intensity, centroid, peak value, and
                 ellipticity of object from positions in the position file.
   1phot <F> 4I - same as "phot", for a single object.
   lphot <F> 4I -same as "1phot", with option to repeat inputs
   aupho <F> N S 2I - same as "phot", for a series of 
                apertures to determine the best magnitude
   1auph <F> 3I - same as "aupho", but for a single object.
   lauph <F> 3I - same as "1auph", but with option to repeat.
   aucp  <F> 3I - crowded-field aperture photometry.
   ppph  <F>  - partial-pixel crowded-field aperture photometry.
   apph  <F>  - "ppph" with auto selection for reference stars.
   sphot <F> - surface photometry of an object (circular apt).
   ssph  <F> - sectional surface photometry of an object.
   isop  <F> - isophotal surface photometry.
   cc1 <F1> <F2> F - correct for colour term for 1 & 2.
   rpof <F>  - read position file for "phot" or "aupho".
   rrpof <F> - read position file with real number input.


 MISCELLANEOUS COMMANDS
   %  - (1st character in command string) denotes csh commands.
   help      - if you are reading this, you already know about this.
   phelp     - output HELP file onto a file for printing.
   hist      - type out the previous 40 commands.
   savh      - save in a file the  previous 40 commands.
   set N I/R - set (to I/R) or display program parameters
   see <F>   - estimate FWHM (seeing) of an object
   cc        - enter into calculator mode.
   posf      - to enter POSITION FILE MANIPULATION SUBSECTION
   mfo       - to enter MULTIPLE FILE OPERATION SUBSECTION
   size <F>   - give size of picture F and ask for new size.
   dir I I   - type picture directory on terminal.
   del N     - delete a picture file from disk and the DIRECTORY LISTING.
   msize     - show/set maximum picture size allowed in core
   mac1/2    - run macro file ppp.macro1/2 
   macr s    - run macro file s.macro.  Macro file MUST end with end
  ! - denotes comment line
   stop or quit     - to quit.
   e I1 (I2) - execute commands I1 (to I2).
   -i        - repeat the ith command back of the current one.
   COMMANDS for Hickson'S PHOTON COUNTING IMAGES:
        rhic,whic,corh,snak,dsin,ur1,ur2,shear,sfuz
   Other random COMMANDS: wvcm

 POSITION FILE (PF) MANIPULATION COMMANDS:
   Enter by issuing "posf" in ppp, to return to ppp,
   enter "q" or "ppp".  Commands have the same format as ppp.

 COMMANDS AVAILABE:
   t <F> 2I    - type PF for frame <F> between #I1 and I2.
   tp <F> 2I    - type PF for frame <F> between pix J1 & J2.
   save <F> N S - save PF in disk.
   rpof <F> N - read PF from disk for frame <F>.
   rpau <F> N - read integer PF from disk "auph" file for <F>.
   rrpau <F> N - read real PF from disk "auph" file for <F>.
   edit <F>  - edit position file <F>
   merp <F>  - merge close objects into one
   trim <F>  - trim position file <F> to within I,J limits.
   del <F>   - delete position file <F>, (set NOB to 0).
   rec <F>   - recover deleted PF <F> (reset NOB).
   shift <F1> 2I - integer shift of co-ordinates in PF <F>.
   copy <F1> <F2> - move (copy) position file of frame 1 to 2
   comb <F1> <F2> - combine position file of frame 1 & 2
   rcros <F1> <F2> - cross-correlate PF of <F1> & <F2> using REAL centroids.
   icros <F1> <F2> - cross-correlate PF of <F1> & <F2> (Integer centroids

 MULTIPLE FILE COMMANDS:
  To enter this subsection issue the command "mfo", to return to'   ppp type q.  Commands in this sublevel allow operations to be
   performed directly on a set of pictures IN THE DISK(changing
   them!!). Parameter IPURGE sets the on-off switch for purging
   the oringal files.  After issuing the command, a file number
   sequence is requested.  Numbers in the sequence must be
   separated by blanks or a dash: e.g. 2 5 8-11 18 means operate
   on files 2,5,8,9,10,11,18.  **NOTE** Here, FILE means file
   numbers of the disk DIR and in some some cases, file numbers
   on tape.  Alternatively, one can enter with the file sequence
   (" enclosure not necessary) at the same time as the command.
   Disk files with qualifiers other then .pic will be rejected
   by mfo commands.  
   COMMANDS AVAILABLE with same meaning as those in ppp are:
       rfit,trim,pdiv,fixpic,del,r90,r90c,r180,miri,mirj,bpfix,
       scbr,scbc,flbr,flbc,rflat,cflat,prfl, and pcfl.

 --Plus the following additional COMMANDS :

   wfit  - write frames to tape in FITS format (simple header) 
   mpic  - match frames according to references by trimming.
   com   - change comment field of DIR pictures.
   bias  - Subtract a constant determined from a section of pic
   psub - Subtract a designated frame from the files.
   fdiv - Same as "pdiv", with auto scaling when dividing frame.
   wsum - Sums N pictures with weights.
   aver - average of N pictures.
   waver - average of N pictures with weights.

     To do PRELIMINARY REDUCTION, i.e.: flatfielding, bias sub.,
   etc., use a combination of "bias", "trim", "psub", and 
"fdiv".
   At this point, no provision exists for multiple defringing.


 DISPLAY COMMANDS (system dependent, Tek compatible terminal assumed)
 **** Co-ordinate convention: for all display commands and most
   other commands, the 1st co-ord is I (or X), 2nd, J (or Y).
   Pictures are displayed with (1,1) at upper right hand corner
   with I increasing downward and J increasing to the left.

   sdis <F> - display two-level picture on graphics terminal.
              ...see help sd for cursor command menu...
   curp <F> - type the last 10 cursor readings from "sdis"

  The following are PGplot commands (subcomands help=m):
   cplt <F> S - contour plot of section of <F1> on device S.
   pltf    - plot one data set vs another from 1 or 2 VMS files.
   hard <F>  - two-level hard copy plot file of picture.
   nhard <F> - same as "hard", but with object position marked and numbered.
   nplt <F>  - same as "hard", but plot position file only.

   sdis/cplt Cursor Commands:
  h -- home (return to ppp)
  s -- show image (sdis only)
  c -- type co-ordinate of cursor and save in cursor file
  e -- erase image and re-display
  n -- plot object positions from position file
  m -- plot object positions from file of another frame
  f -- change frame number for display
  l + r -- zoom region defined by 'l' cursor = lower left
          and 'r' cursor value = upper right
  z + v -- zoom in region definded by z and v cursor values  u -- unzoom
  y -- display image with entry boundry points
  b -- defining a box
  a -- adding an object to the position file
  d -- deleting a list of objects from position file
  x -- deleting an object from the position file
  p -- making a hardcopy file of the plot
  + -- computing centroid of region around cursor
  * -- aperture photometry of object marked by cursor
  w -- compute FWHM (see) of object marked by cursor
  k -- compute sky of a circular region marked by cursor


  SIMULATION COMMANDS: Simulate CCD direct imaging,
     data files for simulation are label as .sim. ++ Simulation
     will destroy all frames in core. ++  Cluster simulation
     requires a .cls file created by the program GCA.
     Parameter NCOSRAY: cosmic ray rate, MODGAL: galaxy model.

   makd - create an image, entered (tty or .sim file) x,y,mag.
   makl - same as "makd" , but creates only .sim file.
   gend - create an image, randomly generated x,y,mag.
   genl - same as "gend" , but creates only .sim file.
   gcld - create an image of a cluster at z.
   gcll - same as "gcld" , but creates only .sim file.
   gcbd - create an image of a cluster at z + background objs.
   gcbl - same as "gcbd" , but creates only .sim file.
   mcbd - same as "gcbd", but background objs from .sim file.
   mcbl - same as mcbd , but creates only .sim file.
   rpsm <F> - creat posf file from .sim(ulation) file.
   make <F>  - create an image of simple Gaussian PSFs.
