C Subroutine scrdis - an intgeractive graphic screen image display facility
c
c  usage: nfra(5) contains nfra(1)=frame number, and (2) to (4) are optional
c          initial display limits
c
c         non-interactive plot device will cost an abort
c
c  sdis cursor commands:
c
c     'h' -- home (return to ppp)
c     '?' -- print out help menu
c     's' -- show image
c     'c' -- type co-ordinate of cursor and save in cursor file
c     'e' -- erase image and re-diaplay
c     'n' -- plot object positions from position file
c     'N' -- plot object positions with numbers marked
c     'm' -- plot object positions from position file of another frame
c     'M' -- same as m, but with numbers marked
c     'f' -- change frame number for display
c     'l' + 'r' -- zoom in region defined by 'l' cursor value = lower left and
c                                            'r' cursor valuse = upper right
c     'z' + 'v' -- zoom in region definded by 'z' and 'v' cursor values
c     'u' -- unzoom
c     'y' -- display image with entry boundry points
c     'b' -- defining a box
c     'a' -- adding an object to the position file
c     'd' -- deleting a list of objects from position file
c     'x' -- deleting an object from the position file
c     'p' -- making a hardcopy file of the plot
c     '+' -- computing centroid of region around cursor
c     '*' -- aperture photometry of object marked by cursor
c     't' -- type out a 10X10 region around cursor
c     'w' -- compute FWHM (see) of object marked by cursor
c     'k' -- compute sky value of circular region marked by cursor
c        
	SUBROUTINE scrdis(*,nfra,scom,ix,nu,nv,kf)
c	INTEGER*2 IX(NU,NV,KF),nndo(50)
	INTEGER IX(NU,NV,KF),nndo(50)
	INTEGER nfra(5),idumnfr(5)
	CHARACTER STR1*20,ch*1,DEVICE*18,scom*60,IAN*1,NAM*16
     *              ,lab*30,dev*18,hplot*18,splot*18,obnum*4
     *              ,dumstr1*30,dumstr2*30,chtemp*1
	INCLUDE 'picdir.inc'
	include 'ppparm.inc'
        include 'objcat.inc' 
	common/plotdev/ hplot,splot,ipinit
	nfr=nfra(1)
	idumnfr(1)=nfr
	dumstr1='1'
	dumstr2='2'
	icl=1
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001   read(scom(1:1),8,err=120) itest
 8	format(i1)
	  device=splot
	  go to 121
 120	  device=scom
 121	if (device.ne.'/sun'.and.device.ne.'/tek'.and.device.ne.
     *    '/xwin') then
	  write(idout,*) ' *** illegal device for interactive sdis ***'
	  return1
	end if
	lab='F#'
901  	NI=NII(NFR)
	NJ=NJJ(NFR)
	ils=1
	if (nfra(2).eq.0.and.nfra(4).eq.0) then
c  whole picture
c     co-ordinate convention: y axis = I = first array variable
c                             x axis = J = second array variable
c        nfra holds: min i, min j, max i and max j respectively
	  ymin=1.0
	  ymax=float(ni)
	  xmin=1.0
	  xmax=float(nj)
	else
	  nfra(2)=max0(1,min0(ni,nfra(2)))
	  nfra(3)=max0(1,min0(nj,nfra(3)))
	  nfra(4)=max0(1,min0(ni,nfra(4)))
	  nfra(5)=max0(1,min0(nj,nfra(5)))
	  ymin=nfra(2)
	  xmin=nfra(3)
	  ymax=nfra(4)
	  xmax=nfra(5)
	end if
 904	imin=nint(ymin)
	imax=nint(ymax)
	jmin=nint(xmin)
	jmax=nint(xmax)
	k1=max0(nint(ymin+(ymax-ymin)/3.-15.),nint(ymin))
	k2=min0(k1+30,nint(ymax))
	k3=max0(nint(xmin+(xmax-xmin)/3.-15.),nint(xmin))
	k4=min0(k3+30,nint(xmax))
c	write(6,*) ni,nj,k1,k2,k3,k4
	  CALL PSTAT(*905,NFR,K1,K3,K2,K4,RMODE,SIG,NDUM,-1,IX,NU,NV,KF)
 905	    WRITE(idout,15) rmode,sig 
 15	FORMAT('  Sky=',f10.1,'  sigma/pix=',f9.2,/
     *    '   ENTER plot level in units of sigma (dflt=2.5): ',$)
	    rmult=0.00000
	    call read1r(rmult,*999,*905)
	  IF (RMULT.lt.0.0001) RMULT=2.5
	  if (rmult.lt.0.0001.or.sig.le.0.00001) then
	    ipthres=nint(rmode+1.)
	    ipth2=ipthres+10
	  else
	    IPTHRES=INT(RMODE+RMULT*SIG)
	    IPTH2=(RMODE+7.*RMULT*SIG)
	  end if
	  call openpg(device,ipinit,*999)
	if (device.eq.'/sun'.or.device.eq.'/xwin') then
	  call pgscr(0,red,green,blue)
c blue colour -- hue=15 light=.65
	  call pgshls(0,hue,light,sat)
	  call pgsci(ici)  
	end if
 910	CALL PGENV(xmax,xmin,ymax,ymin,1,0)
	CALL PGLABEL('J/y Axis','I/x axis',lab)
c  axes have been set up, now wait for command
c
c...............READ cursor....................
 920	call pgcurse(x,y,ch)
c  h key for quiting
	if (ch.eq.'h') then
	  go to 998
c 's' key for display (show)
	else if (ch.eq.'s') then
C Plot image
	  DO 101 J=jmin,jmax
	    DO 101 I=imin,imax
	      IF (IX(I,J,NFR).LT.IPTHRES.OR.IX(I,J,NFR).GT.IPTH2) GOTO 101
	    CALL PGPOINT(1,FLOAT(J),FLOAT(I),-1)
 101	  CONTINUE
c  'e' for erase
	else if (ch.eq.'e') then
	  call rbell(1)
	  ils=0
	  go to 905
c '?' for help
	else if (ch.eq.'?') then
	  call help(*920,'TT','cc')
c 'n' or 'N' for plotting object file
	else if (ch.eq.'n'.or.ch.eq.'N') then
C plot object file
	  IF (NFR.GT.nposfil) THEN
	    WRITE(idout,*) ' *** OBJECT FILE NUMBER MUST BE <= ',
     *               nposfil,'  ****'
	    go to 920
	  END IF
	  call pgsci(13)
	  UP=ABS(YMIN-YMAX)*.019
	  DO 105 I=1,NOB(NFR)
	    XB=IJOI(I,NFR)
	    YB=IJOJ(I,NFR)
	    CALL PGPOINT(1,YB,XB,10)
	    if (ch.eq.'N') then 
	      istat=encode(obnum,float(i),1,0,idum)
	      CALL PGTEXT(YB,XB-UP,obnum)
	    end if
 105	  CONTINUE
	  call pgsci(ici)
	  go to 920
c 'm' for plotting object file from another frame
	else if (ch.eq.'m'.or.ch.eq.'M') then
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
 606	  write(idout,20) 
 20	format(' Enter posf number: ',$)
	  call read1i(ipf,*998,*606)
	  if (ipf.gt.nposfil.or.ipf.lt.1) go to 606
	  UP=ABS(ymin-ymax)*.018
	  call pgsci(8)
	  DO 106 I=1,NOB(ipf)
	    XB=IJOI(I,ipf)
	    YB=IJOJ(I,ipf)
	    CALL PGPOINT(1,YB,XB,7)
	    if (ch.eq.'M') then
	      istat=encode(obnum,float(i),1,0,idum)
	      CALL PGTEXT(YB,XB+UP,obnum)
	    end if
 106	  CONTINUE
	  call pgsci(ici)
c  'f' for switching frame 
	else if (ch.eq.'f') then
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
 607	  write(idout,21) 
 21	format('  Enter new frame #: ',$)
	  call read1i(nfr,*998,*607)
	  call querynfr(nfr,kf,0,*998,*907)
 907	  idumnfr(1)=nfr
	  go to 905
c 'u' to display the whole picture (ie, unzoom)
	else if (ch.eq.'u') then
	  xmin=0.
	  xmax=float(NJ)
	  YMIN=0.
	  YMAX=float(ni)
	  go to  904
c 'g' to reset to boundry at entrance point
	else if (ch.eq.'y') then
	  xmin=float(nfra(3))
	  xmax=float(nfra(5))
	  ymin=float(nfra(2))
	  ymax=float(nfra(4))
	  go to 904
c
c 'l' and 'r', or 'z' and 'v' for zooming
	else if (ch.eq.'l'.or.ch.eq.'r'.or.ch.eq.'z'.or.ch.eq.'v') then
	  ymax=y
	  xmax=x
	  chtemp=ch
	  call pgcurse(x,y,ch)
	  if (ch.eq.chtemp) then
c   2 keys the same in a row --> cancel zooming operation
	    go to 920
	  else if (ch.eq.'r') then
	      ymin=y
	      xmin=x
	  else if (ch.eq.'l') then
c   allow inverse zooming (exchanging left and right corner)
	      ymin=ymax
	      xmin=xmax
	      ymax=y
	      xmax=x
	  else if (ch.eq.'v'.or.ch.eq.'z') then
c   zooming always in the right orientation
	      ymin=y
	      xmin=x
c check for orientation
	      if (xmin.gt.xmax) then
c  swap
	        dt=xmin
	        xmin=xmax
	        xmax=dt
	      end if
	      if (ymin.gt.ymax) then
	        dt=ymin
	        ymin=ymax
	        ymax=dt
	      end if
	  end if
c  check limits
	  if (abs(xmax-xmin).lt.1.) go to 920
	  if (abs(ymax-ymin).lt.1.) go to 920
	  xmin=amax1(1.,amin1(float(nj),xmin))
	  xmax=amax1(1.,amin1(float(nj),xmax))
	  ymin=amax1(1.,amin1(float(nj),ymin))
	  ymax=amax1(1.,amin1(float(nj),ymax))
	  go to 904
c
c 'c' for co-ordinate
	else if (ch.eq.'c') then 
	  lx=nint(x)
	  ly=nint(y)
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  write(idout,10) y,x,ix(ly,lx,nfr)
 10	format(1x,2f6.1,I6)
	  call savecur(ly,lx,0)
c 'b' for defining a box
	else if (ch.eq.'b') then
	  lx=nint(x)
	  ly=nint(y)
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  write(idout,10) y,x,ix(ly,lx,nfr)
	  call savecur(ly,lx,0)
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
 610	  WRITE(idout,34)
 34	FORMAT(/' Enter BOX# & extends in I,J:(!3 integers!): ',$)
	  call readi4(3,nbo,iex,jex,*998,*610,*2100,*2100)
 2100	  CALL MAKEBOX(*920,NBO,LY,LX,IEX,JEX,'DUM',-2)
c
c 'a' for adding an object to the position file
	else if (ch.eq.'a') then
	  IF (NFR.GT.nposfil) THEN
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	    WRITE(idout,*) ' FRAME #>=',nposfil,', NO POSITION FILE'
	    GO TO 920
	  END IF
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  WRITE(idout,10) y,x 
	  IIT=nint(y)
	  IJT=nint(x)
C  check for neighboring pixels for largest value
	  II=IIT
	  IJ=IJT
	  DO 140 M=MAX0(1,IJT-1),MIN0(NJJ(NFR),IJT+1)
	    DO 140 L=MAX0(1,IIT-1),MIN0(NII(NFR),IIT+1)
	      IF (IX(L,M,NFR).GT.IX(II,IJ,NFR)) THEN
	        II=L
	        IJ=M
 	      END IF
 140	  CONTINUE
	  CALL ADDOBJ(II,IJ,INN,NFR)
	  call pgsci(2)
	  CALL PGPOINT(1,float(ij),float(ii),8)
	  call rbell(1)
	  call pgsci(ici)
c
c 'd' for deleting a list of objects from position file
	else if (ch.eq.'d') then
	  IF (NFR.GT.nposfil) THEN
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	    WRITE(idout,*) ' FRAME #>=',nposfil,', NO POSITION FILE'
	    GO TO 920
	  END IF
	  if (device.ne.'/sun'.and.device.ne.'/xwin')
     *         call lskip(idout,ils)
	  WRITE(idout,49) 
 49	 FORMAT(' Enter obj #s to be deleted ',$)
	  DUMSTR1=' '
	  CALL MFNUM(DUMSTR1,30,NNDO,50,NND,0)
	  CALL DELOBJ(NNDO,NND,NFR)
c
c 'x' for deleting an object from the position file
	else if (ch.eq.'x') then
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *        call lskip(idout,ils)
	  WRITE(idout,10) Y,X
	  IIT=nint(y)
	  IJT=nint(x)
	  CALL ZAPOBJ(NFR,IIT,IJT,IIR,JJR,IDEL)
	  IF (IDEL.EQ.1) THEN
	    call pgsch(2.)
	    call pgsci(2)
	    call pgpoint(1,float(jjr),float(iir),5)
	    call pgsci(ici)
	    call pgsch(1.)
	    call rbell(1)
	  END IF

c 'p' for making a hardcopy file of the plot
	else if (ch.eq.'p') then
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *        call lskip(idout,ils)
 609	  WRITE(idout,*) '  Enter title,    20 characters maximum:'
	  call readstr(20,str1,*998,*609)
	DO 309 K=1,12
	  IAN=STR1(K:K)
	  IF (IAN.NE.' ') GO TO 308
 309	CONTINUE
 308	DO 310 I=K,12
	  IAN=STR1(I:I)
	  IF (IAN.EQ.' '.OR.IAN.EQ.'.'.OR.IAN.EQ.'-'.OR.IAN.EQ.'+')
     *        GO TO 311
 310	CONTINUE
 311	IF (I-1.GE.K) THEN
	  NAM=STR1(K:I-1)//'.map'
	ELSE
	  NAM='gplot.map'
	END IF
 18	FORMAT(A8)
 19	FORMAT(A20)
 602	WRITE(6,60)
 60	FORMAT('   Enter plot device name (/xwin,/tek,/sun,'/
     *      '       default=/ps : '   ,$)
	call readstr(18,dev,*998,*602)
 770	IF (DEV.EQ.'/tek'.or.dev.eq.'/sun'.or.dev.eq.'xwin') THEN
	  DEVICE=DEV
c	elseif (dev.eq.'/sun'.or.dev.eq.'/xwin') then
c	  device=dev
	ELSE
	  IF (DEV.EQ.' ') THEN
	    DEVICE=NAM//'/ps'
	  ELSE
	    DEVICE=NAM//DEV
	  END IF
	  WRITE(6,312) NAM
	END IF
 312	FORMAT(1X,'  --- PG Plot-file named: ',A16)
c 'w' for computing FWHM
	else if (ch.eq.'w') then
	  idumnfr(2)=nint(y)
	  idumnfr(3)=nint(x)
	  idumnfr(4)=21
	  idumnfr(5)=55
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  call apdri(*920,idumnfr,dumstr1,dumstr2,3,ix,nu,nv,kf)
c 't' for type out a region of 10X10 around cursor
	else if (ch.eq.'t') then
	  idumnfr(2)=nint(y)
	  idumnfr(3)=nint(x)
	  if(device.eq.'/sun'.and.device.ne.'/xwin') then
	    idumnfr(4)=11
	    idumnfr(5)=11
	  else
	    idumnfr(4)=7
	    idumnfr(5)=7
	    call lskip(idout,ils)
	  end if
	  call printz(*920,idumnfr,dumstr1,0,ix,nu,nv,kf)
c '+' for computing centroid
	else if (ch.eq.'+') then
	  idumnfr(2)=nint(y)
	  idumnfr(3)=nint(x)
	  idumnfr(4)=5
	  idumnfr(5)=49
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  call dpcent(*920,idumnfr,ix,nu,nv,kf,0)
c '*' for aperture photometry
	else if (ch.eq.'*') then
	  idumnfr(2)=nint(y)
	  idumnfr(3)=nint(x)
	  idumnfr(4)=0
	  idumnfr(5)=0
	  if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call lskip(idout,ils)
	  call phodri(*920,idumnfr,scom,scom,1,ix,nu,nv,kf)
	end if
	go to 920
 998	if (device.ne.'/sun'.and.device.ne.'/xwin') 
     *       call closepg(ipinit)
 999	RETURN1
	END

c/////////////////////////////////////////
c
c
	subroutine lskip(idout,ils)
	do 100 i=1,ils
 100	  write(idout,*) 
	ils=ils+1
	return
	end
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE TO ADD AN OBJECT TO POSF FILE AND RE-ARANGE
C
	SUBROUTINE ADDOBJ(II,IJ,INN,NFR)
        include 'objcat.inc' 
	IF (NFR.GT.nposfil) RETURN
	if (nob(nfr).eq.nobmax) then
	  write(6,1) nobmax
 1	format('  ++ Position file buffer full (',i5,' objects)')
	  return
	end if
	IF (NOB(NFR).EQ.0) THEN
	  NOB(NFR)=1
	  IJOI(1,NFR)=II
	  IJOJ(1,NFR)=IJ
	  IDOB(1,NFR)=1
	  INN=1
	  RETURN
	END IF
	DO 100 I=1,NOB(NFR)
	IF (IJOJ(I,NFR).LE.IJ) GO TO 100
C  shift all objects with larger I co-ord down 1
	  DO 102 J=NOB(NFR),I,-1
	    IJOI(J+1,NFR)=IJOI(J,NFR)
	    IJOJ(J+1,NFR)=IJOJ(J,NFR)
	    IDOB(J+1,NFR)=IDOB(J,NFR)
 102	  CONTINUE
	  IDOB(I,NFR)=1
	GO TO 103
 100	CONTINUE
C  add new object
C   for the case of adding to the end of the list
	  IDOB(I,NFR)=1
 103	  IJOI(I,NFR)=II
	  IJOJ(I,NFR)=IJ
	INN=I
	NOB(NFR)=NOB(NFR)+1
	RETURN
	END

C
C///////////////////////////////////////////////////////////////////////
C
C SUBORUITNE TO REMOVE AN OBJECT FROM THE POSITION LIST
C
	SUBROUTINE ZAPOBJ(NFR,II,JJ,IIR,JJR,IDEL)
c	INTEGER*2 NODT(1)
	INTEGER NODT(1)
        include 'objcat.inc' 
	IDEL=0
	IF (NFR.GT.nposfil) RETURN
	call locobj(ii,jj,num,1,nob(nfr),ijoi(1,nfr),ijoj(1,nfr))
c no object located 
 	if (num.le.0) RETURN
c otherwise found object
 	IDEL=1
	IIR=IJOI(num,NFR)
	JJR=IJOJ(num,NFR)
	NODT(1)=num
	CALL DELOBJ(NODT,1,NFR)
	RETURN
	END
c/////////////////////////////////////////////////////
c  subroutine to locate an object from obj file to within idd pixel
c   of ii,jj
c    only works if the positions are sorted in j
c
	subroutine locobjold(ii,jj,num,idd,nob,ijoi,ijoj)
c	integer*2 ijoi(1),ijoj(1)
	integer ijoi(*),ijoj(*)
	IT1=II-idd
	IT2=II+idd
	JT1=JJ-idd
	JT2=JJ+idd
	DO 100 I=1,NOB
	  IF (IJOJ(I).LE.JT2) THEN
	    IF (IJOJ(I).GE.JT1) THEN
	      IF (IJOI(I).GE.IT1.AND.IJOI(I).LE.IT2) GO TO 105
	    END IF
	  ELSE
	    num=0
	    RETURN
	  END IF
 100	CONTINUE
 105	num=i
	return
	end
c/////////////////////////////////////////////////////
c  subroutine to locate an object from obj file to within idd pixel
c   of ii,jj. Return num=pppnumber, 0 if no object is found
c    this searchs for the whole position file
c
	subroutine locobj(ii,jj,num,idd,nob,ijoi,ijoj)
c	integer*2 ijoi(1),ijoj(1)
	integer ijoi(*),ijoj(*)
	IT1=II-idd
	IT2=II+idd
	JT1=JJ-idd
	JT2=JJ+idd
	DO 100 I=1,NOB
	  IF (IJOJ(I).LE.JT2) THEN
	    IF (IJOJ(I).GE.JT1) THEN
	      IF (IJOI(I).GE.IT1.AND.IJOI(I).LE.IT2) GO TO 105
	    END IF
	  END IF
 100	CONTINUE
c no object found
	num=0
	RETURN
c object found, number i
 105	num=i
	return
	end

C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO REMOVE UP TO ND OBJECTS FROM POSITION LIST AT A TIME
C
	SUBROUTINE DELOBJ(NDO,ND,NFR)
c	INTEGER*2 NDO(nd)
	INTEGER NDO(nd)
        include 'objcat.inc' 
	IF (NFR.GT.nposfil) RETURN
	DO 100 K=1,ND
 100	  IJOI(NDO(K),NFR)=0
	NOBORI=NOB(NFR)
	NOB(NFR)=NOB(NFR)-ND
	K=0
 101	  K=K+1
	  IF (K.GT.NOB(NFR)) RETURN
	  IF (IJOI(K,NFR).NE.0) GO TO 101
c if it is zero, move the next one up
	  DO 102 I=K+1,NOBORI
	    IJOI(I-1,NFR)=IJOI(I,NFR)
	    IJOJ(I-1,NFR)=IJOJ(I,NFR)
 102	    IDOB(I-1,NFR)=IDOB(I,NFR)
	  NOBORI=NOBORI-1
	  K=K-1
	GO TO 101
	END
