C
C         SUBROUTINE TO DERIVE SKY FROM BORDER OF A SQUARE.
C                 4 MODES ARE DETERMINED FROM THE 4 BORDER OF THICKNESS
C                 IBORD PIXELS.  THESE ARE AVERAGED.
C                 IC,JC = CO-ORDINATE OF CENTER
C                 IEXT, JEXT = EXTEND OF THE BOX FROM THE CENTER
C                 IMSKY=0: AVERAGE OF 4 EDGES, IMSKY=1: MEDIAN OF 4 EDGES
C                 SKY, SIG = RETURNED VALUES
C
	SUBROUTINE BORDERSKY(NFR,IC,JC,IEXT,JEXT,IBOR,SKY,FSIG,IMSKY,
     *                 nsky,IX,NU,NV,KF)
	DIMENSION RM(4),SIG(4),NPIX(4)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	INCLUDE 'picdir.inc'
	IB=IBOR-1
	IMIN=MAX0(1,IC-IEXT-IB)
	IMAX=MIN0(NII(NFR),IC+IEXT+IB)
	JMIN=MAX0(1,JC-JEXT-IB)
	JMAX=MIN0(NJJ(NFR),JC+JEXT+IB)
	CALL PSTAT(*100,NFR,IMIN,JMIN,IMIN+IB,JMAX,RM(1),
     *                SIG(1),NPIX(1),1,IX,NU,NV,KF)
 100	CALL PSTAT(*101,NFR,IMIN,JMIN,IMAX,JMIN+IB,RM(2),
     *                SIG(2),NPIX(2),1,IX,NU,NV,KF)
 101	CALL PSTAT(*102,NFR,IMAX-IB,JMIN,IMAX,JMAX,RM(3),
     *                SIG(3),NPIX(3),1,IX,NU,NV,KF)
 102	CALL PSTAT(*103,NFR,IMIN,JMAX-IB,IMAX,JMAX,RM(4),
     *                SIG(4),NPIX(4),1,IX,NU,NV,KF)
c ! simple average
 103	IF (IMSKY.EQ.0) THEN  
	  SKY=.25*(RM(1)+RM(2)+RM(3)+RM(4))
c    ! median
	ELSE               
	  CALL SLOMED(4,RM,SKY)
	END IF
	CALL CALSIG(FSIG,4,SIG,NPIX)
	nsky=npix(1)+npix(2)+npix(3)+npix(4)
	RETURN
	END
C
C////////////////////////////////////////////////////////////////////////
C
C  CALCULATE TOTAL SIGMA GIVEN A SET OF SIGMA AND NUMBER OF PTS FOR EACH
C
C
	SUBROUTINE CALSIG(FSIG,NS,SIG,NPIX)
	DIMENSION SIG(NS),NPIX(NS)
	SIGT=0.
	NPIXT=0
	DO 100 I=1,NS
	  SIGT=SIGT+(NPIX(I)-1)*SIG(I)*SIG(I)
	  NPIXT=NPIXT+NPIX(I)
 100	CONTINUE
	FSIG=SQRT(AMAX1(0.,SIGT/FLOAT(MAX0(1,NPIXT))))
	RETURN
	END
C/////////////////////////////////////////////////////////////////////////
C
C   SUBROUTINE FOR DETERMINING SKY VALUE OF PICTURE: option of various
c             geometric shapes
C       
	SUBROUTINE CSKY(*,NFR,ICT,JCT,SKY,SIG,nsky,IX,NU,NV,KF,INCODE)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	REAL SKARAY(50000)
	INCLUDE 'pppcore.inc'
	INCLUDE 'picdir.inc'
	EQUIVALENCE (iscr(1900001),SKARAY(1))
	include 'apert.inc'
	CHARACTER*1 CODE,INCODE
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	IF (INCODE.EQ.' ') THEN
 600	  WRITE(6,9) SKY,SIG
 9	FORMAT('   Current default sky',F10.3,',  sigma',F8.3,
     *       /'   Enter code: u=user supplied, r=ring, c=circle,',
     *   ' s=sectioned (8) ring',/,10x,'b=border of rectangle, <cr>',
     *      '=default: ',$)
	  call readstr(1,code,*999,*600)
	  IF (CODE.EQ.' ') THEN
	    WRITE(6,21) SKY,SIG
	    RETURN1
	  END IF
	ELSE
	  CODE=INCODE
	END IF
	IF (CODE.EQ.'u') THEN 
 6001	  WRITE(6,58) sky,sig
 58	FORMAT( '   Enter sky AND sigma/pixel (df:',f8.1,f7.3,'): ',$)
	  call read2r(sky,sig,*999,*6001)
	  nsky=0
	  GO TO 999
	ELSE
	  IF (ICT.EQ.0.AND.JCT.EQ.0) THEN
 601	    WRITE(6,10) IC,JC
 10	FORMAT('   Enter I,J co-ordinate of center point (default',2I5,
     *        '): ',$)
	    CALL READ2i(IC,JC,*999,*601)
	  ELSE
	    IC=ICT
	    JC=JCT
	  END IF
	  IF (CODE.EQ.'r'.OR.CODE.EQ.'c') THEN
	    IF (CODE.EQ.'r') THEN
 602	      WRITE(6,11) IAP1(1),IAP2
 11	FORMAT('   Default inner and outer diameters:',2I5,
     *   /'   --Enter inner and outer diameters (integers) of ring: ',$)
	      CALL READ2I(IAP1(1),IAP2,*999,*602)
	      CALL APARAY(IAP1(1),IT1(1,1),IROW1(1),QQ(1),RR(1),
     *                   PP(1),NA(1),1)
	      IRC=1
c ! circle
	    ELSE  
 6021	      WRITE(6,110) IAP2
 110	FORMAT('   Enter diameter (integer) of circle (default',I5,
     *         '): ',$)
	      CALL READ1I(IAP2,*999,*6021)
	      IRC=0
	    END IF
	    CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
	    CALL RCSKY(IRC,SKY,SIG,1,IC,JC,NII(NFR),NJJ(NFR),
     *                   IX(1,1,NFR),NU,NV,SKARAY,50000,nsky,1,IPR)
	  ELSE IF (CODE.EQ.'b') THEN
 603	    WRITE(6,12) ISI,JSI
 12	FORMAT('   Enter SIZE of box in I and J directions ',
     *           '(default',2I5,'): ',$)
	    CALL READ2I(ISI,JSI,*999,*603)
	    IEX=ISI/2
	    JEX=JSI/2
 604	    WRITE(6,13) IBOR
 13	FORMAT('   Enter border thickness in pixels (default',I4,'): ',$)
	    CALL READ1I(IBOR,*999,*604)
	    CALL BORDERSKY(NFR,IC,JC,IEX,JEX,IBOR,SKY,SIG,1,nsky,
     *              IX,NU,NV,KF)
	    WRITE(6,21) SKY,SIG
	   ELSE IF (CODE.EQ.'s') THEN
 605	      WRITE(6,11) IAP1(1),IAP2
	      CALL READ2I(IAP1(1),IAP2,*999,*605)
	    CALL APARAY(IAP1(1),IT1(1,1),IROW1(1),QQ(1),RR(1),PP(1),NA(1),1)
	    CALL APARAY(IAP2,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
	    CALL RING8SKY(SKY,SIG,1,IC,JC,NII(NFR),NJJ(NFR),
     *                   IX(1,1,NFR),NU,NV,SKARAY,50000,nsky,1,IPR)	    
	  END IF
	END IF
 21	FORMAT('   Modal Sky=',F11.4,4X,'Sigma/pix = ',F10.4)
 999	RETURN1
	END

C////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR DETERMINING SKY VALUE BY CUTTING A RING INTO 8 PARTS
C      IO,JO = CO-ORINATE (INTEGER*2)
C      RADIUS: IAP2=OUTER RADIUS, IAP(NAPP)=INNER RADIUS : IN COMMON BLOCK
C         ** must call APARRY to set IT's and IROW's before calling RINGSKY
C      SKY, ZSIG = RETURNED VALUE
C      SKYRAY, MSKY= ARRAY TO HOLD SKY VALUES, UP TO MSKY PIXELS
C
	SUBROUTINE RING8SKY(SKY,ZSIG,NNAP,IO,JO,NI,NJ,IX,NU,NV,
     *                      SKARAY,MSKY,nskk,IW,IPR)
c	INTEGER*2 IX(NU,NV)
	INTEGER IX(NU,NV)
	character ians*1
	DIMENSION SKARAY(MSKY),TSKY(8),ZTSIG(8),NSK(8),N3(8),NTPIX(8),
     *            INDEX(8)
	include 'apert.inc'
	INCLUDE 'ppparm.inc'
	K=0
	DO 110 I=1,4
 110	  NSK(I)=0
	MSEC=MSKY/4
	IPR=0
	JR1=JO-IROW1(NNAP)
	JR2=JO+IROW1(NNAP)
C  filling the  array for sky determination
	DO 100 J=MAX0(1,JO-IROW2),MIN0(NJ,JO+IROW2)
	  K=K+1
	  DO 101 I=MAX0(1,IO-IT2(K)/2), MIN0(NI,IO+IT2(K)/2)
	    IF (J.LT.JR1.OR.J.GT.JR2) GO TO 102
	    KK=IT1(K+IROW1(NNAP)-IROW2,NNAP)/2
	    IR1=IO-KK
	    IR2=IO+KK
	    IF (I.LT.IR1.OR.I.GT.IR2) GO TO 102
	    GO TO 101
C determine Section number
 102	    IF      (I.LE.IO.AND.J.LT.JO) THEN
	      NSEC=1
	    ELSE IF (I.GT.IO.AND.J.LE.JO) THEN
	      NSEC=2	 
	    ELSE IF (I.GE.IO.AND.J.GT.JO) THEN
	      NSEC=3	 
	    ELSE IF (I.LT.IO.AND.J.GE.JO) THEN
	      NSEC=4	 
	    END IF
	    NSK(NSEC)=NSK(NSEC)+1
	    IF (NSK(NSEC).GT.MSEC) GO TO 700
	    SKARAY((NSEC-1)*MSEC+NSK(NSEC))=FLOAT(IX(I,J))
 101	  CONTINUE
 100	CONTINUE
	NSKK=NSK(1)+NSK(2)+NSK(3)+NSK(4)
 700	IF (IW.EQ.1) THEN
	  WRITE(6,*) '   Total number of pixels in ring: ',NSKK
	END IF
 	IF (NSKK.LE.0) THEN
	  WRITE(6,*) ' **** Sky pixel number <= 0 ****'
	  IPR=999
	  RETURN
	END IF
	IF (MAX0(NSK(1),NSK(2),NSK(3),NSK(4)).GT.MSKY) THEN
 665	  WRITE(6,*) ' ++++sky pixel no >',MSKY,' pixels' 
c    *	              ,' DO YOU WANT TO CONTINUE? y/n'
c	  call readstr(1,ians,*999,*665)
c	  IF (IANS.EQ.'n') THEN
c	    IPR=999
c	    RETURN
c	  END IF
	  DO K=1,4
	    NSK(K)=MSK/4
	  END DO
	  WRITE(6,*) ' +++SKY DETERMINED FROM INCOMPLETE APERTURE+++'
	END IF
C determine sky in 8 sections using 1/2 of eachof the 4 quarters
	DO 115 I=1,4
	  IF (NSK(I).LE.6) THEN
	    N3(I)=0
	    GO TO 115
	  END IF
	  II1=(I-1)*2+1
	  II2=II1+1
	  MM=(I-1)*MSEC+1
	  NNSKY1=(NSK(I)+1)/2
	  NNSKY2=NSK(I)-NNSKY1
	  CALL MMM(SKARAY(MM),NNSKY1,
     *      N3(II1),ZMEAN,ZMED,ZMODE,ZTSIG(II1),ZSK,ZREJ,NIT,1.,ZM1)
	  IF (ZSK.GT.1.E08) THEN
	    TSKY(II1)=ZM1
	  ELSE
	    TSKY(II1)=SKCMED*ZMED-SKCMEAN*ZMEAN
C	    IF (ZMEAN.LT.ZMED) TSKY(II1)=ZMED
	  END IF
	    IF (IW.EQ.1) WRITE(6,12) II1,N3(II1),ZMEAN,ZMED,ZMODE,TSKY(II1)
 12	FORMAT(1X,I1,' pix#=',I5,1x,'mean,med,mod,sky:',4F10.3,F7.3)
	  CALL MMM(SKARAY(MM+NNSKY1),NNSKY2,
     *      N3(II2),ZMEAN,ZMED,ZMODE,ZTSIG(II2),ZSK,ZREJ,NIT,1.,ZM1)
	  IF (ZSK.GT.1.E08) THEN
	    TSKY(II2)=ZM1
	  ELSE
	    TSKY(II1)=SKCMED*ZMED-SKCMEAN*ZMEAN
C	    TSKY(II2)=ZMODE
C	    TSKY(II2)=0.5*(ZMODE +ZMED)
C	    IF (ZMEAN.LT.ZMED) TSKY(II2)=ZMED
	  END IF
	    IF (IW.EQ.1) WRITE(6,12) II2,N3(II2),ZMEAN,ZMED,ZMODE,TSKY(II2)
 115	CONTINUE
C throw out points with less then 60% of max pixels
	NMAXP=0
	DO I=1,8
	  IF (N3(I).GT.NMAXP) NMAXP=N3(I)
	END DO
	NCOMP=.6*NMAXP
	II=0
	NT=0
	SKYSUM=0.
	DO I=1,8
	  IF (N3(I).GE.NCOMP) THEN
	    II=II+1
	    TSKY(II)=TSKY(I)
	    ZTSIG(II)=ZTSIG(I)
	    NTPIX(II)=N3(I)
	    SKYSUM=SKYSUM+TSKY(I)
	  END IF
	END DO
	CALL MEMEMO(TSKY,II,IRET,INDEX,SKYAVE,SKYMED,SKYMOD,dumsig)
C reindex ZTSIG and NTPIX
	DO 160 I=1,IRET
	  N3(I)=NTPIX(INDEX(I))
	  TSKY(I)=ZTSIG(INDEX(I))
	  NT=NT+N3(I)
 160	CONTINUE
	CALL CALSIG(ZSIG,IRET,TSKY,N3)
	IF (IRET.GE.5) THEN
	  SKY=SKCMED*SKYMED-SKCMEAN*SKYAVE
	ELSE
	  SKY=SKYMED
	END IF
	WRITE(6,*) '   Sector ave,med,mode ',SKYAVE,SKYMED,SKYMOD
	WRITE(6,13) IRET,NT/IRET,SKY,ZSIG
 13	FORMAT(4X,I1,' sectors used (aver.',I4,' pix/sect)',3X,
     *        'sky=',F11.4,'  sig/pix=',F9.4)
 999	RETURN
	END 
C
C////////////////////////////////////////////////////////////////////
C
C SUBROUTINE FOR DETERMINING SKY VALUE OF A RING OR CIRCLE
C      IRC=1: RING,  IRC=0: CIRCLE
C      IO,JO = CO-ORINATE (INTEGER*2)
C      RADIUS: IAP2=OUTER RADIUS, IAP(NAPP)=INNER RADIUS : IN COMMON BLOCK
C         ** must call APARRY to set IT's and IROW's before calling RINGSKY
C      SKY, ZSIG = RETURNED VALUE
C      SKYRAY, MSKY= ARRAY TO HOLD SKY VALUES, UP TO MSKY PIXELS
C
	SUBROUTINE RCSKY(IRC,SKY,ZSIG,NNAP,IO,JO,NI,NJ,IX,NU,NV,
     *                      SKARAY,MSKY,N3,IW,IPR)
c	INTEGER*2 IX(NU,NV)
	INTEGER IX(NU,NV)
	character ians*1
	REAL SKARAY(MSKY)
	include 'apert.inc'
	INCLUDE 'ppparm.inc'
	K=0
	NSK=0
	IPR=0
	JR1=JO-IROW1(NNAP)
	JR2=JO+IROW1(NNAP)
C  filling the  array for sky determination
	IF (IRC.EQ.1) THEN
	  DO 100 J=MAX0(1,JO-IROW2),MIN0(NJ,JO+IROW2)
	    K=K+1
	    DO 101 I=MAX0(1,IO-IT2(K)/2), MIN0(NI,IO+IT2(K)/2)
	      IF (J.LT.JR1.OR.J.GT.JR2) GO TO 102
	      KK=IT1(K+IROW1(NNAP)-IROW2,NNAP)/2
	      IR1=IO-KK
	      IR2=IO+KK
	      IF (I.LT.IR1.OR.I.GT.IR2) GO TO 102
	      GO TO 101
 102	      NSK=NSK+1
	      IF (NSK.GT.MSKY) GO TO 700
	      SKARAY(NSK)=FLOAT(IX(I,J))
 101	    CONTINUE
 100	  CONTINUE
	ELSE
C Filing array for circle sky
	  DO 200 J=MAX0(1,JO-IROW2),MIN0(NJ,JO+IROW2)
	    K=K+1
	    DO 201 I=MAX0(1,IO-IT2(K)/2), MIN0(NI,IO+IT2(K)/2)
	      SKARAY(NSK)=FLOAT(IX(I,J))
	      NSK=NSK+1
	      IF (NSK.GT.MSKY) GO TO 700
 201	    CONTINUE
 200	  CONTINUE
	END IF
 700	IF (NSK.LE.0) THEN
	  WRITE(6,*) ' **** Sky pixel number <= 0 ****'
	  IPR=999
	  RETURN
	END IF
	IF (NSK.GT.MSKY) THEN
 665	  WRITE(6,*) ' +++sky pixel no >',MSKY,' pixels'
c    *	              ,' DO YOU WANT TO CONTINUE? y/n'
c	  call readstr(1,ians,*999,*665)
c	  IF (IANS.EQ.'n') THEN
c	    IPR=999
c	    RETURN
c	  END IF
	  NSK=MSKY
	  WRITE(6,*) ' +++SKY DETERMINED FROM INCOMPLETE APERTURE'
	END IF
	CALL MMM(SKARAY,NSK,N3,ZMEAN,ZMED,ZMODE,ZSIG,ZSK,ZREJ,NIT,1.,
     *             ZM1)
	IF (ZSK.GT.1.E08) THEN
	  SKY=ZM1
	ELSE
	  SKY=SKCMED*ZMED-SKCMEAN*ZMEAN
C	  SKY=ZMODE
C	  SKY=0.5*(ZMODE +ZMOD)
C	  IF (ZMEAN.LT.ZMED) SKY=ZMED
	END IF
	IF (IW.EQ.1) WRITE(6,12) N3,ZMEAN,ZMED,ZMODE,SKY,zsig
 12	FORMAT(' N_pix',I5,1x,'mean,med,mod,sky:',4F9.2,' sig',f9.2)
 999	RETURN
	END 
c/////////////////////////////////////////////////////////////////////
c
c  driving subroutine for compting global sky using a sampling of strips over
c     the whole picture
c         uses STRIPSKY
c
	subroutine stripmode(*,nfr,ix,nu,nv,kf)
c	integer*2 ix(nu,nv,kf)
	integer ix(nu,nv,kf)
	dimension nfr(5)
	include 'picdir.inc'
	include 'ppparm.inc'
c determine number of strips
	if (nfr(2).eq.0.and.nfr(3).eq.0) then
	  nfr(2)=1
	  nfr(3)=nii(nfr(1))
	  nfr(4)=1
	  nfr(5)=njj(nfr(1))
	end if  
	nst=min0(40,max0(20,(nfr(5)-nfr(4)+1)/20))
	call stripsky(nfr(1),nfr(2),nfr(4),nfr(3),nfr(5),nst,sky,
     *           sig,1,ix,nu,nv,kf)
	write(idout,2) sig/sky
 2	format('    sig/mode = ',f7.4)
	return1
	end
C
C///////////////////////////////////////////////////////////////////////
C
C  SUBROUTINE FOR DETERMINING SKY FROM  NST NUMBER OF ROW MODES
C      I1,J1 = TOP CORNER (SMALLER I,J)
C      I2,J2 = LOWER CORNER
C
	SUBROUTINE STRIPSKY(NFR,I1,J1,I2,J2,NST,SKY,SIG,IW,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	DIMENSION TSKY(40),TSIG(40),NPIX(40)
C  determine separation of strips
	IF (NST.GT.40) THEN
	  WRITE(6,*) '  +++ Too many rows, reset to 40 +++'
	  NSTR=40
	else if (nst.le.0) then
	  write(6,*) '  +++ rows=0, set to 40 +++'
	  nstr=40
	else	
	  NSTR=NST
	END IF
	ISEP=(J2-J1+1)/NSTR
	JROW=J1-ISEP/2
	IF (IW.EQ.0) THEN
	  ISTAT=-1
	ELSE
	  ISTAT=1
	END IF
	SIG=0.
	DO 100 K=1,NSTR
	  JROW=JROW+ISEP
	  CALL PSTAT(*100,NFR,I1,JROW,I2,JROW,TSKY(K),TSIG(K),NPIX(K)
     *               ,ISTAT,IX,NU,NV,KF)
 100	CONTINUE
	CALL CALSIG(SIG,NSTR,TSIG,NPIX)
	CALL SLOMED(NSTR,TSKY,SKY)
	npixtot=0
 	do 101 i=1,nstr
	  npixtot=npixtot+npix(i)
 101	continue
	WRITE(6,10) NSTR,SKY,SIG,npixtot
 10	FORMAT('  Sky from',I3,' rows: ',F10.3,'  sigma/pix: ',F9.3,
     *           '  total pixels used:',i5)
	RETURN
	END
c///////////////////////////////////////////////////////////////////
c  subroutine to compute overall sky average and sigma from the
c    whole image.
c    Values in nrow number of rows are chosen with a option of
c    blocking out certain area due to predefined position and radious
c    of bright stars (up to 5)
c    Each row is determined using MMM, and the final result is
c    the median of the rows
c
c     Feb 16, 2004, used in object finding, 
c
c     Jul 31, 2004, added masking: exclude masked pixels from the
c                    computation
c          nfm = 0 (or ge kf) assume no masking
c                otherwise, nfm is the mask frame number
c    Jul 8, 2008: modified so it takes the absolute value of the
c       pixel as the mask (allowing -1 to be masked pixels, from 2 tier
c        masks (actually the original algorithm already does that, only
c        accepting pixels with 0 mask values
c
c    Jul 27,08: modified so that it would deal with bright star
c           within the subroutine only if nfm<0
c      this is due to having making done explicitly outside in the mask file
c 
	subroutine rowskyval(nfr,nfmt,nrow,ni1,ni2,avsky,avsig,
     *                       ix,nu,nv,kf,*)
	integer ix(nu,nv,kf)
	dimension zray(20000),zmode(200),zsigma(200),bsradsq(5)
	include 'pppcore.inc'
	include 'picdir.inc'
c	equivalence (zray(1),iscr(1))
	common/bstarxy/nbstar,bstx(10),bsty(10),bsrad(10),bsmag(10)
c   determine the Y co-ordinate of the rows, starting from 0.03*njj,
c     as often edges are not good
	nfm=iabs(nfmt)
	jinit=nint(0.05*njj(nfr))
 	idy=nint(0.9*float(njj(nfr))/float(nrow))
c	idy=nint(float(njj(nfr))/float(nrow))
c make sure ni1 and ni2 are reasonable
	if (ni1.lt.1.or.ni1.gt.nii(nfr)-10) then
	  i1=1
	  write(6,*) ' ++boundry not reasonable',ni1,' changed to',i1
	else 
	  i1=ni1
	end if
	if (ni2.lt.10.or.ni2.gt.nii(nfr)) then
	  i2=nii(nfr)
	  write(6,*) ' ++boundry not reasonable',ni2,' changed to',i2
	else 
	  i2=ni2
	end if
	if (i1.ge.i2-10) then
	  i1=1
	  i2=nii(nfr)
	  write(6,*) ' ++region too small',i1,i2,' changed to full'
	end if
	if (nfm.le.0.or.nfm.ge.kf) then
	  imask=0
	else
	  imask=1
	end if
	if (nfmt.gt.0.or.nbstar.eq.0) then
c  no bright star to worry about
	  nav=0
 	write(6,*) 'delta y ',idy,' mask frame ',nfm,' mask? ',imask
	  do 100 j=1,nrow
 	    iy=nint(idy*(float(j)-.5))+jinit
c	    iy=nint(idy*(float(j)-.5))
	    npt=0
	    do 101 i=i1,i2
	      if (imask.eq.1) then
	        if (ix(i,iy,nfm).ne.0) goto 101
	      end if
	      npt=npt+1
	      zray(npt)=float(ix(i,iy,nfr))
 101	    continue
c to be commented out
c	write(6,*) ' row, j, npt ',j,iy,npt
c do not compute sky if too few pixels
	    if (npt.ge.200) then
	      nav=nav+1
	      call mmm(zray,npt,nz2,zmean,zmedian,zmode(nav),
     *                zsigma(nav),zskew,zreject,niter,1.,onemean)
c to be commented out
 	write(6,*) j,iy,' npt,mode,sig: ',npt,zmode(nav),zsigma(nav)
     *               ,nz2
c check if there are enough actual points to include the row
	      if (nz2.lt.100) then
	        write(6,*) '   ** too few pts after rejection, not used'
	        nav=nav-1
	      end if
	    end if
 100	  continue
c print out last row
 	  write(6,*) nrow,iy,' last row npt,mode,sig: ',npt,zmode(nav)
     *              ,zsigma(nav) ,nz2
	else
c bright star exists
	  do 120 k=1,nbstar
	    bsradsq(k)=bsrad(k)*bsrad(k)
 120	  continue
	  nav=0
	  do 110 j=1,nrow
 	    iy=nint(idy*(float(j)-.5))+jinit
c	    iy=nint(idy*(float(j)-.5))
	    npt=0
	    do 111 i=1,nii(nfr)
c compute distance sq to center of star
	      do 121 k=1,nbstar
	        ty=bsty(k)-float(iy)
	        tx=bstx(k)-float(i)
	        distsq=ty*ty+tx*tx
	        if (distsq.lt.bsradsq(k)) goto 111
 121	      continue
c  point is not affected by bright star
c  now check masking
	      if (imask.eq.1) then
	        if (ix(i,iy,nfm).ne.0) goto 111
	      end if
	      npt=npt+1
	      zray(npt)=float(ix(i,j,nfr))
 111	    continue
c make sure that there are at least 200 pts before accepting the row
	    if (npt.ge.200) then
	      nav=nav+1
	      call mmm(zray,npt,nz2,zmean,zmedian,zmode(nav),
     *            zsigma(nav),zskew,zreject,niter,1.,onemean)
c to be commened out
 	write(6,*) j,iy,' npt,mode,sig: ',npt,zmode(nav),zsigma(nav)
     *               ,nz2
	      if (nz2.lt.100) then
	        write(6,*) '   ** too few pts after rejection, not used'
	        nav=nav-1
	      end if
	    end if
 110	  continue
c print out last row
 	  write(6,*) nrow,iy,' last row npt,mode,sig: ',npt,zmode(nav)
     *              ,zsigma(nav) ,nz2
	end if
c  compute median of averages and sigmas
c	call slomed(nav,zmode,avsky)
c	call slomed(nav,zsigma,avsig)
	call mmm(zmode,nav,nz2,zmean,avmed,avmod,dummy,zskew,
     *           zreject,niter,1.,onemean)
 	call mmm(zsigma,nav,nz2s,sigmean,sigmed,sigmod,dummy,zskew,
     *           zreject,niter,1.,onemean)
	write(6,*) ' 1st mmm run for zmode',nz2,zmean,avmed,
     *                avmod, ' sigmean: ',nz2s,sigmean,sigmod
c Note: Aug25 2004: it appears that MMM runs into a problem when it
c   tries to compute avmod -- it return a nz2 the same as the last call
c   and nan for avmod.  By running it a 2nd time, it seems to work...
c   
	if (nz2.gt.100) then
	  call mmm(zmode,nav,nz2,zmean,avmed,avmod,dummy,zskew,
     *           zreject,niter,1.,onemean)
	  write(6,*) 'running mmm(zmode) 2nd time',nz2,zmean,avmed,
     *         avmod
	end if
	if (nz2.gt.100) then
c  mmm is freaking out, run it again and hope it works...
	  call mmm(zmode,nav,nz2,zmean,avmed,avmod,dummy,zskew,
     *           zreject,niter,1.,onemean)
	  write(6,*) 'running mmm(zmode) 3rd time',nz2,zmean,avmed,
     *         avmod
	end if
c if mmm still freaking out, just run slowmed
	if (nz2.gt.100) then
 	  call slomed(nav,zmode,avmod)
	  write(6,*) ' ++++ give up on mmm, using slomed for avmode'
c  added 09 jul 07: sometimes average sigma is also not computed
c   proerpy, check and  run slomed if needed
 	  if (abs(sigmod).lt.0.000001) 
     *        call slomed(nav,zsigma,sigmod)
	  nz2=nav
	end if
 	avsky=avmod
 	avsig=sigmod
	write(6,1) nav,avsky,avsig,nz2,nz2s
 1	format('  average sky (mode) and sigma from',i5,' rows: ',
     *           2f9.3,' rows used ',2i5)
 999	return1
	end
c//////////////////////////////////////////////////
c  
c   subroutine to enter position and size of area to be blocked
c    for overall background and sigma determination
c         (Feb 16, 2004)
c
c  nst is the number of bright star, default is 0,
c    entering this subroutine automatically reset nbstar to 0
	subroutine bstarlis(*)
	common/bstarxy/nbstar,bstx(10),bsty(10),bsrad(10),bsmag(10)
	nbstar=0
 600	write(6,1) nbstar
 1	format('  Enter number of bright star (0=flush) [',i2,']: '
     *         ,$)
	call read1i(nbstar,*999,*600)
	if (nbstar.le.0) then
	  nbstar=0
	  return1
	else
	  nbstar=min0(5,nbstar)
	  do 100 i=1,nbstar
 601	    write(6,2) i
 2	format(' Enter x,y,radius for star',i2,': ',$)
	    read(5,*,err=601,end=999) bstx(i),bsty(i),bsrad(i)
 100	  continue
	end if
 999	return1
	end
