c//////////////////////////////////////////////////////////////////////
C
C      SUBROUTINE TO CHECK AND ELIMINATE SHARP OBJECTS FROM A .POS FILE
C       USES SEBOK APERTURE + MMM for sky
C
	SUBROUTINE ZAPCOSRAY(*,NFR,IX,NU,NV,KF)
	DIMENSION ZRAY(2000)
c	INTEGER*2 IX(NU,NV,KF),NODT(1)
	INTEGER IX(NU,NV,KF),NODT(1)
	INCLUDE 'ppparm.inc'
	include 'pppcore.inc'
	include 'objcat.inc'
	INCLUDE 'picdir.inc'
	include 'apert.inc'
	equivalence (iscr(1900001),zray(1))
	CALL QUERYNFR(NFR,KF,0,*200,*20001)
20001	IF (NFR.GT.6) THEN
	  WRITE(6,*) ' *** FRAME NUMBER MUST >=6 FOR POSITION FILE'
	  RETURN1
	END IF
	WRITE(6,12) RWD
 12	FORMAT('  Sharp object rejection: criterion: RWD=',f6.2,
     *               ' = (peak/adjacent pix)')
	IF (IOR.GT.21) THEN
	  WRITE(6,*) ' ***** SKY DIAMETER TOO LARGE ****'
	  RETURN
	END IF
C  make inner and outer circle for ring
	CALL APARAY(IOR,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
	CALL APARAY(IIR,IT1(1,1),IROW1(1),QDUM,RDUM,PDUM,NDUM,1)
	I1=NI/3
	J1=NJ/3
	CALL RCSKY(1,BKG1,ZSIG,1,I1,J1,NII(NFR),NJJ(NFR),IX(1,1,NFR)
     *               ,NU,NV,ZRAY,200,nsky,0,IPR)
	I1=2*NI/3
	J2=2*NJ/3
	CALL RCSKY(1,BKG,ZSIG,1,I1,J1,NII(NFR),NJJ(NFR),IX(1,1,NFR)
     *	              ,NU,NV,ZRAY,200,nsky,0,IPR)
	BKG1=0.5*(BKG1+BKG)
	WRITE(6,*) '  Back-up sky value: ',BKG1
	NZAP=0
	N=1
	NN=0
 199	IF (N.GT.NOB(NFR)) GO TO 198
	    NN=NN+1
	    I=IJOI(N,NFR)
	    J=IJOJ(N,NFR)
	    CALL RCSKY(1,BKG,ZSIG,1,I,J,NII(NFR),NJJ(NFR),IX(1,1,NFR)
     *                      ,NU,NV,ZRAY,200,nsky,0,IPR)
	    IF (IPR.EQ.999) RETURN
 28	    IF (BKG.LT.0.0001) BKG=BKG1
C CHECK IF THERE IS A SHAPR DISCONTINUITY BETWEEN THE LOC MAX
C    AND THE ADJACENT PIXELS (E.G. DUE TO COSMIC RAYS)
 97	    IXBB=NINT(BKG-ZSIG)
	    IXT=NINT(1.*(IX(I,J,NFR)-IXBB)/RWD)
	    NPWHG=0
	    NPHG45=0
	    DO 106 L=J-1,J+1,2
	      IF ((IX(I,L,NFR)-IXBB).GT.IXT) GO TO 106
              NPWHG=NPWHG+1
 106	    CONTINUE
	    DO 105 M=I-1,I+1,2
	     IF ((IX(M,J,NFR)-IXBB).GT.IXT) GO TO 105
             NPWHG=NPWHG+1
 105	    CONTINUE
	    DO 107 L=J-1,J+1,2
	      DO 107 M=I-1,I+1,2
	        IF ((IX(M,L,NFR)-IXBB).GT.IXT) GO TO 107
                NPHG45=NPHG45+1
 107	    CONTINUE
	    IF (NPWHG.GT.0.AND.NPHG45.GT.1) THEN
	      WRITE(6,10) NN,I,J,((IX(K,J,NFR)),K=I-1,I+1)
 10	FORMAT('  Object #',I4,' rejected @',2I5,' -- ',3I6)
	      NODT(1)=N
	      CALL DELOBJ(NODT,1,NFR)
	        NZAP=NZAP+1
	      GO TO 199
	    END IF
	    N=N+1
	GO TO 199
 198	CONTINUE
	WRITE(6,*) '  total number zapped: ',NZAP
 200	RETURN1
	END

C
C////////////////////////////////////////////////////////////////
C
C  Subroutine to create cosmic-ray map, from which BPFI can be used
C    to clean off the bad pixels: 
C
C    Method: a search box dimension ISB and JSB centered on each
C        pixel is used to determine the median and sigma value,
C        without using the pixel itself.  If the pixel is more
C        than nscrit*sigma from the median, the point is marked
C        in the BAD PIXEL map as 1. To save CPU time, any pixel
C        that is within NSCRIT sigma (set from SET) of the nominal sky 
C        value is not checked.
C        Option for search within a specified BOX via setting box,
c         options for (1) exclude a mapped area
c                     (2) only inside the mapped area
c                
C    ipar=0  crm1  all frame, except as excluded by specmap)
c    ipar=1  crmo  object spectrum (specmap=10)
c    ipar=2  crms  sky lines (specmap=100)
C    
c  added July 25 1999: include RWD test so that any pixels that
c    appears to be part of a legitimate object would not be included.
c    This addition makes it usable for direct images as well as 
c    spectroscopy data
c
	SUBROUTINE COSRAYMAP(*,NFR,NMAPT,BOXA,BOXB,NSCRIT,iprtt,ipar,
     *          rwd,IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER BOXA*10,BOXB*10,filname*25,form*1
	DIMENSION ARRAY(1600)
	INCLUDE 'picdir.inc'
	COMMON/BOX/IBOX(4,10),NBOX
	include 'pppcore.inc'
	include 'objcat.inc'
	equivalence (array(1),iscr(1900001))
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NMAP=NMAPT
	CALL QUERYNFR(NMAP,KF,4,*999,*20002)
20002	IF (NII(NMAP).NE.0) WRITE(6,*)
     *       '    ++++ WARNING:  CRMAP will overwrite frame ',NMAP
c  check section to be worked on, use ilpos, iupos, jlpos, jupos
	IF (ilpos(nfr).LE.0.OR.jlpos(nfr).lt.0) THEN
	  J1=1
	  J2=NJJ(NFR)
	  I1=1
	  I2=NII(NFR)
	ELSE
	  I1=ilpos(nfr)
	  I2=iupos(nfr)
	  J1=jlpos(nfr)
	  J2=jupos(nfr)
	end if
c	IF (NMAPT.EQ.0.AND.BOXB.EQ.' ') BOXB=BOXA
c	MBOX=0
c	IF (BOXB(1:3).EQ.'box') THEN
c	  READ(BOXB(4:4),*,ERR=150,END=150) MBOX
c	  GO TO 600
c 150	  IF (MBOX.EQ.0.OR.MBOX.GT.9) THEN
c 6001	    WRITE(6,11)
c 11	FORMAT('  +++ ILLEGAL box number, re-enter: ',$)
c	    call read1i(mbox,*999,*6001)
c	  END IF
c	END IF
c	IF (MBOX.LE.0.OR.MBOX.GT.9) THEN
c	  J1=1
c	  J2=NJJ(NFR)
c	  I1=1
c	  I2=NII(NFR)
c	ELSE
c	  I1=IBOX(1,MBOX)
c	  I2=IBOX(2,MBOX)
c	  J1=IBOX(3,MBOX)
c	  J2=IBOX(4,MBOX)
c	END IF
	  WRITE(6,178) I1,I2,J1,J2
 178	FORMAT('  ...search box I=',I5,' to',I5,', J=',I5,' to',I5)
 600	WRITE(6,1) ISB,JSB
 1	FORMAT('  Enter filter size, odd (dflt: I:',I3,' J:',I3,'): ',$)
	CALL READ2I(ISB,JSB,*999,*600)
	IF (FLOAT(ISB*JSB).GT.1600) THEN
	  WRITE(6,*) '  *** filter too large (max 1600 pixels) ***'
	  GO TO 600
	END IF
 6011	write(6,10) 
 10	format('  Do you want macro file (m) or badpix frame (df: p):',$)
	read(5,'(a1)',end=999) form
	ISBH=ISB/2
	JSBH=JSB/2
C  determine sky
c   Nov 2002: add choices for areas used for sky determination
c     if boxes are defined, use boxes
c     if not, use stripsky, but limited to central 1/2 of image
	isky1=i1+(i2-i1)*.25
	isky2=isky1+(i2-i1)*.5
	jsky1=j1+(j2-j1)*.25
	jsky2=jsky1+(j2-j1)*.5
	CALL STRIPSKY(NFR,isky1,jsky1,isky2,jsky2,7,SKY,CRITMIN,1,
     *               IX,NU,NV,KF)
	IF (SIGCRIT.LT.0.01) SIGCRIT=6.0
 601	WRITE(6,2) SIGCRIT
 2	FORMAT('  Enter threshold in terms of local sigma [',F5.2,
     *                 ']: ',$)
	CALL READ1R(SIGCRIT,*999,*601)
C 602	WRITE(6,18)
C 18	FORMAT('  Do you want to use rejection for MEDIAN? (y/n,'
C     *              ' (dflt:',A1,'): ',$)
C	READ(5,19,ERR=602,END=999) IAN
C 19	FORMAT(A1)
 603	write(6,21) nfmaskt
 21	format('  Enter mask frame # (0=none, +=exclude, -=include)',
     *    ' [',i3,']: ',$)
	call read1i(nfmaskt,*999,*603)
	nfmask=iabs(nfmaskt)
	if (nfmask.gt.kf-1) then
	  write(6,*) '   +++ mask frame number too large'
	  go to 603
	end if 
	if (nfmask.eq.nfr.or.nfmask.eq.nmap) then
	  write(6,*) '  +++ illegal mask frame number +++'
	  go to 603
	end if
	if (form.eq. 'm') WRITE(6,*) 
     *   '   Search begins... A file of crbp positions',
     *            ' cosray.macro will be created.'
	filname='cosray.macro'
	if (form.eq.'m') then
	  call opennew(28,1,25,filname,*999)
	  WRITE(28,31) NMAP,NII(NFR),NJJ(NFR)
	else
 31	FORMAT(1X,'crbp'/1X,I2/1X,2I5)
C  create frame for map
	  NII(NMAP)=NII(NFR)
	  NJJ(NMAP)=NJJ(NFR)
	  nfl(6,nmap)=1
	end if
	IZAP=0
	CRITMIN=NSCRIT*CRITMIN
	CRITMIN2=5.*CRITMIN
	write(6,*) ' critmin: ',CRITMIN
	DO 100 J=J1,J2
	  DO 100, I=I1,I2
	    if (form.ne.'m') IX(I,J,NMAP)=0
c check for restriction
	    if (ipar.eq.0) then
	      if (nfmaskt.eq.0) then
	        go to 120
	      else if (nfmaskt.gt.0) then
	        if (ix(i,j,nfmask).ge.1) then
	          ix(i,j,nmap)=-ix(i,j,nfmask)
	          go to 100
	        end if
	      else if (nfmaskt.lt.0) then
	        if (ix(i,j,nfmask).eq.0) go to 100
	      end if
	    else if (ipar.eq.1) then
	      if (ix(i,j,nfmask).ne.10) go to 100
	    else if (ipar.eq.2) then
	      if (ix(i,j,nfmask).ne.100) go to 100
	    end if
 120	    IF (ABS(FLOAT(IX(I,J,NFR))-SKY).GT.CRITMIN) THEN
C  
C   make array of pixels to determine local background and sigma
	      K=0
	      DO 101 M=MAX0(1,J-JSBH),MIN0(J+JSBH,NJJ(NFR))
	        DO 101 L=MAX0(1,I-ISBH),MIN0(I+ISBH,NII(NFR))
	          IF (M.NE.J.OR.L.NE.I) THEN
	            K=K+1
	            ARRAY(K)=IX(L,M,NFR)
	          END IF
 101	      CONTINUE
 	      CALL MEDSIGR(ARRAY,RMED,SIG,K)
C  check for very large sigma which is an indication of several bad
C  pixels stringed together
	      IF (SIG.GT.CRITMIN2) THEN
C  reject the brightest pixel and recompute
	        K=K-1
 	        CALL MEDSIGR(ARRAY,RMED,SIG,K)
C	         WRITE(6,*) I,J,'  ..Pixel rejected ',ARRAY(K+1)
	      END IF
	      IF (ABS(FLOAT(IX(I,J,NFR))-RMED).GT.SIGCRIT*SIG) THEN
c  determine if it could be part of a real object using rwd check
	        if (rwd.gt.1.) then
	          IXBG=NINT(rmed-SQRT(ABS(rmed)))
c  ixt is the threshold such that if a neigbouring pt is smaller
c   then the neigbour is too low (hence the pt is too sharp) 
	          IXT=NINT(1.*(IX(I,J,nfr)-IXBG)/RWD)
	          NPWHG=0
	          NPHG45=0
	          DO 106 L=J-1,J+1,2
	            IF ((IX(I,L,nfr)-IXBG).le.IXT) NPWHG=NPWHG+1
 106	          CONTINUE
	          DO 105 M=I-1,I+1,2
	            IF ((IX(M,J,nfr)-IXBG).le.IXT) NPWHG=NPWHG+1
 105	          CONTINUE
	          DO 107 L=J-1,J+1,2
	            DO 107 M=I-1,I+1,2
	             IF ((IX(M,L,nfr)-IXBG).le.IXT) NPHG45=NPHG45+1
 107              CONTINUE
c condition for not being cosray
	          IF (NPWHG.eq.0.or.NPHG45.le.1) goto 100
	        end if 
	        if (ipra.eq.1) WRITE(6,5) I,J,IX(I,J,NFR),RMED,SIG
 5	FORMAT('  FLAGGED pix',I5,I5,I7,'  aver, sig:',F7.1,F7.2)
	          if (form.eq.'m') then
	            WRITE(28,6) I,J
	            goto 100
	          end if
 6	FORMAT('  p',2I5)
	        IX(I,J,NMAP)=1
	      end if
c	      ELSE
c	        IX(I,J,NMAP)=0
c	      END IF
c	    ELSE
c	      if (form.eq.'m') go to 100
c	      IX(I,J,NMAP)=0
	    END IF
 100	CONTINUE
 	if (form.eq.'m') then
	  write(28,51)
 51	format('  '/'end')
	  CLOSE(UNIT=28)
	end if
999	RETURN1
	END
C
C////////////////////////////////////////////////////////////////
C
C  Subroutine to create cosmic-ray map, from which BPFI can be used
C    to clean off the bad pixels: 
C
C    Method: a search box dimension ISB and JSB centered on each
C        pixel is used to determine the median and sigma value,
C        without using the pixel itself.  If the pixel is more
C        than nscrit*sigma from the median, the point is marked
C        in the BAD PIXEL map as 1. To save CPU time, any pixel
C        that is within NSCRIT sigma (set from SET) of the nominal sky 
C        value is not checked.
C        Option for search within a specified BOX via setting box,
c         options for (1) exclude a mapped area
c                     (2) only inside the mapped area
c                
C    ipar=0  crm1  all frame, except as excluded by specmap)
c    ipar=1  crmo  object spectrum (specmap=10)
c    ipar=2  crms  sky lines (specmap=100)
C    
c  modified version Oct 24 1996
	SUBROUTINE COSRAYMAPB(*,NFR,NMAPT,BOXA,BOXB,nscrit,iprtt,ipar,
     *          IX,NU,NV,KF)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER BOXA*10,BOXB*10,filname*25,form*1
	DIMENSION ARRAY(1600)
	INCLUDE 'picdir.inc'
	COMMON/BOX/IBOX(4,10),NBOX
	include 'pppcore.inc'
	include 'apert.inc'
	equivalence (array(1),iscr(1900001))
	CALL QUERYNFR(NFR,KF,0,*999,*20001)
20001	NMAP=NMAPT
	CALL QUERYNFR(NMAP,KF,4,*999,*20002)
20002	IF (NII(NMAP).NE.0) WRITE(6,*)
     *       '    ++++ WARNING:  CRMAP will overwrite frame ',NMAP
	IF (NMAPT.EQ.0.AND.BOXB.EQ.' ') BOXB=BOXA
	MBOX=0
	IF (BOXB(1:3).EQ.'box') THEN
	  READ(BOXB(4:4),*,ERR=150,END=150) MBOX
	  GO TO 600
 150	  IF (MBOX.EQ.0.OR.MBOX.GT.9) THEN
 6001	    WRITE(6,11)
 11	FORMAT('  +++ ILLEGAL box number, re-enter: ',$)
	    call read1i(mbox,*999,*6001)
	  END IF
	END IF
	IF (MBOX.LE.0.OR.MBOX.GT.9) THEN
	  J1=1
	  J2=NJJ(NFR)
	  I1=1
	  I2=NII(NFR)
	ELSE
	  I1=IBOX(1,MBOX)
	  I2=IBOX(2,MBOX)
	  J1=IBOX(3,MBOX)
	  J2=IBOX(4,MBOX)
	END IF
	  WRITE(6,178) I1,I2,J1,J2
 178	FORMAT('  ...search box I=',I5,' to',I5,', J=',I5,' to',I5)
 600	WRITE(6,1) ISB,JSB
 1	FORMAT('  Enter filter size, odd (dflt: I:',I3,' J:',I3,'): ',$)
	CALL READ2I(ISB,JSB,*999,*600)
	IF (FLOAT(ISB*JSB).GT.1600) THEN
	  WRITE(6,*) '  *** filter too large (max 1600 pixels) ***'
	  GO TO 600
	END IF
 6011	write(6,10) 
 10	format('  Do you want macro file (m) or badpix frame (df: p):',$)
	read(5,'(a1)',end=999) form
	ISBH=ISB/2
	JSBH=JSB/2
	isbh2=max0(7,ishb/3)
	jsbh2=max0(1,jshb/2)
C  determine sky
	CALL STRIPSKY(NFR,1,1,NII(NFR),NJJ(NFR),7,SKY,skysig,1,
     *               IX,NU,NV,KF)
	IF (SIGCRIT.LT.0.01) SIGCRIT=6.0
 601	WRITE(6,2) SIGCRIT
 2	FORMAT('  Enter threshold in terms of local sigma [',F5.2,
     *                 ']: ',$)
	CALL READ1R(SIGCRIT,*999,*601)
c	CALL APARAY(IOR,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
c	CALL APARAY(IIR,IT1(1,1),IROW1(1),QDUM,RDUM,PDUM,NDUM,1)
 603	write(6,21) nfmaskt
 21	format('  Enter mask frame # (0=none, +=exclude, -=include)',
     *    ' [',i3,']: ',$)
	call read1i(nfmaskt,*999,*603)
	nfmask=iabs(nfmaskt)
	if (nfmask.gt.kf-1) then
	  write(6,*) '   +++ mask frame number too large'
	  go to 603
	end if 
	if (nfmask.eq.nfr.or.nfmask.eq.nmap) then
	  write(6,*) '  +++ illegal mask frame number +++'
	  go to 603
	end if
	if (form.eq. 'm') WRITE(6,*) 
     *   '   Search begins... A file of crbp positions',
     *            ' cosray.macro will be created.'
	filname='cosray.macro'
	if (form.eq.'m') then
	  call opennew(28,1,25,filname,*999)
	  WRITE(28,31) NMAP,NII(NFR),NJJ(NFR)
	else
 31	FORMAT(1X,'crbp'/1X,I2/1X,2I5)
C  create frame for map
	  NII(NMAP)=NII(NFR)
	  NJJ(NMAP)=NJJ(NFR)
	  nfl(6,nmap)=1
	end if
	IZAP=0
	CRITMIN=NSCRIT*skysig
	CRITMIN2=5.*CRITMIN
	write(6,*) ' critmin=nscritXsig',CRITMIN,
     *          ' -- net threshold for checking'
C  make inner and outer circle for ring
	DO 100 J=J1,J2
	  DO 100, I=I1,I2
c check for restriction
	    if (ipar.eq.0) then
	      if (nfmaskt.eq.0) then
	        go to 120
	      else if (nfmaskt.gt.0) then
	        if (ix(i,j,nfmask).ge.1) then
	          ix(i,j,nmap)=-ix(i,j,nfmask)
	          go to 100
	        end if
	      else if (nfmaskt.lt.0) then
	        if (ix(i,j,nfmask).eq.0) go to 100
	      end if
	    else if (ipar.eq.1) then
	      if (ix(i,j,nfmask).ne.10) go to 100
	    else if (ipar.eq.2) then
	      if (ix(i,j,nfmask).ne.100) go to 100
	    end if
 120	    IF (ABS(FLOAT(IX(I,J,NFR))-SSKY).GT.CRITMIN) THEN
c   pixels pass initial condition
C  
C   make array of pixels to determine local background and sigma
c     of the filter size
	      K=0
	      DO 101 M=MAX0(1,J-JSBH),MIN0(J+JSBH,NJJ(NFR))
	        DO 101 L=MAX0(1,I-ISBH),MIN0(I+ISBH,NII(NFR))
c	          IF (M.NE.J.OR.L.NE.I) THEN
	            K=K+1
	            ARRAY(K)=IX(L,M,NFR)
c	          END IF
 101	      CONTINUE
              CALL MMM(array,NNZ,K,ZMEAN1,ZMED1,skymod,SIG,
     *                 ZSKEW1,ZREJ1,NIT1,1.,ONEMEAN)
	      IF (ABS(FLOAT(IX(I,J,NFR))-skymod).GT.SIGCRIT*SIG) THEN
	        if (ipra.eq.1) WRITE(6,5) I,J,IX(I,J,NFR),skymod,SIG
 5	FORMAT('  FLAGGED pix',I5,I5,I7,'  aver, sig:',F7.1,F7.2)
	          if (form.eq.'m') then
	            WRITE(28,6) I,J
	            goto 100
	          end if
 6	FORMAT('  p',2I5)
	        IX(I,J,NMAP)=1
	      ELSE
	        IX(I,J,NMAP)=0
	      END IF
	    ELSE
	      if (form.eq.'m') go to 100
	      IX(I,J,NMAP)=0
	    END IF
 100	CONTINUE
 	if (form.eq.'m') then
	  write(28,51)
 51	format('  '/'end')
	  CLOSE(UNIT=28)
	end if
999	RETURN1
	END
C
C///////////////////////////////////////////////////////////////////////
C
C SUBROUTINE TO CALCULTE MEDIAN AND SIGMA
C
	SUBROUTINE MEDSIGR(X,RMED,SIG,NP)
	REAL X(*)
	SSQ=0.
	SUM=0.
	DO 100 I=1,NP
	  SSQ=SSQ+X(I)*X(I)
 100	  SUM=SUM+X(I)
	AVE=SUM/FLOAT(NP)
	IF (NP.EQ.1) THEN
	  RMED=X(1)
	  SIG=.00001
	ELSE 
	  IF (NP.EQ.2) THEN
	    RMED=.5*(X(1)+X(2))
	  ELSE
	    CALL SORT(NP,X)
 	    IF (MOD(NP,2).EQ.1) THEN
	      RMED=X(NP/2+1)
	    ELSE
	      RMED=.5*(X(NP/2)+X(NP/2+1))
	    END IF
	  END IF
	  SIG=SQRT(AMAX1(.00001,(SSQ-SUM*AVE)/FLOAT(NP-1)))
	END IF
	RETURN
	END
c////////////////////////////////////////////////////////
c
c   subroutine to modify badpixel map (ie set to 0) near positions 
c         defined by the position file
c
	subroutine objmask(*,nfr,nfrm,ix,nu,nv,kf)
c	INTEGER*2 IX(NU,NV,KF)
	INTEGER IX(NU,NV,KF)
	CHARACTER ian*1
	INCLUDE 'ppparm.inc'
	include 'pppcore.inc'
        include 'objcat.inc' 
	INCLUDE 'picdir.inc'
	include 'apert.inc'
	CALL QUERYNFR(NFR,KF,1,*999,*2001)
 2001	if (nfr.gt.6) then
	  write(6,*) '  +++ no position file for frame #>6 +++'
	  return1
	end if
	if (nob(nfr).le.0) then
	  write(6,*) '  +++ no position file, no change made ++'
	  return1
	end if
	call querynfr(nfrm,kf,2,*999,*2002)
c  check if nfrm is a mask
 2002	if (ix(nii(nfrm)/4,njj(nfrm)/4,nfrm).gt.10.or.
     *        ix(nii(nfrm)/2,njj(nfrm)/2,nfrm).gt.10) then
	  write(6,2) nfrm
 2	format('  +++ frame ',i2,' doesn''t look like a bad pixel map,'/
     *      '   Do you want to continue (y/n=dflt): ',$)
	  read(5,'(a1)',end=999) ian
	  if (ian.ne.'y') return1
	end if
 600	write(6,1) irad
 1	format('  Enter diameter of mask [',i3,']: ',$)
	call read1i(irad,*999,*600)
c  set aperture	
	CALL APARAY(irad,IT2,IROW2,QDUM,RDUM,PDUM,NDUM,1)
c  check mask and  replace value to 0 near objects
	nfl(6,nfrm)=1
	do 100 m=1,nob(nfr)
	  jr1=ijoj(m,nfr)-irow2
	  jr2=ijoj(m,nfr)+irow2
	  k=0
	  npc=0
	  do 102 j=max0(1,jr1),min0(njj(nfr),jr2)
	    k=k+1
	    do 103 i=max0(1,ijoi(m,nfr)-it2(k)/2),
     *          min0(nii(nfr),ijoi(m,nfr)+it2(k)/2)
	      if (ix(i,j,nfrm).gt.0) then
	        ix(i,j,nfrm)=0
	        npc=npc+1
	      end if
 103	    continue
 102	  continue
	  if (npc.gt.0) write(6,3) m,npc
 3	format('   obj#',i5,'....',i3,' pixels masked')
 100	continue
 999	return1
	end 
c/////////////////////////////////////////////////////////////////////
c  program to produce mask of spectra and sky line 
c
	subroutine spectromask(*,nfr,ix,nu,nv,kf)
	dimension xm(200),ym(200),rmagm(200),xright(200),xleft(200),
     *        skyline(15),skylinef(15)
c	integer*2 ix(nu,nv,kf)
	integer ix(nu,nv,kf)
	include 'picdir.inc'
	data skyline/5577.,5890.,6230.,6300.,6364.,6560.,6830.,
     *          6864.,7242.,7277.,0.,0.,0.,0.,0./
	CALL QUERYNFR(NFR,KF,1,*999,*2001)
c read in axf file
 2001	call readaxf(nslit,xm,ym,xright,xleft,
     *      rmagm,sshift,speclen)
c ask for spectral range
	if (centwave.lt.0.1) centwave=5900.
	if (ypix1.lt.0.001) then
	  ypix1=450.
	  angpix1=3.45
	  ypix2=1600.
	  angpix2=3.60
	end if
 601	write(6,2) centwave
	call read1r(centwave,*999,*601)
 2	format('  Enter center wavelength [',f7.1, ']: ',$)
 6011	write(6,11) ypix1,angpix1
 11	format('  Enter 2 pairs of (ypix,ang/pix) values --'/
     *         '     enter pair 1 [',f6.1,f6.2,']: ',$)
	call read2r(ypix1,angpix1,*999,*6011)
 6012	write(6,12) ypix2,angpix2
 12	format('     enter pair 2 [',f6.1,f6.2,']: ',$)
	call read2r(ypix2,angpix2,*999,*6011)
 6015	write(6,5) xshift
 5	format('  Enter xshift of spectral image from axf [',f4.1,
     *    'pix]: ',$)
	call read1r(xshift,*999,*6015)
	if (thick.lt.0.1) thick=7.
 6016	write(6,6) thick
 6	format('  Enter thickness of spectrum to be mapped [',f5.1,
     *    ' pix]: ' ,$)	
	call read1r(thick,*999,*6016)
	if (niit.eq.0) niit=nu
	if (njjt.eq.0) njjt=nv
 602	write(6,3) niit,njjt
 3	format('  Enter mask image size [',2i5,']: ',$)
	call read2i(niit,njjt,*999,*602)
	nii(nfr)=niit
	njj(nfr)=njjt
	do 100 j=1,nii(nfr)
	  do 100 i=1,njj(nfr)
	    ix(i,j,nfr)=0
 100	continue
c create mask. Algorithm:  width of object spectrum is proportional
c     to magnitude: min width 7 pixels, add 1 pixel for every mag
c       brighter than 20 mag
c       sky line = 7 pixels wide
	slen2=speclen*.5
	ithick=thick/2
	skylwid=18./(0.5*(angpix1+angpix2))
	do 110 i=1,nslit
c determine upper and lower corners of the object spectra
	  thick2=ithick+int(amax1(0.,20.9999-rmagm(i)))*.5
	  imin=max0(1,nint(xm(i)-thick2+xshift))
	  imax=min0(nii(nfr),nint(xm(i)+thick2+xshift))
	  jmin=max0(1,nint(ym(i)-slen2+sshift))
	  jmax=min0(njj(nfr),nint(ym(i)+slen2+sshift))
	  angpix=angpix1+(angpix2-angpix1)*(ym(i)-ypix1)/(ypix2-ypix1)
	  do 111 m=jmin,jmax
	    do 111 n=imin,imax
	      if(ix(n,m,nfr).eq.0) ix(n,m,nfr)=10
 111	  continue
c put in border of spectrum
	  imin=nint(xm(i)+xright(i)+xshift)
	  imax=nint(xm(i)+xleft(i)+xshift)
	  do 112 m=jmin,jmax
	    do 113 n=imin-1,imin+1
	      if(ix(n,m,nfr).eq.0) ix(n,m,nfr)=10
 113	  continue
	    do 114 n=imax-1,imax+1
	      if(ix(n,m,nfr).eq.0) ix(n,m,nfr)=10
 114	  continue
 112	  continue
c determine skylines, sky lines are marked with 100's
	  imin=nint(xm(i)+xright(i)+xshift-2.5)
	  imax=nint(xm(i)+xleft(i)+xshift+2.5)
	  censpec=centwave+sshift*angpix
	  halfspec=speclen*angpix*.5
	  wavemax=censpec+halfspec
	  wavemin=censpec-halfspec
	  do 120 j=1,100
	    if (skyline(j).lt.0.01) go to 110
	    if (skyline(j).lt.wavemax.and.skyline(j).gt.wavemin) then
c derive max and min corner of line
	      cenpix=ym(i)-(centwave-skyline(j))/angpix
c check if the line is in 
c	      jmin=nint(cenpix-5.5)
c	      jmax=nint(cenpix+5.5)
 	      jmin=nint(cenpix-skylwid)
 	      jmax=nint(cenpix+skylwid)
	      do 121 m=jmin,jmax
	        do 121 n=imin,imax
	          ix(n,m,nfr)=100
 121	      continue
	    end if
 120	  continue
 110	continue
	nfl(6,nfr)=1
 999	return1
	end
c////////////////////////////////////////////////////////
c  subroutine to read axf file
	subroutine readaxf(nslit,xm,ym,xright,xleft,
     *     rmagm,sshift,speclen)
	dimension xm(1),ym(1),xright(1),xleft(1),rmagm(1)
	character axfname*20
 601	write(6,1)
 1	format('  Enter axf file name: ',$)
	read(5,'(a20)',end=999) axfname
	ierr=0
 202	open(unit=27,file=axfname,status='old',err=200)
	goto 201
 200	  ierr=ierr+1
	  if (ierr.gt.1) then
	    go to 601
	  else
	    axfname=axfname(1:lnblnk(axfname))//'.axf'
	    go to 202
	  end if
 201	continue
c read spectral shift and spectral length in pixles
	read(27,2,err=204,end=205) sshift,speclen
 2	format(66x,2f6.0)
	go to 206
 204	sshift=0.
	speclen=0.
c  check if slit shift and speclength data have been read
 206	if (speclen.le.0.001) then
 602	  write(6,3) speclen,sshift
 3	format('  Enter spectral length and shift in pixels [',
     *      2f5.0,']: ',$)
	  call read2r(speclen,sshift,*999,*602)
	end if
 	read(27,*)
	do 100 i=1,200
	  read(27,*,err=208,end=207) idum,xm(i),ym(i),
     *       xright(i),xleft(i),dum,rmagm(i)
	  go to 100
 208	  write(6,*) '  ++ error in reading slit ',i
 100	continue
 207	nslit=i-1
	close(unit=27)
 999	return
 205	write(6,*) '  +++ axf file empty +++'
	return
	end
